#pragma comment(linker, "/STACK:1000000000")

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>

#define ll long long

using namespace std;

const int N = 5000;
const int MAX = 10000;

void solve() {
	int n, m, q, p, a, b, f, r;
	vector<pair<int, int>> edges[N];
	bool exist[N][MAX + 1];
	ll w;
	bool found;
	string ans;

	cin >> n >> m >> q >> p;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> w;
		if (w > (ll)MAX)
			continue;
		a--;
		b--;
		if (a > b)
			swap(a, b);
		edges[b].push_back({ a, (int)w });
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j <= MAX; j++)
			exist[i][j] = false;
	exist[0][0] = true;

	for (int v = 1; v < n; v++)
		for (auto e : edges[v])
			for (int i = 0; i <= MAX; i++)
				if (exist[e.first][i] && i + e.second <= MAX)
					exist[v][i + e.second] = true;

	for (int i = 0; i < q; i++) {
		cin >> f >> r;
		f--;
		found = false;
		for (int j = 0; j <= MAX; j++)
			if (exist[f][j] && j >= r && j * (p - 1) <= p * r)
				found = true;
		ans.push_back('0' + found);
	}
	cout << ans << endl;
}

int t;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> t;
	for (int test = 0; test < t; test++)
		solve();

	//system("pause");
	return 0;
}