#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define all(v) v.begin(), v.end()

typedef long long ll;

bool check(ll v, ll r, ll need, vector<ll> &d) {
	for (int i = 0; i < v; ++i) {
		if (need < d[i] && d[i] - need <= r) return true;
	}
	return false;
}

void Solve() {
	ll n, m, q, p;
	cin >> n >> m >> q >> p;
	vector<vector<pair<ll, ll>>> g(n);
	for (ll i = 0; i < m; ++i) {
		ll v, u;
		ll d;
		cin >> v >> u >> d;
		--v; --u;
		g[v].push_back({ u, d });
	}
	vector<vector<ll, ll>> arr(n);
	for (int i = 0; i < n - 1; ++i) {
		arr[i] = { g[i][0].second, g[i][1].second };
		if (arr[i][0] > arr[i][1]) swap(arr[i][0], arr[i][1]);
	}
	vector<ll> pref(n);
	for (int i = 1; i < n; ++i) {
		pref[i] = pref[i - 1] + arr[i - 1][0];
	}
	vector<ll> d(n);
	for (int i = 0; i < n; ++i) {
		d[i] = arr[i][1] - arr[i][0];
	}
	while (q--) {
		ll v, r;
		cin >> v >> r;
		--v;
		if (pref[v] > p * r / (p - 1)) std::cout << 0;
		else {
			ll need = r - pref[v];
			if (check(v, r, need, pref)) cout << 1;
			else {
				int i = 0;
				while (i != v && need > 0) {
					if (d[i] - need <= r) {
						need -= d[i];
					}
					++i;
				}
				if (need <= 0) cout << 1;
				else cout << 0;
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); std::cout.tie(NULL);
	ll t;
	cin >> t;
	while (t--) Solve();
	system("pause");
	return 0;
}
/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9

*/

/*
1
4 6 5 2
1 2 1
1 2 70
2 3 1
2 3 120
3 4 1
3 4 4
4 90
4 2
4 10
4 37
2 34
*/