#include <bits/stdc++.h>
using namespace std;
 
#define INF 1000000010
#define MOD 1000000007
#define pb push_back
#define f first
#define s second
 
using vi = vector <int>;
using ll = long long;
using pii = pair <int, int>;
 
void fastIO(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
}
 
const int MAXN = 1e6 + 10;
 
int n, m, q;
int col[MAXN], row[MAXN];
vi v1, v2;
bool was1[MAXN], was2[MAXN];
 
int get_case(int x, int y, int k){
    if(row[x] < k && col[y] < k) return 0;
    else if(row[x] >= k && col[y] >= k) return 3;
    else if(row[x] >= k && col[y] < k) return 1;
    return 2;
}

int tree[4 * MAXN][2], tree2[4 * MAXN][2];

void upd(int u, int l, int r, int pos, int val, int num){
	if(l == r){
		tree[u][num] = val;
		return;
	}
	if(pos <= (l + r) / 2)
		upd(u * 2 + 1, l, (l + r) / 2, pos, val, num);
	else
		upd(u * 2 + 2, (l + r) / 2 + 1, r, pos, val, num);
	tree[u][num] = min(tree[u * 2 + 1][num], tree[u * 2 + 2][num]);
}

int get(int u, int l, int r, int ql, int qr, int num){
	if(l >= ql && r <= qr)
		return tree[u][num];
	if(l > qr || r < ql)
		return INF;
	return min(get(u * 2 + 1, l, (l + r) / 2, ql, qr, num), get(u * 2 + 2, (l + r) / 2 + 1, r, ql, qr, num));
}

void upd2(int u, int l, int r, int pos, int val, int num){
	if(l == r){
		tree2[u][num] = val;
		return;
	}
	if(pos <= (l + r) / 2)
		upd2(u * 2 + 1, l, (l + r) / 2, pos, val, num);
	else
		upd2(u * 2 + 2, (l + r) / 2 + 1, r, pos, val, num);
	tree2[u][num] = max(tree2[u * 2 + 1][num], tree2[u * 2 + 2][num]);
}

int get2(int u, int l, int r, int ql, int qr, int num){
	if(l >= ql && r <= qr)
		return tree2[u][num];
	if(l > qr || r < ql)
		return INF;
	return max(get2(u * 2 + 1, l, (l + r) / 2, ql, qr, num), get2(u * 2 + 2, (l + r) / 2 + 1, r, ql, qr, num));
}

int solve1(int a, int b, int c, int d, int k){
    if(get(0, 0, n - 1, min(a, c), max(a, c), 0) >= k)    
        return abs(a - c) + abs(b - d);
    int ans = INF;
    int l = b + 1, r = m - 1;
    while(r - l > 1){
    	int mid = (l + r) / 2;
    	get2(0, 0, m - 1, b, mid, 1) >= k ? r = mid : l = mid;
    }
   	if(col[l] >= k)
   		ans = min(ans, abs(a - c) + l - b + abs(l - d));
   	l++;
   	if(l < m && col[l] >= k)
   		ans = min(ans, abs(a - c) + l - b + abs(l - d));
   	l = 0, r = b;
   	while(r - l > 1){
   		int mid = (l + r) / 2;
   		get2(0, 0, m - 1, mid, b, 1) >= k ? l = mid : r = mid;
   	}
	if(col[l] >= k)
   		ans = min(ans, abs(a - c) + b - l + abs(l - d));
   	l++;
   	if(l < b && col[l] >= k)
   		ans = min(ans, abs(a - c) + b - l + abs(l - d));
   	if(ans == INF)
   		return -1;
   	return ans;
}
 
int solve2(int a, int b, int c, int d, int k){
	//cerr << a << ' ' << b << ' ' << c << ' ' << d << ' ' << k << endl;
	if(get(0, 0, m - 1, min(b, d), max(b, d), 1) >= k)    
        return abs(a - c) + abs(b - d);
    int ans = INF;
    int l = a + 1, r = n - 1;
    while(r - l > 1){
    	int mid = (l + r) / 2;
    	get2(0, 0, n - 1, a, mid, 0) >= k ? r = mid : l = mid;
    }
   	if(row[l] >= k)
   		ans = min(ans, abs(b - d) + l - a + abs(l - c));
   	l++;
   	if(l < n && row[l] >= k)
   		ans = min(ans, abs(b - d) + l - a + abs(l - c));
   	l = 0, r = a;
   	while(r - l > 1){
   		int mid = (l + r) / 2;
   		get2(0, 0, n - 1, mid, a, 0) >= k ? l = mid : r = mid;
   	}
	if(row[l] >= k)
   		ans = min(ans, abs(b - d) + a - l + abs(l - c));
   	l++;
   	if(l < n && row[l] >= k)
   		ans = min(ans, abs(b - d) + a - l + abs(l - c)); 
	if(ans == INF)
   		return -1;
   	return ans;
}
 
int main(){
    fastIO();
    cin >> n >> m >> q;
    for(int num = 1; num <= q; num++){
        int id;
        cin >> id;
        if(id == 1){
            int r;
            cin >> r;
            r--;
            row[r] = num;
            upd(0, 0, n - 1, r, num, 0);
            upd2(0, 0, n - 1, r, num, 0);
        }
        else if(id == 2){
        	int c;
            cin >> c;
            c--;
            col[c] = num;
            upd(0, 0, m - 1, c, num, 1);
            upd2(0, 0, m - 1, c, num, 1);
        }
        else{
            int a, b, c, d, k;
            cin >> a >> b >> c >> d >> k;
            a--; b--; c--; d--;
            k = num - k;
            int c1 = get_case(a, b, k), c2 = get_case(c, d, k);
            if(c1 == 0 || c2 == 0)
                cout << -1 << '\n';
            else if(c1 == 3 || c2 == 3 || (c1 != c2))
                cout << abs(a - c) + abs(b - d) << '\n';
            else if(c1 == 1)
                cout << solve1(a, b, c, d, k) << '\n';  
            else
                cout << solve2(a, b, c, d, k) << '\n';
        }
    }
     
     
     
    return 0;
}