#include <bits/stdc++.h>

using namespace std;
using ll = long long;

char _buf_[(int)1e8];
size_t _p_ = 0;

void* operator new(size_t _n_) {
    _p_ += _n_;
    return _buf_ + _p_ - _n_;
}

void operator delete(void*) {};


struct SegTree {
    vector<int> t_max, t_min;
    int size;
    SegTree(int n) : size(n), t_min(2 * n), t_max(2 * n) {}

    void update(int pos, int val) {
        pos += size;
        t_min[pos] = t_max[pos] = val;
        for (pos /= 2; pos > 0; pos /= 2) {
            t_min[pos] = min(t_min[2 * pos], t_min[2 * pos + 1]);
            t_max[pos] = max(t_max[2 * pos], t_max[2 * pos + 1]);
        }
    }


    int get_max(int l, int r) {
        l += size;
        r += size;
        int res = INT_MIN;
        while (l <= r) {
            if (l % 2 == 1) {
                res = max(res, t_max[l]);
                ++l;
            }
            if (r % 2 == 0) {
                res = max(res, t_max[r]);
                --r;
            }
            l /= 2;
            r /= 2;
        }
        return res;
    }


    int get_min(int l, int r) {
        l += size;
        r += size;
        int res = INT_MAX;
        while (l <= r) {
            if (l % 2 == 1) {
                res = min(res, t_min[l]);
                ++l;
            }
            if (r % 2 == 0) {
                res = min(res, t_min[r]);
                --r;
            }
            l /= 2;
            r /= 2;
        }
        return res;
    }

};


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, q;
    cin >> n >> m >> q;

    SegTree a(n), b(m);

    for (int i = 1; i <= q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int r; cin >> r;
            a.update(r - 1, i);
        }
        else if (t == 2) {
            int c; cin >> c;
            b.update(c - 1, i);
        }
        else {
            int x0, y0, x1, y1, k;
            cin >> x0 >> y0 >> x1 >> y1 >> k;
            --x0; --y0; --x1; --y1;

            if (i - max(a.get_min(min(x0, x1), max(x0, x1)), b.get_min(min(y0, y1), max(y0, y1))) <= k) {
                cout << abs(x0 - x1) + abs(y0 - y1) << "\n";
            }
            else {
                bool hor1, hor2, ver1, ver2;
                hor1 = i - a.get_min(x0, x0) <= k;
                hor2 = i - a.get_min(x1, x1) <= k;
                ver1 = i - b.get_min(y0, y0) <= k;
                ver2 = i - b.get_min(y1, y1) <= k;
                if ((hor1 && ver2) || (hor2 && ver1)) {
                    cout << abs(x0 - x1) + abs(y0 - y1) << "\n";
                }
                else {
                    if (hor1 && hor2) {
                        int from = min(y0, y1);
                        int l = max(y0, y1), r = m - 1;
                        while (l != r) {
                            int mid = (l + r - 1) / 2;
                            if (i - b.get_max(from, mid) > k) {
                                l = mid + 1;
                            }
                            else {
                                r = mid;
                            }
                        }
                        int ans = INT_MAX;
                        if (i - b.get_max(from, r) <= k) {
                            ans = r - from + abs(x1 - x0) + r - max(y0, y1);
                        }
                        from = max(y0, y1);
                        l = 0, r = min(y0, y1);
                        while (l != r) {
                            int mid = (l + r + 1) / 2;
                            if (i - b.get_max(mid, from) > k) {
                                r = mid - 1;
                            }
                            else {
                                l = mid;
                            }
                        }
                        if (i - b.get_max(r, from) <= k) {
                            ans = min(ans, from - r + abs(x1 - x0) + min(y0, y1) - r);
                        }
                        if (ans == INT_MAX) {
                            cout << "-1\n";
                        }
                        else {
                            cout << ans << "\n";
                        }
                        continue;
                    }
                    if (ver1 && ver2) {
                        int from = min(x0, x1);
                        int l = max(x0, x1), r = n - 1;
                        while (l != r) {
                            int mid = (l + r - 1) / 2;
                            if (i - a.get_max(from, mid) > k) {
                                l = mid + 1;
                            }
                            else {
                                r = mid;
                            }
                        }
                        int ans = INT_MAX;
                        if (i - a.get_max(from, r) <= k) {
                            ans = r - from + abs(y1 - y0) + r - max(y0, y1);
                        }
                        from = max(x0, x1);
                        l = -1, r = min(x0, x1);
                        while (l != r) {
                            int mid = (l + r + 1) / 2;
                            if (i - a.get_max(mid, from) > k) {
                                r = mid - 1;
                            }
                            else {
                                l = mid;
                            }
                        }
                        if (i - a.get_max(r, from) < k) {
                            ans = min(ans, from - r + abs(y1 - y0) + min(x0, x1) - r);
                        }
                        if (ans == INT_MAX) {
                            cout << "-1\n";
                        }
                        else {
                            cout << ans << "\n";
                        }
                        continue;
                    }
                    cout << "-1\n";
                }
            }
        }
    }

    return 0;
}