#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

const int maxn = static_cast<const int>(3 * 1e5) + 1;

#define R1 first.first
#define R2 second.first
#define C1 first.second
#define C2 second.second

using namespace std;

vector< pair<int, int> > v;
vector< int > vsearch;
vector< pair<int, int> > h;
vector< int > hsearch;

vector< int > qver;
vector< int > qvert;
vector< int > qhor;
vector< int > qhort;

vector< vector<int> > tver(maxn * 4);
vector< vector<int> > thor(maxn * 4);

void buildqv(int x, int l, int r){
    if(l == r){
        //tver[x].insert((l - 1) < qver.size() ? qver[l - 1] : 999999);
        tver[x] = vector<int>(1, (l - 1) < qver.size() ? qver[l - 1] : 999999);
        return;
    }
    int m = (l + r) / 2;
    buildqv(x * 2, l, m);
    buildqv(x * 2 + 1, m + 1, r);
    //merge(tver[x * 2].begin(), tver[x * 2].end(), tver[x * 2 + 1].begin(), tver[x * 2 + 1].end(), back_inserter(tver[x]));
    int i = 0, j = 0;
    while(1) {
        while (i < tver[x * 2].size() && j == tver[x * 2 + 1].size() || i < tver[x * 2].size() && tver[x * 2][i] <= tver[x * 2 + 1][j]){
            tver[x].push_back(tver[x* 2][i]);
            i++;
        }
        while(j < tver[x * 2 + 1].size() && tver[x * 2][i] > tver[x * 2 + 1][j]){
            tver[x].push_back(tver[x* 2 + 1][j]);
            j++;
        }
        while(j < tver[x * 2 + 1].size() && tver[x * 2][i] == tver[x * 2 + 1][j]){
            j++;
        }
        if(j < tver[x * 2 + 1].size()){
            tver[x].push_back(tver[x* 2 + 1][j]);
            j++;
        }
        if(i == tver[x * 2].size() && j == tver[x * 2 + 1].size()) break;
    }
}

int getqv(int x, int l, int r, int A, int B, int lower, int upper){
    if(l > B || r < A) return 0;
    if(l >= A && r <= B){
        return lower_bound(tver[x].begin(), tver[x].end(), upper) - lower_bound(tver[x].begin(), tver[x].end(), lower) + 1;
    }
    int m = (l + r) / 2;
    return getqv(x * 2, l, m, A, B, lower, upper) + getqv(x * 2 + 1, m + 1, r, A, B, lower, upper);
}

void buildqh(int x, int l, int r){
    if(l == r){
        //thor[x].insert((l - 1) < qver.size() ? qver[l - 1] : 999999);
        thor[x] = vector<int>(1, (l - 1) < qhor.size() ? qhor[l - 1] : 999999);
        return;
    }
    int m = (l + r) / 2;
    buildqh(x * 2, l, m);
    buildqh(x * 2 + 1, m + 1, r);
    //merge(thor[x * 2].begin(), thor[x * 2].end(), thor[x * 2 + 1].begin(), thor[x * 2 + 1].end(), back_inserter(thor[x]));
    int i = 0, j = 0;
    while(1) {
        while (i < thor[x * 2].size() && j == thor[x * 2 + 1].size() || i < thor[x * 2].size() && thor[x * 2][i] <= thor[x * 2 + 1][j]){
            thor[x].push_back(thor[x* 2][i]);
            i++;
        }
        while(j < thor[x * 2 + 1].size() && thor[x * 2][i] > thor[x * 2 + 1][j]){
            thor[x].push_back(thor[x* 2 + 1][j]);
            j++;
        }
        while(j < thor[x * 2 + 1].size() && thor[x * 2][i] == thor[x * 2 + 1][j]){
            j++;
        }
        if(j < thor[x * 2 + 1].size()){
            thor[x].push_back(thor[x* 2 + 1][j]);
            j++;
        }
        if(i == thor[x * 2].size() && j == thor[x * 2 + 1].size()) break;
    }
}

int getqh(int x, int l, int r, int A, int B, int lower, int upper){
    if(l > B || r < A) return 0;
    if(l >= A && r <= B){
        return lower_bound(thor[x].begin(), thor[x].end(), upper) - lower_bound(thor[x].begin(), thor[x].end(), lower) + 1;
    }
    int m = (l + r) / 2;
    return getqh(x * 2, l, m, A, B, lower, upper) + getqh(x * 2 + 1, m + 1, r, A, B, lower, upper);
}

vector< vector<int> > tv(maxn * 4);
vector< vector<int> > th(maxn * 4);

void buildv(int x, int l, int r){
    if(l == r){
        tv[x] = vector<int>(1, ((l - 1) < v.size()) ?  v[l - 1].second : 999999);
        return;
    }
    int m = (l + r) / 2;
    buildv(x * 2, l, m);
    buildv(x * 2 + 1, m + 1, r);
    merge(tv[x * 2].begin(), tv[x * 2].end(), tv[x * 2 + 1].begin(), tv[x * 2 + 1].end(), back_inserter(tv[x]));
}

int getv(int x, int l, int r, int A, int B, int low, int up){
    if(l > B || r < A) return 0;
    if(r <= B && l >= A) {
        return lower_bound(tv[x].begin(), tv[x].end(), up) - lower_bound(tv[x].begin(), tv[x].end(), low) + 1;
    }
    int m = (l + r) / 2;
    return getv(x * 2, l, m, A, B, low, up) + getv(x * 2 + 1, m + 1, r, A, B, low, up);
}

void buildh(int x, int l, int r){
    if(l == r){
        th[x] = vector<int>(1, ((l - 1) < h.size()) ?  h[l - 1].second : 999999);
        return;
    }
    int m = (l + r) / 2;
    buildh(x * 2, l, m);
    buildh(x * 2 + 1, m + 1, r);
    merge(th[x * 2].begin(), th[x * 2].end(), th[x * 2 + 1].begin(), th[x * 2 + 1].end(), back_inserter(th[x]));
}

int geth(int x, int l, int r, int A, int B, int low, int up){
    if(l > B || r < A) return 0;
    if(r <= B && l >= A) {
        return lower_bound(th[x].begin(), th[x].end(), up) - lower_bound(th[x].begin(), th[x].end(), low) + 1;
    }
    int m = (l + r) / 2;
    return geth(x * 2, l, m, A, B, low, up) + geth(x * 2 + 1, m + 1, r, A, B, low, up);
}

int main() {

    int n, m, q;
    cin >> n >> m >> q;

    map<int, set< int > > ver;
    map<int, set< int > > hor;

    vector< pair< pair<int, int>, pair<int, int> > > qs;
    vector< pair<int, int> > ks;

    for(int i = 0; i < q; i++){
        int number;
        cin >> number;
        switch(number){
            case 1:
                qhort.push_back(i);
                int r;
                cin >> r;
                qhor.push_back(r);
                h.emplace_back(r, i);
                hor[r].insert(i);
                break;
            case 2:
                int c;
                cin >> c;
                qver.push_back(c);
                qvert.push_back(i);
                v.emplace_back(c, i);
                ver[c].insert(i);
                break;
            case 3:
                int r1, c1, r2, c2, k;
                cin >> r1 >> c1 >> r2 >> c2 >> k;
                qs.push_back({{r1, c1}, {r2, c2}});
                ks.emplace_back(k, i);
        }
    }

    sort(h.begin(), h.end());
    sort(hsearch.begin(), hsearch.end());
    sort(v.begin(), v.end());
    sort(vsearch.begin(), vsearch.end());

    buildv(1, 1, maxn);
    buildqv(1, 1, maxn);
    buildh(1, 1, maxn);
    buildqh(1, 1, maxn);

    for(int i = 0; i < qs.size(); i++){

        if(ks[i].first > ks[i].second){
            cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
            continue;
        }

        int lower = ks[i].second - ks[i].first;
        int upper = ks[i].second;

        auto end1ver = ver[qs[i].C1].end();
        auto end1hor = hor[qs[i].R1].end();

        auto end2ver = ver[qs[i].C2].end();
        auto end2hor = hor[qs[i].R2].end();

        auto it1ver = lower_bound(ver[qs[i].C1].begin(), end1ver, lower);
        auto it1hor = lower_bound(hor[qs[i].R1].begin(), end1hor, lower);

        auto it2ver = lower_bound(ver[qs[i].C2].begin(), end2ver, lower);
        auto it2hor = lower_bound(hor[qs[i].R2].begin(), end2hor, lower);

        if(qs[i].C1 == qs[i].C2 && it1ver != end1ver && *it1ver < upper){
            cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
            continue;
        }

        if(qs[i].R1 == qs[i].R2 && it1hor != end1hor && *it1hor < upper){
            cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
            continue;
        }

        if((it1ver == end1ver || *it1ver > upper) && (it1hor == end1hor || *it1hor > upper)){
            cout << -1 << endl;
            continue;
        }

        if((it2ver == end2ver || *it2ver > upper) && (it2hor == end2hor || *it2hor > upper)){
            cout << -1 << endl;
            continue;
        }


        //Первый случай
        if(it1ver != end1ver && it2hor != end2hor && *it1ver < upper && *it2hor < upper || it1hor != end1hor && it2ver != end2ver && *it1hor < upper && *it2ver < upper){
            cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
            continue;
        }

        //Бинпоиск для других случаев

        if(it1ver != end1ver && *it1ver < upper){
            //Ищем горизонтальную прямую

            //int pos1 = lower_bound(h.begin(), h.end(), pair<int, int>(qs[i].R1, -1)) - h.begin();
            //int pos2 = lower_bound(h.begin(), h.end(), pair<int, int>(qs[i].R2, -1)) - h.begin();

            int p1 = lower_bound(qhort.begin(), qhort.end(), lower) - qhort.begin();
            int p2 = lower_bound(qhort.begin(), qhort.end(), upper) - qhort.begin();
            p2--;

            if(getqh(1, 1, maxn, p1, p2, min(qs[i].R1 + 1, qs[i].R2 + 1), max(qs[i].R1 - 1, qs[i].R2 - 1)) == abs(qs[i].R1 - qs[i].R2) - 1){
                cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
                continue;
            }

            int pos1 = lower_bound(hsearch.begin(), hsearch.end(), qs[i].R1) - hsearch.begin();
            int pos2 = lower_bound(hsearch.begin(), hsearch.end(), qs[i].R2) - hsearch.begin();

            int min1, min2, min3, min4;

            if(geth(1, 1, maxn, 1, pos1 + 1, lower, upper) == 0){
                min1 = 999999;
            }else{
                int l = 0, r = pos1;
                while(l != r){
                    int c = (l + r + 1) / 2;
                    if(geth(1, 1, maxn, c + 1, r + 1, lower, upper) != 0) l = c;
                    else r = c - 1;
                }
                min1 = abs(qs[i].C1 - qs[i].C2) + abs(qs[i].R1 - h[l].first) + abs(qs[i].R2 - h[l].first);
            }

            if(geth(1, 1, maxn, pos1 + 1, maxn, lower, upper) == 0){
                min2 = 999999;
            }else{
                int l = pos1, r = maxn - 1;
                while(l != r){
                    int c = (l + r) / 2;
                    if(geth(1, 1, maxn, l + 1, c + 1, lower, upper) != 0) r = c;
                    else l = c + 1;
                }
                min2 = abs(qs[i].C1 - qs[i].C2) + abs(qs[i].R1 - h[l].first) + abs(qs[i].R2 - h[l].first);
            }

            if(geth(1, 1, maxn, 1, pos2 + 1, lower, upper) == 0){
                min3 = 999999;
            }else{
                int l = 0, r = pos2;
                while(l != r){
                    int c = (l + r + 1) / 2;
                    if(geth(1, 1, maxn, c + 1, r + 1, lower, upper) != 0) l = c;
                    else r = c - 1;
                }
                min3 = abs(qs[i].C1 - qs[i].C2) + abs(qs[i].R1 - h[l].first) + abs(qs[i].R2 - h[l].first);
            }

            if(geth(1, 1, maxn, pos2 + 1, maxn, lower, upper) == 0){
                min4 = 999999;
            }else{
                int l = pos2, r = maxn - 1;
                while(l != r){
                    int c = (l + r) / 2;
                    if(geth(1, 1, maxn, l + 1, c + 1, lower, upper) != 0) r = c;
                    else l = c + 1;
                }
                min4 = abs(qs[i].C1 - qs[i].C2) + abs(qs[i].R1 - h[l].first) + abs(qs[i].R2 - h[l].first);
            }

            if(min(min(min1, min2), min(min3, min4)) == 999999){
                cout << -1 << endl;
                continue;
            }

            cout << min(min(min1, min2), min(min3, min4)) << endl;

        }else{
            //Ищем вертикальные прямые

            int p1 = lower_bound(qvert.begin(), qvert.end(), lower) - qvert.begin();
            int p2 = lower_bound(qvert.begin(), qvert.end(), upper) - qvert.begin();
            p2--;

            if(getqv(1, 1, maxn, p1, p2, min(qs[i].C1 + 1, qs[i].C2 + 1), max(qs[i].C1 - 1, qs[i].C2 - 1)) == abs(qs[i].C1 - qs[i].C2) - 1){
                cout << abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - qs[i].C2) << endl;
                continue;
            }

            int pos1 = lower_bound(vsearch.begin(), vsearch.end(), qs[i].C1) - vsearch.begin();
            int pos2 = lower_bound(vsearch.begin(), vsearch.end(), qs[i].C2) - vsearch.begin();

            int min1, min2, min3, min4;

            if(getv(1, 1, maxn, 1, pos1 + 1, lower, upper) == 0){
                min1 = 999999;
            }else{
                int l = 0, r = pos1;
                while(l != r){
                    int c = (l + r + 1) / 2;
                    if(getv(1, 1, maxn, c + 1, r + 1, lower, upper) != 0) l = c;
                    else r = c - 1;
                }
                min1 = abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - v[l].first) + abs(qs[i].C2 - v[l].first);
            }

            if(getv(1, 1, maxn, pos1 + 1, maxn, lower, upper) == 0){
                min2 = 999999;
            }else{
                int l = pos1, r = maxn - 1;
                while(l != r){
                    int c = (l + r) / 2;
                    if(getv(1, 1, maxn, l + 1, c + 1, lower, upper) != 0) r = c;
                    else l = c + 1;
                }
                min2 = abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - v[l].first) + abs(qs[i].C2 - v[l].first);
            }

            if(getv(1, 1, maxn, 1, pos2 + 1, lower, upper) == 0){
                min3 = 999999;
            }else{
                int l = 0, r = pos2;
                while(l != r){
                    int c = (l + r + 1) / 2;
                    if(getv(1, 1, maxn, c + 1, r + 1, lower, upper) != 0) l = c;
                    else r = c - 1;
                }
                min3 = abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - v[l].first) + abs(qs[i].C2 - v[l].first);
            }

            if(getv(1, 1, maxn, pos2 + 1, maxn, lower, upper) == 0){
                min4 = 999999;
            }else{
                int l = pos2, r = maxn - 1;
                while(l != r){
                    int c = (l + r) / 2;
                    if(getv(1, 1, maxn, l + 1, c + 1, lower, upper) != 0) r = c;
                    else l = c + 1;
                }
                min4 = abs(qs[i].R1 - qs[i].R2) + abs(qs[i].C1 - v[l].first) + abs(qs[i].C2 - v[l].first);
            }

            if(min(min(min1, min2), min(min3, min4)) == 999999){
                cout << -1 << endl;
                continue;
            }

            cout << min(min(min1, min2), min(min3, min4)) << endl;

        }

    }

    return 0;
}