#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>

#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef long double ld;

struct edge
{
	int to;
	ll w;
	edge() {}
	edge(int _to, ll _w)
	{
		to = _to;
		w = _w;
	}
};

int t, n, m, q, p;
vector <vector <edge>> gr;

bool check(int to, int w)
{
	int maw = p * w / (p - 1);
	set <int> s[5000];
	s[0].insert(0);
	for (int i = 1; i <= to; i++)
	{
		for (auto e : gr[i])
		{
			for (auto it = s[e.to].begin(); it != s[e.to].end() && *it + e.w <= maw; it++)
				s[i].insert(*it + e.w);
		}
	}
	auto it = s[to].lower_bound(w);
	return (it != s[to].end() && *it <= maw);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> t;
	while (t--)
	{
		cin >> n >> m >> q >> p;
		gr.clear();
		gr.resize(n);
		while (m--)
		{
			int v, u;
			ll d;
			cin >> v >> u >> d;
			gr[u - 1].pb(edge(v - 1, d));
		}
		while (q--)
		{
			int f, r;
			cin >> f >> r;
			cout << check(f - 1, r);
		}
		cout << '\n';
	}
	return 0;
}