#include <iostream>
#include <vector>
#include <set>

struct Line {
    int L, R;
};

struct Tree {
    Tree *left, *right;
    int L, R;
    int val;
};

void BuildTree(Tree *root, int l, int r);
void Add(Tree *root, int l, int r, int target);
int Get(Tree *root, int i);

int main(void) {
    int m = 0, n = 0;
    std::cin >> m >> n;
    int *a = new int[m];
    for (int i = 0; i < m; i++) {
        std::cin >> a[i];
        a[i]--;
    }
    Line *l = new Line[n];
    for (int i = 0; i < n; i++)
        l[i].L = l[i].R = -1;

    for (int i = 0; i < m; i++) {
        if (l[a[i]].L == -1)
            l[a[i]].L = i;
        l[a[i]].R = i;
    }

    int k = 0;
    std::vector < std::set <int> > lenght(m);
    for (int i = 0; i < m; i++)
        lenght[i].clear();
    for (int i = 0; i < n; i++)
        if (l[i].L >= 0) {
            lenght[l[i].R - l[i].L].insert(i);
            k++;
        }

    Tree *root = new Tree;
    BuildTree(root, 0, m - 1);
    for (int i = m - 1; i >= 0; i--) {
        for (std::set<int>::iterator it = lenght[i].begin(); it != lenght[i].end(); it++)
            Add(root, l[*it].L, l[*it].R, *it);
    }

    for (int i = 0; i < m; i++)
        if (a[i] != Get(root, i)) {
            std::cout << -1;
            return 0;
        }
    // else
    std::cout << k << std::endl;
    for (int i = m - 1; i >= 0; i--) {
        for (std::set<int>::iterator it = lenght[i].begin(); it != lenght[i].end(); it++)
            std::cout << (*it) + 1 << " " << l[*it].L + 1 << " " << l[*it].R + 1 << "\n";
    }
    return 0;
}

void BuildTree(Tree *root, int l, int r) {
    root->L = l; root->R = r;
    root->val = -1;
    if (l != r) {
        root->left = new Tree;
        BuildTree(root->left, l, (l + r) / 2);
        root->right = new Tree;
        BuildTree(root->right, (l + r) / 2 + 1, r);
    }
    else
        root->left = root->right = NULL;
}

void Add(Tree *root, int l, int r, int target) {
    if (l <= root->L && root->R <= r) {
        root->val = target;
        return;
    }
    if (root->val >= 0) {
        root->left->val = root->right->val = root->val;
        root->val = -1;
    }
    if (l <= (root->L + root->R) / 2)
        Add(root->left, l, r, target);
    if (r >= (root->L + root->R) / 2 + 1)
        Add(root->right, l, r, target);
}

int Get(Tree *root, int i) {
    if (root->val >= 0)
        return root->val;

    if (i <= (root->L + root->R) / 2)
        return Get(root->left, i);
    else
        return Get(root->right, i);
}
