#include <iostream>
#include <vector>
#include <queue>

int Drive(int r1, int c1, int r2, int c2, int kRes, std::vector < std::vector <int> > &field, int n, int m);

int main(void) {
    int n = 0, m = 0, q = 0;
    std::cin >> n >> m >> q;
    std::vector < std::vector <int> > field(n);
    for (int i = 0; i < n; i++) {
        field[i].clear();
        for (int j = 0; j < m; j++)
            field[i].push_back(0);
    }
    for (int globalLevel = 1; globalLevel <= q; globalLevel++) {
        int type = 0;
        int r1 = 0, r2 = 0, c1 = 0, c2 = 0, k = 0;
        std::cin >> type;
        if (type == 1) {
            std::cin >> r1;
            r1--;
            for (int i = 0; i < m; i++)
                field[r1][i] = -globalLevel;
        }
        else if (type == 2) {
            std::cin >> c1;
            c1--;
            for (int i = 0; i < n; i++)
                field[i][c1] = -globalLevel;
        }
        else { // if (type == 3)
            std::cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            std::cout << Drive(r1, c1, r2, c2, k - globalLevel, field, n, m) << "\n";
        }
    }
    return 0;
}

int Drive(int r1, int c1, int r2, int c2, int kRes, std::vector < std::vector <int> > &field, int n, int m) {
    if (field[r1][c1] > kRes || field[r2][c2] > kRes)
        return -1;

    bool **used = new bool *[n];
    for (int i = 0; i < n; i++) {
        used[i] = new bool[m];
        for (int j = 0; j < m; j++)
            used[i][j] = 0;
    }

    std::queue <int> bfsX;
    std::queue <int> bfsY;
    std::queue <int> bfsStep;
    bfsX.push(c1);
    bfsY.push(r1);
    bfsStep.push(0);
    while (!bfsX.empty()) {
        int x = bfsX.front();
        int y = bfsY.front();
        int step = bfsStep.front();
        bfsX.pop(); bfsY.pop(); bfsStep.pop();
        if (x == c2 && y == r2)
            return step;
        step++;
        used[y][x] = 1;
        if (x > 0 && field[y][x - 1] <= kRes && !used[y][x - 1]) {
            bfsX.push(x - 1);
            bfsY.push(y);
            bfsStep.push(step);
        }
        if (x < m - 1 && field[y][x + 1] <= kRes && !used[y][x + 1]) {
            bfsX.push(x + 1);
            bfsY.push(y);
            bfsStep.push(step);
        }
        if (y > 0 && field[y - 1][x] <= kRes && !used[y - 1][x]) {
            bfsX.push(x);
            bfsY.push(y - 1);
            bfsStep.push(step);
        }
        if (y < n - 1 && field[y + 1][x] <= kRes && !used[y + 1][x]) {
            bfsX.push(x);
            bfsY.push(y + 1);
            bfsStep.push(step);
        }
    }
    return -1; // no way found
}
