#include <iostream>
#include <vector>
#include <set>

const long long INF = 2 * 100000000000000000 + 1;

int main(void) {
    int t = 0;
    std::cin >> t;
    for (int testId = 0; testId < t; testId++) {
        long long n = 0, m = 0, q = 0, p = 0;
        std::cin >> n >> m >> q >> p;

        std::vector < std::set <long long> > ways(n);
        std::vector < std::vector <long long> > graph(n);
        std::vector < std::vector <long long> > cost(n);
        for (int i = 0; i < m; i++) {
            long long v = 0, u = 0, d = 0;
            std::cin >> v >> u >> d;
            v--; u--;
            graph[u].push_back(v);
            cost[u].push_back(d);
        }

        long long *f = new long long[q], *r = new long long[q];
        long long rMax = 0;
        for (int i = 0; i < q; i++) {
            long long fCur = 0, rCur = 0;
            std::cin >> fCur >> rCur;
            fCur--;
            if (rCur > rMax)
                rMax = rCur;
            f[i] = fCur; r[i] = rCur;
        }

        long long wayMax = rMax * p / (p - 1) + ((rMax * p) % (p - 1) != 0);

        ways[0].insert(0);
        for (int i = 1; i < n; i++)
            ways[i].insert(wayMax + 1);

        for (int i = 1; i < n; i++)
            for (unsigned int j = 0; j < graph[i].size(); j++)
                for (std::set <long long>::iterator it = ways[graph[i][j]].begin(); it != ways[graph[i][j]].end(); it++)
                    if (*it + cost[i][j] <= wayMax)
                        ways[i].insert(*it + cost[i][j]);

        bool *success = new bool[n];
        for (int i = 0; i < n; i++)
            success[i] = 0;
        for (int i = 1; i < n; i++){
            for (std::set <long long>::iterator it = ways[i].begin(); it != ways[i].end(); it++)
                if (r[0] <= (*it) && (*it) * (p - 1) <= r[0] * p) {
                    success[i] = 1;
                    break;
                }
        }
        std::string ans = "";
        for (int i = 0; i < q; i++) {
            if (!success[i])
                ans += "0";
            else
                ans += "1";
        }

        delete[] f;
        delete[] r;
        std::cout << ans << std::endl;
    }
    return 0;
}

/*include <iostream>
#include <vector>
#include <set>

const long long INF = 2 * 100000000000000000 + 1;

int main(void) {
    int t = 0;
    std::cin >> t;
    for (int testId = 0; testId < t; testId++) {
        long long n = 0, m = 0, q = 0, p = 0;
        std::cin >> n >> m >> q >> p;

        std::vector < std::set <long long> > ways(n);
        std::vector < std::vector <long long> > graph(n);
        std::vector < std::vector <long long> > cost(n);
        for (int i = 0; i < m; i++) {
            long long v = 0, u = 0, d = 0;
            std::cin >> v >> u >> d;
            v--; u--;
            graph[u].push_back(v);
            cost[u].push_back(d);
        }

        long long *f = new long long[q], *r = new long long[q];
        long long rMax = 0;
        for (int i = 0; i < q; i++) {
            long long fCur = 0, rCur = 0;
            std::cin >> fCur >> rCur;
            fCur--;
            if (rCur > rMax)
                rMax = rCur;
            f[i] = fCur; r[i] = rCur;
        }

        long long wayMax = rMax * p / (p - 1) + ((rMax * p) % (p - 1) != 0);

        ways[0].insert(0);
        for (int i = 1; i < n; i++)
            ways[i].insert(wayMax + 1);

        for (int i = 1; i < n; i++)
            for (unsigned int j = 0; j < graph[i].size(); j++)
                for (std::set <long long>::iterator it = ways[graph[i][j]].begin(); it != ways[graph[i][j]].end(); it++)
                    if (*it + cost[i][j] <= wayMax)
                        ways[i].insert(*it + cost[i][j]);

        std::string ans = "";
        for (int i = 0; i < q; i++) {
            bool success = 0;
            for (std::set <long long>::iterator it = ways[f[i]].begin(); it != ways[f[i]].end(); it++)
                if (r[i] <= (*it) && (*it) * (p - 1) <= r[i] * p) {
                    success = 1;
                    ans += "1";
                    break;
                }
            if (!success)
                ans += "0";
        }

        delete[] f;
        delete[] r;
        std::cout << ans << std::endl;
    }
    return 0;
}*/
