#include <iostream>
#include <vector>
#include <set>

const long long INF = 1e18;

int main(void) {
    int t = 0;
    std::cin >> t;
    for (int testId = 0; testId < t; testId++) {
        long long n = 0, m = 0, q = 0, p = 0;
        std::cin >> n >> m >> q >> p;
        std::vector < std::set <long long> > ways(n);
        std::vector < std::vector <long long> > graph(n);
        std::vector < std::vector <long long> > cost(n);
        for (int i = 0; i < m; i++) {
            long long v = 0, u = 0, d = 0;
            std::cin >> v >> u >> d;
            v--; u--;
            graph[u].push_back(v);
            cost[u].push_back(d);
        }

        ways[0].insert(0);
        for (int i = 1; i < n; i++)
            ways[i].insert(INF);

        for (int i = 1; i < n; i++)
            for (unsigned int j = 0; j < graph[i].size(); j++)
                for (std::set <long long>::iterator it = ways[graph[i][j]].begin(); it != ways[graph[i][j]].end(); it++)
                    if (*it + cost[i][j] <= 100000)
                        ways[i].insert(*it + cost[i][j]);

        std::string ans = "";
        for (int i = 0; i < q; i++) {
            long long f = 0, r = 0;
            bool success = 0;
            std::cin >> f >> r;
            f--;
            for (std::set <long long>::iterator it = ways[f].begin(); it != ways[f].end(); it++)
                if (r <= (*it) && (*it) * (p - 1) <= r * p) {
                    success = 1;
                    ans += "1";
                    break;
                }
            if (!success)
                ans += "0";
        }

        std::cout << ans << std::endl;
    }
    return 0;
}
