#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stdio.h>
#include <math.h>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i,n) for(int i=0;i<n;i++)
#define ll long long
#define ld long double
#define pii pair<int,int>
#define mp make_pair

using namespace std;


struct node {
	int l, r;
	int mx, mn;
	node*left = NULL, *right = NULL;
	node() {};
	node(int l, int r, int mx = 0) :mx(mx), mn(mx), l(l), r(r) {};
};

void recalc(node*a) {
	if (a->left == NULL) {
		return;
	}
	a->mx = max(a->left->mx, a->right->mx);
	a->mn = min(a->left->mn, a->right->mn);
}

void build_tree(node*a) {
	if (a->r - a->l == 1)return;
	int m = (a->r + a->l) / 2;
	a->left = new node(a->l, m);
	build_tree(a->left);
	a->right = new node(m, a->r);
	build_tree(a->right);
}

void add(node*a, int x, int n) {
	if (a->l > x || a->r <= x) {
		return;
	}
	if (a->l == x && a->r == x + 1) {
		a->mx = n;
		a->mn = n;
		return;
	}
	add(a->left, x, n);
	add(a->right, x, n);
	recalc(a);
}

int get(node* a, int l, int r) {
	if (a->l >= r || a->r <= l) {
		return 0;
	}
	if (a->l >= l && a->r <= r) {
		return a->mx;
	}
	return max(get(a->left, l, r), get(a->right, l, r));
}

int get_mn(node* a, int l, int r) {
	if (a->l >= r || a->r <= l) {
		return 0;
	}
	if (a->l >= l && a->r <= r) {
		return a->mn;
	}
	return min(get_mn(a->left, l, r), get_mn(a->right, l, r));
}

int to_l(node*a, int l, int r, int n) {
	if (a->mx < n)return -1;
	if (a->l >= r || a->r <= l) {
		return -1;
	}
	if (a->r - a->l == 1) {
		return a->l;
	}
	int ans = to_l(a->left, l, r, n);
	if (ans != -1)return ans;
	return to_l(a->right, l, r, n);
}

int to_r(node*a, int l, int r, int n) {
	if (a->mx < n)return -1;
	if (a->l >= r || a->r <= l) {
		return -1;
	}
	if (a->r - a->l == 1) {
		return a->l;
	}
	int ans = to_r(a->right, l, r, n);
	if (ans != -1)return ans;
	return to_r(a->left, l, r, n);
}


int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int>h_val(n, 0), w_val(m, 0);
	node*h = new node(0, n), *w = new node(0, m);
	build_tree(h);
	build_tree(w);
	forn(i, q + 1)if (i > 0) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			--x;
			h_val[x] = i;
			add(h, x, i);
		}
		else if (t == 2) {
			int x;
			cin >> x;
			--x;
			w_val[x] = i;
			add(w, x, i);
		}
		else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			--x1;
			--y1;
			--x2;
			--y2;
			int d = i - k;
			int ac = abs(x1 - x2) + abs(y1 - y2);
			if (h_val[x1] < d && w_val[y1] < d) {
				cout << -1 << '\n';
				continue;
			}
			if (h_val[x2] < d && w_val[y2] < d) {
				cout << -1 << '\n';
				continue;
			}
			if (h_val[x1] >= d && w_val[y2] >= d) {
				cout << ac << '\n';
				continue;
			}
			if (h_val[x2] >= d && w_val[y1] >= d) {
				cout << ac << '\n';
				continue;
			}
			if (h_val[x1] >= d) {
				if (abs(x1 - x2) <= 1) {
					cout << ac << '\n';
					continue;
				}
				int l = min(y1, y2);
				int r = max(y1, y2);
				int g = 0;
				for (int j = l; j < r; j++)g = max(g, w_val[j]);
				if (get(w, l, r) >= d) {
					cout << ac << '\n';
					continue;
				}
				g = d;
				for (int j = min(x1,x2); j < max(x1,x2); j++)g = min(g, h_val[j]);
				if (get_mn(h, min(x1, x2), max(x1, x2)) >= d) {
					cout << ac << '\n';
					continue;
				}
				int ans = m + 1;
				int idl = -1;
				for (int j = l; j >= 0; j--)if (w_val[j] >= d) {
					idl = j;
					break;
				}
				if (idl != -1)ans = l - idl;
				idl = -1;
				for (int j = r; j < m; j++)if (w_val[j] >= d) {
					idl = j;
					break;
				}
				int idr = idl;
				if (idr != -1) {
					ans = min(ans, idr - r);
				}
				if (ans == m + 1) {
					cout << -1 << '\n';
					continue;
				}
				cout << ac + 2 * ans << '\n';
				continue;
			}
			if (abs(y1 - y2) <= 1) {
				cout << ac << '\n';
				continue;
			}
			int l = min(x1, x2);
			int r = max(x1, x2);
			int g = 0;
			for (int j = l; j < r; j++)g = max(g, h_val[j]);
			if (g >= d) {
				cout << ac << '\n';
				continue;
			}
			g = d;
			for (int j = min(y1, y2); j < max(y1, y2); j++)g = min(g, w_val[j]);
			if (g >= d) {
				cout << ac << '\n';
				continue;
			}
			int ans = n + 1;
			int idl = -1;
			for (int j = l; j >= 0; j--)if (h_val[j] >= d) {
				idl = j;
				break;
			}
			if (idl != -1)ans = l - idl;
			idl = -1;
			for (int j = r; j < n; j++)if (h_val[j] >= d) {
				idl = j;
				break;
			}
			int idr = idl;
			if (idr != -1) {
				ans = min(ans, idr - r);
			}
			if (ans == n + 1) {
				cout << -1 << '\n';
				continue;
			}
			cout << ac + 2 * ans << '\n';
			continue;
		}
	}
}