#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define pb push_back
#define kek pop_back
#define all(v) v.begin(), v.end()
#define len(v) ((int)(v).size())
#define pii pair<int, int>
#define mp make_pair

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const int INF = 1e18 + 666;

void run();

signed main() {
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}

struct MinSegTree {
	vector<int> tree;
	int n;

	MinSegTree(int sz) : n(sz) {
		while (n & (n - 1)) {
			++n;
		}
		tree.resize(2 * n - 1, 0);
	}

	void update(int idx, int v) {
		idx += n - 1;
		tree[idx] = v;
		while (idx > 0) {
			idx = (idx - 1) >> 1;
			tree[idx] = min(tree[2 * idx + 1], tree[2 * idx + 2]);
		}
	}

	int rquery(int v, int tl, int tr, int l, int val) {
		if (tr <= l) {
			return -1;
		}
		if (tree[v] > val) {
			return -1;
		}
		if (tr - tl == 1) {
			return tl;
		}
		int mid = (tl + tr) >> 1;
		int a1 = rquery(2 * v + 1, tl, mid, l, val);
		if (a1 != -1) {
			return a1;
		}
		return rquery(2 * v + 2, mid, tr, l, val);
	}

	int lquery(int v, int tl, int tr, int r, int val) {
		if (tl > r) {
			return -1;
		}
		if (tree[v] > val) {
			return -1;
		}
		if (tr - tl == 1) {
			return tl;
		}
		int mid = (tl + tr) >> 1;
		int a1 = lquery(2 * v + 2, mid, tr, r, val);
		if (a1 != -1) {
			return a1;
		}
		return lquery(2 * v + 1, tl, mid, r, val);
	}

	int lquery(int r, int v) {
		return lquery(0, 0, n, r, v);
	}

	int rquery(int l, int v) {
		return rquery(0, 0, n, l, v);
	}
	// vector<int> arr;
	
	// MinSegTree(int n) : arr(n, 0) {}

	// void update(int idx, int val) {
	// 	arr[idx] = val;
	// }

	// int lquery(int idx, int val) {
	// 	for (int i = idx; i > -1; --i) {
	// 		if (arr[i] <= val) {
	// 			return i;
	// 		}
	// 	}
	// 	return -1;
	// }

	// int rquery(int idx, int val) {
	// 	for (int i = idx; i < len(arr); ++i) {
	// 		if (arr[i] <= val) {
	// 			return i;
	// 		}
	// 	}
	// 	return -1;
	// }
};

struct MaxSegTree {
	vector<int> tree;
	int n;

	MaxSegTree(int sz) : n(sz) {
		while (n & (n - 1)) {
			++n;
		}
		tree.resize(2 * n - 1, 0);
	}

	void update(int idx, int v) {
		idx += n - 1;
		tree[idx] = v;
		while (idx > 0) {
			idx = (idx - 1) >> 1;
			tree[idx] = max(tree[2 * idx + 1], tree[2 * idx + 2]);
		}
	}

	int query(int v, int tl, int tr, int l, int r) {
		if (l >= tr || tl >= r) {
			return -INF;
		}
		if (l <= tl && r >= tr) {
			return tree[v];
		}
		int mid = (tl + tr) >> 1;
		return max(query(2 * v + 1, tl, mid, l, r), query(2 * v + 2, mid, tr, l, r));
	}

	int query(int l, int r) {
		return query(0, 0, n, l, r);
	}
};

void run() {
	int n, m, q;
	cin >> n >> m >> q;
	MinSegTree mn_row(n), mn_col(m);
	MaxSegTree mx_row(n), mx_col(m);
	vector<int> rpaint(n, 0), cpaint(m, 0);
	for (int i = 1; i <= q; ++i) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int r;
			cin >> r;
			--r;
			mn_row.update(r, -i);
			mx_row.update(r, -i);
			rpaint[r] = -i;
		}
		if (tp == 2) {
			int c;
			cin >> c;
			--c;
			mn_col.update(c, -i);
			mx_col.update(c, -i);
			cpaint[c] = -i;
		}
		if (tp == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --c1, --r2, --c2;
			k -= i;
			if (mx_row.query(min(r1, r2), max(r1, r2) + 1) <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				continue;
			}
			if (mx_col.query(min(c1, c2), max(c1, c2) + 1) <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				continue;
			}
			if ((cpaint[c1] <= k && rpaint[r2] <= k) || (cpaint[c2] <= k && rpaint[r1] <= k)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				continue;
			}
			if (cpaint[c1] <= k && cpaint[c2] <= k) {
				int ans = INF;
				int cl = mn_row.lquery(r1, k), cr = mn_row.rquery(r1, k);
				if (cl != -1) {
					cmin(ans, r1 - cl + abs(c1 - c2) + abs(r2 - cl));
				}
				if (cr != -1) {
					cmin(ans, cr - r1 + abs(c1 - c2) + abs(r2 - cr));
				}
				if (ans != INF) {
					cout << ans << endl;
					continue;
				}
			}
			if (rpaint[r1] <= k && rpaint[r2] <= k) {
				int ans = INF;
				int cl = mn_col.lquery(c1, k), cr = mn_col.rquery(c1, k);
				if (cl != -1) {
					cmin(ans, c1 - cl + abs(r1 - r2) + abs(c2 - cl));
				}
				if (cr != -1) {
					cmin(ans, cr - c1 + abs(r1 - r2) + abs(c2 - cr));
				}
				if (ans != INF) {
					cout << ans << endl;
					continue;
				}
			}
			cout << -1 << endl;
		}
	}
}