#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n, m;
int maxr[MAXN];
int val[MAXN];
vector<int> all[MAXN];

vector<int> ans;
vector<pair<int, int>> res;

void process(int l, int r) {
	if (r < l) {
		return;
	}
	int border = maxr[val[l]];
	if (border > r) {
		cout << "-1\n";
		exit(0);
	}
	res.emplace_back(l, border);
	ans.push_back(val[l]);
	for (int i = 0; i + 1 < all[val[l]].size(); i++) {
		process(all[val[l]][i] + 1, all[val[l]][i + 1] - 1);
	}
	if (border != r) {
		process(border + 1, r);
	}
}

void init() {
	memset(maxr, -1, sizeof(maxr));
}

void solve() {
	init();
	for (int i = 0; i < n; i++) {
		cin >> val[i];
		val[i]--;
		all[val[i]].push_back(i);
		maxr[val[i]] = i;
	}
	process(0, n - 1);
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] + 1 << ' ' << res[i].first + 1 << ' ' << res[i].second + 1 << '\n';
	}
	cout << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("A.in", "r", stdin);
		freopen("A.out", "w", stdout);
	#else

	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m) {
		solve();
	}
	return 0;
}