#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 1e6 + 3;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n, m, q;

int w[MAXN];
int h[MAXN];

struct segtree {
	int mx = 0, mn = 0;
};

segtree t[2][4 * MAXN];

void upd(int v, int tl, int tr, int pos, int x, int tp) {
	if (tl == tr) {
		t[tp][v].mx = x;
		t[tp][v].mn = x;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos <= tm) {
		upd(2 * v, tl, tm, pos, x, tp);
	}
	else {
		upd(2 * v + 1, tm + 1, tr, pos, x, tp);
	}
	t[tp][v].mx = max(t[tp][2 * v].mx, t[tp][2 * v + 1].mx);
	t[tp][v].mn = min(t[tp][2 * v].mn, t[tp][2 * v + 1].mn);
}

int get_min(int v, int tl, int tr, int l, int r, int tp) {
	if (tl > r || l > tr) {
		return INF;
	}
	if (l <= tl && tr <= r) {
		return t[tp][v].mn;
	}
	int tm = (tl + tr) >> 1;
	return min(get_min(2 * v, tl, tm, l, r, tp), get_min(2 * v + 1, tm + 1, tr, l, r, tp));
}

int get_max(int v, int tl, int tr, int l, int r, int tp) {
	if (tl > r || l > tr) {
		return -INF;
	}
	if (l <= tl && tr <= r) {
		return t[tp][v].mx;
	}
	int tm = (tl + tr) >> 1;
	return max(get_max(2 * v, tl, tm, l, r, tp), get_max(2 * v + 1, tm + 1, tr, l, r, tp));
}

void init() {

}

void solve() {
	init();
	for (int i = 1; i <= q; i++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int x;
			cin >> x;
			x--;
			w[x] = -i;
			upd(1, 0, MAXN - 1, x, -i, 0);
		}
		if (tp == 2) {
			int x;
			cin >> x;
			x--;
			h[x] = -i;
			upd(1, 0, MAXN - 1, x, -i, 1);
		}
		if (tp == 3) {
			int a, b, c, d, k;
			cin >> a >> b >> c >> d >> k;
			a--, b--, c--, d--;
			bool ok_w_a = w[a] + i <= k;
			bool ok_h_a = h[b] + i <= k;
			bool ok_w_b = w[c] + i <= k;
			bool ok_h_b = h[d] + i <= k;
			cerr << a << ' ' << b << ' ' << c << ' ' << d << '\n';
			cerr << ok_w_a << ' ' << ok_h_a << ' ' << ok_w_b << ' ' << ok_h_b << '\n' << '\n';			
			if (ok_h_b && ok_w_a) {
				cout << abs(c - a) + abs(b - d) << '\n';
				continue;
			}
			if (ok_h_a && ok_w_b) {
				cout << abs(c - a) + abs(b - d) << '\n';
				continue;
			}
			if (a == c && ok_w_a) {
				cout << abs(b - d) + abs(a - c) << '\n';
				continue;
			}
			if (b == d && ok_h_a) {
				cout << abs(b - d) + abs(a - c) << '\n';
				continue;
			}
			int ans = INF;
			if (ok_h_a && ok_h_b) {
				if (get_min(1, 0, MAXN - 1, min(a, c), max(a, c), 0) + i <= k) {
					ans = abs(b - d) + abs(a - c);
				}
				if (get_max(1, 0, MAXN - 1, min(b, d), max(b, d), 1) + i <= k) {
					ans = abs(b - d) + abs(a - c);
				}
				{
					int l = -1;
					int r = min(a, c) + 1;
					while (l + 1 < r) {
						int mid = (l + r) >> 1;
						if (get_min(1, 0, MAXN - 1, mid, min(a, c), 0) + i <= k) {
							l = mid;
						}
						else {
							r = mid;
						}
					}
					if (l != -1) {
						ans = min(ans, abs(l - a) + abs(l - c) + abs(b - d));
					}
				}
				{
					int l = max(a, c) - 1;
					int r = n;
					while (l + 1 < r) {
						int mid = (l + r) >> 1;
						if (get_min(1, 0, MAXN - 1, max(a, c), n - 1, 0) + i <= k) {
							r = mid;
						}
						else {
							l = mid;
						}
					}
					if (r != n) {
						ans = min(ans, abs(r - a) + abs(r - c) + abs(b - d));
					}
				}

			}
			if (ok_w_a && ok_w_b) {
				if (get_min(1, 0, MAXN - 1, min(b, d), max(b, d), 1) + i <= k) {
					ans = abs(b - d) + abs(a - c);
				}
				if (get_max(1, 0, MAXN - 1, min(a, c), max(a, c), 0) + i <= k) {
					ans = abs(b - d) + abs(a - c);
				}
				{
					int l = -1;
					int r = min(b, d) + 1;
					while (l + 1 < r) {
						int mid = (l + r) >> 1;
						if (get_min(1, 0, MAXN - 1, mid, min(b, d), 1) + i <= k) {
							l = mid;
						}
						else {
							r = mid;
						}
					}
					if (l != -1) {
						ans = min(ans, abs(l - b) + abs(l - d) + abs(a - c));
					}
				}
				{
					int l = max(b, d) - 1;
					int r = m;
					while (l + 1 < r) {
						int mid = (l + r) >> 1;
						if (get_min(1, 0, MAXN - 1, max(b, d), m - 1, 1) + i <= k) {
							r = mid;
						}
						else {
							l = mid;
						}
					}
					if (r != m) {
						ans = min(ans, abs(r - b) + abs(r - d) + abs(a - c));
					}
				}
			}
			if (ans != INF) {
				cout << ans << '\n';
			}
			else {
				cout << "-1\n";
			}
		}
	}
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#else

	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> q){
		solve();
	}
	return 0;
}