#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>
 
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
 
#ifdef DEBUG
    const int MAXN = 6e5;
    const int MAXLOG = 4;
    const int MAXSQRT = 4;
#else
    const int MAXN = 6e5;
    const int MAXLOG = 20;
    const int MAXSQRT = 400;
    #define cerr if (false) cerr
#endif
 
mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;
 
int n;
int maxp;
int dp[MAXN];
int opt[MAXN];

vector<int> get(int mask) {
	vector<int> ret;
	for (int i = 0; i < n; i++) {
		ret.push_back(mask % 3);
		mask /= 3;
	}
	return ret;
}

int from(vector<int> mask) {
	int ret = 0;
	for (int i = n - 1; i >= 0; i--) {
		ret *= 3;
		ret += mask[i]; 
	}
	return ret;
}

void init() {
	for (int i = 0; i < MAXN; i++) {
		dp[i] = INF;
		opt[i] = -1;
	}
	int tpow = 1;
	for (int i = 0; i < n; i++) {
		tpow *= 3;
	}
	for (int mask = tpow - 1; mask >= 0; mask--) {
		vector<int> lel = get(mask);
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (lel[i] == 2) {
				cnt++;
			}
		}
		if (cnt == n - 1) {
			dp[mask] = 0;
			for (int i = 0; i < n; i++) {
				if (lel[i] != 2) {
					opt[mask] = i;
				}
			}
		}
		for (int i = 0; i < n; i++) {
			vector<int> nx = lel;
			for (int j = 0; j < i; j++) {
				nx[j]++;
				nx[j] = min(nx[j], 2);
			}
			int a = dp[from(nx)];
			nx = lel;
			for (int j = i; j < n; j++) {
				nx[j]++;
				nx[j] = min(nx[j], 2);
			}
			int b = dp[from(nx)];
			if (dp[mask] > 1 + max(a,b)) {
				dp[mask] = 1 + max(a, b);
				opt[mask] = i;
			}
		}
	}
}
 
void solve() {
	vector<int> cur(n);
	while (dp[from(cur)] != 0) {
		int e = opt[from(cur)];
		cout << "? " << e + 1 << endl;
		string x;
		cin >> x;
		if (x == "Yes") {
			for (int i = 0; i < e; i++) {
				cur[i]++;
				cur[i] = min(cur[i], 2);
			}
		}
		else {
			for (int i = e; i < n; i++) {
				cur[i]++;
				cur[i] = min(cur[i], 2);
			}
		}
	}
	cout << "! " << opt[from(cur)] + 1 << endl;
	string s;
	cin >> s;
	if (s == "Done") {
		exit(0);
	}
}
 
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    init();
    while (1) 
        solve();
    return 0;
}