#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
#define int ll

#define endl '\n'
#define getchar getchar_unlocked
#define putchar putchar_unlocked

int readint() {
	char c = getchar();
	while (c <= 32)
		c = getchar();
	int ans = 0;
	while (c >= '0' && c <= '9')
		ans = ans * 10 + c - '0', c = getchar();
	return ans;
}

void writeint(int a) {
	char c[20];
	int n = 0;
	while (a > 0 || !n)
		c[n++] = a % 10 + '0', a /= 10;
	while (n--)
		putchar(c[n]);
}

const ll INF = 1000000000;

const ll N = 1000010;

int Timer = 1;
int tupdr[N], tupdc[N];
int n, m, q, k;
pair < int, int > treer[N * 4], treec[N * 4];

bool ok(int x, int k, int type) {
	if (type == 0)
		return Timer - tupdr[x] <= k;
	else
		return Timer - tupdc[x] <= k;
}

int rget_min(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r)
		return treer[v].first;
	if (tl > r || tr < l)
		return INF;
	int mid = (tl + tr) >> 1;
	return min(rget_min(v * 2 + 1, tl, mid, l, r), rget_min(v * 2 + 2, mid + 1, tr, l, r));
}

int rget_max(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r)
		return treer[v].second;
	if (tl > r || tr < l)
		return -INF;
	int mid = (tl + tr) >> 1;
	return max(rget_max(v * 2 + 1, tl, mid, l, r), rget_max(v * 2 + 2, mid + 1, tr, l, r));
}

int cget_min(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r)
		return treec[v].first;
	if (tl > r || tr < l)
		return INF;
	int mid = (tl + tr) >> 1;
	return min(cget_min(v * 2 + 1, tl, mid, l, r), cget_min(v * 2 + 2, mid + 1, tr, l, r));
}

int cget_max(int v, int tl, int tr, int l, int r) {
	if (tl >= l && tr <= r)
		return treec[v].second;
	if (tl > r || tr < l)
		return -INF;
	int mid = (tl + tr) >> 1;
	return max(cget_max(v * 2 + 1, tl, mid, l, r), cget_max(v * 2 + 2, mid + 1, tr, l, r));
}

void updr(int v, int tl, int tr, int ind) {
	if (tl > ind || tr < ind)
		return;
	if (tl == ind && tr == ind) {
		treer[v].first = treer[v].second = Timer;
		return;
	}
	int mid = (tl + tr) >> 1;
	updr(v * 2 + 1, tl, mid, ind);
	updr(v * 2 + 2, mid + 1, tr, ind);
	treer[v].first = min(treer[v * 2 + 1].first, treer[v * 2 + 2].first);
	treer[v].second = max(treer[v * 2 + 1].second, treer[v * 2 + 2].second);
}

void updc(int v, int tl, int tr, int ind) {
	if (tl > ind || tr < ind)
		return;
	if (tl == ind && tr == ind) {
		treec[v].first = treec[v].second = Timer;
		return;
	}
	int mid = (tl + tr) >> 1;
	updc(v * 2 + 1, tl, mid, ind);
	updc(v * 2 + 2, mid + 1, tr, ind);
	treec[v].first = min(treec[v * 2 + 1].first, treec[v * 2 + 2].first);
	treec[v].second = max(treec[v * 2 + 1].second, treec[v * 2 + 2].second);
}

int rget_min(int l, int r) {
	return rget_min(0, 0, n - 1, l, r);
}

int rget_max(int l, int r) {
	return rget_max(0, 0, n - 1, l, r);
}

int cget_min(int l, int r) {
	return cget_min(0, 0, m - 1, l, r);
}

int cget_max(int l, int r) {
	return cget_max(0, 0, m - 1, l, r);
}

void updr(int ind) {
	updr(0, 0, n - 1, ind);
}

void updc(int ind) {
	updc(0, 0, m - 1, ind);
}

int binpc(int l, int r, bool up) {
	int tl = l, tr = r;
	--l, ++r;
	if (up) {
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (cget_max(tl, mid) >= Timer - k) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (r == tr + 1)
			return INF;
		else
			return r;
	}
	else {
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (cget_max(mid, tr) >= Timer - k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (l == tl - 1)
			return INF;
		else
			return l;
	}
}

int binpr(int l, int r, bool up) {
	int tl = l, tr = r;
	--l, ++r;
	if (up) {
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (rget_max(tl, mid) >= Timer - k) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (r == tr + 1)
			return INF;
		else
			return r;
	}
	else {
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (rget_max(mid, tr) >= Timer - k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (l == tl - 1)
			return INF;
		else
			return l;
	}
}

#undef int

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
#define int long long
	//cin >> n >> m >> q;
	n = readint(), m = readint(), q = readint();
	while (q--) {
		int type;
		//cin >> type;
		type = readint();
		if (type == 1) {
			int r;
			//cin >> r;
			r = readint();
			--r;
			tupdr[r] = Timer;
			updr(r);
		}
		else if (type == 2) {
			int c;
			//cin >> c;
			c = readint();
			--c;
			tupdc[c] = Timer;
			updc(c);
		}
		else {
			int r1, c1, r2, c2;
			r1 = readint();
			c1 = readint();
			r2 = readint();
			c2 = readint();
			k = readint();
			//cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --c1, --r2, --c2;
			if (ok(r1, k, 0) && ok(c2, k, 1)) {
				//cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				writeint(abs(r1 - r2) + abs(c1 - c2));
				putchar('\n');
				goto end;
			}
			if (ok(c1, k, 1) && ok(r2, k, 0)) {
				//cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				writeint(abs(r1 - r2) + abs(c1 - c2));
				putchar('\n');
				goto end;
			}
			int Min = INF;
			if (ok(r1, k, 0) && ok(r2, k, 0)) {
				int sit = 0;
				if (rget_min(min(r1, r2), max(r1, r2)) >= Timer - k)
					sit = 0;
				else
					sit = 1;
				if (sit == 0) {
					//cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					writeint(abs(r1 - r2) + abs(c1 - c2));
					putchar('\n');
					goto end;
				}
				if (sit == 1) {
					int next = binpc(c1, m - 1, true);
					if (next != INF)
						Min = min(Min, abs(c1 - next) + abs(r1 - r2) + abs(next - c2));
					next = binpc(0, c1, false);
					if (next != INF)
						Min = min(Min, abs(c1 - next) + abs(r1 - r2) + abs(next - c2));
					next = binpc(0, c2, false);
					if (next != INF)
						Min = min(Min, abs(c1 - next) + abs(r1 - r2) + abs(next - c2));
					next = binpc(c2,  m - 1, true);
					if (next != INF)
						Min = min(Min, abs(c1 - next) + abs(r1 - r2) + abs(next - c2));
				}
			}
			if (ok(c1, k, 1) && ok(c2, k, 1)) {
				int sit = 0;
				if (cget_min(min(c1, c2), max(c1, c2)) >= Timer - k)
					sit = 0;
				else
					sit = 1;
				if (sit == 0) {
					//cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					writeint(abs(r1 - r2) + abs(c1 - c2));
					putchar('\n');
					goto end;
				}
				if (sit == 1) {
					int next = binpr(r1, m - 1, true);
					if (next != INF)
						Min = min(Min, abs(r1 - next) + abs(c1 - c2) + abs(next - r2));
					next = binpr(0, r1, false);
					if (next != INF)
						Min = min(Min, abs(r1 - next) + abs(c1 - c2) + abs(next - r2));
					next = binpr(0, r2, false);
					if (next != INF)
						Min = min(Min, abs(r1 - next) + abs(c1 - c2) + abs(next - r2));
					next = binpr(r2, m - 1, true);
					if (next != INF)
						Min = min(Min, abs(r1 - next) + abs(c1 - c2) + abs(next - r2));
				}
			}
			if (Min == INF) {
				//cout << -1;
				putchar('-');
				putchar('1');
			}
			else {
				//cout << Min;
				writeint(Min);
			}
			putchar('\n');
		}
	end:
		++Timer;
	}
}