#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

int tree[4000001];
int delta[400001];

void push(int v, int l, int r) {
    if (l + 1 != r) {
        delta[2 * v + 1] += delta[v];
        delta[2 * v + 2] += delta[v];
    }
    tree[v] += delta[v];
    delta[v] = 0;
}

void set0(int v, int l, int r, int idx) {
    push(v, l, r);
    if (l > idx || r <= idx) {
        return;
    }
    if (l + 1 == r && l == idx) {
        tree[v] = 0;
        return;
    }
    set0(2 * v + 1, l, (l + r) / 2, idx);
    set0(2 * v + 2, (l + r) / 2, r, idx);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int mx(int v, int l, int r, int x, int y) {
    push(v, l, r);
    if (l >= y || r <= x) {
        return 0;
    }
    if (x <= l && r <= y) {
        return tree[v];
    }
    return max(mx(2 * v + 1, l, (l + r) / 2, x, y), mx(2 * v + 2, (l + r) / 2, r, x, y));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    for (int o = 0; o < q; ++o) {
        int c;
        cin >> c;
        delta[0] += 1;
        if (c == 1) {
            int r;
            cin >> r;
            --r;
            set0(0, 0, n, r);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (mx(0, 0, n, r1 - 1, r2) <= k) {
                cout << abs(r2 - r1) + abs(c1 - c2) << "\n";
            } else {
                cout << -1 << "\n";
            }
        }
    }
    return 0;
}

/*
4 3 7
3 2 1 3 3 1
3 2 1 3 3 1
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6*/
