#include <iostream>
#include <fstream>

#include <set>
#include <vector>
#include <stack>

#include <cstring>
#include <cassert>
#include <cmath>

#include <bitset>
#include <algorithm>
#include <functional>

using namespace std;
//#define DEBUG
#ifdef  DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif //  DEBUG

typedef long long ll;
#define int ll
struct edge {
	ll cost, dest;
};
#define MXX 10010
typedef bitset<MXX> bset;

ll n, m, q, p;
vector<edge> *g;
vector<edge> *gt;

bset *lens;

void dfs(ll node, ll len) {
	if (len >= MXX)return;
	if (lens[node][len])return;
	lens[node][len] = 1;
	for (auto e : g[node]) {
		dfs(e.dest, len + e.cost);
	}
}

void test() {
	cin >> n >> m >> q >> p;
	g = new vector<edge>[n];
	gt = new vector<edge>[n];

	for (int i = 0; i < m; i++) {
		ll from, dest, cost;
		cin >> from >> dest >> cost; from--; dest--;
		g[from].push_back({ cost,dest });
		gt[dest].push_back({ cost,from });
	}

	lens = new bset[n];
	for (int i = 0; i < n; i++) {
		lens[i].reset();
	}
	dfs(0, 0);
	while (q--) {
		ll f, r;
		cin >> f >> r;
		f--;
		ll l1 = r;
		ll r1 = (r * p) / (p - 1);
		bool ok = false;
		r1 = min(r1, (ll)(MXX - 3));
		for (int i = l1; i <= r1; i++) {
			if (lens[f][i]) {
				cout << 1;
				ok = true;
				break;
			}
		}
		if (!ok)cout << 0;
	}

	cout << endl;


}
#undef int
int main() {
	ios::sync_with_stdio(0);
	cin.tie(NULL);

	int t;
	cin >> t;
	while (t--) {
		test();
	}
}
