#include <bits/stdc++.h>
typedef long long ll;
#define all(x) x.begin(), x.end()
using namespace std;
  
void time_assert(bool c) {
    while (!c) {
        ;
    }
}
  
struct segment {
    vector<int> sx, sy;
    segment() {}
    friend segment operator+(const segment a, const segment b) {
        segment res;
        res.sx.resize(a.sx.size() + b.sx.size());
        merge(all(a.sx), all(b.sx), res.sx.begin());
        res.sy.resize(a.sy.size() + b.sy.size());
        merge(all(a.sy), all(b.sy), res.sy.begin());
        return res;
    }
};

const int N     = 1e6 + 64;
const int INF   = 1e9;

struct down_tree {
	int t[2 * N];
	down_tree() {
		fill_n(t, 2 * N, 0);
	}
	void upd(int i, int v) {
		t[i += N] = v;
		for (i /= 2; i >= 1; i /= 2) {
			t[i] = min(t[2 * i], t[2 * i + 1]);
		}
	}
	int query(int l, int r) {
		int res = INF;
		for (l += N, r += N; l <= r; l /= 2, r /= 2) {
			if (l % 2 == 1) {
				res = min(res, t[l++]);
			}
			if (r % 2 == 0) {
				res = min(res, t[r--]);
			}
		}
		return res;
	}
} xtree, ytree;

int n, m, q;
segment t[N];
int h = 0;


int read_int() {
    int i;
    cin >> i;
    return i;
}
  
int dist(vector<int> &v, int l, int r) {
                                                                        assert(l <= r);
    int answer = INF;
    auto it = lower_bound(all(v), l);
    if (it != v.end()) {
        if (l <= *it && *it <= r) {
            return 0;
        }
                                                                        assert(*it > r);
        answer = min(answer, *it - r);
    }
    if (it != v.begin()) {
        --it;
                                                                        assert(*it < l);
        answer = min(answer, l - *it);
    }
    return answer;
}
  
int dist(vector<int> &v, int val) {
    /*int ans = INF;
    auto it = lower_bound(all(v), val);
    if (it != v.end()) {
        ans = min(ans, *it - val);
    }
    if (it != v.begin()) {
        --it;
        ans = min(ans, val - *it);
    }
                                                                        time_assert(ans >= 0);
    return ans;*/
    return dist(v, val, val);
}
  
void unify(vector<int> &v) {
    sort(all(v));
    v.erase(unique(all(v)), v.end());
}
  
int solve_inf(int x1, int y1, int x2, int y2, int k) {
    int mind = abs(x1 - x2) + abs(y1 - y2);
    if (k >= h) {
        return mind;
    }
    vector<segment*> intr;
    intr.reserve(k + 1);
    for (int i = h - k; i <= h; ++i) {
        intr.push_back(&t[i]);
    }
    bool hx1 = false,
         hx2 = false,
         hy1 = false,
         hy2 = false;
    for (auto ptr : intr) {
        segment &s = *ptr;
        hx1 |= binary_search(all(s.sx), x1);
        hx2 |= binary_search(all(s.sx), x2);
        hy1 |= binary_search(all(s.sy), y1);
        hy2 |= binary_search(all(s.sy), y2);
    }
    
    int hx = h - xtree.query(min(x1, x2), max(x1, x2));
	int hy = h - ytree.query(min(y1, y2), max(y1, y2));
    if (hx <= k || hy <= k) {
		return mind;
	}
    int answer = INF;
    if (x1 == x2) {
                                                                        assert(hx1 == hx2);
        if (hx1) {
            return mind;
        }
        if (hy1 && hy2) {
            for (auto ptr : intr) {
                segment &s = *ptr;
                answer = min(answer, mind + 2 * dist(s.sx, x1));
                                                                        assert(answer > mind);
            }
        }
        return answer;
    }
    if (y1 == y2) {
                                                                        assert(hy1 == hy2);
        if (hy1) {
            return mind;
        }
        if (hx1 && hx2) {
            for (auto ptr : intr) {
                segment &s = *ptr;
                answer = min(answer, mind + 2 * dist(s.sy, y1));
                                                                        assert(answer > mind);
            }
        }
        return answer;
    }
    if ((hx1 && hy2) || (hy1 && hx2)) {
        return mind;
    }
    if (hx1 && hx2) {
        for (auto ptr : intr) {
            segment &s = *ptr;
            answer = min(answer, mind + 2 * dist(s.sy, min(y1, y2), max(y1, y2)));
        }
    }
    if (hy1 && hy2) {
        for (auto ptr : intr) {
            segment &s = *ptr;
            answer = min(answer, mind + 2 * dist(s.sx, min(x1, x2), max(x1, x2)));
        }
    }
                                                                        assert(answer >= mind);
    return answer;
}
  
int solve(int a, int b, int c, int d, int e) {
    int ans = solve_inf(a, b, c, d, e);
    if (ans >= INF) {
        return -1;
    }
    return ans;
}
  
int main() {
#ifdef LC
    assert(freopen("input.txt", "r", stdin));
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
      
    cin >> n >> m >> q;
    for (int i = 0; i < q; ++i) {
        ++h;
        int tp = read_int();
        if (tp == 1) {
            int x = read_int();
            t[h].sx.push_back(x);
            xtree.upd(x, h);
        } else if (tp == 2) {
            int y = read_int();
            t[h].sy.push_back(y);
            ytree.upd(y, h);
        } else {
            int a = read_int(),
                b = read_int(),
                c = read_int(),
                d = read_int(),
                e = read_int();
            cout << solve(a, b, c, d, e) << "\n";
        }
    }
    return 0;
}
