#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int MAX = 1e6 + 2;

int slow_row(int r1, int r2, vector<int> &r, int t, int n) {
    if (r1 > r2) {
        swap(r1, r2);
    }
    int base = abs(r1 - r2);
    for (int i = r1; i <= r2; i++) {
        if (r[i] >= t) {
            return base;
        }
    }
    int up = INF, down = INF;
    for (int i = r1; i >= 1; i--) {
        if (r[i] >= t) {
            up = r1 - i;
            break;
        }
    }
    for (int i = r2; i <= n; i++) {
        if (r[i] >= t) {
            down = i - r2;
            break;
        }
    }
    if (up == INF && down == INF) {
        return INF;
    }
    int ans = base + 2 * min(up, down);
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    //for (int test = 0; test <= 1000; test++) {
    int n, m, q = 1000;
    //n = rand() % 10 + 2;
    //m = rand() % 10 + 2;
    cin >> n >> m >> q;
    vector<int> r(n + 1);
    vector<int> c(m + 1);
    for (int i = 1; i <= q; i++) {
        int t = rand() % 3 + 1;
        cin >> t;
        if (t == 1) {
            int x = rand() % n + 1;
            cin >> x;
            r[x] = i;
        } else if (t == 2) {
            int x = rand() % m + 1;
            cin >> x;
            c[x] = i;
        } else {
            int r1, c1, r2, c2, k;
            /*r1 = rand() % n + 1;
            c1 = rand() % m + 1;
            r2 = rand() % n + 1;
            c2 = rand() % m + 1;
            k = rand() % q;*/
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            int t = i - k;
            if ((r[r1] >= t && c[c2] >= t) || (r[r2] >= t && c[c1] >= t)) {
                int ans = abs(r1 - r2) + abs(c1 - c2);
                cout << ans << '\n';
                continue;
            }
            if (*min_element(c.begin() + min(c1, c2), c.begin() + max(c1, c2) + 1) >= t) {
                int ans = abs(r1 - r2) + abs(c1 - c2);
                cout << ans << '\n';
                continue;
            }
            if (*min_element(r.begin() + min(r1, r2), r.begin() + max(r1, r2) + 1) >= t) {
                int ans = abs(r1 - r2) + abs(c1 - c2);
                cout << ans << '\n';
                continue;
            }
            int ans = INF;
            if (c[c1] >= t && c[c2] >= t) {
                ans = min(ans, slow_row(r1, r2, r, t, n) + abs(c1 - c2));
            }
            if (r[r1] >= t && r[r2] >= t) {
                ans = min(ans, slow_row(c1, c2, c, t, m) + abs(r1 - r2));
            }
            cout << (ans == INF ? -1 : ans) << '\n';
        }
    //}
    }
}
/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
