#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void dfs(int v, vector<vector<pair<int, long long>>> &gr, vector<vector<long long>> &d, long long cur = 0) {
    d[v].push_back(cur);
    for (auto p : gr[v]) {
        dfs(p.first, gr, d, cur + p.second);
    }
}

int main() {
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int test = 0; test < t; test++) {
        int n, m, p, q;
        cin >> n >> m >> q >> p;
        vector<vector<pair<int, long long>>> graph(n + 1);
        bool two = true;
        vector<int> cnt(n + 1);
        for (int i = 0; i < m; i++) {
            int u, v;
            long long d;
            cin >> u >> v >> d;
            graph[u].push_back({v, d});
            if (v != u + 1)
                two = false;
            cnt[u]++;
        }
        for (int i = 1; i < n; i++) {
            two = two && cnt[i] == 2;
        }
        two = two && p == 2;
        if (!two) {
            vector<vector<long long>> d(n + 1);
            dfs(1, graph, d);
            for (int i = 0; i < q; i++) {
                int f;
                long long r;
                cin >> f >> r;
                bool ok = false;
                auto max_ = p * r / (p - 1);
                for (auto k : d[f]) {
                    if (k >= r && k <= max_) {
                        ok = true;
                        break;
                    }
                }
                cout << ok;
            }
            cout << '\n';
            continue;
        }
        vector<long long> w1(n + 1);
        vector<long long> w2(n + 1);
        for (int i = 1; i < n; i++) {
            w1[i] = min(graph[i][0].second, graph[i][1].second);
            w2[i] = max(graph[i][0].second, graph[i][1].second);
        }
        for (int i = 0; i < q; i++) {
            int f;
            long long r;
            cin >> f >> r;
            vector<long long> add(f);
            long long min_ = 0;
            for (int i = 1; i < f; i++) {
                add[i] = w2[i] - w1[i];
                min_ += w1[i];
            }
            if (min_ > 2 * r) {
                cout << 0;
                continue;
            }
            if (min_ >= r && min_ <= 2 * r) {
                cout << 1;
                continue;
            }
            bool ok = false;
            for (int i = 1; i < f; i++) {
                if (min_ + add[i] >= r && min_ + add[i] <= 2 * r) {
                    ok = true;
                    break;
                }
            }
            if (ok) {
                cout << 1;
                continue;
            }
            for (int i = 1; i < f; i++) {
                if (min_ + add[i] > 2 * r) {
                    continue;
                }
                min_ += add[i];
                if (min_ >= r && min_ <= 2 * r) {
                    ok = true;
                    break;
                }
            }
            cout << ok;
        }
        cout << '\n';
    }
}
/*
1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34
*/
