#define _USE_MATH_DEFINES
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <deque>
#include <set>
#include <cmath>
using namespace std;

#define kekek ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)

vector<int> dx = { 1, 0, -1, 0 }, dy = { 0, 1, 0, -1 };

const int inf = 1e9;
int n, m, q;
vector<int> r, c;

int getsnow(int r1, int c1, int t) {
	if (r1 <= 0 || c1 <= 0 || r1 > n || c1 > m) return inf;
	return t - max(r[r1], c[c1]);
}

int dijkstra(int r1, int c1, int r2, int c2, int k, int t) {
	vector<vector<int>> d(n + 1, vector<int>(m + 1, inf));
	set<pair<int, pair<int, int>>> buf;
	buf.insert({ 0, {r1, c1} });

	while (!buf.empty() && d[r2][c2] == inf) {
		auto kek = buf.begin()->second;
		auto a = buf.begin()->first;
		buf.erase(buf.begin());

		for (int i = 0; i < 4; i++) {
			int rto = kek.first + dx[i], cto = kek.second + dy[i];
			if (getsnow(rto, cto, t) <= k && a + 1 < d[rto][cto]) {
				buf.erase({ d[rto][cto], {rto, cto} });
				d[rto][cto] = a + 1;
				buf.insert({ d[rto][cto], {rto, cto} });
			}
		}
	}

	if (d[r2][c2] == inf) return -1;
	else return d[r2][c2];
}

signed main() {
	kekek;

	cin >> n >> m >> q;
	r.resize(n + 1);
	c.resize(m + 1);

	for (int t = 1; t <= q; t++) {
		int z;
		cin >> z;

		if (z == 1) {
			int aaa;
			cin >> aaa;
			r[aaa] = t;
		}
		else if (z == 2) {
			int aaa;
			cin >> aaa;
			c[aaa] = t;
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;

			if (max(getsnow(r1, c1, t), getsnow(r2, c2, t)) > k) {
				cout << -1 << '\n';
			}
			else {
				cout << dijkstra(r1, c1, r2, c2, k, t) << '\n';
			}
		}
	}

	//system("pause");
	return 0;
}