#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

const int MAXN = 1e3 + 5;
int n, m, q;
int rs[MAXN];
int cs[MAXN];
int a[MAXN][MAXN];

void update_row(int r, int v) {
    v = -v;
    rs[r] = v;
}

void update_col(int c, int v) {
    v = -v;
    cs[c] = v;
}

int max_row(int l, int r) {
    return *max_element(rs + l, rs + r + 1);
}

int max_col(int l, int r) {
    return *max_element(cs + l, cs + r + 1);
}

int min_row(int l, int r) {
    return *min_element(rs + l, rs + r + 1);
}

int min_col(int l, int r) {
    return *min_element(cs + l, cs + r + 1);
}

int solve_row(int r, int c1, int c2, int k) {
    if (rs[r] <= k || max_col(c1, c2) <= k) return c2 - c1;
    if (cs[c1] > k || cs[c2] > k) return -1;
    int res = INT_MAX;
    for (int i = 0; i < n; ++i) {
        if (rs[i] <= k) res = min(res, c2 - c1 + abs(i - r) * 2);
    }
    if (res == INT_MAX) return -1;
    return res;
}

int solve_col(int c, int r1, int r2, int k) {
    if (cs[c] <= k || max_row(r1, r2) <= k) return r2 - r1;
    if (rs[r1] > k || rs[r2] > k) return -1;
    int res = INT_MAX;
    for (int i = 0; i < m; ++i) {
        if (cs[i] <= k) res = min(res, r2 - r1 + abs(i - c) * 2);
    }
    if (res == INT_MAX) return -1;
    return res;
}

int solve_gen(int r1, int c1, int r2, int c2, int k) {
    if (max_row(r1, r2) <= k ||
        max_col(c1, c2) <= k ||
        rs[r1] <= k && rs[r2] <= k && min_col(c1, c2) <= k ||
        cs[c1] <= k && cs[c2] <= k && min_row(r1, r2) <= k) return abs(r1 - r2) + abs(c1 - c2);
    return -1;
}

int d[MAXN][MAXN];
int dx[] = {-1, 0, 0, 1};
int dy[] = {0, -1, 1, 0};
int solve(int r1, int c1, int r2, int c2, int k) {
    if (min(rs[r1], cs[c1]) > k) return -1;

    int res = solve_gen(r1, c1, r2, c2, k);
    if (res != -1) return res;

    if (r1 == r2) {
        if (c1 > c2) swap(c1, c2);
        int res = solve_row(r1, c1, c2, k);
        return res;
    }

    if (c1 == c2) {
        if (r1 > r2) swap(r1, r2);
        int res = solve_col(c1, r1, r2, k);
        return res;
    }

    rep(i, n) {
        rep(j, m) {
            a[i][j] = min(rs[i], cs[j]);
        }
    }

    if (a[r1][c1] > k) return -1;

    rep(i, n) {
        rep(j, m) {
            d[i][j] = -1;
        }
    }
    d[r1][c1] = 0;
    queue<pii> q;
    q.push({r1, c1});
    while (!q.empty()) {
        int x = q.front().f, y = q.front().s;
        q.pop();
        rep(t, 4) {
            int nx = x + dx[t], ny = y + dy[t];
            if (nx < 0 || nx >= n || ny < 0 || ny >= m || d[nx][ny] != -1 || a[nx][ny] > k) continue;
            d[nx][ny] = d[x][y] + 1;
            q.push({nx, ny});
        }
    }

    return d[r2][c2];
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> q;
    rep(i, q) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            update_row(r - 1, i + 1);
        } else if (t == 2) {
            int c;
            cin >> c;
            update_col(c - 1, i + 1);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << solve(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k - (i + 1)) << '\n';
        }
    }
}