#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

struct st{
    int n;
    vector<pair<int, int> > t;

    void init(int _n){
        n = _n;
        t.resize(4 * n, {-1, INF});
    }

   /* void update(int v, int pos, int val, int dl, int dr){
        if (dl == dr - 1){
            t[v] = {val, val};
            return;
        }
        int dm = (dl + dr) / 2;
        if (pos < dm){
            update(2 * v, pos, val, dl, dm);
        }else{
            update(2 * v + 1, pos, val, dm, dr);
        }
        t[v].first = max(t[2 * v].first, t[2 * v + 1].first);
        t[v].second = min(t[2 * v].second, t[2 * v + 1].second);
    }*/

    void update(int pos, int val){
        //update(1, pos, val, 0, n);
        t[pos] = {val, val};
    }

    /*int getmax(int v, int l, int r, int dl, int dr){
        if (l >= r){
            return -1;
        }
        if (dl == l && dr == r){
            return t[v].second;
        }
        int dm = (dl + dr) / 2;
        int res1 = getmax(2 * v, l, min(r, dm), dl, dm);
        int res2 = getmax(2 * v + 1, max(l, dm), r, dm, dr);
        return max(res1, res2);
    }*/

    int getmax(int l, int r){
        //return getmax(1, l, r, 0, n);
        int ans = -1;
        for (int i = l; i < r; i++){
            ans = max(ans, t[i].first);
        }
        return ans;
    }

    /*int getmin(int v, int l, int r, int dl, int dr){
        if (l >= r){
            return INF;
        }
        if (dl == l && dr == r){
            return t[v].second;
        }
        int dm = (dl + dr) / 2;
        int res1 = getmax(2 * v, l, min(r, dm), dl, dm);
        int res2 = getmax(2 * v + 1, max(l, dm), r, dm, dr);
        return min(res1, res2);
    }*/

    int getmin(int l, int r){
        //return getmin(1, l, r, 0, n);
        int ans = INF;
        for (int i = l; i < r; i++){
            ans = min(ans, t[i].second);
        }
        return ans;
    }

};

int main()
{
    //freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    st rt;
    rt.init(n);
    st ct;
    ct.init(n);
    for (int i = 0; i < n; i++){
        rt.update(i, -1);
    }
    for (int i = 0; i < m; i++){
        ct.update(i, -1);
    }
    for (int i = 0; i < q; i++){
        int t;
        cin >> t;
        if (t == 1){
            int ri;
            cin >> ri;
            ri--;
            rt.update(ri, i);
        }else if (t == 2){
            int ci;
            cin >> ci;
            ci--;
            ct.update(ci, i);
        }else{
            int x1, x2, y1, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            int mn = abs(x1 - x2) + abs(y1 - y2);
            if (rt.getmax(x1, x1 + 1) >= i - k && ct.getmax(y2, y2 + 1) >= i - k){
                cout << mn << "\n";
                continue;
            }
            if (rt.getmax(x2, x2 + 1) >= i - k && ct.getmax(y1, y1 + 1) >= i - k){
                cout << mn << "\n";
                continue;
            }
            if (x1 > x2){
                swap(x1, x2);
            }
            if (y1 > y2){
                swap(y1, y2);
            }
            if (ct.getmin(y1, y2 + 1) >= i - k || rt.getmin(x1, x2 + 1)){
                cout << mn << "\n";
                continue;
            }
            int ans = INF;
            if (rt.getmin(x1, x1 + 1) >= i - k && rt.getmin(x2, x2 + 1) >= i - k){
                if (ct.getmax(y1, y2 + 1) >= i - k){
                    cout << mn << "\n";
                    continue;
                }
                for (int cur = 1; cur + y2 < m; cur++){
                    if (ct.t[y2 + cur].first >= i - k){
                        ans = min(ans, mn + 2 * cur);
                        break;
                    }
                }
                for (int cur = 1; y1 - cur >= 0; cur++){
                    if (ct.t[y1 - cur].first >= i - k){
                        ans = min(ans, mn + 2 * cur);
                        break;
                    }
                }
            }
            if (ct.getmin(y1, y1 + 1) >= i - k && ct.getmin(y2, y2 + 1) >= i - k){
                if (rt.getmax(x1, x2 + 1) >= i - k){
                    cout << mn << "\n";
                    continue;
                }
                for (int cur = 1; cur + x2 < n; cur++){
                    if (rt.t[cur + x2].first >= i - k){
                        ans = min(ans, mn + 2 * cur);
                        break;
                    }
                }
                for (int cur = 1; x1 - cur >= 0; cur++){
                    if (rt.t[x1 - cur].first >= i - k){
                        ans = min(ans, mn + 2 * cur);
                        break;
                    }
                }
            }
            if (ans < INF){
                cout << ans << "\n";
            }else{
                cout << -1 << "\n";
            }
        }
    }
    return 0;
}
