#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

struct st{
    int n;
    vector<pair<int, int> > t;

    void init(int _n){
        n = _n;
        t.resize(4 * n, {-1, INF});
    }

   /* void update(int v, int pos, int val, int dl, int dr){
        if (dl == dr - 1){
            t[v] = {val, val};
            return;
        }
        int dm = (dl + dr) / 2;
        if (pos < dm){
            update(2 * v, pos, val, dl, dm);
        }else{
            update(2 * v + 1, pos, val, dm, dr);
        }
        t[v].first = max(t[2 * v].first, t[2 * v + 1].first);
        t[v].second = min(t[2 * v].second, t[2 * v + 1].second);
    }*/

    void update(int pos, int val){
        //update(1, pos, val, 0, n);
        t[pos] = {val, val};
    }

    /*int getmax(int v, int l, int r, int dl, int dr){
        if (l >= r){
            return -1;
        }
        if (dl == l && dr == r){
            return t[v].second;
        }
        int dm = (dl + dr) / 2;
        int res1 = getmax(2 * v, l, min(r, dm), dl, dm);
        int res2 = getmax(2 * v + 1, max(l, dm), r, dm, dr);
        return max(res1, res2);
    }*/

    int getmax(int l, int r){
        //return getmax(1, l, r, 0, n);
        int ans = -1;
        for (int i = l; i < r; i++){
            ans = max(ans, t[i].first);
        }
        return ans;
    }

    /*int getmin(int v, int l, int r, int dl, int dr){
        if (l >= r){
            return INF;
        }
        if (dl == l && dr == r){
            return t[v].second;
        }
        int dm = (dl + dr) / 2;
        int res1 = getmax(2 * v, l, min(r, dm), dl, dm);
        int res2 = getmax(2 * v + 1, max(l, dm), r, dm, dr);
        return min(res1, res2);
    }*/

    int getmin(int l, int r){
        //return getmin(1, l, r, 0, n);
        int ans = INF;
        for (int i = l; i < r; i++){
            ans = min(ans, t[i].second);
        }
        return ans;
    }

};

int main()
{
    //freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    st rt;
    rt.init(n);
    st ct;
    ct.init(n);
    for (int i = 0; i < n; i++){
        rt.update(i, -1);
    }
    for (int i = 0; i < m; i++){
        ct.update(i, -1);
    }
    for (int i = 0; i < q; i++){
        int t;
        cin >> t;
        if (t == 1){
            int ri;
            cin >> ri;
            ri--;
            rt.update(ri, i);
        }else if (t == 2){
            int ci;
            cin >> ci;
            ci--;
            ct.update(ci, i);
        }else{
            int x1, x2, y1, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            if (rt.getmax(x1, x1 + 1) >= i - k && ct.getmax(y2, y2 + 1) >= i - k){
                cout << abs(x2 - x1) + abs(y2 - y1) << "\n";
                continue;
            }
            if (rt.getmax(y2, x2 + 1) >= i - k && ct.getmax(y1, y1 + 1) >= i - k){
                cout << abs(x2 - x1) + abs(y2 - y1) << "\n";
                continue;
            }
            if (x1 > x2){
                swap(x1, x2);
            }
            if (y1 > y2){
                swap(y1, y2);
            }
            if (ct.getmin(y1, y2 + 1) >= i - k){
                cout << x2 - x1 + y2 - y1 << "\n";
                continue;
            }
            if (rt.getmin(x1, x2 + 1) >= i - k){
                cout << x2 - x1 + y2 - y1 << "\n";
                continue;
            }
            if (x1 == x2){
                if (ct.getmax(y1, y2) >= i - k){
                    cout << y2 - y1 << "\n";
                    continue;
                }
            }
            if (y1 == y2){
                if (rt.getmax(x1, x2) >= i - k){
                    cout << x2 - x1 << "\n";
                    continue;
                }
            }
            if (i == 5){
                int breakpoint = 1;
            }
            int mn = INF;
            if (rt.getmax(x1, x1 + 1) >= i - k && rt.getmax(x2, x2 + 1) >= i - k){
                if (ct.getmax(y1, y2 + 1) >= i - k){
                    cout << x2 - x1 + y2 - y1 << "\n";
                    continue;
                }
                if (ct.getmax(y2, m) >= i - k){
                    int l = 0;
                    int r = m;
                    while (r - l > 1){
                        int mid = (r + l) / 2;
                        if (ct.getmax(y2, mid) >= i - k){
                            r = mid;
                        }else{
                            l = mid;
                        }
                    }
                    mn = min(mn, x2 - x1 + y2 - y1 + 2 * (r - y2));
                }
                if (ct.getmax(0, y1) >= i - k){
                    int l = 0;
                    int r = y1;
                    while (r - l > 1){
                        int mid = (r + l) / 2;
                        if (ct.getmax(mid, y1) >= i - k){
                            l = mid;
                        }else{
                            r = mid;
                        }
                    }
                    mn = min(mn, x2 - x1 + y2 - y1 + 2 * (y1 - l));
                }
            }
            if (ct.getmax(y1, y1 + 1) >= i - k && ct.getmax(y2, y2 + 1) >= i - k){
                if (rt.getmax(x1, x2 + 1) >= i - k){
                    cout << x2 - x1 + y2 - y1 << "\n";
                    continue;
                }
                if (ct.getmax(x2, n) >= i - k){
                    int l = 0;
                    int r = n;
                    while (r - l > 1){
                        int mid = (r + l) / 2;
                        if (rt.getmax(x2, mid) >= i - k){
                            r = mid;
                        }else{
                            l = mid;
                        }
                    }
                    mn = min(mn, x2 - x1 + y2 - y1 + 2 * (r - x2));
                }
                if (rt.getmax(0, x1) >= i - k){
                    int l = 0;
                    int r = x1;
                    while (r - l > 1){
                        int mid = (r + l) / 2;
                        if (rt.getmax(mid, x1) >= i - k){
                            l = mid;
                        }else{
                            r = mid;
                        }
                    }
                    mn = min(mn, x2 - x1 + y2 - y1 + 2 * (x1 - l));
                }
            }
            if (mn != INF){
                cout << mn << "\n";
            }else{
                cout << -1 << "\n";
            }
        }
    }
    return 0;
}
