#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <bitset>

using namespace std;

const int N = 10'100;

vector <vector <pair <int, long long>>> g;
bitset <N> used;
vector <bitset<N>> check;
vector <int> topsort;

void dfs(int v = 0, long long p = 0) {
	used[v] = true;
	for (auto i : g[v])
		if (!used[i.first])
			dfs(i.first);
	topsort.push_back(v);
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		long long n, m, q, p;
		cin >> n >> m >> q >> p;
		g.clear(); check.clear();
		g.resize(n); check.resize(n);
		topsort.clear();
		used.reset();
		for (int j = 0; j < m; j++) {
			int a, b;
			long long d;
			cin >> a >> b >> d;
			g[a - 1].push_back({ b - 1, d });
		}
		dfs();
		check[0][0] = true;
		reverse(topsort.begin(), topsort.end());
		for (auto j : topsort) {
			for (auto e : g[j]) {
				for (long long t = e.second; t < N; t++)
					check[e.first][t] = check[e.first][t] | check[j][t - e.second];
			}
		}
		for (int j = 0; j < q; j++) {
			int h; long long T;
			cin >> h >> T;
			long long to = (p * T) / (p - 1);
			bool is = false;
			for (long long t = T; t <= to; t++) {
				if (check[h-1][t]) {
					is = true;
					break;
				}
			}
			if (is) cout << 1;
			else cout << 0;
		}
		cout << endl;
	}
}