#include <bits/stdc++.h>
using namespace std;

class Segment_tree {
public:
    int size;
    vector<int> t;

    void build(int size_) {
        size = size_;
        t.resize(size_ * 4);
        build_tree(0, 0, size);
    }

    void build_tree(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = 0;
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            build_tree(vl, l, m);
            build_tree(vr, m, r);
        }
    }

    void update_vertex(int ind) {
        update_tree(0, 0, size, ind);
    }

    void update_tree(int v, int l, int r, int ind) {
        if (l + 1 == r) {
            t[v] = 1;
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            if (ind < m) {
                update_tree(vl, l, m, ind);
            } else {
                update_tree(vr, m, r, ind);
            }
            t[v] = t[vl] + t[vr];
        }
    }

    int get_segment(int s, int e) {
        return get_tree(0, 0, size, s, e);
    }

    int get_tree(int v, int l, int r, int s, int e) {
//        cout << s << " " << e << endl;
        if (s == e) return 0;
        else if (l == s && r == e) {
            return t[v];
        } else {
            int m = (l + r) / 2, vl = v*2 + 1, vr = vl + 1;
            int a, b;
            a = get_tree(vl, l, m, min(s, m), min(m, e));
            b = get_tree(vr, m, r, max(s, m), max(m, e));
            return a + b;
        }
    }
 };
struct Move {
    int l, r, c;
    Move(int l_, int r_, int c_) : l(l_), r(r_), c(c_) {}

    bool operator < (Move &m) {
        return l == m.l ? r > m.r : l < m.l;
    }
};

/*
7 10
10 5 5 10 4 2 4
*/

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;

    vector<int> a(m+1), fst(n+1), lst(n+1);
    vector<vector<int>> t(n+1);
    for (int i = 1; i <= m; i++) {
        cin >> a[i];
        t[a[i]].push_back(i);
        if (!fst[a[i]]) {
            fst[a[i]] = i;
        }
        lst[a[i]] = i;
    }
    vector<Move> moves;
//    for (int i = 1; i <= n; i++) {
//        cout << i << ": ";
//        for (int j = 0; j < t[i].size(); j++) {
//            cout << t[i][j] << " ";
//        }
//        cout << endl;
//    }

    for (int i = 1; i <= n; i++) {
        if (fst[i] != 0 && lst[i] != 0) {
            moves.push_back(Move(fst[i], lst[i], i));
        }
    }

    sort(moves.begin(), moves.end());
    vector<int> f(n+1);

    Segment_tree st;
    st.build(m);

    for (auto i : moves) {
        if (st.get_segment(i.l-1, i.r) != 0) {
            cout << -1;
            return 0;
        }
        for (int j = 0; j < t[i.c].size(); j++) {
            int ind = t[i.c][j];
            st.update_vertex(--ind);
        }
    }

    cout << moves.size() << "\n";

    for (int i = 0; i < moves.size(); i++) {
        cout << moves[i].c << " " << moves[i].l << " " << moves[i].r << "\n";
    }

    return 0;
}
