
#include <iostream>
#include <vector>
#include <utility>
using namespace std;

const int N = 300005;
int a[N], b[N], used[N], lastPos[N];
int tree[4 * N], p[4 * N];

void push(int i, int tl, int tr)
{
	if (p[i] != 0) {
		tree[i] = p[i];
		if (tl + 1 != tr) {
			p[i * 2] = p[i];
			p[i * 2 + 1] = p[i];
		}
		p[i] = 0;
	}
}

void modify(int i, int tl, int tr, int l, int r, int cl) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		p[i] = cl;
		push(i, tl, tr);
		return;
	}
	else if (l >= tr || tl >= r) {
		return;
	}
	int mid = (tl + tr) / 2;
	modify(i * 2, tl, mid, l, r, cl);
	modify(i * 2 + 1, mid, tr, l, r, cl);
}

int get(int i, int tl, int tr, int pos) {
	push(i, tl, tr);
	if (tl + 1 == tr) {
		return tree[i];
	}
	int mid = (tl + tr) / 2;
	if (pos < mid)
		return get(i * 2, tl, mid, pos);
	else
		return get(i * 2 + 1, mid, tr, pos);
}

void solve() {
	int m, n;
	cin >> m >> n;
	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
		lastPos[a[i]] = i;
	}
	vector <pair<int, pair<int, int>>> ans;
	for (int i = 1; i <= m; ++i) {
		int color = a[i];
		if (used[color]) continue;	
		used[color] = 1;
		int post = lastPos[color];
		ans.push_back({ color, {i, post} });
		modify(1, 0, N, i, post + 1, color);
	}
	for (int i = 1; i <= m; ++i) {
		if (get(1, 0, N, i) != a[i]) {
			cout << -1 << '\n';
			exit(0);
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i.first << ' ' << i.second.first << ' ' << i.second.second << '\n';
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
}