
#include <iostream>
#include <vector>
#include <queue>
#include <cassert>
#include <utility>
using namespace std;

const int N = 1e6 + 15;

int t[4 * N], p[4 * N];

void push(int i, int tl, int tr) {
	t[i] += p[i];
	if (tl + 1 != tr) {
		p[i * 2] += p[i];
		p[i * 2 + 1] += p[i];
	}
	p[i] = 0;
}

void add() {
	p[1]++;
	push(1, 0, N);
}

void upd(int i, int l, int r, int pos) {
	push(i, l, r);
	if (l + 1 == r) {
		t[i] = 0;
		return;
	}
	int mid = (l + r) / 2;
	if (pos < mid)
		upd(i * 2, l, mid, pos);
	else
		upd(i * 2 + 1, mid, r, pos);
	t[i] = max(t[i * 2], t[i * 2 + 1]);
}

int get_max(int i, int tl, int tr, int l, int r) {
	push(i, tl, tr);
	if (l <= tl && tr <= r) {
		return t[i];
	}
	else if (tl >= r || l >= tr) {
		return 0;
	}
	int mid = (tl + tr) / 2;
	return max(get_max(i * 2, tl, mid, l, r), get_max(i * 2 + 1, mid, tr, l, r));
}

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	while (q--) {
		add();
		int t;
		cin >> t;
		if (t == 1) {
			int pos;
			cin >> pos;
			upd(1, 0, N, pos);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (r1 > r2) {
				swap(r1, r2), swap(c1, c2);
			}
			int gt = get_max(1, 0, N, r1, r2 + 1);
			if (gt > k) {
				cout << -1 << '\n';
			}
			else {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
			}
		}
	}
	return 0;
}