#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define endl '\n'

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;
typedef vector<vector<pair<int, ll>>> graph;

int const inf = (int) 2e9;

bool good(int x, int y, int n, int m) {
    return (1 <= x && x <= n && 1 <= y && y <= m);
}


int const N = (int) 1e6 + 1;

int tree[4 * N];

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) return -inf;
    if (tl == l && tr == r) return tree[v];
    int tm = (tl + tr) / 2;
    return max(get(2 * v, tl, tm, l, min(tm, r)),
               get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
}

void upd(int v, int tl, int tr, int ind, int val) {
    if (tl == tr) {
        tree[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (ind <= tm) upd(2 * v, tl, tm, ind, val);
    else upd(2 * v + 1, tm + 1, tr, ind, val);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int main() {
   // freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    if (max(n, max(m, q)) <= 10000) {
        int time = 0;
        vi raw(n + 1, 0), col(m + 1, 0);
        while (q--) {
            time++;
            int t;
            cin >> t;
            if (t == 1) {
                int r;
                cin >> r;
                raw[r] = time;
            } else if (t == 2) {
                int c;
                cin >> c;
                col[c] = time;
            } else {
                int r1, c1, r2, c2, k;
                cin >> r1 >> c1 >> r2 >> c2 >> k;
                if (time - max(col[c1], raw[r1]) > k) {
                    cout << "-1\n";
                    continue;
                }
                queue<pair<int, int>> que;
                vvi dist(n + 1, vi(m + 1, inf));
                dist[r1][c1] = 0;
                que.push({r1, c1});
                vector<vector<char>> used(n + 1, vector<char>(m + 1, false));
                while (!que.empty()) {
                    auto tt = que.front();
                    que.pop();
                    int r, c;
                    tie(r, c) = tt;
                    if (used[r][c]) continue;
                    used[r][c] = true;
                    for (int dr = -1; dr < 2; ++dr) {
                        for (int dc = -1; dc < 2; ++dc) {
                            if (abs(dc) != abs(dr) && good(dr + r, dc + c, n, m) &&
                                dist[dr + r][dc + c] > dist[r][c] + 1 && time - max(raw[dr + r], col[dc + c]) <= k) {
                                dist[dr + r][dc + c] = dist[r][c] + 1;
                                que.push({r + dr, c + dc});
                            }
                        }
                    }
                }
                cout << (dist[r2][c2] == inf ? -1 : dist[r2][c2]) << endl;
            }
        }
        return 0;
    }
    int time = 0;
    while (q--) {
        time++;
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            upd(1, 1, n, r, -time);
        } else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            if (x1 > x2) swap(x1, x2);
            if (get(1, 1, n, x1, x2) + time > k) cout << "-1\n";
            else cout << x2 - x1 + abs(y2 - y1) << endl;
        }
    }
    return 0;
}