#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>

using namespace std;

#define endl '\n'
#define int long long

bool rec(int v, int x, vector<vector<pair<int, int> > >& grph, int r, int p) {
	if (v == 0) {
		if (r * p - r <= x * p - x && x * p - x <= p * r) {
			return 1;
		}
		return 0;
	}
	for (auto u : grph[v]) {
		if (rec(u.first, x + u.second, grph, r, p)) return 1;
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	srand(239179179);

	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<pair<int, int> > cost(n, { -1, -1 });
		for (int i = 0; i < m; i++) {
			int a, b, d;
			cin >> a >> b >> d;
			--a; --b;
			if (a > b) swap(a, b);
			if (cost[b].first == -1) {
				cost[b].first = d;
			}
			else {
				cost[b].second = d;
				if (cost[b].first > cost[b].second) swap(cost[b].first, cost[b].second);
			}
		}

		vector<pair<int, int> > dp(n);
		for (int i = 1; i < n; i++) {
			dp[i].first = dp[i - 1].first + cost[i].first;
			dp[i].second = dp[i - 1].second + cost[i].second;
		}

		string ans;
		for (int i = 0; i < q; i++) {
			int v, r;
			cin >> v >> r;
			--v;
			bool f = 1;
			int delta = 0;
			while (v > 0) {
				int var1 = 1;
				int var2 = 1;
				if (cost[v].first + dp[v - 1].second + delta < r) {
					var1 = 0;
				}
				if ((cost[v].second + dp[v - 1].first + delta) * (p - 1) > p * r) {
					var2 = 0;
				}

				if (!var1 && !var2) {
					f = 0;
					break;
				}
				if (var1 && !var2) {
					delta += cost[v].first;
				}
				else if (var2 && !var1) {
					delta += cost[v].second;
				}
				else if (rand() % 2) {
					delta += cost[v].first;
				}
				else {
					delta += cost[v].second;
				}
				v--;
			}

			if (f && delta >= r && delta * (p - 1) <= p * r) {
				ans += '1';
			}
			else {
				ans += '0';
			}
		}
		cout << ans << endl;
	}
}