#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct edge
{
    int to;
    ll price;
};

const int MAXR = 6000;

vector<vector<edge>> g;
vector<vector<edge>> rev;
vector<vector<int>> dp;

int calc(int a, int b)
{
    if (dp[a][b] != -1)
        return dp[a][b];

    dp[a][b] = 0;
    for (auto e : rev[a])
    {
        if (b >= e.price && calc(e.to, b - e.price))
        {
            dp[a][b] = 1;
            break;
        }
    }

    return dp[a][b];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;

    for (int test = 0; test < tests; test++)
    {
        int n, m, q;
        ll p;
        cin >> n >> m >> q >> p;

        g.assign(n, vector<edge>());
        rev.assign(n, vector<edge>());
        dp.assign(n, vector<int>(MAXR, -1));
        dp[0][0] = 1;
        for (int i = 0; i < m; i++)
        {
            int a, b;
            ll c;
            cin >> a >> b >> c;

            g[a - 1].push_back({b - 1, c});
            rev[b - 1].push_back({a - 1, c});
        }

        for (int i = 0; i < n; i++)
            for (int j = 0; j < MAXR; j++)
                if (dp[i][j] == -1)
                    calc(i, j);

        for (int i = 0; i < q; i++)
        {
            int f;
            ll r;
            cin >> f >> r;
            f--;

            if (r >= MAXR)
            {
                cout << "0";
                continue;
            }

            bool flag = false;
            for (int j = 0; j < MAXR; j++)
            {
                if (dp[f][j] &&
                    r * (p - 1) <= j * (p - 1) &&
                    j * (p - 1) <= p * r)
                {
                    cout << "1";
                    flag = true;
                    break;
                }
            }

            if (!flag)
                cout << "0";
        }

        cout << endl;
    }

    return 0;
}