#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_set>

using namespace std;

typedef long long ll;

vector<vector<pair<int, ll>>> g;
vector<bool> used;
vector<unordered_set<ll>> dp;

void topsort(int cv, vector<int> &ts) {
    used[cv] = true;
    for (auto nv : g[cv]) {
        if (!used[nv.first]) {
            topsort(nv.first, ts);
        }
    }
    ts.push_back(cv);
}

void calc(int cv) {
    for (auto nv : g[cv]) {
        for (ll i : dp[cv]) {
            dp[nv.first].insert(i + nv.second);
        }
    }
}

int main() {
    int t;
    cin >> t;
    while (t) {
        t--;
        int n, m, q, p;
        cin >> n >> m >> q >> p;

        g.clear();
        used.clear();
        dp.clear();

        g.resize(n);
        used.resize(n);
        dp.resize(n);

        for (int i = 0; i < m; ++i) {
            int a, b;
            ll d;
            cin >> a >> b >> d;
            g[a - 1].push_back({b - 1, d});
        }

        vector<int> ts;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                topsort(i, ts);
            }
        }
        reverse(ts.begin(), ts.end());
        dp[0].insert(0);
        for (int i = 0; i < n; ++i) {
            calc(ts[i]);
        }

        vector<bool> ans;
        while (q) {
            q--;
            int f;
            ll r;
            cin >> f >> r;
            ll rr = r;
            ll rrr = (ll)floor(1.0 * r * p / (p - 1)) + 1;
            bool flag = false;
            for (ll i : dp[f - 1]) {
                if (rr <= i && i < rrr) {
                    flag = true;
                    break;
                }
            }
            ans.push_back(flag);
//            ans.push_back(*max_element(dp[f - 1].begin() + rr, dp[f - 1].begin() + rrr));
        }
        for (auto i : ans) {
            if (i) {
                cout << 1;
            }
            else {
                cout << 0;
            }
        }
        cout << endl;
    }
}