#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define x first
#define y second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()

int n, m, q;

const int INF = 1e9;

struct DO {
	int n;
	vector<int> t, mn;
	DO(){}
	DO(int _n) : n(_n) {
		t.resize(4 * n);
	}
	void init(int _n) {
		n = _n;
		mn.resize(4 * n);
		t.resize(4 * n);
	}
	int get_min(int v, int tl, int tr, int l, int r) {
		if (l >= r) return INF;
		if (tl == l && tr == r) return mn[v];
		int tm = (tl + tr) / 2;
		return min(get_min(v * 2 + 1, tl, tm, l, min(r, tm)),
			get_min(v * 2 + 2, tm, tr, max(l, tm), r));
	}
	int get_min(int l, int r) {
		return get_min(0, 0, n, l, r);
	}
	int val(int pos) {
		int v = 0, tl = 0, tr = n;
		while (tl + 1 != tr) {
			int tm = (tl + tr) / 2;
			if (pos < tm) {
				v = v * 2 + 1;
				tr = tm;
			}
			else {
				v = v * 2 + 2;
				tl = tm;
			}
		}
		return t[v];
	}
	void put(int v, int tl, int tr, int pos, int val) {
		if (tl + 1 == tr) {
			t[v] = val;
			mn[v] = val;
		}
		else {
			int tm = (tl + tr) / 2;
			if (pos < tm) put(v * 2 + 1, tl, tm, pos, val);
			else put(v * 2 + 2, tm, tr, pos, val);
			t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
			mn[v] = min(mn[v * 2 + 1], mn[v * 2 + 2]);
		}
	}
	void put(int pos, int val) {
		put(0, 0, n, pos, val);
	}
	int getLeft(int v, int tl, int tr, int l, int r, int  val) {
		if (l >= r) return INF;
		if (t[v] < val) return INF;
		int tm = (tl + tr) / 2;
		if (tl == l && tr == r) {
			if (tl + 1 == tr) return tl;
			if (val <= t[v * 2 + 1]) return getLeft(v * 2 + 1, tl, tm, l, min(r, tm), val);
			else return getLeft(v * 2 + 2, tm, tr, max(l, tm), r, val);
		}
		else {
			return min(getLeft(v * 2 + 1, tl, tm, l, min(r, tm), val),
					getLeft(v * 2 + 2, tm, tr, max(l, tm), r, val));
		}
	}
	int getLeft(int l, int r, int val) {
		return getLeft(0, 0, n, l, r, val);
	}
	int getRight(int v, int tl, int tr, int l, int r, int  val) {
		if (l >= r) return -INF;
		if (t[v] < val) return -INF;
		int tm = (tl + tr) / 2;
		if (tl == l && tr == r) {
			if (tl + 1 == tr) return tl;
			if (val <= t[v * 2 + 2]) return getRight(v * 2 + 2, tm, tr, max(l, tm), r, val);
			else return getRight(v * 2 + 1, tl, tm, l, min(r, tm), val);
		}
		else {
			return max(getRight(v * 2 + 1, tl, tm, l, min(r, tm), val),
				getRight(v * 2 + 2, tm, tr, max(l, tm), r, val));
		}
	}
	int getRight(int l, int r, int val) {
		return getRight(0, 0, n, l, r, val);
	}
};

DO row, column;
int timer = 0;

bool check_one(int r1, int c1, int r2, int c2, int k) {
	if (r1 == r2) {
		if (timer - row.val(r1) <= k) {
			return 1;
		}
		if (c1 > c2) swap(c1, c2);
		if (timer - column.get_min(c1, c2 + 1) <= k) return 1;
	}
	if (c1 == c2) {
		if (timer - column.val(c1) <= k) {
			return 1;
		}
		if (r1 > r2) swap(r1, r2);
		if (timer - row.get_min(r1, r2 + 1) <= k) return 1;
	}
	return 0;
}

bool check_two(int r1, int c1, int r2, int c2, int k) {
	if (r1 == r2) return 0;
	if (c1 == c2) return 0;
	int x, y;
	x = r1, y = c2;
	if (check_one(r1, c1, x, y, k) && check_one(r2, c2, x, y, k)) {
		return 1;
	}
	x = r2, y = c1;
	if (check_one(r1, c1, x, y, k) && check_one(r2, c2, x, y, k)) {
		return 1;
	}
	return 0;
}

void solve() {
	cin >> n >> m >> q;
	row.init(n), column.init(m);
	while (q--) {
		timer++;
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			--r;
			row.put(r, timer);
		}
		else if (type == 2) {
			int c;
			cin >> c;
			--c;
			column.put(c, timer);
		}
		else {
			int ans = INF;
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1; --c1; --r2; --c2;
			// check one
			if (check_one(r1, c1, r2, c2, k)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			// check two
			if (check_two(r1, c1, r2, c2, k)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			// magic
			
			// check put vertical line
			if (timer - row.val(r1) <= k && timer - row.val(r2) <= k) {
				int y1 = c1, y2 = c2;
				if (y1 > y2) swap(y1, y2);
				if (column.getLeft(y1, y2, timer - k) != INF) {
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}
				// check right
				int res = column.getLeft(y2, m, timer - k);
				if (res != INF) {
					ans = min(ans, abs(r1 - r2) + (res - y1) + (res - y2));
				}
				res = column.getRight(0, y1, timer - k);
				if (res != -INF) {
					ans = min(ans, abs(r1 - r2) + (y1 - res) + (y2 - res));
				}
			}
			// check put horizontal
			if (timer - column.val(c1) <= k && timer - column.val(c2) <= k) {
				int x1 = r1, x2 = r2;
				if (x1 > x2) swap(x1, x2);
				if (row.getLeft(x1, x2, timer - k) != INF) {
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}
				int res = row.getLeft(x2, n, timer - k);
				if (res != INF) {
					ans = min(ans, abs(c1 - c2) + (res - x1) + (res - x2));
				}
				res = row.getRight(0, x1, timer - k);
				if (res != -INF) {
					ans = min(ans, abs(c1 - c2) + (x1 - res) + (x2 - res));
				}
			}
			if (ans == INF) {
				cout << -1 << '\n';
			}
			else {
				cout << ans << '\n';
			}
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	solve();
}