// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

struct stree {
	vector<int> mn, mx;
	void init(int n) {
		int _n = 1;
		while (_n < n) _n *= 2;
		n = _n;
		mn.assign(2 * n, -1);
		mx.assign(2 * n, -1);
	}
	void upd(int i, int x) {
		i += (int)mn.size() / 2;
		mn[i] = x, mx[i] = x;
		while (i > 1) {
			i /= 2;
			mn[i] = min(mn[2 * i], mn[2 * i + 1]);
			mx[i] = max(mx[2 * i], mx[2 * i + 1]);
		}
	}
	int _get_mn(int v, int vl, int vr, int l, int r) {
		if (vr <= l || r <= vl) return 1e9;
		if (vl >= l && vr <= r) return mn[v];
		int vm = (vl + vr) / 2;
		return min(_get_mn(2 * v, vl, vm, l, r), _get_mn(2 * v + 1, vm, vr, l, r));
	}
	int get_mn(int l, int r) {
		return _get_mn(1, 0, (int)mn.size() / 2, l, r);
	}
	int _get_mx(int v, int vl, int vr, int l, int r) {
		if (vr <= l || r <= vl) return -1e9;
		if (vl >= l && vr <= r) return mx[v];
		int vm = (vl + vr) / 2;
		return max(_get_mx(2 * v, vl, vm, l, r), _get_mx(2 * v + 1, vm, vr, l, r));
	}
	int get_mx(int l, int r) {
		return _get_mx(1, 0, (int)mx.size() / 2, l, r);
	}
	int get(int i) {
		return mn[i + (int)mn.size() / 2];
	}
	int get_pref(int i, int x) {
		i += (int)mx.size() / 2;
		int v = -1;
		while (i > 1) {
			if (i % 2 == 1 && mx[i - 1] >= x) {
				v = i - 1;
				break;
			}
			i /= 2;
		}
		if (v == -1) return -1;
		while (2 * v + 1 < (int)mx.size()) {
			if (mx[2 * v + 1] >= x) v = 2 * v + 1;
			else v = 2 * v;
		}
		return v - (int)mx.size() / 2;
	}
	int get_suf(int i, int x) {
		i += (int)mx.size() / 2;
		int v = -1;
		while (i > 1) {
			if (i % 2 == 0 && mx[i + 1] >= x) {
				v = i + 1;
				break;
			}
			i /= 2;
		}
		if (v == -1) return -1;
		while (2 * v + 1 < (int)mx.size()) {
			if (mx[2 * v] >= x) v = 2 * v;
			else v = 2 * v + 1;
		}
		return v - (int)mx.size() / 2;
	}
};

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	//ifstream cin("input.txt");
	int n, m, q;
	cin >> n >> m >> q;
	stree s, t;
	s.init(n), t.init(m);
	for (int i = 0; i < q; i++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int ri;
			cin >> ri;
			ri--;
			s.upd(ri, i);
		}
		else if (tp == 2) {
			int ci;
			cin >> ci;
			ci--;
			t.upd(ci, i);
		}
		else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, y1--, x2--, y2--;
			int ans = -1;
			//if (x1 == x2 && s[x1] >= i - k) ans = abs(y1 - y2);
			//if (y1 == y2 && t[y1] >= i - k) ans = abs(x1 - x2);
			if (s.get(x1) >= i - k && t.get(y2) >= i - k) ans = abs(x1 - x2) + abs(y1 - y2);
			if (t.get(y1) >= i - k && s.get(x2) >= i - k) ans = abs(x1 - x2) + abs(y1 - y2);
			if (ans != -1) {
				cout << ans << '\n';
				continue;
			}
			if (t.get(y1) >= i - k && t.get(y2) >= i - k) {
				ans = 1e9;
				if (t.get_mn(min(y2, y1), max(y2, y1) + 1) >= i - k) {
					ans = abs(x1 - x2) + abs(y1 - y2);
				}
				int x = s.get_pref(x1, i - k);
				if (x != -1) ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
				/*for (int x = x1 - 1; x >= 0; x--) {
					if (s.get(x) >= i - k) {
						ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
						break;
					}
				}*/
				x = s.get_suf(x1, i - k);
				if (x != -1) ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
				/*for (int x = x1 + 1; x < n; x++) {
					if (s.get(x) >= i - k) {
						ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
						break;
					}
				}*/
				x = s.get_pref(x2, i - k);
				if (x != -1) ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
				/*for (int x = x2 - 1; x >= 0; x--) {
					if (s.get(x) >= i - k) {
						ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
						break;
					}
				}*/
				x = s.get_suf(x2, i - k);
				if (x != -1) ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
				/*for (int x = x2 + 1; x < n; x++) {
					if (s.get(x) >= i - k) {
						ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x2 - x));
						break;
					}
				}*/
				if (ans == 1e9) cout << -1 << '\n';
				else cout << ans << '\n';
			}
			else if (s.get(x1) >= i - k && s.get(x2) >= i - k) {
				ans = 1e9;
				if (s.get_mn(min(x2, x1), max(x2, x1) + 1) >= i - k) {
					ans = abs(x1 - x2) + abs(y1 - y2);
				}
				int y = t.get_pref(y1, i - k);
				if (y != -1) ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
				/*for (int y = y1 - 1; y >= 0; y--) {
					if (t.get(y) >= i - k) {
						ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
						break;
					}
				}*/
				y = t.get_suf(y1, i - k);
				if (y != -1) ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
				/*for (int y = y1 + 1; y < m; y++) {
					if (t.get(y) >= i - k) {
						ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
						break;
					}
				}*/
				y = t.get_pref(y2, i - k);
				if (y != -1) ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
				/*for (int y = y2 - 1; y >= 0; y--) {
					if (t.get(y) >= i - k) {
						ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
						break;
					}
				}*/
				y = t.get_suf(y2, i - k);
				if (y != -1) ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
				/*for (int y = y2 + 1; y < m; y++) {
					if (t.get(y) >= i - k) {
						ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y2 - y));
						break;
					}
				}*/
				if (ans == 1e9) cout << -1 << '\n';
				else cout << ans << '\n';
			}
			else {
				cout << -1 << '\n';
			}
		}
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
