#include <iostream>
#include <algorithm>
#include <tuple>
#include <vector>
using namespace std;

const int max_n = 3 * 1e5;
int a[max_n];
int t[4 * max_n];  /// 0 - nothing

void push(int v){
    if(t[v] == 0)
        return;
    t[2 * v] = t[2 * v + 1] = t[v];
    t[v] = 0;
}

void update(int v, int tl, int tr, int l, int r, int new_color){
    if(l > r)
        return;
    if(l == tl && r == tr){
        t[v] = new_color;
        return;
    }
    int tm = (tl + tr) / 2;
    push(v);
    update(2 * v, tl, tm, l, min(tm, r), new_color);
    update(2 * v + 1, tm + 1, tr, max(tm + 1, l), r, new_color);
}
int get(int v, int tl, int tr, int pos){
    if(t[v] != 0)
        return t[v];
    int tm = (tl + tr) / 2;
    if(pos <= tm)
        return get(2 * v, tl, tm, pos);
    else
        return get(2 * v + 1, tm + 1, tr, pos);
}
int main(){
    int m, n;
    cin >> m >> n;
    for(int i=0; i<m; i++){
        cin >> a[i];
    }
    int first_index[n + 1], last_index[n + 1];
    bool used[n + 1];
    fill(first_index, first_index + n + 1, -1);
    fill(last_index, last_index + n + 1, -1);
    fill(used, used + n + 1, -1);
    for(int i=0; i<m; i++){
        if(first_index[a[i]] == -1)
            first_index[a[i]] = i;
        last_index[a[i]] = i;
    }
    vector<tuple<int, int, int>> answer;  /// c, l, r
    for(int i=0; i<m; i++){
        int cur_color = a[i];
        if(i == first_index[cur_color]){
            answer.push_back(make_tuple(cur_color, first_index[cur_color] + 1, last_index[cur_color] + 1));
            update(1, 0, m - 1, first_index[cur_color], last_index[cur_color], cur_color);
        }
    }
    /// check
    for(int i=0; i<m; i++){
        if(a[i] != get(1, 0, m - 1, i)){
            cout << -1;
            return 0;
        }
    }
    cout << answer.size() << "\n";
    for(int i=0; i<answer.size(); i++){
        auto t = answer[i];
        cout << get<0>(t) << " " << get<1>(t) << " " << get<2>(t) << "\n";
    }
    return 0;
}
