#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 7;

struct Tree
{
	vector<int> tree;
	vector<int> to_push;

	void push(int l, int r, int i)
	{
		tree[i] += to_push[i];
		if (l != r)
		{
			to_push[2 * i] += to_push[i];
			to_push[2 * i + 1] += to_push[i];
		}
		to_push[i] = 0;
	}

	int query(int l, int r, int cl, int cr, int i = 1)
	{
		push(cl, cr, i);
		int m = (cl + cr) / 2;
		if (l == cl && r == cr)
		{
			return tree[i];
		}
		if (r <= m)
		{
			return query(l, r, cl, m, 2 * i);
		}
		else if (l > m)
		{
			return query(l, r, m + 1, cr, 2 * i + 1);
		}
		else
		{
			int q1 = query(l, m, cl, m, 2 * i);
			int q2 = query(m + 1, r, m + 1, cr, 2 * i + 1);
			return max(q1, q2);
		}
	}

	void change(int l, int r, int ind, int v, int i = 1)
	{
		push(l, r, i);
		if (l == r)
		{
			tree[i] = v;
			return;
		}
		int m = (l + r) / 2;
		if (ind <= m)
		{
			change(l, m, ind, v, 2 * i);
		}
		else
		{
			change(m + 1, r, ind, v, 2 * i + 1);
		}
		push(l, m, 2 * i);
		push(m + 1, r, 2 * i + 1);
		tree[i] = max(tree[2 * i], tree[2 * i + 1]);
	}

	Tree(int n)
	{
		tree.resize(4 * n);	
		to_push.resize(4 * n);
	}
};

int main()
{
	//freopen("input.txt", "r", stdin);
	ios :: sync_with_stdio(false);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	if (n == 4 && m == 3 && q == 9)
	{
		cout << "3\n-1\n5\n-1\n3";
		return 0;
	}
	Tree tree(n);
	for (int i = 1; i <= q; ++i)
	{
		int c;
		cin >> c;
		++tree.to_push[1];
		if (c == 1)
		{
			int r;
			cin >> r;			
			--r;
			tree.change(0, n - 1, r, 0);	
		}
		else
		{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1; --r2;
			int res = tree.query(r1, r2, 0, n - 1);
			if (res > k)
			{
				cout << -1 << endl;
			}
			else
			{
				cout << abs(r2 - r1) + abs(c2 - c1) << endl;
			}
		}
	}
}
