#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

vector<int> tx, ty;

int getx(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return 1000000000;
    if(x<=l&&r<=y)
        return tx[it];
    int m = (l+r)/2;
    return min(getx(l, m, x, y, 2*it), getx(m, r, x, y, 2*it+1));
}

int gety(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return 1000000000;
    if(x<=l&&r<=y)
        return ty[it];
    int m = (l+r)/2;
    return min(gety(l, m, x, y, 2*it), gety(m, r, x, y, 2*it+1));
}

void updx(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        tx[it] = y;
        return;
    }
    int m = (l+r)/2;
    updx(l, m, x, y, 2*it);
    updx(m, r, x, y, 2*it+1);
    tx[it] = min(tx[2*it], tx[2*it+1]);
}

void updy(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        ty[it] = y;
        return;
    }
    int m = (l+r)/2;
    updy(l, m, x, y, 2*it);
    updy(m, r, x, y, 2*it+1);
    ty[it] = min(ty[2*it], ty[2*it+1]);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    tx.resize(4*m, -1);
    ty.resize(4*n, -1);
    vector<int> v(n, -1), g(m, -1);
    for(int i = 0; i<q; i++){
        int t;
        cin >> t;
        if(t==1){
            int it;
            cin >> it;
            it--;
            updy(0, n, it, i, 1);
            v[it] = i;
        }
        if(t==2){
            int it;
            cin >> it;
            it--;
            updx(0, m, it, i, 1);
            g[it] = i;
        }
        if(t==3){
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            int mny = gety(0, n, min(x1, x2), max(x1, x2), 1), mnx = getx(0, m, min(y1, y2), max(y1, y2), 1);
            if(mny==1000000000)
                mny = -1;
            if(mnx==1000000000)
                mnx = -1;
            //cout << mnx << ':' << mny << endl;
            if((max(v[x1], mnx)>=i-k&&max(g[y2], mny)>=i-k)||(max(g[y1], mny)>=i-k&&max(v[x2], mnx)>=i-k)){
                cout << abs(x1-x2)+abs(y1-y2) << '\n';
                continue;
            }
            int ans = 1000000000;
            if(v[x1]>=i-k&&v[x2]>=i-k){
                for(int j = 0; j<m; j++){
                    if(g[j]<i-k)
                        continue;
                    ans = min(ans, abs(x1-x2)+abs(j-y1)+abs(j-y2));
                }
            }
            if(g[y1]>=i-k&&g[y2]>=i-k){
                for(int j = 0; j<n; j++){
                    if(v[j]<i-k)
                        continue;
                    ans = min(ans, abs(y1-y2)+abs(j-x1)+abs(j-x2));
                }
            }
            if(ans==1000000000)
                cout << -1 << '\n';
            else
                cout << ans << '\n';
        }
    }

    return 0;
}
/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
