#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

vector<int> tx, ty, tx1, ty1;

int getx(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return 1000000000;
    if(x<=l&&r<=y)
        return tx[it];
    int m = (l+r)/2;
    return min(getx(l, m, x, y, 2*it), getx(m, r, x, y, 2*it+1));
}

int gety(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return 1000000000;
    if(x<=l&&r<=y)
        return ty[it];
    int m = (l+r)/2;
    return min(gety(l, m, x, y, 2*it), gety(m, r, x, y, 2*it+1));
}

void updx(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        tx[it] = y;
        return;
    }
    int m = (l+r)/2;
    updx(l, m, x, y, 2*it);
    updx(m, r, x, y, 2*it+1);
    tx[it] = min(tx[2*it], tx[2*it+1]);
}

void updy(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        ty[it] = y;
        return;
    }
    int m = (l+r)/2;
    updy(l, m, x, y, 2*it);
    updy(m, r, x, y, 2*it+1);
    ty[it] = min(ty[2*it], ty[2*it+1]);
}

int getx1(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return -1000000000;
    if(x<=l&&r<=y)
        return tx1[it];
    int m = (l+r)/2;
    return max(getx1(l, m, x, y, 2*it), getx1(m, r, x, y, 2*it+1));
}

int gety1(int l, int r, int x, int y, int it){
    if(r<=l||r<=x||y<=l)
        return -1000000000;
    if(x<=l&&r<=y)
        return ty1[it];
    int m = (l+r)/2;
    return max(gety1(l, m, x, y, 2*it), gety1(m, r, x, y, 2*it+1));
}

void updx1(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        tx1[it] = y;
        return;
    }
    int m = (l+r)/2;
    updx1(l, m, x, y, 2*it);
    updx1(m, r, x, y, 2*it+1);
    tx1[it] = max(tx1[2*it], tx1[2*it+1]);
}

void updy1(int l, int r, int x, int y, int it){
    if(l>x||r<=x)
        return;
    if(l==x&&r-1==l){
        ty1[it] = y;
        return;
    }
    int m = (l+r)/2;
    updy1(l, m, x, y, 2*it);
    updy1(m, r, x, y, 2*it+1);
    ty1[it] = max(ty1[2*it], ty1[2*it+1]);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    tx.resize(4*m, -1);
    ty.resize(4*n, -1);
    tx1.resize(4*m, -1);
    ty1.resize(4*n, -1);
    vector<int> v(n, -1), g(m, -1);
    for(int i = 0; i<q; i++){
        int t;
        cin >> t;
        if(t==1){
            int it;
            cin >> it;
            it--;
            updy(0, n, it, i, 1);
            updy1(0, n, it, i, 1);
            v[it] = i;
        }
        if(t==2){
            int it;
            cin >> it;
            it--;
            updx(0, m, it, i, 1);
            updx1(0, m, it, i, 1);
            g[it] = i;
        }
        if(t==3){
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            int mny = gety(0, n, min(x1, x2), max(x1, x2)+1, 1), mnx = getx(0, m, min(y1, y2), max(y1, y2)+1, 1);
            if(mny==1000000000)
                mny = -1;
            if(mnx==1000000000)
                mnx = -1;
            //cout << mnx << ':' << mny << endl;
            if((max(v[x1], mnx)>=i-k&&max(g[y2], mny)>=i-k)||(max(g[y1], mny)>=i-k&&max(v[x2], mnx)>=i-k)){
                cout << abs(x1-x2)+abs(y1-y2) << '\n';
                continue;
            }
            int ans = 1000000000;
            //cout << getx1(0, m, min(y1, y2), max(y1, y2)+1, 1) << ' ';
            /*if(g[y1]>=i-k&&g[y2]>=i-k){
                if(gety1(0, n, min(x1, x2), max(x1, x2)+1, 1)>=i-k)
                    ans = min(ans, abs(x1-x2)+abs(y1-y2));
                int l = -1, r = min(x1, x2);
                while(r-l>1){
                    int m1 = (l+r)/2;
                    if(gety1(0, n, m1, min(n, max(x1, x2)+1+(min(x1, x2)-m1)), 1)>=i-k)
                        l = m1;
                    else
                        r = m1;
                }
                if(l>=0)
                    ans = min(ans, abs(y1-y2)+2*(min(x1, x2)-l)+abs(x1-x2));
                l = max(x1, x2), r = n;
                while(r-l>1){
                    int m1 = (l+r)/2;
                    if(gety1(0, n, x1, m1+1, 1)>=i-k)
                        r = m1;
                    else
                        l = m1;
                }
                if(r<n)
                    ans = min(ans, abs(y1-y2)+2*(r-max(x1, x2))+abs(x1-x2));
            }*/
            if(g[y1]>=i-k&&g[y2]>=i-k){
                int l = -1, r = max(min(x1, x2), n-max(x1, x2)-1)+1;
                while(r-l>1){
                    int m1 = (r+l)/2;
                    if(gety1(0, n, max(0, min(x1, x2)-m1), min(n, max(x1, x2)+1+m1), 1)>=i-k)
                        r = m1;
                    else
                        l = m1;
                }
                if(l<max(min(x1, x2), n-max(x1, x2)-1))
                    ans = min(ans, abs(y1-y2)+abs(x1-x2)+2*r);
            }
            if(v[x1]>=i-k&&v[x2]>=i-k){
                if(getx1(0, m, min(y1, y2), max(y1, y2)+1, 1)>=i-k)
                    ans = min(ans, abs(y1-y2)+abs(x1-x2));
                int l = -1, r = min(y1, y2);
                while(r-l>1){
                    int m1 = (l+r)/2;
                    if(getx1(0, m, m1, y1, 1)>=i-k)
                        l = m1;
                    else
                        r = m1;
                }
                if(l>=0)
                    ans = min(ans, abs(x1-x2)+abs(l-y1)+abs(l-y2));
                l = max(y1, y2), r = n;
                while(r-l>1){
                    int m1 = (l+r)/2;
                    if(getx1(0, m, y1, m1+1, 1)>=i-k)
                        r = m1;
                    else
                        l = m1;
                }
                if(r<n)
                    ans = min(ans, abs(x1-x2)+abs(r-y1)+abs(r-y2));
            }
            if(ans==1000000000)
                cout << -1 << '\n';
            else
                cout << ans << '\n';
        }
    }

    return 0;
}
/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
