#include <iostream>
#include <bits/stdc++.h>

using namespace std;

struct segment_tree {
    vector<int> Max, Min;
    int inf = (int) 1e9;
    int last;

    segment_tree(int n) {
        last = n - 1;
        Max.resize(n * 4, 0);
        Min.resize(n * 4, 0);
    }

    int get_min(int l, int r) {
        return get_min(0, 0, last, l, r);
    }

    int get_min(int v, int l, int r, int left, int right) {
        if (l > right || r < left) return inf;
        if (l >= left && r <= right) return Min[v];
        int m = (l + r) / 2;
        return min(get_min(v * 2 + 1, l, m, left, right), get_min(v * 2 + 2, m + 1, r, left, right));
    }

    void update(int v, int l, int r, int id, int c) {
        if (l > id || r < id) return;
        if (l == id && r == id) {
            Max[v] = c;
            Min[v] = c;
            return;
        }
        int m = (l + r) / 2;
        update(v * 2 + 1, l, m, id, c);
        update(v * 2 + 2, m + 1, r, id, c);
        Max[v] = max(Max[v * 2 + 1], Max[v * 2 + 2]);
        Min[v] = min(Min[v * 2 + 1], Min[v * 2 + 2]);
    }

    void update(int id, int c) {
        update(0, 0, last, id, c);
    }

    int pref_id(int v, int l, int r, int id, int t) {
        if (Max[v] < t) return inf;
        if (r < id) return inf;
        if (l == r) return l;
        int m = (l + r) / 2;
        int ans = pref_id(v * 2 + 1, l, m, id, t);
        if (ans == inf) ans = pref_id(v * 2 + 2, m + 1, r, id, t);
        return ans;
    }

    int pref_id(int id, int t) {
        return pref_id(0, 0, last, id, t);
    }

    int suf_id(int id, int t) {
        return suf_id(0, 0, last, id, t);
    }

    int suf_id(int v, int l, int r, int id, int t) {
        if (Max[v] < t) return -1;
        if (l > id) return -1;
        if (l == r) return l;
        int m = (l + r) / 2;
        int ans = suf_id(v * 2 + 2, m + 1, r, id, t);
        if (ans == -1) ans = suf_id(v * 2 + 1, l, m, id, t);
        return ans;
    }
};

int n, m;
vector<int> one_, two_;
segment_tree one = segment_tree(1), two = segment_tree(1);
int inf = 1e9;

int third_type(int x1, int y1, int x2, int y2, int k, int t) {
    int ans = inf;
    int min_ = abs(x1 - x2) + abs(y1 - y2);
    bool all_two = false;
    bool all_one = false;
    bool have_one = false;
    bool have_two = false;

    if (t - one_[x1] <= k) all_two = true;
    if (t - two_[y1] <= k) all_one = true;
    if (t - one_[x2] <= k) have_one = true;
    if (t - two_[y2] <= k) have_two = true;

    if ((!have_one && !have_two) || (!all_two && !all_one)) {
        return -1;
    }

    bool can1 = true;
    if (t - one.get_min( min(x1, x2), max(x1,x2)) > k) can1 = false;
    bool can2 = true;
    if (t - two.get_min(min(y1, y2), max(y1,y2)) > k) can2 = false;

    if (can1 || can2) ans = min_;

    if ((all_one && have_one) || (all_two && have_two)) ans = min_;

    if (all_one && have_two) {
        int max_x = one.suf_id(x2, t - k);
        int min_x = one.pref_id(x2, t - k);
        int maybe1 = inf;
        if (max_x != -1) maybe1 = abs(x1 - max_x) + abs(y1 - y2) + abs(max_x - x2);
        int maybe2 = inf;
        if (min_x != inf) maybe2 = abs(min_x - x1) + abs(y1 - y2) + abs(min_x - x2);
        ans = min(ans, min(maybe1, maybe2));
    }

    if (all_two && have_one) {
        int max_y = two.suf_id(y2, t - k);
        int min_y = two.pref_id(y2, t - k);
        int maybe1 = inf;
        int maybe2 = inf;
        if (max_y != -1) maybe1 = abs(y1 - max_y) + abs(x1 - x2) + abs(max_y - y2);
        if (min_y != inf) maybe2 = abs(min_y - y1) + abs(x1 - x2) + abs(min_y - y2);
        ans = min(ans, min(maybe1, maybe2));
    }
    return ans == inf ? -1 : ans;
}

int main() {
    int q;
    cin >> n >> m >> q;
    one = segment_tree(n);
    two = segment_tree(m);
    one_.resize(n, 0);
    two_.resize(m, 0);
    for (int t = 1; t <= q; t++) {
        int type;
        cin >> type;
        int x;
        if (type == 1) {
            cin >> x;
            x--;
            one_[x] = t;
            one.update(x, t);
        }
        if (type == 2) {
            cin >> x;
            x--;
            two_[x] = t;
            two.update(x, t);
        }
        if (type == 3) {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            cout << (third_type(x1, y1, x2, y2, k, t));
        }
    }
}