#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstdio>
#include <deque>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>
#include <ctime>
#include <fstream>
#include <cassert>
#include <cmath>

#pragma warning(4996:disable)
#pragma comment(linker, "/STACK:512000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)

const int inf = 1e9, maxn = 3e5;
const ll llinf = 1e18, mod = 1000'000'007;
const char el = '\n';

mt19937 rnd(time(NULL));

struct node {
	int l, r, mx, mn;
	node() { mx = mn = 0; }
};
struct Segment_Tree {
	vector<node> t;
	void build(int v, int l, int r) {
		t[v].l = l, t[v].r = r;
		if (l + 1 < r) {
			int m = (l + r) >> 1;
			build(v + v, l, m);
			build(v + v + 1, m, r);
		}
	}
	Segment_Tree(int n) {
		t.resize(n * 4);
		build(1, 0, n);
	}
	void update(int pos, int x, int v = 1) {
		if (t[v].l + 1 == t[v].r) {
			t[v].mx = t[v].mn = x;
		}
		else {
			int m = (t[v].l + t[v].r) >> 1;
			if (pos < m) update(pos, x, v + v);
			else update(pos, x, v + v + 1);
			t[v].mx = max(t[v + v].mx, t[v + v + 1].mx);
			t[v].mn = min(t[v + v].mn, t[v + v + 1].mn);
		}
	}
	int mx(int l, int r, int v = 1) {
		if (l >= r) return 0;
		if (t[v].l == l && t[v].r == r)
			return t[v].mx;
		int m = (t[v].l + t[v].r) >> 1;
		return max(mx(l, min(m, r), v + v), mx(max(l, m), r, v + v + 1));
	}
	int mn(int l, int r, int v = 1) {
		if (l >= r) return inf;
		if (t[v].l == l && t[v].r == r)
			return t[v].mn;
		int m = (t[v].l + t[v].r) >> 1;
		return min(mn(l, min(m, r), v + v), mn(max(l, m), r, v + v + 1));
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	Segment_Tree r(n), c(m);
	vector<int> rr(n), cc(m);
	firn(it, q + 1) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			r.update(x - 1, it);
			rr[x - 1] = it;
			continue;
		}
		if (type == 2) {
			int x;
			cin >> x;
			c.update(x - 1, it);
			cc[x - 1] = it;
			continue;
		}
		int x1, y1, x2, y2, k;
		cin >> x1 >> y1 >> x2 >> y2 >> k;
		x1--; y1--; x2--; y2--;
		k = it - k;
		if (rr[x1] < k && cc[y1] < k) {
			cout << -1 << el;
			continue;
		}
		if (rr[x2] < k && cc[y2] < k) {
			cout << -1 << el;
			continue;
		}
		if ((rr[x1] >= k && cc[y1] >= k) || (rr[x2] >= k && cc[y2] >= k)) {
			cout << abs(x1 - x2) + abs(y1 - y2) << el;
			continue;
		}
		if (x1 > x2) swap(x1, x2);
		if (y1 > y2) swap(y1, y2);
		if ((rr[x1] >= k && rr[x2] >= k) || (cc[y1] >= k && cc[y2] >= k)) {
			if (rr[x1] >= k) {
				if (r.mn(x1, x2 + 1) >= k) {
					cout << abs(x1 - x2) + abs(y1 - y2) << el;
					continue;
				}
				int l1 = -1, r1 = m;
				if (c.t[1].mx < k) {
					cout << -1 << el;
					continue;
				}
				while (r1 - l1 > 1) {
					int mid = (l1 + r1) >> 1;
					int ll = max(y1 - mid, 0), rr = min(y2 + mid + 1, m);
					if (c.mx(ll, rr) >= k)
						r1 = mid;
					else l1 = mid;
				}
				cout << abs(x1 - x2) + abs(y1 - y2) + 2 * r1 << el;
			}
			else {
				if (c.mn(y1, y2 + 1) >= k) {
					cout << abs(x1 - x2) + abs(y1 - y2) << el;
					continue;
				}
				int l1 = -1, r1 = n;
				if (r.t[1].mx < k) {
					cout << -1 << el;
					continue;
				}
				while (r1 - l1 > 1) {
					int mid = (l1 + r1) >> 1;
					int ll = max(x1 - mid, 0), rr = min(x2 + mid + 1, n);
					if (r.mx(ll, rr) >= k)
						r1 = mid;
					else l1 = mid;
				}
				cout << abs(x1 - x2) + abs(y1 - y2) + 2 * r1 << el;
			}
		}
		else {
			cout << abs(x1 - x2) + abs(y1 - y2) << el;
		}
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}