#define REL
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <queue>
#include <set>
#include <map>
#include <set>

#define mp make_pair
#define pb push_back
#define pp " "
#define nn "\n"
#define all(x) x.begin(), x.end()

using namespace std;

struct Zap {
	int ty;
	int a;
	pair <int, int> s, f;
	Zap() {}
	Zap(int ty_, int a_) {
		ty = ty_;
		a = a_;
	}
	Zap(int ty_, int a_, pair <int, int> s_, pair <int, int> f_) {
		ty = ty_;
		a = a_;
		s = s_;
		f = f_;
	}
};

int n, m, q;
vector <Zap> zap;
vector <pair <int, int>> g, v;
vector <int> used;

bool finnd(vector <int> &t, int l, int r) {
	int lg = lower_bound(all(t), l) - t.begin();
	int rg = upper_bound(all(t), r) - t.begin();
	if (rg > lg) return true;
	return false;
}

int dist(int i) {
	return abs(zap[i].f.first - zap[i].s.first) + abs(zap[i].f.second - zap[i].s.second);
}

pair <int, int> get_gp(vector <pair <int, int>> &v, int lg, int rg) {
	pair<int, int> ret;
	int l = -1, r = v.size(), m;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (v[m].second >= lg) {
			r = m;
		}
		else {
			l = m;
		}
	}
	ret.first = r;
	l = -1; r = v.size();  m = 0;
	while (r - l > 1) {
		m = (l + r) / 2;
		if (v[m].first > rg) {
			r = m;
		}
		else {
			l = m;
		}
	}
	ret.second = r - 1;
	return ret;
}

const int INF = 1e9 + 7;

pair <int, int> hod(int tims, int timf, pair <int, int> a) {
	pair <int, int> ret = mp(INF, INF);
	for (int i = tims; i <= timf; i++) {
		if (zap[i].ty == 1) {
			ret.first = min(ret.first, abs(a.first - zap[i].a));
		}
		if (zap[i].ty == 2) {
			ret.second = min(ret.second, abs(a.second - zap[i].a));
		}
	}
	return ret;
}

int tpro = 0;

bool pro(int l, int r, int ty, int x, int y) {
	tpro++;
	for (int i = l; i <= r; i++) {
		if (ty == zap[i].ty) {
			used[zap[i].a] = tpro;
		}
	}
	for (int i = x; i <= y; i++) {
		if (used[i] != tpro) {
			return false;
		}
	}
	return true;
}

int check(int l, int r, int x, int y, int ty) {
	pair<int, int> ret = mp(INF, INF);
	for (int i = l; i <= r; i++) {
		if (zap[i].ty == ty) {
			if (zap[i].a >= x && zap[i].a <= y) return 0;
			ret.first = min(ret.first, abs(x - zap[i].a));
			ret.second = min(ret.second, abs(y - zap[i].a));
		}
	}
	return min(ret.first, ret.second);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> q;
	used.resize(max(n, m));
	zap.resize(q);
	for (int i = 0; i < q; i++) {
		cin >> zap[i].ty;
		if (zap[i].ty <= 2) {
			cin >> zap[i].a;
			zap[i].a--;
		}
		else {
			cin >> zap[i].s.first >> zap[i].s.second >> zap[i].f.first >> zap[i].f.second >> zap[i].a;
			zap[i].s.first--; zap[i].s.second--; zap[i].f.first--; zap[i].f.second--;
			if (zap[i].s > zap[i].f) swap(zap[i].s, zap[i].f);
		}
	}
	for (int i = 0; i < zap.size(); i++) {
		if (zap[i].ty == 3) {
			int tim = i - zap[i].a;
			if (tim <= -1) {
				cout << dist(i) << nn;
				continue;
			}
			auto sq = hod(tim, i, zap[i].s);
			auto fq = hod(tim, i, zap[i].f);
			if ((sq.first == 0 && fq.second == 0) || (fq.first == 0 && sq.second == 0)) {
				cout << dist(i) << nn;
				continue;
			}
			else {
				if (sq.first == 0 && fq.first == 0) {
					if (pro(tim, i, 1, min(zap[i].f.first, zap[i].s.first), max(zap[i].f.first, zap[i].s.first))) {
						cout << dist(i) << nn;
						continue;
					}
					auto w = check(tim, i, min(zap[i].f.second, zap[i].s.second), max(zap[i].f.second, zap[i].s.second), 2);
					if (w == INF) {
						cout << -1 << nn;
						continue;
					}
					else {
						cout << dist(i) + w * 2 << nn;
						continue;
					}
					continue;
				}
				if (sq.second == 0 && fq.second == 0) {
					if (pro(tim, i, 2, min(zap[i].f.second, zap[i].s.second), max(zap[i].f.second, zap[i].s.second))) {
						cout << dist(i) << nn;
						continue;
					}
					auto w = check(tim, i, min(zap[i].f.first, zap[i].s.first), max(zap[i].f.first, zap[i].s.first), 1);
					if (w == INF) {
						cout << -1 << nn;
						continue;
					}
					else {
						cout << dist(i) + w * 2 << nn;
						continue;
					}
					continue;
				}
				cout << -1 << nn;
			}
		}
	}
}