#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allar(a) a, a + n
#define allv(a) a.begin(), a.end()

#include <iostream>
#include <algorithm>
#include <math.h>
#include <string>
#include <string.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int inf = (int)1e9 + 7;
const int N = (int)1e6;

int n, m, q;
int column_tree[N], string_tree[N];

int query(int tree[N], int l, int r) {
	int res = 0;
	for (int i = l; i < r; ++i)
		res = min(res, tree[i]);
	return res;
}

int max_query(int tree[N], int l, int r) {
	int res = -inf;
	for (int i = l; i < r; ++i)
		res = max(res, tree[i]);
	return res;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d%d", &n, &m, &q);
	rep(q, i) {
		int type; scanf("%d", &type);
		if (type == 1) {
			int r; scanf("%d", &r); --r;
			string_tree[r] = -i - 1;
		}
		else if (type == 2) {
			int c; scanf("%d", &c); --c;
			column_tree[c] = -i - 1;
		}
		else {
			int r1, c1, r2, c2, k;
			scanf("%d%d%d%d%d", &r1, &c1, &r2, &c2, &k);
			--r1; --c1; --r2; --c2;

			k -= i + 1;

			int min_r1 = string_tree[r1];
			int min_c1 = column_tree[c1];

			int min_r2 = string_tree[r2];
			int min_c2 = column_tree[c2];

			if (min_r1 > k && min_c1 > k || min_r2 > k && min_c2 > k) {
				printf("-1\n");
				continue;
			}

			if (r1 == r2) {
				if (min_r1 <= k) {
					printf("%d\n", abs(c2 - c1));
					continue;
				}
			}
			else if (c1 == c2) {
				if (min_c1 <= k) {
					printf("%d\n", abs(r2 - r1));
					continue;
				}
			}
			else {
				if (min_r1 <= k && min_c2 <= k || min_c1 <= k && min_r2 <= k) {
					printf("%d\n", abs(r1 - r2) + abs(c1 - c2));
					continue;
				}
			}

			if (min_r1 <= k) {
				if (max_query(string_tree, min(r1, r2), max(r1, r2) + 1 ) <= k) {
					printf("%d\n", abs(r1 - r2) + abs(c1 - c2));
					continue;
				}
				int l = c1, r = c2;
				if (l > r) swap(l, r);
				if (query(column_tree, l + 1, r) <= k) {
					printf("%d\n", abs(r1 - r2) + abs(c1 - c2));
					continue;
				}
				int res1 = inf, res2 = inf;
				if (l > 0 && query(column_tree, 0, l) <= k) {
					int left_ = 0, right_ = l;
					while (left_ + 1 != right_) {
						int middle_ = (left_ + right_) / 2;
						if (query(column_tree, middle_, l) <= k)
							left_ = middle_;
						else
							right_ = middle_;
					}
					res1 = left_;
				}
				if (r < m - 1 && query(column_tree, r + 1, m) <= k) {
					int left_ = r, right_ = m - 1;
					while (left_ + 1 != right_) {
						int middle_ = (left_ + right_) / 2;
						if (query(column_tree, middle_, m) <= k)
							right_ = middle_;
						else
							left_ = middle_;
					}
					res2 = right_;
				}
				if (res1 == inf && res2 == inf) {
					printf("-1\n");
					continue;
				}
				if (res1 != inf) {
					res1 = c1 - res1 + c2 - res1;
					res1 += abs(r1 - r2);
				}
				if (res2 != inf) {
					res2 = res2 - c1 + res2 - c2;
					res2 += abs(r1 - r2);
				}
				printf("%d\n", min(res1, res2));
			}
			else {
				if (max_query(column_tree, min(c1, c2), max(c1, c2) + 1) <= k) {
					printf("%d\n", abs(r1 - r2) + abs(c1 - c2));
					continue;
				}
				int l = r1, r = r2;
				if (l > r) swap(l, r);
				int cur_res = query(string_tree, l + 1, r);
				if (cur_res <= k) {
					printf("%d\n", abs(r1 - r2) + abs(c1 - c2));
					continue;
				}
				int res1 = inf, res2 = inf;
				if (l > 0 && query(string_tree, 0, l) <= k) {
					int left_ = 0, right_ = l;
					while (left_ + 1 != right_) {
						int middle_ = (left_ + right_) / 2;
						cur_res = query(string_tree, middle_, l);
						if (cur_res <= k)
							left_ = middle_;
						else
							right_ = middle_;
					}
					res1 = left_;
				}
				if (r < n - 1 && query(string_tree, r + 1, n) <= k) {
					int left_ = r, right_ = n - 1;
					while (left_ + 1 != right_) {
						int middle_ = (left_ + right_) / 2;
						cur_res = query(string_tree, middle_, n);
						if (cur_res <= k)
							right_ = middle_;
						else
							left_ = middle_;
					}
					res2 = right_;
				}
				if (res1 == inf && res2 == inf) {
					printf("-1\n");
					continue;
				}
				if (res1 != inf) {
					res1 = r1 - res1 + r2 - res1;
					res1 += abs(c1 - c2);
				}
				if (res2 != inf) {
					res2 = res2 - r1 + res2 - r2;
					res2 += abs(c1 - c2);
				}
				printf("%d\n", min(res1, res2));
			}
		}
	}
	return 0;
}