#include <iostream>
#include <stdio.h>
#include <vector>
#include <queue>

using namespace std;

struct node
{
	int mn, mx;
	node* l;
	node* r;
	node() : mn(0), mx(0), l(NULL), r(NULL) {};
};

void recalc(node* &root)
{
	root->mn = 1e9;
	root->mx = -1;
	if (root->l != NULL)
		root->mx = max(root->mx, root->l->mx), root->mn = min(root->mn, root->l->mn);
	if (root->r != NULL)
		root->mx = max(root->mx, root->r->mx), root->mn = min(root->mn, root->r->mn);
}

void build(node* &root, int l, int r)
{
	if (l + 1 > r)
		return;
	root = new node();
	if (l + 1 == r)
		return;
	int m = (l + r) / 2;
	build(root->l, l, m);
	build(root->r, m, r);
	recalc(root);
}

int get(node* &root, int l, int r, int id)
{
	if (l + 1 > r || l > id || r <= id)
		return -2;
	if (l + 1 == r)
		return root->mn;
	int m = (l + r) / 2;
	int q1 = get(root->l, l, m, id);
	int q2 = get(root->r, m, r, id);
	return (q1 == -2 ? q2 : q1);
}

int getmax(node* &root, int l, int r, int l1, int r1)
{
	if (l + 1 > r || l >= r1 || l1 >= r)
		return -2;
	if (l1 <= l && r <= r1)
		return root->mx;
	int m = (l + r) / 2;
	int q1 = getmax(root->l, l, m, l1, r1);
	int q2 = getmax(root->r, m, r, l1, r1);
	return max(q1, q2);
}

int getmin(node* &root, int l, int r, int l1, int r1)
{
	if (l + 1 > r || l >= r1 || l1 >= r)
		return 1e9;
	if (l1 <= l && r <= r1)
		return root->mn;
	int m = (l + r) / 2;
	int q1 = getmin(root->l, l, m, l1, r1);
	int q2 = getmin(root->r, m, r, l1, r1);
	return min(q1, q2);
}


void inc(node* &root, int l, int r, int id, int x)
{
	if (l + 1 > r || l > id || r <= id)
		return;
	if (l + 1 == r)
	{
		root->mn = x, root->mx = x;
		return;
	}
	int m = (l + r) / 2;
	inc(root->l, l, m, id, x);
	inc(root->r, m, r, id, x);
	recalc(root);
}

int tp, x, y, x2, y2, k, tx, ty, tx2, ty2;

int more(node* root, int l, int r, int id)
{
	for (int i = id; i < r; i++)
		if (get(root, l, r, i) >= k)
			return i;


	int ll = id, rr = r, m;
	if (getmax(root, l, r, id, r) < k)
		return 1e9;
	while (ll + 1 < rr)
	{
		m = (ll + rr) / 2;
		if (getmax(root, l, r, id, m) >= k)
			rr = m;
		else
			ll = m;
	}
	return rr - 1;
}

int les(node* root, int l, int r, int id)
{
	for (int i = id; i >= 0; i--)
		if (get(root, l, r, i) >= k)
			return i;


	int ll = 0, rr = id, m;
	if (getmax(root, l, r, 0, id) < k)
		return 1e9;
	while (ll + 1 < rr)
	{
		m = (ll + rr) / 2;
		if (getmax(root, l, r, m, id) >= k)
			ll = m;
		else
			rr = m;
	}
	return ll;
}

node* sb;
node* sr;

int n, m, qq;


int bfs()
{
	int norm = abs(x - x2) + abs(y - y2);
	if (get(sb, 0, m + 1, y) >= k && get(sr, 0, n + 1, x2) >= k || get(sb, 0, m + 1, y2) >= k && get(sr, 0, n + 1, x) >= k)
		return norm;

	int mm = 1e9;
	if (get(sb, 0, m + 1, y) >= k && get(sb, 0, m + 1, y2) >= k)
	{
		int mn = 1e9;
		if (getmin(sb, 0, m + 1, min(y, y2), max(y, y2) + 1) >= k)
			return norm;
		for (int i = 1; i <= n; i++)
			if (get(sr, 0, n + 1, i) >= k)
				mn = min(mn, abs(x - i) + abs(x2 - i) + abs(y2 - y));
		mm = min(mm, mn);
	}
	if (get(sr, 0, n + 1, x) >= k && get(sr, 0, n + 1, x2) >= k)
	{
		int mn = 1e9;
		if (getmin(sr, 0, n + 1, min(x, x2), max(x, x2) + 1) >= k)
			return norm;
		for (int i = 1; i <= m; i++)
			if (get(sb, 0, m + 1, i) >= k)
				mn = min(mn, abs(y - i) + abs(y2 - i) + abs(x2 - x));
		mm = min(mm, mn);
	}
	if (mm == 1e9)
		return -1;

	return mm;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m >> qq;
	build(sb, 0, m + 1);
	build(sr, 0, n + 1);
	int t;
	for (int i = 1; i <= qq; i++)
	{
		cin >> t;
		if (t == 1)
		{
			cin >> x;
			inc(sr, 0, n + 1, x, i);
		}
		else if (t == 2)
		{
			cin >> x;
			inc(sb, 0, m + 1, x, i);
		}
		else
		{
			cin >> x >> y >> x2 >> y2 >> k;
			k = i - k;
			cout << bfs() << "\n";
		}
	}
	cin >> n;
	return 0;
}