#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 1e6;
const int INF = 2e9;

int n, m, q, type, t1[4 * maxn], t2[4 * maxn];

void change1(int v, int tl, int tr, int pos, int val) {
    if(tl == tr)
        t1[v] = val;
    else {
        int tm = (tl + tr) >> 1;
        if(pos <= tm)
            change1(2 * v, tl, tm, pos, val);
        else
            change1(2 * v + 1, tm + 1, tr, pos, val);
        t1[v] = min(t1[2 * v], t1[2 * v + 1]);
    }
}

void change2(int v, int tl, int tr, int pos, int val) {
    if(tl == tr)
        t2[v] = val;
    else {
        int tm = (tl + tr) >> 1;
        if(pos <= tm)
            change2(2 * v, tl, tm, pos, val);
        else
            change2(2 * v + 1, tm + 1, tr, pos, val);
        t2[v] = min(t2[2 * v], t2[2 * v + 1]);
    }
}

int get1(int v, int tl, int tr, int l, int r) {
    if(l > r) return INF;
    if(tl == l && tr == r) return t1[v];
    int tm = (tl + tr) >> 1;
    int h1 = get1(2 * v, tl, tm, l, min(tm, r));
    int h2 = get1(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
    return min(h1, h2);
}

int get2(int v, int tl, int tr, int l, int r) {
    if(l > r) return INF;
    if(tl == l && tr == r) return t2[v];
    int tm = (tl + tr) >> 1;
    int h1 = get2(2 * v, tl, tm, l, min(tm, r));
    int h2 = get2(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
    return min(h1, h2);
}

void res(int x1, int y1, int x2, int y2, int k, int cur) {
    queue <pair <int, pair <int, int> > > qq;
    map <pair <int, int>, int> used;
    qq.push( { 0, { x1, y1 } } );
    used[{x1, y1}] = 1;
    while(!qq.empty()) {
        pair <int, pair <int, int> > p = qq.front();
        qq.pop();
        int dist = p.first, x = p.second.first, y = p.second.second;
        if(x == x2 && y == y2) {
            cout << dist << '\n';
            return;
        }
        if(x - 1 >= 0 && used[{x - 1, y}] == 0 && max(get1(1, 0, n - 1, x - 1, x - 1), get2(1, 0, m - 1, y, y)) >= cur - k) {
            qq.push( { dist + 1, { x - 1, y } } );
            used[{x - 1, y}] = 1;
        }
        if(x + 1 < n && used[{x + 1, y}] == 0 && max(get1(1, 0, n - 1, x + 1, x + 1), get2(1, 0, m - 1, y, y)) >= cur - k) {
            qq.push( { dist + 1, { x + 1, y } } );
            used[{x + 1, y}] = 1;
        }
        if(y - 1 >= 0 && used[{x, y - 1}] == 0 && max(get1(1, 0, n - 1, x, x), get2(1, 0, m - 1, y - 1, y - 1)) >= cur - k) {
            qq.push( { dist + 1, { x, y - 1 } } );
            used[{x, y - 1}] = 1;
        }
        if(y + 1 < m && used[{x, y + 1}] == 0 && max(get1(1, 0, n - 1, x, x), get2(1, 0, m - 1, y + 1, y + 1)) >= cur - k) {
            qq.push( { dist + 1, { x, y + 1 } } );
            used[{x, y + 1}] = 1;
        }
    }
    cout << -1 << '\n';
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> m >> q;
    int x1, y1, x2, y2, k, cur = 0;
    for(int i = 0; i < q; i++) {
        cur++;
        cin >> type;
        if(type == 1) {
            cin >> k;
            k--;
            change1(1, 0, n - 1, k, cur);
        }
        if(type == 2) {
            cin >> k;
            k--;
            change2(1, 0, m - 1, k, cur);
        }
        if(type == 3) {
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            int str1 = get1(1, 0, n - 1, x1, x1);
            int st1 = get2(1, 0, m - 1, y1, y1);
            int str2 = get1(1, 0, n - 1, x2, x2);
            int st2 = get2(1, 0, m - 1, y2, y2);
            if(str1 < cur - k && st1 < cur - k) {
                cout << -1 << '\n';
                continue;
            }
            if(str2 < cur - k && st2 < cur - k) {
                cout << -1 << '\n';
                continue;
            }
            if(str1 >= cur - k && st2 >= cur - k) {
                cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                continue;
            }
            if(st1 >= cur - k && str2 >= cur - k) {
                cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                continue;
            }
            if(str1 >= cur - k && str2 >= cur - k) {
                int ans = INF;
                for(int j = 0; j < m; j++) {
                    if(max(get2(1, 0, m - 1, j, j), get1(1, 0, n - 1, min(x1, x2), max(x1, x2))) >= cur - k) {
                        ans = min(ans, abs(y1 - j) + abs(x1 - x2) + abs(y2 - j));
                    }
                }
                cout << ans << '\n';
                continue;
            }
            res(x1, y1, x2, y2, k, cur);
            continue;
            if(st1 >= cur - k && st2 >= cur - k) {
                int ans = INF;
                for(int j = 0; j < n; j++) {
                    if(max(get1(1, 0, n - 1, j, j), get2(1, 0, m - 1, min(y1, y2), max(y1, y2))) >= cur - k) {
                        ans = min(ans, abs(x1 - j) + abs(y1 - y2) + abs(x2 - j));
                    }
                }
                cout << ans << '\n';
                continue;
            }
        }
    }
    return 0;
}
