#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>

using namespace std;

#define pii pair<int, int>

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 1e6 + 10;
int rt[4 * N];
int lt[4 * N];
int rr[N];
int cc[N];

void upd(int t[], int v, int tl, int tr, int i, int x) {
    if (tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (tm >= i) {
        upd(t, 2 * v, tl, tm, i, x);
    } else {
        upd(t, 2 * v + 1, tm + 1, tr, i, x);
    }
    t[v] = min(t[2 * v], t[2 * v + 1]);
}

int get(int t[], int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l) {
        return 1e9;
    }
    if (tl >= l && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return min(get(t, 2 * v, tl, tm, l, r), get(t, 2 * v + 1, tm + 1, tr, l, r));
}

int dist(int r1, int c1, int r2, int c2) {
    return abs(r1 - r2) + abs(c1 - c2);
}

signed main() {
    fast();
    int n, m, q;
    cin >> n >> m >> q;
    memset(cc, 0, sizeof(cc));
    memset(rr, 0, sizeof(rr));
    int h = 0;
    int mxr = -1;
    int mxc = -1;
    for (int i = 1; i <= q; i++) {
        h++;
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            r--;
            upd(rt, 1, 0, n - 1, r, i);
            rr[r] = i;
            mxr = i;
        } else if (t == 2) {
            int c;
            cin >> c;
            c--;
            cc[c] = i;
            upd(lt, 1, 0, m - 1, c, i);
            mxc = i;
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            if (k >= h) {
                cout << dist(r1, c1, r2, c2) << '\n';
            } else {
                if (h - max(rr[r1], cc[c1]) > k || h - max(rr[r2], cc[c2]) > k) {
                    cout << -1 << '\n';
                    continue;
                }
                if (h - rr[r1] <= k  && h - cc[c2] <= k || h - cc[c1] <= k && h - rr[r2] <= k) {
                    cout << dist(r1, c1, r2, c2) << '\n';
                    continue;
                }
                if (h - get(rt, 1, 0, n - 1, min(r1, r2), max(r1, r2)) <= k
                || h - get(lt, 1, 0, m - 1, min(c1, c2), max(c1, c2)) <= k) {
                    cout << dist(r1, c1, r2, c2) << '\n';
                    continue;
                }
                int answ = 2e9;
                if (h - rr[r1] <= k && h - rr[r2] <= k) {
                    for (int j = 0; j < m; j++) {
                        if (h - cc[j] <= k) {
                            answ = min(answ, abs(r1 - r2) + abs(c1 - j) + abs(c2 - j));
                        }
                    }
                } else if (h - cc[c1] <= k && h - cc[c2] <= k) {
                    for (int j = 0; j < n; j++) {
                        if (h - rr[j] <= k) {
                            answ = min(answ, abs(c1 - c2) + abs(r1 - j) + abs(r2 - j));
                        }
                    }
                }
                if (answ > 1e8) {
                    cout << -1 << '\n';
                } else {
                    cout << answ << '\n';
                }
            }
        }
    }
    return 0;
}