#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())
#define pil pair<int, ll>
#define output(a) cout << '!'; for (auto& elem : a) cout << elem << ' '; cout << '\n';

using namespace std;

const int INF = 1e9 + 9;

struct tree {
    vector<int> t;
    int sz = 1;

    tree() {}

    tree(int n) {
        while (sz < n) {
            sz <<= 1;
        }
        t.resize(sz << 1);
    }

    void upd(int p, int x) {
        p += sz - 1;
        t[p] = x;
        while (p) {
            p >>= 1;
            t[p] = min(t[p << 1], t[p << 1 | 1]);
        }
    }

    int get_min(int v, int l, int r, int L, int R) {
        if (l > R || r < L) {
            return INF;
        }
        if (l >= L && r <= R) {
            return t[v];
        }
        int m = l + r >> 1;
        return min(get_min(v << 1, l, m, L, R), get_min(v << 1 | 1, m + 1, r, L, R));
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector<int> xr(n + 1), xc(m + 1);  /// last update

    tree tr(n + 1), tc(m + 1);

    for (int st = 1; st <= q; ++st) {
        int t;
        cin >> t;
        if (t == 1) {
            int x;
            cin >> x;
            xr[x] = st;
            tr.upd(x, st);
        }
        else if (t == 2) {
            int x;
            cin >> x;
            xc[x] = st;
            tc.upd(x, st);
        }
        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;

            int ans = INF;

            const int md = abs(r1 - r2) + abs(c1 - c2);
            const int need = st - k;

            if ((xr[r1] >= need && xc[c2] >= need) || (xr[r2] >= need && xc[c1] >= need)) {
                ans = md;
            }

            if (xr[r1] >= need && xr[r2] >= need) {
                for (int i = 1; i <= m; ++i) {
                    if (xc[i] >= need) {
                        if (i < min(c1, c2)) {
                            ans = min(ans, md + 2 * (min(c1, c2) - i));
                        }
                        else if (i > max(c1, c2)) {
                            ans = min(ans, md + 2 * (i - max(c1, c2)));
                        }
                        else {
                            ans = md;
                            break;
                        }
                    }
                }
            }

            if (xc[c1] >= need && xc[c2] >= need) {
                for (int i = 1; i <= n; ++i) {
                    if (xr[i] >= need) {
                        if (i < min(r1, r2)) {
                            ans = min(ans, md + 2 * (min(r1, r2) - i));
                        }
                        else if (i > max(r1, r2)) {
                            ans = min(ans, md + 2 * (i - max(r1, r2)));
                        }
                        else {
                            ans = md;
                            break;
                        }
                    }
                }
            }

            if (tr.get_min(1, 1, tr.sz, min(r1, r2), max(r1, r2)) >= st - k) {
                ans = md;
            }
            if (tc.get_min(1, 1, tc.sz, min(c1, c2), max(c1, c2)) >= st - k) {
                ans = md;
            }
            cout << (ans == INF ? -1 : ans) << '\n';
        }
    }
    return 0;
}
