#include <bits/stdc++.h>
#define ff first
#define ss second
using namespace std;

vector<vector<int>> place;

const int INF = 1e9 + 7;

vector<int> rows, cols;
int qid;
std::vector<vector<int>> dist;

const vector<pair<int, int>> to = {{-1, 0}, {0, -1}, {0, 1}, {1, 0}};

vector<tuple<int, int, int>> lifo;

struct Cartesian {
	vector<set<int>> T;
	Cartesian() {}

	void init(int t_sz) {
		int N = 1;
		t_sz++;
		while (N < t_sz) N *= 2;
		T.resize(2 * N);
	}

	void rec_add(int we, int L, int R, int pos, int val) {
		if (pos < L || R < pos) return;
		T[we].insert(val);
		if (L == R) {
			return;
		}
		int med = (L + R) / 2;
		rec_add(we * 2, L, med, pos, val);
		rec_add(we * 2 + 1, med + 1, R, pos, val);
	}

	void add(int id, int val) {
		rec_add(1, 0, T.size() / 2 - 1, id, val);
	}

	void erase(int id) {}

	int rec_mn(int we, int L, int R, int l, int r, int k) {
		if (r < L || R < l) return INF;
		if (l <= L && R <= r) {
			int ans = INF;
			auto it = T[we].upper_bound(k);
			if (it != T[we].end()) ans = *it;
			return ans;
		}
		int ans = INF;
		int med = (L + R) / 2;
		ans = min(ans, rec_mn(we * 2, L, med, l, r, k));
		ans = min(ans, rec_mn(we * 2 + 1, med + 1, R, l, r, k));
		return ans;
	}

	int get_mn(int since, int k) {
		return rec_mn(1, 0, T.size() / 2 - 1, since, INF, k);
	}

	int rec_mx(int we, int L, int R, int l, int r, int k) {
		if (r < L || R < l) return -INF;
		if (l <= L && R <= r) {
			int ans = -INF;
			auto it = T[we].upper_bound(k);
			if (it == T[we].begin()) return ans;
			it--;
			ans = *it;
			return ans;
		}
		int ans = -INF;
		int med = (L + R) / 2;
		ans = max(ans, rec_mn(we * 2, L, med, l, r, k));
		ans = max(ans, rec_mn(we * 2 + 1, med + 1, R, l, r, k));
		return ans;
	}

	int get_mx(int since, int k) {
		return rec_mx(1, 0, T.size() / 2 - 1, since, INF, k);
	}
};

Cartesian cart_r;
Cartesian cart_c;

struct SegmentTree {
	vector<int> T;
	SegmentTree() {
	}
	void init(int n) {
		int N = 1;
		while (N < n) N *= 2;
		T.resize(N * 2);
	}
	int get(int l, int r) {
		l += T.size() / 2;
		r += T.size() / 2;
		int ans = INF;
		while (l <= r) {
			if (l % 2 == 1) {
				ans = min(ans, T[l++]);
			}
			if (r % 2 == 0) {
				ans = min(ans, T[r--]);
			}
			l /= 2;
			r /= 2;
		}
		return ans;
	}

	void change(int pos, int val) {
		pos += T.size() / 2;
		T[pos] = val;
		pos /= 2;
		while (pos) {
			T[pos] = min(T[pos * 2], T[pos * 2 + 1]);
			pos /= 2;
		}
	}
};

SegmentTree rows_mn, cols_mn;

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	cart_c.init(q + 1);
	cart_r.init(q + 1);
	rows_mn.init(n);
	cols_mn.init(m);
	//place.resize(n, vector<int>(m));
	rows.resize(n);
	cols.resize(m);
	for (qid = 1; qid <= q; qid++) {
		int t;
		cin >> t;
		if (t == 1) {
			int id;
			cin >> id;
			--id;
			cart_r.erase(rows[id]);
			rows[id] = qid;
			rows_mn.change(id, qid);
			cart_r.add(rows[id], id);
		} else if (t == 2) {
			int id;
			cin >> id;
			--id;
			cart_c.erase(cols[id]);
			cols[id] = qid;
			cols_mn.change(id, qid);
			cart_c.add(cols[id], id);
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--, c1--, r2--, c2--;
			if (r1 == r2 && c1 == c2) {
				cout << 0 << '\n';
				continue;
			}
			if (k >= qid) {
				cout << abs(r1 - r2) + abs(c2 - c1) << '\n';
				continue;
			}
			if (qid - max(rows[r1], cols[c1]) > k || 
				qid - max(rows[r2], cols[c2]) > k) {
				cout << -1 << '\n';
				continue;
			}
			
			int ans = INF;

			/*cout << "cols: ";
			for (auto el: is_gc) cout << el << ' ';
			cout << endl;*/

			int mnr = min(r1, r2), mxr = max(r1, r2);
			int mnc = min(c1, c2), mxc = max(c1, c2);
			//cout << "H! " << r1 << " " << c1 << endl;
			//cout << r2 << " " << c2 << endl << endl;

			int mx2r = rows_mn.get(mnr, mxr);
			int mx2c = cols_mn.get(mnc, mxc);

			bool fr = qid - mx2r <= k;
			bool fc = qid - mx2c <= k;

			//cout << "fr: "<< fr << " " << "fc: " <<fc << endl;

			if (fr || fc) {
				ans = mxc - mnc + mxr - mnr;
			}

			if (qid - cols[c1] <= k && qid - cols[c2] <= k) {
				int a1 = cart_r.get_mx(qid - k, mxr);
				int a2 = cart_r.get_mn(qid - k, mnr);
				ans = min(ans, 
				abs(c1 -c2) + min(abs(a1 - r1) + abs(a1 - r2), abs(a2 - r1) + abs(a2 - r2)));
			}

			if (qid - cols[c1] <= k && qid - rows[r2] <= k) {
				ans = min(ans, abs(c1 - c2) + abs(r1 - r2));
			}

			if (qid - cols[c2] <= k && qid - rows[r1] <= k) {
				ans = min(ans, abs(c1 - c2) + abs(r2 - r1));
			}
			
			if (qid - rows[r1] <= k && qid - rows[r2] <= k) {
				int a1 = cart_c.get_mx(qid - k, mxc);
				int a2 = cart_c.get_mn(qid - k, mnc);
				ans = min(ans,
					abs(r1 - r2) + min(abs(a1 - c1) + abs(a1 - c2), abs(a2 - c1) + abs(a2 - c2)));
			}

			if (qid - rows[r1] <= k && qid - cols[c2] <= k) {
				ans = min(ans, abs(r1- r2) + abs(c2 - c1));
			}

			if (qid - rows[r2] <= k && qid - cols[c1] <= k) {
				ans = min(ans, abs(r1 - r2) + abs(c2 - c1));
			}
			

			if (ans == INF) cout << -1 << '\n';
			else cout << ans << '\n';
		}
	}

	return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6


2 5 2
1 1
3 1 1 1 4 1

2 3 2
2 2
3 1 2 1 2 0
*/