#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 10010;

void dfs(int u, vector <vector <pair <int, ll>>> &g, vector <bitset <MAXN>> &dst)
{
    for (auto e : g[u])
    {
        dst[u] |= (dst[e.first] << e.second);
    }
}

int solve()
{
    ll n, m, q, p;
    cin >> n >> m >> q >> p;

    vector <vector <pair <int, ll>>> g(n + 1);
    vector <bitset <MAXN>> dst(n + 1);

    for (int i = 0; i < m; i++)
    {
        ll u, v, d;
        cin >> u >> v >> d;
        if (d <= MAXN)
            g[v].push_back({u, d});
    }
    dst[1][0] = 1;

    for (int i = 1; i <= n; i++)
    {
        dfs(i, g, dst);
    }

    for (int i = 0; i < q; i++)
    {
        ll f, r;
        cin >> f >> r;
        int left = r;
        int right = r * p / (p - 1);
        int ok = 0;

        for (int j = left; j <= right; j++)
            ok |= dst[f][j];

        cout << ok;
    }

    cout << "\n";
}

signed main()
{
#ifdef POSPELOV
    freopen("in", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}
