#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long
#define double long double

int n, m, q;
void read() {
	cin >> n >> m >> q;
}

const int MAXN = 1e6 + 10;
int tree[MAXN * 4], mod[MAXN * 4];

inline void push(int v) {
	mod[v * 2] += mod[v];
	mod[v * 2 + 1] += mod[v];
	mod[v] = 0;
}

inline int get_val(int v) {
	return tree[v] + mod[v];
}

void upd(int v, int tl, int tr, int l, int r, int val) {
	if (tl >= r || tr <= l) {
		return;
	}
	if (tl >= l && tr <= r) {
		mod[v] += val;
		return;
	}
	push(v);
	int tm = (tl + tr) / 2;
	upd(v * 2, tl, tm, l, r, val);
	upd(v * 2 + 1, tm, tr, l, r, val);
	tree[v] = max(get_val(v * 2), get_val(v * 2 + 1));
}

int get(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l)
		return -1e9;
	if (tl >= l && tr <= r) {
		return get_val(v);
	}
	push(v);
	int tm = (tl + tr) / 2;
	int ans = max(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
	tree[v] = max(get_val(v * 2), get_val(v * 2 + 1));
	return ans;
}

vector <int> ans;

void run() {
	for (int test = 0; test < q; test++) {
		upd(1, 0, n, 0, n, 1);
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			int help = get(1, 0, n, r, r + 1);
			upd(1, 0, n, r, r + 1, -help);
		}

		if (type == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (r1 > r2) {
				swap(r1, r2);
				swap(c1, c2);
			}
			int ax;
			int help = get(1, 0, n, r1, r2 + 1);
			ax = -1;
			if (help <= k)
				ax = abs(r1 - r2) + abs(c1 - c2);
			cout << ax << endl;
			//ans.push_back(ax);
		}
	}
}

void write() {
	for (auto i : ans) {
		cout << i << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}