#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long
#define double long double

struct segment_tree {
	vector <int> tree;
	int n;
	segment_tree() {
		tree = {};
		n = 0;
	}

	segment_tree(int sz) {
		tree.assign(sz + 10, 0);
		n = sz;
	}

	int get(int l, int r) {
		int mx = -1e9;
		for (int i = l; i <= r; i++)
			mx = max(tree[i], mx);
		return mx;
	}

	void upd(int l, int r, int val) {
		for (int i = l; i <= r; i++) {
			tree[i] += val;
		}
	}

	void add() {
		upd(1, n, 1);
	}

	void make_zero(int pos) {
		tree[pos] = 0;
	}

	int first_left(int pos, int val) {
		for (int i = pos; i >= 1; i--) {
			if (tree[i] <= val)
				return i;
		}
		return -1;
	}

	int first_right(int pos, int val) {
		for (int i = pos; i <= n; i++) {
			if (tree[i] <= val)
				return i;
		}
		return -1;
	}

	int val(int pos) {
		return tree[pos];
	}
};


int n, m, q;

segment_tree h, w;
void read() {
	cin >> n >> m >> q;
	h = segment_tree(n);
	w = segment_tree(m);
}

void del_r(int r) {
	h.make_zero(r);
}

void del_c(int c) {
	w.make_zero(c);
}

void add() {
	h.add();
	w.add();
}

int fans(int r1, int c1, int r2, int c2, int k) {
	if ((h.val(r1) > k && w.val(c1) > k) || (h.val(r2) > k && w.val(c2) > k))
		return -1;

	if (r1 > r2) {
		swap(r1, r2);
		swap(c1, c2);
	}

	int help_h, help_w;

	help_h = h.get(r1, r2);
	help_w = w.get(min(c1, c2), max(c1, c2));
	
	if (min(help_h, help_w) <= k)
		return abs(r1 - r2) + abs(c1 - c2);

	int ans = 1e9;

	int v1 = h.val(r1);
	int v2 = h.val(r2);

	if (v1 <= k && v2 <= k) {
		int pos1_1 = w.first_left(c1, k);
		int pos1_2 = w.first_right(c1, k);
		int pos2_1 = w.first_left(c2, k);
		int pos2_2 = w.first_right(c2, k); 
		
		int fans = 1e9;
		if (pos1_1 != -1) {
			fans = min(fans, abs(r1 - r2) + abs(pos1_1 - c1) + abs(pos1_1 - c2));
		}
		
		if (pos1_2 != -1) {
			fans = min(fans, abs(r1 - r2) + abs(pos1_2 - c1) + abs(pos1_2 - c2));
		}
		
		if (pos2_1 != -1) {
			fans = min(fans, abs(r1 - r2) + abs(pos2_1 - c1) + abs(pos2_1 - c2));
		}
		
		if (pos2_2 != -1) {
			fans = min(fans, abs(r1 - r2) + abs(pos2_2 - c1) + abs(pos2_2 - c2));
		}

		ans = min(ans, fans);
	}

	v1 = w.val(c1);
	v2 = w.val(c2);

	if (v1 <= k && v2 <= k) {
		int pos1_1 = h.first_left(r1, k);
		int pos1_2 = h.first_right(r1, k);
		int pos2_1 = h.first_left(r2, k);
		int pos2_2 = h.first_right(r2, k);

		int fans = 1e9;
		if (pos1_1 != -1) {
			fans = min(fans, abs(c1 - c2) + abs(r1 - pos1_1) + abs(r2 - pos1_1));
		}

		if (pos1_2!= -1) {
			fans = min(fans, abs(c1 - c2) + abs(r1 - pos1_2) + abs(r2 - pos1_2));
		}

		if (pos2_2 != -1) {
			fans = min(fans, abs(c1 - c2) + abs(r1 - pos2_2) + abs(r2 - pos2_2));
		}

		if (pos2_1 != -1) {
			fans = min(fans, abs(c1 - c2) + abs(r1 - pos2_1) + abs(r2 - pos2_1));
		}
		ans = min(ans, fans);
	}
	if (ans == 1e9)
		ans = -1;
	return ans;
}

vector <int> ans;

void run() {
	for (int test = 0; test < q; test++) {
		add();
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			del_r(r);
		}
		if (type == 2) {
			int c;
			cin >> c;
			del_c(c);
		}
		if (type == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			int ax;
			ax = fans(r1, c1, r2, c2, k);
			ans.push_back(ax);
		}
	}
}

void write() {
	for (auto i : ans) {
		cout << i << '\n';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}