#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <random>

#define ll long long
#define ld long double
#define F first
#define S second
#define ep emplace_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = (1 << 21) + 10, inf = 1e9 + 123;

int tree[2][N];
int mn[2][N];

void mklast(int v, int j, int ind, int q, int l, int r){
	//cout << "Make Last " << v << ' ' << j << ' ' << ind << ' ' << q << ' ' << l << ' ' << r << endl;
	//cout << tree[j][v] << endl;
	if (l + 1 == r){
		tree[j][v] = q;
		mn[j][v] = q;
		return;
	}
	//cout << tree[j][v * 2] << ' ' << tree[j][v * 2 + 1] << endl;

	int mid = (l + r) / 2;
	if (ind < mid)
		mklast(v * 2, j, ind, q, l, mid);
	else
		mklast(v * 2 + 1, j, ind, q, mid, r);
	tree[j][v] = max(tree[j][v * 2], tree[j][v * 2 + 1]);
	mn[j][v] = min(mn[j][v * 2], mn[j][v * 2 + 1]);
}

int pref_max(int v, int j, int ind, int x, int l, int r){
	//cout << "Pref Max " << v << ' ' << j << ' ' << ind << ' ' << x << ' ' << l << ' ' << r << endl;
	//cout << tree[j][v] << endl;
	if (l + 1 == r){
		if (tree[j][v] < x)
			return -1;
		return l;
	}
	//cout << tree[j][v * 2] << ' ' << tree[j][v * 2 + 1] << endl;

	int mid = (l + r) / 2;
	if (ind < mid)
		return pref_max(v * 2, j, ind, x, l, mid);
	else if (ind < r){
		int tmp = pref_max(v * 2 + 1, j, ind, x, mid, r);
		if (tmp == -1 && tree[j][v * 2] >= x)
			return pref_max(v * 2, j, ind, x, l, mid);
		else return tmp;
	}
	else{
		if (tree[j][v * 2 + 1] >= x)
			return pref_max(v * 2 + 1, j, ind, x, mid, r);
		else if (tree[j][v * 2] >= x)
			return pref_max(v * 2, j, ind, x, l, mid);
		else
			return -1;
	}

}

int suf_max(int v, int j, int ind, int x, int l, int r){
	//cout << "Suf Max " << v << ' ' << j << ' ' << ind << ' ' << x << ' ' << l << ' ' << r << endl;
	//cout << tree[j][v] << endl;
	if (l + 1 == r){
		if (tree[j][v] < x)
			return -1;
		return l;
	}
	//cout << tree[j][v * 2] << ' ' << tree[j][v * 2 + 1] << endl;

	int mid = (l + r) / 2;
	if (ind >= mid)
		return suf_max(v * 2 + 1, j, ind, x, mid, r);
	else if (ind >= l){
		int tmp = suf_max(v * 2, j, ind, x, l, mid);
		if (tmp == -1 && tree[j][v * 2 + 1] >= x)
			return suf_max(v * 2 + 1, j, ind, x, mid, r);
		else return tmp;
	}
	else{
		if (tree[j][v * 2] >= x)
			return suf_max(v * 2, j, ind, x, l, mid);
		else if (tree[j][v * 2 + 1] >= x)
			return suf_max(v * 2 + 1, j, ind, x, mid, r);
		else
			return -1;
	}
}

int Min(int v, int j, int l1, int r1, int l, int r){
	//cout << "Min " << v << ' ' << j << ' ' << l1 << ' ' << r1 << ' ' << l << ' ' << r << endl;
	if (l1 == l && r1 == r)
		return mn[j][v];

	int mid = (l + r) / 2, ans = inf;
	if (l1 < mid)
		ans = min(ans, Min(v * 2, j, l1, min(r1, mid), l, mid));
	if (r1 > mid)
		ans = min(ans, Min(v * 2 + 1, j, max(l1, mid), r1, mid, r));
	return ans;
}

const int Side = 1e6 + 10;
int R[Side], C[Side];

int D(int x, int y){
	return abs(x - y);
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, q;
	cin >> n >> m >> q;

	for (int qi = 1; qi <= q; qi++){
		//cout << "QI = " << qi << endl;
		int t;
		cin >> t;
		if (t == 1){
			int r;
			cin >> r;
			r--;
			R[r] = qi;
			mklast(1, 0, r, qi, 0, n);
		}
		else if (t == 2){
			int c;
			cin >> c;
			c--;
			C[c] = qi;
			mklast(1, 1, c, qi, 0, m);
		}
		else{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--, c1--, r2--, c2--;
			bool s[2], f[2];
			s[0] = s[1] = f[0] = f[1] = false;
			int last = qi - k;

			if (R[r1] >= last) s[0] = true;
			if (C[c1] >= last) s[1] = true;
			if (R[r2] >= last) f[0] = true;
			if (C[c2] >= last) f[1] = true;

			if (s[0] && f[1] || s[1] && f[0]){
				cout << D(r1, r2) + D(c1, c2) << '\n';
			}
			else if (s[0] && f[0]){
				if (r1 > r2){
					swap(r1, r2);
					swap(c1, c2);
				}
				if (r1 + 1 > r2 - 1 || Min(1, 0, r1 + 1, r2, 0, n) >= last){
					cout << D(r1, r2) + D(c1, c2) << '\n';
					//cout << "------------\n";
					continue;
				}

				if (c1 > c2){
					swap(c1, c2);
					swap(r1, r2); 
				}

				int i1, i2;
				i1 = suf_max(1, 1, c1, last, 0, m);
				i2 = pref_max(1, 1, c2, last, 0, m);
				
				int ans1, ans2;
				ans1 = ans2 = inf;
				if (i1 != -1) ans1 = D(c1, i1) + D(r1, r2) + D(i1, c2);
				if (i2 != -1) ans2 = D(c1, i2) + D(r1, r2) + D(i2, c2);

				if (min(ans1, ans2) == inf)
					cout << -1 << '\n';
				else
					cout << min(ans1, ans2) << '\n';
			}
			else if (s[1] && f[1]){
				if (c1 > c2){
					swap(c1, c2);
					swap(r1, r2);
				}
				if (c1 + 1 > c2 - 1 || Min(1, 1, c1 + 1, c2, 0, m) >= last){
					cout << D(r1, r2) + D(c1, c2) << '\n';
					//cout << "------------\n";
					continue;
				}

				if (r1 > r2){
					swap(r1, r2);
					swap(c1, c2);
				}

				int i1, i2;
				i1 = suf_max(1, 0, r1, last, 0, n);
				i2 = pref_max(1, 0, r2, last, 0, n);

				int ans1, ans2;
				ans1 = ans2 = inf;
				if (i1 != -1) ans1 = D(r1, i1) + D(c1, c2) + D(i1, r2);
				if (i2 != -1) ans2 = D(r1, i2) + D(c1, c2) + D(i2, r2);

				if (min(ans1, ans2) == inf)
					cout << -1 << '\n';
				else
					cout << min(ans1, ans2) << '\n';
			}
			else
				cout << -1 << '\n';
		}
		//cout << "------------\n";
	}

}