#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <random>
#include <bitset>

#define ll long long
#define ld long double
#define F first
#define S second
#define ep emplace_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N1 = 5e5 + 10;
vector<pair<int, ll> > g[N1];
int n, m, q, p;

bool dfs_case_1(int v, int f, ll r, ll cur = 0){
	if (v == f)
		return (r * (p - 1) <= cur * (p - 1) && cur * (p - 1) <= r * p);

	for (auto e : g[v])
		if (dfs_case_1(e.F, f, r, cur + e.S))
			return true;
	return false;
}

void solve_case_1(){
	while (q--){
		int v;
		ll r;
		cin >> v >> r;
		v--;
		cout << (dfs_case_1(0, v, r) ? '1' : '0');
	}
	cout << '\n';
}

const int N2 = 5e3 + 10;
bitset<5300> dp[N2];

void dfs_case_2(int v){
	for (int i = 0; i < 5300; i++){
		if (!dp[v][i])
			continue;
		for (auto &e : g[v])
			if (e.S < (ll)(5300 - i))
				dp[e.F].set(i + e.S);
	}
}

void solve_case_2(){
	for (int i = 0; i < n; i++)
		dp[i].reset();
	dp[0].set(0);
	for (int i = 0; i < n; i++)
		dfs_case_2(i);

	while (q--){
		int v;
		ll r;
		cin >> v >> r;
		v--;
		char ch = '0';
		for (int i = r; i * (p - 1) <= r * p && i < 5300; i++)
			if (dp[v][i])
				ch = '1';
		cout << ch;
	}
	cout << '\n';
}

bool test_case_3(){
	int i;
	if (m != n * 2 - 2)
		return false;
	for (i = 0; i < n - 1; i++)
		if (g[i].size() != 2)
			return false;
	return true;
}

void solve_case_3(){
	while (q--){
		int v;
		ll r;
		cin >> v >> r;
		v--;
		vector<int> tmp;
		ll cur = 0;
		for (int i = 0; i < v; i++){
			cur += min(g[i][0].S, g[i][1].S);
			tmp.ep(max(g[i][0].S, g[i][1].S) - min(g[i][0].S, g[i][1].S));
		}
		sort(tmp.begin(), tmp.end());
		
		if (cur > 2 * r)
			cout << '0';
		else if (cur >= r)
			cout << '1';
		else{
			while (!tmp.empty()){
				if (tmp.back() + cur <= 2 * r)
					cur += tmp.back();
				tmp.pop_back();
			}
			if (cur >= r && cur <= 2 * r)
				cout << '1';
			else
				cout << '0';
		}
	}
	cout << '\n';
}

void solve(){
	cin >> n >> m >> q >> p;
	int i;
	for (i = 0; i < n; i++)
		g[i].clear();
	int v, u;
	ll c;
	for (i = 0; i < m; i++){
		cin >> v >> u >> c;
		v--, u--;
		g[v].ep(u, c);
	}

	if (n <= 10 && m <= 10 && q <= 10)
		solve_case_1();
	else if (test_case_3())
		solve_case_3();
	else
		solve_case_2();
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	while (t--)
		solve();

}