﻿#include <iostream>
#include <algorithm>>
#include <iomanip>
#include <vector>
#include <cmath>
#include <string>
#include <queue>

using namespace std;

typedef long double ld;
typedef long long ll;

#define all(x) x.begin(), x.end()

const int INF = 1e9;

int times;
vector <vector <int>> dp;
vector <vector <int>> distanceTo;

const int dx[4] = { +1, -1, 0, 0 };
const int dy[4] = { 0, 0, -1, +1 };

int n, m;

void bfs(int fx, int fy, int k, const vector <vector <int>> &a)
{
	queue <pair<int, int>> que;
	if (times - a[fx][fy] <= k)
	{
		distanceTo[fx][fy] = 0;
		que.push({ fx, fy });
	}
	while (!que.empty())
	{
		pair<int, int> current = que.front();
		que.pop();
		int x = current.first;
		int y = current.second;

		if (dp[x][y] == times)
			continue;
		dp[x][y] = times;

		for (int j = 0; j < 4; j++)
		{
			int nx = x + dx[j];
			int ny = y + dy[j];
			if (nx >= 1 && nx <= n && ny >= 1 && ny <= m && dp[nx][ny] != times && times - a[nx][ny] <= k)
			{
				que.push({ nx, ny });
				distanceTo[nx][ny] = distanceTo[x][y] + 1;
			}
		}
	}
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> n >> m >> q;
	vector <vector <int>> a(n + 1, vector <int>(m + 1));
	dp.resize(n + 1, vector <int>(m + 1));
	distanceTo.resize(n + 1, vector <int>(m + 1));

	for (int zz = 1; zz <= q; zz++)
	{
		times = zz;
		int type;
		cin >> type;
		if (type == 1 || type == 2)
		{
			int line;
			cin >> line;
			if (type == 1)
			{
				//строка line
				for (int j = 1; j <= m; j++)
				{
					a[line][j] = times;
				}
			}
			else
			{
				//столбец line
				for (int j = 1; j <= n; j++)
				{
					a[j][line] = times;
				}
			}
		}
		else
		{
			int sx, sy, fx, fy, k;
			cin >> sx >> sy >> fx >> fy >> k;
			bfs(sx, sy, k, a);
			/*for (int i = 1; i <= n; i++)
			{
				for (int j = 1; j <= m; j++)
				{
					if (dp[i][j] == times)
						cout << distanceTo[i][j] << " ";
					else
						cout << -1 << " ";
				}
				cout << endl;
			}*/
			if (dp[fx][fy] == times)
				cout << distanceTo[fx][fy] << endl;
			else
				cout << -1 << endl;
		}

	}
	return 0;
}