#include <vector>
#include <stack>
#include <stdio.h>
#include <algorithm>

using namespace std;

const int St = 1;
const int Fn = 2;

struct Event {
    int x;
    int cl;
    int type;

    bool operator<(const Event other) const {
        if (x == other.x) {
            return type < other.type;
        }
        return x < other.x;
    }
};

struct Ans {
    int cl;
    int l;
    int r;
};

int stp = 0;

void push(int x, int y, vector<pair<int, int>> &st) {
    st[stp].first = x;
    st[stp].second = y;
    stp++;
}

void pop(vector<pair<int, int>> &st) {
    stp--;
}

pair<int, int> top(vector<pair<int, int>> &st) {
    return st[stp - 1];
}

int main() {
//    ios_base::sync_with_stdio(false);
    int n, m;
    scanf("%d%d", &n, &m);
//    cin >> n >> m;
    vector<int> a(n);
    vector<int> mn(m, -1);
    vector<int> mx(m, 0);
    vector<bool> used(m, false);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
//        cin >> a[i];
        a[i]--;
        used[a[i]] = true;
        if (mn[a[i]] == -1) {
            mn[a[i]] = i;
        }
        mx[a[i]] = max(mx[a[i]], i);
    }
    vector<Event> ev;
    for (int i = 0; i < m; i++) {
        if (used[i]) {
            ev.push_back({mn[i], i, St});
            ev.push_back({mx[i], i, Fn});
        }
    }
    sort(ev.begin(), ev.end());
    vector<Ans> ans;
    vector<int> ans1(n);
//    stack<pair<int, int>> st;
    vector<pair<int, int>> st(300000);
    for (auto item: ev) {
        if (item.type == St) {
//            st.push({item.cl, item.x});
            push(item.cl, item.x, st);
        } else {
//            assert1(item.type == Fn);
//            assert1(st.size());
            if (top(st).first == item.cl) {
                ans.push_back({item.cl, top(st).second, item.x});
                pop(st);
            } else {
                printf("-1");
//                cout << -1;
                return 0;
            }
        }
    }

    reverse(ans.begin(), ans.end());
    for (auto i: ans) {
        fill(ans1.begin() + i.l, ans1.begin() + i.r + 1, i.cl);
    }
//    for (auto i: ans1) {
//        cerr << i + 1 << ' ';
//    }
    if (ans1 != a) {
        printf("-1");
//        cout << -1;
        return 0;
    }
    printf("%d\n", ans.size());
//    cout << ans.size() << '\n';
    for (auto i: ans) {
        printf("%d %d %d\n", i.cl + 1, i.l + 1, i.r + 1);
//        cout << i.cl + 1 << ' ' << i.l + 1 << ' ' << i.r + 1 << '\n';
    }

}