#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x;
    int y;
};

const int INF = 1e9;

int bfs(int x1, int y1, int x2, int y2, int k, vector<vector<int>> &a, int n, int m) {
    if (a[x1][y1] > k) {
        return -1;
    }
    vector<vector<int>> dst(n, vector<int>(m, INF));
    dst[x1][y1] = 0;
    queue<Point> q;
    q.push({x1, y1});
    while (q.size()) {
        auto v = q.front();
        q.pop();
        if (v.x == x2 && v.y == y2) {
            return dst[x2][y2];
        }
        for (int i = -1; i <= 1; i++) {
            for (int j = -1; j <= 1; j++) {
                if (abs(i + j) != 1 || v.x + i >= n || v.x + i < 0 || v.y + j >= m || v.y + j < 0) {
                    continue;
                }
                if (a[v.x + i][v.y + j] <= k && dst[v.x + i][v.y + j] == INF) {
                    q.push({v.x + i, v.y + j});
                    dst[v.x + i][v.y + j] = dst[v.x][v.y] + 1;
                }
            }
        }
    }
    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> a(n, vector<int>(m));
    for (int q1 = 0; q1 < q; q1++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j]++;
            }
        }
        int c;
        cin >> c;
        if (c == 1) {
            int x;
            cin >> x;
            x--;
            for (int i = 0; i < m; i++) {
                a[x][i] = 0;
            }
        }
        if (c == 2) {
            int x;
            cin >> x;
            x--;
            for (int i = 0; i < n; i++) {
                a[i][x] = 0;
            }
        }
        if (c == 3) {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            cout << bfs(x1, y1, x2, y2, k, a, n, m) << '\n';
        }
    }
}