#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int N = (int)3e5 + 7;
const int INF = (int)1e9 + 7;

///////////////////////////////////////////////////\

struct Triple {
	int x, t, val, l;
	Triple() {};
	Triple(int x, int t, int val, int l = -1) :
		x(x), t(t), val(val), l(l) {};
};

bool operator < (const Triple &a, const Triple &b) {
	return a.x < b.x;
}

int n, m, a[N];
int l[N], r[N], b[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	fill(l, l + m + 1, INF);
	for (int i = 0; i < n; i++) {
		l[a[i]] = min(l[a[i]], i);
		r[a[i]] = max(r[a[i]], i);
	}
	vector <Triple> t, ans;
	for (int i = 0; i < n; i++) {
		if (l[a[i]] == i) {
			t.push_back(Triple(l[a[i]], -1, a[i], i));
			t.push_back(Triple(r[a[i]], 1, a[i], i));
			ans.push_back(Triple(l[a[i]], r[a[i]], a[i]));
		}
	}
	sort(t.begin(), t.end());
	set <Triple> s;
	int ind = 0, sz = (int)t.size();
	for (int i = 0; i < n; i++) {
		if (ind < sz && t[ind].x == i && t[ind].t == -1)
			s.insert(Triple(t[ind].x, -1, t[ind].val, t[ind].l)), ind++;
		if (s.size() == 0) {
			cout << -1;
			return 0;
		}
		b[i] = (*s.rbegin()).val;
		if (ind < sz && t[ind].x == i && t[ind].t == 1)
			s.erase(Triple(t[ind].l, -1, t[ind].val, t[ind].l)), ind++;
	}
	bool fl = true;
	for (int i = 0; i < n; i++) {
		if (a[i] != b[i])
			fl = false;
	}
	if (fl) {
		cout << ans.size() << endl;
		for (auto t : ans)
			cout << t.val << ' ' << t.x + 1 << ' ' << t.t + 1 << endl;
	}
	else
		cout << -1;
}