#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int N = (int)3e5 + 7;
const int INF = (int)1e9 + 7;

///////////////////////////////////////////////////

struct Triple {
	int x, t, val, l;
	Triple() {};
	Triple(int x, int t, int val, int l = -1) :
		x(x), t(t), val(val), l(l) {};
};

int n, m, a[N], p[4 * N];
int l[N], r[N], tr[4 * N];

void relax(int v) {
	tr[v] = min(tr[2 * v], tr[2 * v + 1]);
}

void push(int v, int l, int r) {
	if (p[v] != 0) {
		tr[v] = p[v];
		if (l != r)
			tr[2 * v] = tr[2 * v + 1] = p[2 * v] = p[2 * v + 1] = p[v];
	}
	p[v] = 0;
}

void update(int v, int l, int r, int ql, int qr, int val) {
	push(v, l, r);
	if (ql <= l && r <= qr) {
		p[v] = val;
		push(v, l, r);
		return;
	}
	if (ql > r || l > qr)
		return;
	int m = (r + l) / 2;
	update(2 * v, l, m, ql, qr, val), update(2 * v + 1, m + 1, r, ql, qr, val);
	relax(v);
}

int get(int v, int l, int r, int pos) {
	push(v, l, r);
	if (l == r)
		return tr[v];
	int m = (r + l) / 2;
	if (m >= pos)
		return get(2 * v, l, m, pos);
	else
		return get(2 * v + 1, m + 1, r, pos);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	fill(l, l + m + 1, INF);
	for (int i = 0; i < n; i++) {
		l[a[i]] = min(l[a[i]], i);
		r[a[i]] = max(r[a[i]], i);
	}
	vector <Triple>	ans;
	for (int i = 0; i < n; i++) {
		if (l[a[i]] == i) {
			ans.push_back(Triple(l[a[i]], r[a[i]], a[i]));
			update(1, 0, n - 1, l[a[i]], r[a[i]], a[i]);
		}
	}
	for (int i = 0; i < n; i++) {
		int val = get(1, 0, n - 1, i);
		if (get(1, 0, n - 1, i) != a[i]) {
			cout << -1;
			return 0;
		}
	}
	cout << ans.size() << endl;
	for (auto t : ans)
		cout << t.val << ' ' << t.x + 1 << ' ' << t.t + 1 << endl;
}