#include <bits/stdc++.h>
 
#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;
 
template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
 
const int MAXN = 1 << 20, INF = 1e9;
 
int n, m;
int rows[MAXN], cols[MAXN];
 
struct seg_tree_mx {
    int *t;
    seg_tree_mx() {
        t = new int[MAXN * 2];
        memset(t, 0, sizeof(int) * MAXN * 2);
    }
    void set(int pos, int nv) {
        pos += MAXN;
        t[pos] = nv;
        while (pos > 1) {
            pos /= 2;
            t[pos] = max(t[pos * 2], t[pos * 2 + 1]);
        }
    }
    int get(int v, int vl, int vr, int l, int r) {
        if (vl > r || vr < l) return -INF;
        if (l <= vl && vr <= r) return t[v];
        int vm = (vl + vr) / 2;
        return max(get(v * 2, vl, vm, l, r), 
                    get(v * 2 + 1, vm + 1, vr, l, r));
    }
    int get(int l, int r) {
        return get(1, 0, MAXN - 1, l, r);
    }
};
 
struct seg_tree_mn {
    int *t;
    seg_tree_mn() {
        t = new int[MAXN * 2];
        memset(t, 0, sizeof(int) * MAXN * 2);
    }
    void set(int pos, int nv) {
        pos += MAXN;
        t[pos] = nv;
        while (pos > 1) {
            pos /= 2;
            t[pos] = min(t[pos * 2], t[pos * 2 + 1]);
        }
    }
    int get(int v, int vl, int vr, int l, int r) {
        if (vl > r || vr < l) return INF;
        if (l <= vl && vr <= r) return t[v];
        int vm = (vl + vr) / 2;
        return min(get(v * 2, vl, vm, l, r), 
                    get(v * 2 + 1, vm + 1, vr, l, r));
    }
    int get(int l, int r) {
        return get(1, 0, MAXN - 1, l, r);
    }
};
 
seg_tree_mx col_mx, row_mx;
seg_tree_mn col_mn, row_mn;
 
int get_rrr(int r, int c, int r1, int c1, int k, int t) {
    int res = abs(r - r1);
    if (r < r1 && row_mx.get(r + 1, r1) + t > k)
        return INF;
    if (r > r1 && row_mx.get(r1 + 1, r) + t > k)
        return INF;
    if (c != c1 && rows[r1] + t > k) return INF;
    return abs(r - r1) + abs(c - c1);
}
 
int get_ccc(int r, int c, int r1, int c1, int k, int t) {
    int res = abs(c - c1);
    if (c < c1 && col_mx.get(c + 1, c1) + t > k)
        return INF;
    if (c > c1 && col_mx.get(c1 + 1, c) + t > k) 
        return INF;
    if (r != r1 && cols[c1] + t > k) return INF;
    return abs(r - r1) + abs(c - c1);
}
 
set<int> av_rows, av_cols;
 
int solve(int t, int r, int c, int r1, int c1, int k) {
    if (rows[r] + t > k && cols[c] + t > k) return -1;
    if (rows[r1] + t > k && cols[c1] + t > k) return -1;
    if (c == c1 && cols[c] + t <= k) return abs(r - r1);
    if (r == r1 && rows[r] + t <= k) return abs(c - c1);
 
    int res = INF;
    chkmin(res, get_rrr(r, c, r1, c1, k, t));
    chkmin(res, get_ccc(r, c, r1, c1, k, t));
 
    // r->c->r
    vector<int> need_cols = {c, c1};
    if (c - 1 >= 1) need_cols.pb(c - 1);
    if (c1 - 1 >= 1) need_cols.pb(c1 - 1);
    if (c + 1 <= m) need_cols.pb(c + 1);
    if (c1 + 1 <= m) need_cols.pb(c1 + 1);
    // to the left and to the right from c
 
    if (c - 1 >= 1 && col_mn.get(1, c - 1) + t <= k) {
        int lb = 1, rb = c;
        while (rb - lb > 1) {
            int mid = (lb + rb) / 2;
            if (col_mn.get(mid, c - 1) + t <= k)
                lb = mid;
            else
                rb = mid;
        }
        need_cols.pb(lb);
    }
    if (c + 1 <= m && col_mn.get(c + 1, m) + t <= k) {
        int lb = c + 1, rb = m;
        while (rb - lb > 1) {
            int mid = (lb + rb) / 2;
            if (col_mn.get(c + 1, mid) + t <= k)
                rb = mid;
            else
                lb = mid;
        }
        need_cols.pb(rb);
    }
    for (int col : need_cols) {
        if (cols[col] + t > k) continue;
        if (abs(col - c) > 1 && rows[r] + t > k) continue;
        if (abs(col - c1) > 1 && rows[r1] + t > k) continue;
         
        chkmin(res, abs(c - col) + abs(c1 - col) + abs(r - r1));
    }
    vector<int> need_rows = {r, r1};
    if (r - 1 >= 1) need_rows.pb(r - 1);
    if (r1 - 1 >= 1) need_rows.pb(r1 - 1);
    if (r + 1 <= n) need_rows.pb(r + 1);
    if (r1 + 1 <= n) need_rows.pb(r1 + 1);
    if (r - 1 >= 1 && row_mn.get(1, r - 1) + t <= k) {
        int lb = 1, rb = r;
        while (rb - lb > 1) {
            int mid = (lb + rb) / 2;
            if (row_mn.get(mid, r - 1) + t <= k)
                lb = mid;
            else
                rb = mid;
        }
        need_rows.pb(lb);
    }
    if (r + 1 <= n && row_mn.get(r + 1, n) + t <= k) {
        int lb = r + 1, rb = n;
        while (rb - lb > 1) {
            int mid = (lb + rb) / 2;
            if (row_mn.get(r + 1, mid) + t <= k)
                rb = mid;
            else
                lb = mid;
        }
        need_rows.pb(rb);
    }
    // c->r->c
    for (int row : need_rows) {
        if (rows[row] + t > k) continue;
        if (abs(row - r) > 1 && cols[c] + t > k) continue;
        if (abs(row - r1) > 1 && cols[c1] + t > k) continue;
         
        chkmin(res, abs(r - row) + abs(r1 - row) + abs(c - c1));
    }
    return res == INF ? -1 : res;
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int q;
    cin >> n >> m >> q;
    for (int i = 1; i <= q; ++i) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int row;
            cin >> row;
            row_mn.set(row, -i);
            row_mx.set(row, -i);
            rows[row] = -i;
            av_rows.insert(row);
            continue;
        }
        if (tp == 2) {
            int col;
            cin >> col;
            col_mn.set(col, -i);
            col_mx.set(col, -i);
            cols[col] = -i;
            av_cols.insert(col);
            continue;
        }
        if (tp == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (k > i) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
            }
            else {
                cout << solve(i, r1, c1, r2, c2, k) << '\n';
            }
        }
    }
    return 0;
}