#pragma GCC optimize("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <math.h>
#include <algorithm>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(x) x.begin(), x.end()
#define pb push_back

void io() {
//	freopen("a.in", "r", stdin);
//	freopen("a.out", "w", stdout);
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
}

ll n, m, q;
ll t = 1;
const ll inf = 3e6 + 10;
vector<ll> row;
vector<ll> col;

struct node{
	ll mn;
	ll mx;
	node() {}
	node(ll mn, ll mx) {
		this->mn = mn;
		this->mx = mx;
	}
};

inline ll ls(ll v) {
	return 2 * v + 1;
}

inline ll rs(ll v) {
	return 2 * v + 2;
}

vector<node> ti, tj;

inline void combi(ll v) {
	ti[v].mn = min(ti[ls(v)].mn, ti[rs(v)].mn);
	ti[v].mx = max(ti[ls(v)].mx, ti[rs(v)].mx);
}

inline void combj(ll v) {
	tj[v].mn = min(tj[ls(v)].mn, tj[rs(v)].mn);
	tj[v].mx = max(tj[ls(v)].mx, tj[rs(v)].mx);
}

void buildi(ll v, ll l, ll r) {
	if (l == r - 1) {
		ti[v] = node(0, 0);
		return;
	}
	ll m = (l + r) / 2;
	buildi(ls(v), l, m);
	buildi(rs(v), m, r);
	combi(v);
}

void buildj(ll v, ll l, ll r) {
	if (l == r - 1) {
		tj[v] = node(0, 0);
		return;
	}
	ll m = (l + r) / 2;
	buildj(ls(v), l, m);
	buildj(rs(v), m, r);
	combj(v);
}

void upi(ll v, ll l, ll r, ll ql, ll x) {
	if (ql >= r || ql < l)
		return;
	if (ql == l && l == r - 1) {
		ti[v] = node(x, x);
		return;
	}
	ll m = (l + r) / 2;
	upi(ls(v), l, m, ql, x);
	upi(rs(v), m, r, ql, x);
	combi(v);
}

void upj(ll v, ll l, ll r, ll ql, ll x) {
	if (ql >= r || ql < l)
		return;
	if (ql == l && l == r - 1) {
		tj[v] = node(x, x);
		return;
	}
	ll m = (l + r) / 2;
	upj(ls(v), l, m, ql, x);
	upj(rs(v), m, r, ql, x);
	combj(v);
}

ll qmini(ll v, ll l, ll r, ll ql, ll qr) {
	if (ql >= r || l >= qr)
		return inf;
	if (l == ql && r == qr)
		return ti[v].mn;
	ll m = (l + r) / 2;
	return min(qmini(ls(v), l, m, ql, min(m, qr)), qmini(rs(v), m, r, max(ql, m), qr));
}

ll qminj(ll v, ll l, ll r, ll ql, ll qr) {
	if (ql >= r || l >= qr)
		return inf;
	if (l == ql && r == qr)
		return tj[v].mn;
	ll m = (l + r) / 2;
	return min(qminj(ls(v), l, m, ql, min(m, qr)), qminj(rs(v), m, r, max(ql, m), qr));
}



signed main() {
	io();
	cin >> n >> m >> q;
	row.resize(n, 0);
	col.resize(m, 0);
	ti.resize(4 * n);
	tj.resize(4 * m);
	buildi(0, 0, n);
	buildj(0, 0, m);
	while (q--) {
		ll typ;
		cin >> typ;
		if (typ == 1) {
			ll i;
			cin >> i;
			i--;
			upi(0, 0, n, i, t);
			row[i] = t;
		}
		if (typ == 2) {
			ll j;
			cin >> j;
			j--;
			upj(0, 0, m, j, t);
			col[j] = t;
		}
		if (typ == 3) {
			ll i1, j1, i2, j2, k;
			cin >> i1 >> j1 >> i2 >> j2 >> k;
			i1--, j1--, i2--, j2--;
			//1 and 2
			ll ned = t - k;
			ll ans = inf;
			ll o =  abs(i1 - i2) + abs(j1 - j2);
			if (row[i1] >= ned && col[j2] >= ned || row[i2] >= ned && col[j1] >= ned
				|| i1 == i2 && row[i1] >= ned || j1 == j2 && col[j1] >= ned)
				ans = o;
			//3 and 4
			if (qmini(0, 0, n, min(i1, i2), max(i1, i2) + 1) >= ned)
				ans = o;
			//5
			cout << (ans == inf ? -1 : ans) << endl;
		}

		t++;
	}
	return 0;
}