#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <assert.h>
#include <math.h>
#include <algorithm>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define all(x) x.begin(), x.end()
#define pb push_back

void io() {
//	freopen("a.in", "r", stdin);
//	freopen("a.out", "w", stdout);
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
}

int n, m, q;
int t = 1;
const int inf = 3e5 + 10;
vector<int> row;
vector<int> col;

struct node{
	int mn;
	int imn;
	int mx;
	int imx;
	node() {}
	node(int mn, int imn, int mx, int imx) {
		this->mn = mn;
		this->imn = imn;
		this->imx = imx;
		this->mx = mx;
	}
};

inline int ls(int v) {
	return 2 * v + 1;
}

inline int rs(int v) {
	return 2 * v + 2;
}

vector<node> ti, tj;

inline void combi(int v) {
	if (ti[ls(v)].mn <= ti[rs(v)].mn) {
		ti[v].mn = ti[ls(v)].mn;
		ti[v].imn = ti[rs(v)].imn;
	} else {
		ti[v].mn = ti[rs(v)].mn;
		ti[v].imn = ti[rs(v)].imn;
	}
	if (ti[ls(v)].mx <= ti[rs(v)].mx) {
		ti[v].mx = ti[ls(v)].mx;
		ti[v].imx = ti[ls(v)].imx;
	}
	else {
		ti[v].mx = ti[rs(v)].mx;
		ti[v].imx = ti[rs(v)].imx;
	}
}

inline void combj(int v) {
	if (tj[ls(v)].mn <= tj[rs(v)].mn) {
		tj[v].mn = tj[ls(v)].mn;
		tj[v].imn = tj[ls(v)].imn;
	}
	else {
		tj[v].mn = tj[rs(v)].mn;
		tj[v].imn = tj[rs(v)].imn;
	}
	if (tj[ls(v)].mx <= tj[rs(v)].mx) {
		tj[v].mx = tj[ls(v)].mx;
		tj[v].imx = tj[ls(v)].imx;
	}
	else {
		tj[v].mx = tj[rs(v)].mx;
		tj[v].imx = tj[rs(v)].imx;
	}
}

void buildi(int v, int l, int r) {
	if (l == r - 1) {
		ti[v] = node(0, l, 0, l);
		return;
	}
	int m = (l + r) / 2;
	buildi(ls(v), l, m);
	buildi(rs(v), m, r);
	combi(v);
}

void buildj(int v, int l, int r) {
	if (l == r - 1) {
		tj[v] = node(0, l, 0, l);
		return;
	}
	int m = (l + r) / 2;
	buildj(ls(v), l, m);
	buildj(rs(v), m, r);
	combj(v);
}

void upi(int v, int l, int r, int ql, int x) {
	if (ql >= r || ql < l)
		return;
	if (ql == l && l == r - 1) {
		ti[v] = node(x, ql, x, ql);
		return;
	}
	int m = (l + r) / 2;
	upi(ls(v), l, m, ql, x);
	upi(rs(v), m, r, ql, x);
	combi(v);
}

void upj(int v, int l, int r, int ql, int x) {
	if (ql >= r || ql < l)
		return;
	if (ql == l && l == r - 1) {
		tj[v] = node(x, ql, x, ql);
		return;
	}
	int m = (l + r) / 2;
	upj(ls(v), l, m, ql, x);
	upj(rs(v), m, r, ql, x);
	combj(v);
}

int qmini(int v, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr)
		return inf;
	if (l == ql && r == qr)
		return ti[v].mn;
	int m = (l + r) / 2;
	return min(qmini(ls(v), l, m, ql, min(m, qr)), qmini(rs(v), m, r, max(ql, m), qr));
}

int qminj(int v, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr)
		return inf;
	if (l == ql && r == qr)
		return tj[v].mn;
	int m = (l + r) / 2;
	return min(qminj(ls(v), l, m, ql, min(m, qr)), qminj(rs(v), m, r, max(ql, m), qr));
}


int qmaxi(int v, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr)
		return -inf;
	if (l == ql && r == qr)
		return ti[v].mx;
	int m = (l + r) / 2;
	return max(qmaxi(ls(v), l, m, ql, min(m, qr)), qmaxi(rs(v), m, r, max(ql, m), qr));
}

int qmaxj(int v, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr)
		return -inf;
	if (l == ql && r == qr)
		return tj[v].mx;
	int m = (l + r) / 2;
	return max(qmaxj(ls(v), l, m, ql, min(m, qr)), qmaxj(rs(v), m, r, max(ql, m), qr));
}

int main() {
	io();
	cin >> n >> m >> q;
	row.resize(n, 0);
	col.resize(m, 0);
	ti.resize(4 * n);
	tj.resize(4 * m);
	buildi(0, 0, n);
	buildj(0, 0, m);
	while (q--) {
		int typ;
		cin >> typ;
		if (typ == 1) {
			int i;
			cin >> i;
			i--;
			upi(0, 0, n, i, t);
			row[i] = t;
		}
		if (typ == 2) {
			int j;
			cin >> j;
			j--;
			upj(0, 0, m, j, t);
			col[j] = t;
		}
		if (typ == 3) {
			int i1, j1, i2, j2, k;
			cin >> i1 >> j1 >> i2 >> j2 >> k;
			i1--, j1--, i2--, j2--;
			//1 and 2
			int ned = t - k;
			int ans = inf;
			int o =  abs(i1 - i2) + abs(j1 - j2);
			if (row[i1] >= ned && col[j2] >= ned || row[i2] >= ned && col[j1] >= ned
				|| i1 == i2 && row[i1] >= ned || j1 == j2 && col[j1] >= ned)
				ans = o;
			//3 and 4
			if (qminj(0, 0, m, j1, j2 + 1) >= ned)
				ans = o;
			if (qmini(0, 0, n, i1, i2 + 1) >= ned)
				ans = o;
			//5
			if (col[j1] >= ned && col[j2] >= ned) {
				if (qmaxi(0, 0, n, min(i1, i2), max(i1, i2) + 1) >= ned)
					ans = o;
				else {
					if (i1 > i2)
						swap(i1, i2);
					int l = i2;
					int r = n;
					while (r - l > 1) {
						int mm = (l + r) / 2;
						int qq = qmaxi(0, 0, n, i2, mm);
						if (qq < ned)
							l = mm;
						else
							r = mm;
					}
					if (r != n) {
						ans = min(ans, abs(j1 - j2) + abs(i1 - r) + abs(i2 - r));
					}
					l = 0;
					r = i1;
					while (r - l > 1) {
						int mm = (l + r) / 2;
						int qq = qmaxi(0, 0, n, mm, i1);
						if (qq >= ned)
							r = mm;
						else
							l = mm;
					}
					if (qmaxi(0, 0, n, 0, i1) >= ned)
						ans = min(ans, abs(j1 - j2) + abs(i1 - l) + abs(i2 - l));
				}
			}
			// 6
			if (row[i1] >= ned && row[i2] >= ned) {
				if (qmaxj(0, 0, m, min(j1, j2), max(j1, j2) + 1) >= ned)
					ans = o;
				else {
					if (j1 > j2)
						swap(j1, j2);
					int l = j2;
					int r = m;
					while (r - l > 1) {
						int mm = (l + r) / 2;
						int qq = qmaxj(0, 0, m, j2, mm);
						if (qq < ned)
							l = mm;
						else
							r = mm;
					}
					if (r != n) {
						ans = min(ans, abs(i1 - i2) + abs(j1 - r) + abs(j2 - r));
					}
					l = 0;
					r = j1;
					while (r - l > 1) {
						int mm = (l + r) / 2;
						int qq = qmaxj(0, 0, m, mm, j1);
						if (qq >= ned)
							r = mm;
						else
							l = mm;
					}
					if (qmaxj(0, 0, m, 0, j1) >= ned)
						ans = min(ans, abs(i1 - i2) + abs(j1 - l) + abs(j2 - l));
				}
			}
			cout << (ans == inf ? -1 : ans) << endl;
		}

		t++;
	}
	return 0;
}