#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>
#include <stack>

#pragma GCC optimize("Ofast,fast-math,no-stack-protector,unroll-loops")

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll cst = 5e5 + 5;

struct segment {
	ll l, r;
	ll g;
	ll c;
	segment(ll nl = 0, ll nr = 0, ll gr = 0, ll nc = 0) {
		l = nl; r = nr;
		g = gr;
		c = nc;
	}
	bool operator <(segment& that) {
		return that.l > this->l;
	}
};

vector<segment> vc;

ll n, m;
ll arr[cst];

ll ml[cst];
ll mr[cst];

ll gr[cst];

ll pr = -1;

ll t[4 * cst];
ll prs[4 * cst];

void push(ll v) {
	if (prs[v] != 0) {
		t[v] = prs[v];
		prs[2 * v] = prs[2 * v + 1] = prs[v];
		prs[v] = 0;
	}
}

void upd(ll v, ll tl, ll tr, ll l, ll r, ll k) {
	if (l >= r) return;
	push(v);
	if (l == tl && r == tr) {
		prs[v] = k;
		push(v);
		return;
	}
	ll tm((tl + tr) >> 1);
	upd(2 * v, tl, tm, l, min(r, tm), k);
	upd(2 * v + 1, tm, tr, max(tm, l), r, k);
	t[v] = min(t[2 * v], t[2 * v + 1]);
}

ll get(ll v, ll tl, ll tr, ll p) {
	push(v);
	if (tl == tr - 1) return t[v];
	ll tm((tl + tr) >> 1);
	if (p < tm) return get(2 * v, tl, tm, p);
	else return get(2 * v + 1, tm, tr, p);
}

int main() {
	cin >> m >> n;
	memset(ml, 0b0111, sizeof(ml));
	for (int i = 0; i < m; i++) {
		cin >> arr[i];
		if (arr[i] != pr) gr[arr[i]]++;
		mr[arr[i]] = max((ll)i, mr[arr[i]]);
		ml[arr[i]] = min((ll)i, ml[arr[i]]);
		pr = arr[i];
	}
	for (int i = 1; i <= n; i++) {
		if (gr[i] != 0) {
			vc.push_back({ ml[i], mr[i], gr[i], i });
		}
	}
	sort(all(vc));
	for (int i = 0; i < vc.size(); i++) {
		upd(1, 0, m, vc[i].l, vc[i].r + 1, vc[i].c);
	}
	for (int i = 0; i < m; i++) {
		ll x = get(1, 0, m, i);
		if (x != arr[i]) {
			cout << -1;
			system("pause");
			return 0;
		}
	}
	cout << vc.size() << endl;
	for (int i = 0; i < vc.size(); i++) {
		cout << vc[i].c << " " << vc[i].l + 1 << " " << vc[i].r + 1 << endl;
	}
	system("pause");
	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/