#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>
#include <stack>

#pragma GCC optimize("Ofast,fast-math,no-stack-protector,unroll-loops,unswitch-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,popcnt,tune=native")

#define all(x) x.begin(), x.end()

using namespace std;

typedef int ll;

const ll cst = 1e6 + 5;

ll r[cst], c[cst];

ll n, m, q;
ll timer = 1;

ll t1[ll(2.5 * cst)];
ll t2[ll(2.5 * cst)];

void upd1(ll v, ll tl, ll tr, ll p, ll x) {
	if (tl == tr - 1) {
		t1[v] = x;
		return;
	}
	ll tm((tl + tr) >> 1);
	if (p < tm) upd1(2 * v, tl, tm, p, x);
	else upd1(2 * v + 1, tm, tr, p, x);
	t1[v] = min(t1[2 * v], t1[2 * v + 1]);
}

void upd2(ll v, ll tl, ll tr, ll p, ll x) {
	if (tl == tr - 1) {
		t2[v] = x;
		return;
	}
	ll tm((tl + tr) >> 1);
	if (p < tm) upd2(2 * v, tl, tm, p, x);
	else upd2(2 * v + 1, tm, tr, p, x);
	t2[v] = min(t2[2 * v], t2[2 * v + 1]);
}

ll get1(ll v, ll tl, ll tr, ll l, ll r) {
	if (l >= r) return 1e18;
	if (l == tl && r == tr) return t1[v];
	ll tm((tl + tr) >> 1);
	ll v1 = get1(2 * v, tl, tm, l, min(r, tm));
	ll v2 = get1(2 * v + 1, tm, tr, max(l, tm), r);
	return min(v1, v2);
}

ll get2(ll v, ll tl, ll tr, ll l, ll r) {
	if (l >= r) return 1e18;
	if (l == tl && r == tr) return t2[v];
	ll tm((tl + tr) >> 1);
	ll v1 = get2(2 * v, tl, tm, l, min(r, tm));
	ll v2 = get2(2 * v + 1, tm, tr, max(l, tm), r);
	return min(v1, v2);
}

ll ans = 1e18;

bool get(ll x1, ll y1, ll x2, ll y2, ll k) {
	if (min(timer - r[x1], timer - get2(1, 0, m + 1, min(y1, y2), max(y1, y2) + 1)) <= k &&
		min(timer - c[y2], timer - get1(1, 0, n + 1, x1, x2)) <= k) return true;
	if (min(timer - r[x2], timer - get2(1, 0, m + 1, min(y1, y2), max(y1, y2) + 1)) <= k &&
		min(timer - c[y1], timer - get1(1, 0, n + 1, x1, x2)) <= k) return true;
	return false;
}

ll sn(ll x, ll y) {
	return timer - max(r[x], c[y]);
}

void operator delete(void*);

int main() {
	cin >> n >> m >> q;
	for (int pok = 0; pok < q; pok++) {
		ll type;
		cin >> type;
		if (type == 1) {
			ll x;
			cin >> x;
			upd1(1, 0, n + 1, x, timer);
			r[x] = timer;
		}
		else if (type == 2) {
			ll x;
			cin >> x;
			upd2(1, 0, m + 1, x, timer);
			c[x] = timer;
		}
		else {
			ans = 1e9;
			ll x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			if (sn(x1, y1) > k || sn(x2, y2) > k) {
				cout << -1 << endl;
				continue;
			}
			if (x1 > x2) {
				swap(x1, x2);
				swap(y1, y2);
			}

			if (get(x1, y1, x2, y2, k)) ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
			// up   //\\  //  ||// ||
			if (y1 < y2) {
				for (int i = x1; i > 0; i--) {
					if (sn(i, y1 + 1) <= k) {
						if (get((ll)i, ll(y1 + 1ll), x2, y2, k)) ans = min(ans, abs(i - x1) + abs(i - x2) + abs(y1 - y2));
						break;
					}
				}
			}
			else if(y1 > y2) {
				for (int i = x1; i > 0; i--) {
					if (sn(i, y1 - 1) <= k) {
						if (get((ll)i, ll(y1 + 1ll), x2, y2, k)) ans = min(ans, abs(i - x1) + abs(i - x2) + abs(y1 - y2));
						break;
					}
				}
			}
			//down				\\// \\// || //||																																																																									:(
			if (y1 < y2) {
				for (int i = x1; i <= n; i++) {
					if (sn(i, y1 + 1) <= k) {
						if (get((ll)i, ll(y1 + 1ll), x2, y2, k)) ans = min(ans, abs(i - x1) + abs(i - x2) + abs(y1 - y2));
						break;
					}
				}
			}
			else if (y1 > y2) {
				for (int i = x1; i <= n; i++) {
					if (sn(i, y1 - 1) <= k) {
						if (get((ll)i, ll(y1 + 1ll), x2, y2, k)) ans = min(ans, abs(i - x1) + abs(i - x2) + abs(y1 - y2));
						break;
					}
				}
			}
			if (ans == 1e9) cout << -1 << endl;
			else cout << ans << endl;
		}
		/*for (int k = 0; k < n; k++) {
			for (int j = 0; j < m; j++) {
				cout << sn(k + 1, j + 1) << " \n"[j == m - 1];
			}
		}*/
		timer++;
	}
	system("pause");
	return 0;
}

/*

4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6

*/