#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cmath>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e9 + 7;
const int eps = 1e-9;

struct Del
{
	int l;
	int r;
	int c;

	Del(int l = -1, int r = -1, int c = 0) : l(l), r(r), c(c) {}
};

bool lcomp(Del a, Del b)
{
	return a.r > b.r;
}

bool rcomp(Del a, Del b)
{
	return a.l < b.l;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m;
	cin >> m >> n;

	vector<int> arr(m);
	for (int i = 0; i < m; i++)
	{
		cin >> arr[i];
	}

	vector<Del> del(n + 1);
	for (int i = 0; i < m; i++)
	{
		int j = arr[i];
		if (del[j].c != 0)
			del[j].r = i;
		else
			del[j] = { i, i, j };
	}	 

	vector<int> add(m, 0);
	vector<int> er(m, 0);
	for (Del d : del)
	{
		if (d.c != 0)
		{
			add[d.l] = d.c;
			er[d.r] = d.c;
		}
	}

	vector<int> st;
	vector<Del> ans;
	bool ok = true;
	for (int i = 0; i < m; i++)
	{
		if (add[i] != 0)
		{
			st.push_back(add[i]);
			ans.push_back(del[add[i]]);
		}
		if (st.back() != arr[i])
		{
			ok = false;
			break;
		}
		if (er[i] != 0)
		{
			if (st.back() != er[i])
			{
				ok = false;
				break;
			}
			else
			{
				st.pop_back();
			}
		}
	}

	if (!ok)
	{
		cout << -1 << endl;
	}
	else
	{
		int sz = ans.size();
		cout << sz << '\n';

		for (int i = 0; i < sz; i++)
		{
			cout << ans[i].c << ' ' << ans[i].l + 1 << ' ' << ans[i].r + 1 << '\n';
		}
	}

	//system("pause");
	return 0;
}