#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cmath>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e9 + 7;
const int eps = 1e-9;

int getans(int x1, int y1, int x2, int y2, vector<int>& x, vector<int>& y, int minv)
{
	int ans = abs(x1 - x2) + abs(y1 - y2);

	int l = y1;
	int r = y2;
	if (r < l)
		swap(l, r);

	if (abs(x1 - x2) > 1)
	{
		for (int i = l; i <= r; i++)
		{
			if (y[i] >= minv)
				goto out;
		}

		int l1 = x1, r1 = x2;
		if (r1 < l1)
			swap(l1, r1);
		bool ok = true;
		for (int i = l1 + 1; i < r1; i++)
		{
			if (x[i] < minv)
			{
				ok = false;
				break;
			}
		}
		if (ok)
			goto out;

		int add = inf;
		for (int i = l - 1; i >= 0; i--)
		{
			if (y[i] >= minv)
			{
				add = min(add, l - i);
				break;
			}
		}
		for (int i = r + 1; i < y.size(); i++)
		{
			if (y[i] >= minv)
			{
				add = min(add, i - r);
				break;
			}
		}
		if (add == inf)
			ans = -1;
		else
			ans += 2 * add;
	}
out:
	return ans;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, q;
	cin >> n >> m >> q;

	vector<int> vert(n, 0);
	vector<int> hor(m, 0);

	for (int t = 1; t <= q; t++)
	{
		int type;
		cin >> type;

		if (type == 1)
		{
			int x;
			cin >> x;
			x--;

			vert[x] = t;
		}
		else if (type == 2)
		{
			int y;
			cin >> y;
			y--;

			hor[y] = t;
		}
		else
		{
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;

			int minv = t - k;

			if (vert[x1] >= minv && hor[y2] >= minv)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
			}
			else if (vert[x2] >= minv && hor[y1] >= minv)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
			}
			else if (vert[x1] >= minv && vert[x2] >= minv)
			{
				//vert
				cout << getans(x1, y1, x2, y2, vert, hor, minv) << '\n';
			}
			else if (hor[y1] >= minv && hor[y2] >= minv)
			{
				//hor
				cout << getans(y1, x1, y2, x2, hor, vert, minv) << '\n';
			}
			else
			{
				cout << -1 << '\n';
			}

		}
	}

	//system("pause");
	return 0;
}