#include<bits/stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define X first
#define Y second
#define is insert
#define er erase
#define sz(a) (int)a.size();

using namespace std;

const int MAX_N = 1e4 + 5;
const int INF = 1e9;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}

int n;
int m;
int q;

unordered_map<int, int> mr, mc;

int run;

int getR(int x)
{
    if (mr.find(x) == mr.end())
    {
        return 0;
    }
    return mr[x];
}

int getC(int x)
{
    if (mc.find(x) == mc.end())
    {
        return 0;
    }
    return mc[x];
}

int get(int x, int y)
{

    return min(run - getR(x), run - getC(y));
}

pii t[2][4 * MAX_N];

void build(int b, int v, int LG, int RG)
{
    t[b][v] = mp(0, 0);
    if (LG == RG)
    {
        return;
    }
    int MG = (LG + RG) / 2;
    build(b, v * 2, LG, MG);
    build(b, v * 2 + 1, MG + 1, RG);
}

pii merge(pii p1, pii p2)
{
    return mp(min(p1.X, p2.X), max(p1.Y, p2.Y));
}

void update(int b, int v, int LG, int RG, int pos, int x)
{
    if (LG == RG)
    {
        t[b][v].X = t[b][v].Y = x;
        return;
    }
    int MG = (LG + RG) / 2;
    if (pos <= MG)
    {
        update(b, v * 2, LG, MG, pos, x);
    }
    else
    {
        update(b, v * 2 + 1, MG + 1, RG, pos, x);
    }
    t[b][v] = merge(t[b][v * 2], t[b][v * 2 + 1]);
}

pii get(int b, int v, int LG, int RG, int l, int r)
{
    if (r < l)
    {
        return mp(INF, -INF);
    }
    if (LG == l && RG == r)
    {
        return t[b][v];
    }
    int MG = (LG + RG) / 2;
    return merge(get(b, v * 2, LG, MG, l, min(MG, r)), get(b, v * 2 + 1, MG + 1, RG, max(MG + 1, l), r));
}

pii findR(int r1, int c1, int k)
{
    pii res;
    int lg = 0;
    int rg = c1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, mg, c1);
        if (run - cur.X > k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    res.X = rg;
    lg = c1;
    rg = m + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(1, 1, 1, m, c1, mg);
        if (run - cur.X > k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    res.Y = lg;
    return res;
}

int goRow(int r1, int c1, int r2, int c2, int k)
{
    int res = INF;
    int lg, rg;
    pii cur = findR(r1, c1, k);
    lg = cur.X;
    rg = cur.Y;
    if (run - getR(r1) <= k)
    {
        lg = 1;
        rg = m;
    }
    cur = findR(r2, c2, k);
    if (run - getR(r2) <= k)
    {
        cur.X = 1;
        cur.Y = m;
    }
    //cerr << "0 " << run << ' ' << lg << ' ' << rg << ' ' << cur.X << ' ' << cur.Y << '\n';
    lg = max(lg, cur.X);
    rg = min(rg, cur.Y);

    for (int i = lg; i <= rg; ++i)
    {
        if (run - getC(i) <= k)
        {
            res = min(res, abs(c1 - i) + abs(r1 - r2) + abs(c2 - i));
        }
    }
    return res;
}

pii findC(int r1, int c1, int k)
{
    pii res;
    int lg = 0;
    int rg = r1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, mg, r1);
        if (run - cur.X > k)
        {
            lg = mg;
        }
        else
        {
            rg = mg;
        }
    }
    //cerr << run << ' ' << rg << '\n';
    res.X = rg;
    lg = r1;
    rg = n + 1;
    while (rg - lg > 1)
    {
        int mg = (lg + rg) / 2;
        pii cur = get(0, 1, 1, n, r1, mg);
        if (run - cur.X > k)
        {
            rg = mg;
        }
        else
        {
            lg = mg;
        }
    }
    res.Y = lg;
    return res;
}

int goColumn(int r1, int c1, int r2, int c2, int k)
{
    int res = INF;
    int lg, rg;
    pii cur = findC(r1, c1, k);
    lg = cur.X;
    rg = cur.Y;
    if (run - getC(c1) <= k)
    {
        lg = 1;
        rg = n;
    }
    cur = findC(r2, c2, k);
    if (run - getC(c2) <= k)
    {
        cur.X = 1;
        cur.Y = n;
    }
    lg = max(lg, cur.X);
    rg = min(rg, cur.Y);
    //cerr << "1 " << run << ' ' << lg << ' ' << rg << ' ' << cur.X << ' ' << cur.Y << '\n';
    for (int i = lg; i <= rg; ++i)
    {
        if (run - getR(i) <= k)
        {
            res = min(res, abs(r1 - i) + abs(c1 - c2) + abs(r2 - i));
        }
    }
    return res;
}

int solve()
{
    cin >> n >> m >> q;
    build(0, 1, 1, n);
    build(1, 1, 1, m);
    for (int i = 1; i <= q; ++i)
    {
        run = i;
        int z;
        cin >> z;
        if (run == 6)
        {
            pii cur = get(0, 1, 1, n, 1, 2);
        }
        if (z == 1)
        {
            int r;
            cin >> r;
            mr[r] = run;
            update(0, 1, 1, n, r, run);
        }
        else if (z == 2)
        {
            int c;
            cin >> c;
            mc[c] = run;
            update(1, 1, 1, m, c, run);
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            int ans = INF;

            if (get(r1, c1) > k || get(r2, c2) > k)
            {
                cout << "-1\n";
                continue;
            }
            int r = goRow(r1, c1, r2, c2, k);
            int c = goColumn(r1, c1, r2, c2, k);
            //cerr << i << ' ' << r << ' ' << c << '\n';
            ans = min(r, c);
            if (ans == INF)
            {
                cout << "-1\n";
                continue;
            }
            cout << ans << '\n';
        }
    }
    return 0;
}

