#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <functional>

using namespace std;

const long long int INF = 1000000000;

int main() {
	long long int m, n;
	cin >> m >> n;

	vector <long long int> last_i(n, -1);
	vector <long long int> dp_arr(m);
	vector <long long int> arr(m);
	for (long long int i = 0; i < m; i++) {
		cin >> arr[i];
		arr[i]--;
		dp_arr[i] = i;
		if (last_i[arr[i]] != -1) {
			dp_arr[last_i[arr[i]]] = i;
		}
		last_i[arr[i]] = i;
	}

	function <bool(long long int, long long int)> func = [&](long long int l, long long int r) {
		if (r < l) {
			return true;
		}
		if (dp_arr[l] == l) {
			return func(l + 1, r);
		}
		if (dp_arr[l] <= r) {
			if (!(func(l + 1, dp_arr[l] - 1))) {
				return false;
			}
			else {
				return func(dp_arr[l], r);
			}
		}
		else {
			return false;
		}
	};

	if (!(func(0, m - 1))) {
		cout << -1;
		return 0;
	}

	vector <long long int> dp_dp_arr(n, -1);
	for (long long int i = 0; i < m; i++) {
		dp_dp_arr[arr[i]] = i;
	}

	vector <long long int> used(n, 0);
	vector <pair<long long int, pair<long long int, long long int>>> ans(0);
	for (long long int i = 0; i < m; i++) {
		if (used[arr[i]] == 0) {
			ans.push_back({ arr[i] + 1, {i + 1, dp_dp_arr[arr[i]] + 1} });
			used[arr[i]] = 1;
		}
	}

	cout << ans.size() << "\n";
	for (long long int i = 0; i < ans.size(); i++) {
		cout << ans[i].first << " " << ans[i].second.first << " " << ans[i].second.second << "\n";
	}
	system("pause");
	return 0;
}