#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int INF = (int)1e9 + 10;
const int K = 20;
const int C = 1 << K;

void change(vector<pii>& a, int i, int x) {
	i += C;
	a[i] = { x, x };
	i /= 2;
	while (i) {
		a[i] = { min(a[i * 2].first, a[i * 2 + 1].first), max(a[i * 2].second, a[i * 2 + 1].second) };
		i /= 2;
	}
	return;
}

int minn(vector<pii>& a, int l, int r) {
	l += C;
	r += C;
	int res = INF;
	while (l < r) {
		if (l % 2)
			res = min(a[l].first, res);
		if (r % 2 == 0)
			res = min(a[r].first, res);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	if (l == r)
		res = min(res, a[l].first);
	return res;
}

int maxx(vector<pii>& a, int l, int r) {
	l += C;
	r += C;
	int res = -INF;
	while (l < r) {
		if (l % 2)
			res = max(a[l].second, res);
		if (r % 2 == 0)
			res = max(a[r].second, res);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	if (l == r)
		res = max(res, a[l].second);
	return res;
}

int last(vector<pii>& a, int v, int L, int R, int i, int x) {
	if (L > i)
		return -1;
	if (a[v].first > x)
		return -1;
	if (R - L == 1)
		return L;
	int M = (L + R) / 2;
	int ans = last(a, v * 2 + 1, M, R, i, x);
	if (ans == -1)
		return last(a, v * 2, L, M, i, x);
	return ans;
}

int first(vector<pii>& a, int v, int L, int R, int i, int x) {
	if (R <= i)
		return -1;
	if (a[v].first > x)
		return -1;
	if (R - L == 1)
		return L;
	int M = (L + R) / 2;
	int ans = first(a, v * 2, L, M, i, x);
	if (ans == -1)
		return first(a, v * 2 + 1, M, R, i, x);
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, q;
	cin >> n >> m >> q;

	vector<pii> x(2 << K), y(2 << K);
	for (int t = 1; t <= q; ++t) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			--r;
			change(x, r, -t);
		}
		else if (type == 2) {
			int c;
			cin >> c;
			--c;
			change(y, c, -t);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1; --c1; --r2; --c2;
			k -= t;
			if ((x[r1 + C].first > k && y[c1 + C].first > k) || (x[r2 + C].first > k && y[c2 + C].first > k)) {
				cout << "-1\n";
				continue;
			}
			if ((x[r1 + C].first <= k && y[c2 + C].first <= k) || (x[r2 + C].first <= k && y[c1 + C].first <= k)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				continue;
			}
			if (x[r1 + C].first <= k) {
				if (maxx(x, r1, r2) <= k || minn(y, c1, c2) <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					continue;
				}
				int l = last(y, 1, 0, C, c1, k), r = first(y, 1, 0, C, c1, k);
				if (l == -1 && r == -1)
					cout << "-1\n";
				else if (l == -1)
					cout << abs(r1 - r2) + abs(r - c1) + abs(r - c2) << endl;
				else if (r == -1)
					cout << abs(r1 - r2) + abs(l - c1) + abs(l - c2) << endl;
				else
					cout << abs(r1 - r2) + min(abs(l - c1) + abs(l - c2), abs(r - c1) + abs(r - c2)) << endl;
			}
			else {
				if (maxx(y, c1, c2) <= k || minn(x, r1, r2) <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
					continue;
				}
				int l = last(x, 1, 0, C, r1, k), r = first(x, 1, 0, C, r1, k);
				if (l == -1 && r == -1)
					cout << "-1\n";
				else if (l == -1)
					cout << abs(c1 - c2) + abs(r - r1) + abs(r - r2) << endl;
				else if (r == -1)
					cout << abs(c1 - c2) + abs(l - r1) + abs(l - r2) << endl;
				else
					cout << abs(c1 - c2) + min(abs(l - r1) + abs(l - r2), abs(r - r1) + abs(r - r2)) << endl;
			}
		}
	}

	return 0;
}