#include <iostream>
#include <vector>

using namespace std;

struct node {
    int cl, cr;
    int mn, mx;
    node *left, *right;
    node (){}
    node (int _cl, int _cr, int _mn, int _mx, node *_left, node *_right){
        cl = _cl;
        cr = _cr;
        mn = _mn;
        mx = _mx;
        left = _left;
        right = _right;
    }
};

node *create(int cl, int cr){
    if (cl + 1 == cr){
        return new node(cl, cr, 0, 0, nullptr, nullptr);
    }
    int mid = (cr + cl) / 2;
    return new node(cl, cr, 0, 0, create(cl, mid), create(mid, cr));
}

int get_min(node* rt, int cl, int cr){
    if (cl <= rt -> cl && rt -> cr <= cr){
        return rt -> mn;
    }
    if (cl >= rt -> cr || cr <= rt -> cl){
        return 1e9;
    }
    return min(get_min(rt -> left, cl, cr), get_min(rt -> right, cl, cr));
}

int get_max(node* rt, int cl, int cr){
    if (cl <= rt -> cl && rt -> cr <= cr){
        return rt -> mx;
    }
    if (cl >= rt -> cr || cr <= rt -> cl){
        return 0;
    }
    return max(get_max(rt -> left, cl, cr), get_max(rt -> right, cl, cr));
}

void change(node *rt, int x, int nw){
    if (rt -> cl + 1 == rt -> cr){
        rt -> mn = nw;
        rt -> mx = nw;
        return;
    }
    int mid = (rt -> cl + rt -> cr) / 2;
    if (x < mid){
        change(rt -> left, x, nw);
    }
    else {
        change(rt -> right, x, nw);
    }
    rt -> mn = min(rt -> left -> mn, rt -> right -> mn);
    rt -> mx = max(rt -> left -> mx, rt -> right -> mx);
}

int main() {
    int n, m, q;
    cin >> n >> m >> q;
    node *clr = create(0, n), *clc = create(0, m);
    vector <int> clr2(n, 0), clc2(n, 0);
    for (int i = 1; i <= q; i++){
        int c;
        cin >> c;
        if (c == 1){
            int r;
            cin >> r;
            r--;
            change(clr, r, i);
            clr2[r] = i;
        }
        if (c == 2){
            int r;
            cin >> r;
            r--;
            change(clc, r, i);
            clc2[r] = i;
        }
        if (c == 3){
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            int mny = min(y1, y2), mxy = max(y1, y2) + 1, mnx = min(x1, x2), mxx = max(x1, x2) + 1;
            bool r1 = i - clr2[x1] <= k;
            bool r2 = i - clr2[x2] <= k;
            bool c1 = i - clc2[y1] <= k;
            bool c2 = i - clc2[y2] <= k;
            bool ar = i - get_min(clr, mnx, mxx) <= k;
            bool ac = i - get_min(clc, mny, mxy) <= k;
            if ((r1 && c2) || (r2 && c1) || ar || ac){
                cout << abs(x2 - x1) + abs(y2 - y1) << endl;
                continue;
            }
            int res = 1e9;
            if (r1 && r2){
                if (i - get_max(clc, mny, mxy) <= k){
                    res = abs(x2 - x1) + abs(y2 - y1);
                }
                for (int j = 0; j < m; j++){
                    if (i - clc2[j] <= k){
                        res = min(res, abs(x2 - x1) + abs(j - y1) + abs(j - y2));
                    }
                }
            }
            if (c1 && c2){
                if (i - get_max(clr, mnx, mxx) <= k){
                    res = abs(x2 - x1) + abs(y2 - y1);
                }
                for (int j = 0; j < n; j++){
                    if (i - clr2[j] <= k){
                        res = min(res, abs(y2 - y1) + abs(j - x1) + abs(j - x2));
                    }
                }
            }
            if (res == 1e9){
                cout << -1 << endl;
            }
            else {
                cout << res << endl;
            }
        }
    }
    return 0;
}