#include <bits/stdc++.h>
using namespace std;

#define X first
#define Y second

const int MAX_N = 524288, INF = 1e9;

int rows[MAX_N], columns[MAX_N];
int rowsMin[2 * MAX_N], rowsMax[2 * MAX_N], columnsMin[2 * MAX_N], columnsMax[2 * MAX_N];
int n, m;

bool can(int x, int y, int delta) {
	return max(rows[x], columns[y]) >= delta;
}

void setValueMax(int *tree, int i, int x) {
	int curr = i + MAX_N;
	tree[curr] = x;
	curr >>= 1;
	while (curr != 0) {
		tree[curr] = max(tree[curr << 1], tree[(curr << 1) ^ 1]);
		curr >>= 1;
	}
}

void setValueMin(int *tree, int i, int x) {
	int curr = i + MAX_N;
	tree[curr] = x;
	curr >>= 1;
	while (curr != 0) {
		tree[curr] = min(tree[curr << 1], tree[(curr << 1) ^ 1]);
		curr >>= 1;
	}
}

int getMax(int *tree, int l, int r) {
	int cL = l + MAX_N, cR = r + MAX_N - 1;
	int ans = -INF;
	while (cL <= cR) {
		if (!(cR & 1))
			ans = max(ans, tree[cR]);
		if (cL & 1)
			ans = max(ans, tree[cL]);
		cL = (cL + 1) / 2;
		cR = (cR - 1) / 2;
	}
	return ans;
}

int getMin(int *tree, int l, int r) {
	int cL = l + MAX_N, cR = r + MAX_N - 1;
	int ans = +INF;
	while (cL <= cR) {
		if (!(cR & 1))
			ans = min(ans, tree[cR]);
		if (cL & 1)
			ans = min(ans, tree[cL]);
		cL = (cL + 1) / 2;
		cR = (cR - 1) / 2;
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int q;
	cin >> n >> m >> q;
	for (int currentT = 1; currentT <= q; ++currentT) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			setValueMin(rowsMin, --r, currentT);
			setValueMax(rowsMax, r, currentT);
			rows[r] = currentT;
		} else if (type == 2) {
			int c;
			cin >> c;
			setValueMin(columnsMin, --c, currentT);
			setValueMax(columnsMax, c, currentT);
			columns[c] = currentT;
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --c1, --r2, --c2;
			int delta = currentT - k;
			if (!can(r1, c1, delta) || !can(r2, c2, delta)) {
				cout << "-1\n";
				continue;
			}
			bool firstS = getMin(rowsMin, min(r1, r2), max(r1, r2) + 1) > delta;
			bool secondS = 1;
			for (int i = min(c1, c2); i <= max(c1, c2) && secondS; ++i)
				if (columns[i] < delta)
					secondS = 0;
			if (firstS || secondS || (rows[r1] >= delta && columns[c2] >= delta) ||
				(rows[r2] >= delta && columns[c1] >= delta)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << "\n";
				continue;
			}
			vector<int> interesting;
			if (rows[r1] >= delta && rows[r2] >= delta) {
				int ans = +INF;
				for (int i = c1; i < m; ++i) {
					if (columns[i] >= delta) {
						interesting.push_back(i);
						break;
					}
				}
				for (int i = c1 - 1; i >= 0; --i) {
					if (columns[i] >= delta) {
						interesting.push_back(i);
						break;
					}
				}
				for (auto i : interesting)
					ans = min(ans, abs(c1 - i) + abs(r2 - r1) + abs(c2 - i));

				if (ans == +INF)
					cout << "-1\n";
				else
					cout << ans << "\n";
			} else {
				int ans = +INF;
				for (int i = r1; i < n; ++i) {
					if (rows[i] >= delta) {
						interesting.push_back(i);
						break;
					}
				}
				for (int i = r1 - 1; i >= 0; --i) {
					if (rows[i] >= delta) {
						interesting.push_back(i);
						break;
					}
				}
				for (int i : interesting) {
					ans = min(ans, abs(r1 - i) + abs(c1 - c2) + abs(r2 - i));
				}
				if (ans == +INF)
					cout << "-1\n";
				else
					cout << ans << "\n";
			}
		}
		/*cout << "Time: " << currentT << "\n";
		cout << "Columns:\n";
		for (int i = 0; i < m; ++i)
			cout << columns[i] << " ";
		cout << "\n";
		cout << "Rows:\n";
		for (int i = 0; i < n; ++i)
			cout << rows[i] << " ";
		cout << "\n";*/
	}
	return 0;
}