#include <bits/stdc++.h>

using namespace std;

#define enl "\n"

const int INF = INT_MAX;
const int N = 0;

int get_max(int v, int l, int r, int vl, int vr, vector<int> &tree) {
    if (l <= vl && vr <= r) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    return max(get_max(2 * v, l, r, vl, vr, tree), get_max(2 * v + 1,l, r, vm, vr, tree));
}

int get_min(int v, int l, int r, int vl, int vr, vector<int> &tree) {
    if (l <= vl && vr <= r) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    return min(get_min(2 * v, l, r, vl, vr, tree), get_min(2 * v + 1,l, r, vm, vr, tree));
}

void update_min(int x, int v, vector<int> & tree) {
    int pos = N + x;
    tree[pos] = v;
    pos /= 2;
    while (pos > 0) {
        tree[pos] = min(tree[pos * 2], tree[pos * 2 + 1]);
        pos /= 2;
    }
}
void update_max(int x, int v, vector<int> & tree) {
    int pos = N + x;
    tree[pos] = v;
    pos /= 2;
    while (pos > 0) {
        tree[pos] = max(tree[pos * 2], tree[pos * 2 + 1]);
        pos /= 2;
    }
}


signed main() {
    int n, m, q;
    cin >> n >> m >> q;

    vector<int> st_rmx(2 * N, 0);
    vector<int> st_rmn(2 * N, 0);

    vector<int> st_cmx(2 * N, 0);
    vector<int> st_cmn(2 * N, 0);


    vector<int> rows(n, 0);
    vector<int> cols(m, 0);
    int dist[n][m];

    int t = 0;
    for (int qi = 0; qi < q; ++qi) {
        t++;
        int type;
        cin >> type;
        if (type == 1) {
            int ri;
            cin >> ri;
            update_min(ri - 1, t, st_rmn);
            update_max(ri - 1, t, st_rmx);
            rows[ri - 1] = t;

        } else if (type == 2) {
            int ci;
            cin >> ci;
            update_min(ci - 1, t, st_cmn);
            update_max(ci - 1, t, st_cmx);
            cols[ci - 1] = t;
        } else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;

            int vt = t - k;
            if (rows[x1] < vt && cols[y1] < vt) {
                cout << -1 << enl;
                continue;
            }
            if (rows[x2] < vt && cols[y2] < vt) {
                cout << -1 << enl;
                continue;
            }

            int simple = abs(x1 - x2) + abs(y1 - y2);
            if (rows[x1] >= vt && cols[y2] >= vt) {
                cout << simple << enl;
                continue;
            }
            if (cols[y1] >= vt && rows[x2] >= vt) {
                cout << simple << enl;
                continue;
            }
            int res = INF;
            if (rows[x1] >= vt) {
                int mn = get_min(1, min(x1, x2), max(x1, x2), 0, N, st_rmn);
                if (mn >= vt) {
                    cout << simple << enl;
                    continue;
                }

                for (int col = 0; col < m; ++col) {
                    if (cols[col] >= vt) {
                        if (min(y1, y2) <= col && col <= max(y1, y2)) {
                            res = simple;
                            break;
                        } else {
                            int add = min(abs(y1 - col), abs(y2 - col));
                            res = min(res, simple + add * 2);
                        }
                    }

                }
                if (res == INF) {
                    cout << -1 << enl;
                } else {
                    cout << res << enl;
                }
            } else {
                int mn = INF;
                for (int col = min(y1, y2); col < max(y1, y2); ++col) {
                    mn = min(mn, cols[col]);
                }
                if (mn >= vt) {
                    cout << simple << enl;
                    continue;
                }

                for (int row = 0; row < n; ++row) {
                    if (rows[row] >= vt) {
                        if (min(x1, x2) <= row && row <= max(x1, x2)) {
                            res = simple;
                            break;
                        } else {
                            int add = min(abs(x1 - row), abs(x2 - row));
                            res = min(res, simple + add * 2);
                        }
                    }

                }
                if (res == INF) {
                    cout << -1 << enl;
                } else {
                    cout << res << enl;
                }
            }
        }

    }
}
