#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e6 + 10, INF = 1e9 + 7;

struct node{
    int mx;
    node *l, *r;
    node(int v) {
        mx = v;
        l = r = 0;
    }
    node(node *a, node *b) {
        l = a;
        r = b;
        mx = max(l->mx, r->mx);
    }
} *tx, *ty;

int n, m, q, x[N], y[N];

node* build(int *a, int tl, int tr) {
    if (tl == tr)
        return new node(a[tl]);
    int tm = (tl + tr) / 2;
    return new node(build(a, tl, tm), build(a, tm + 1, tr));
}

void update(node *&t, int tl, int tr, int &p, int &v) {
    if (tl == tr)
        t->mx = v;
    else {
        int tm = (tl + tr) / 2;
        if (p <= tm)
            update(t->l, tl, tm, p, v);
        else
            update(t->r, tm + 1, tr, p, v);
        t->mx = max(t->l->mx, t->r->mx);
    }
}

int get(node *t, int tl, int tr, int l, int r) {
    if (l > r)
        return -INF;
    if (l == tl && r == tr)
        return t->mx;
    int tm = (tl + tr) / 2;
    return max(get(t->l, tl, tm, l, min(tm, r)), get(t->r, tm + 1, tr, max(tm + 1, l), r));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> q;
    tx = build(x, 0, n - 1);
    ty = build(y, 0, m - 1);
    for (int i = 1; i <= q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            r--;
            x[r] = -i;
            update(tx, 0, n - 1, r, x[r]);
        }
        else if (t == 2) {
            int c;
            cin >> c;
            c--;
            y[c] = -i;
            update(ty, 0, m - 1, c, y[c]);
        }
        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            r2--;
            c1--;
            c2--;
            if (get(tx, 0, n - 1, min(r1, r2), max(r1, r2)) + i <= k)
                cout << abs(r2 - r1) + abs(c2 - c1) << endl;
            else
                cout << -1 << endl;
        }
    }

    return 0;
}
