#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <math.h>

using namespace std;

struct node {
	int l = -1;
	int r = -1;
	int x = 0;
	node(){}
};

vector<node> pool;

int build(int L, int R) {
	node A;
	if (L == R - 1) {
		int ind = pool.size();
		pool.push_back(A);
		return ind;
	}
	int M = (L + R) / 2;
	A.l = build(L, M);
	A.r = build(M, R);
	int ind = pool.size();
	pool.push_back(A);
	return ind;
}

void upd(int root, int L, int R, int id, int x) {
	if (L == R - 1) {
		pool[root].x = x;
		return;
	}
	int M = (L + R) / 2;
	if (id < M) upd(pool[root].l, L, M, id, x);
	else upd(pool[root].r, M, R, id, x);
	pool[root].x = min(pool[pool[root].l].x, pool[pool[root].r].x);
}

int get(int root, int L, int R, int l, int r) {
	if (L == l && R == r) {
		return pool[root].x;
	}
	int M = (L + R) / 2;
	int res1 = 1e9;
	int res2 = 1e9;
	if (l < M) res1 = get(pool[root].l, L, M, l, min(M, r));
	if (r > M) res2 = get(pool[root].r, M, R, max(l, M), r);
	return min(res1, res2);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	//vector<int> row(n);
	int root = build(0, n);
	int tim = 0;
	for (int ij = 0; ij < q; ij++) {
		tim++;
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			r--;
			upd(root, 0, n, r, tim);
			continue;
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;
			int manhet = abs(x1 - x2) + abs(y1 - y2);
			if (y1 > y2) {
				swap(x1, x2);
				swap(y1, y2);
			}
			int need = tim - k;
			int res = get(root, 0, n, y1, y2 + 1);
			if (res >= need) {
				cout << manhet << "\n";
			}
			else cout << -1 << "\n";
			continue;
		}
		return 0;
	}
}