#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define ll long long
#define ld long double

using namespace std;

ld eps = 1e-5;

bool check(ll x, ll r, ll p) {
	if (x < r) return 0;
	ld p1 = p;
	p1 /= (p - 1);
	p1 *= r;
	p1 += eps;
	return (x <= p1);
}

int main() {
	int t;
	cin >> t;
	for (int ijk = 0; ijk < t; ijk++){
		int n, m, q;
		ll p;
		string ans = "";
		cin >> n >> m >> q >> p;
		vector<vector<pair<int, long long> > > to(n);
		vector<set<long long> > pos(n);
		pos[0].insert(0);
		for (int i = 0; i < m; i++) {
			int u, v;
			ll d;
			cin >> u >> v >> d;
			u--;
			v--;
			if (u > v) swap(u, v);
			to[u].push_back({ v, d });
		}
		for (int i = 0; i < n - 1; i++) {
			for (auto edge : to[i]) {
				int v = edge.first;
				ll w = edge.second;
				for (auto elem : pos[i]) {
					ll d = w + elem;
					pos[v].insert(d);
				}
			}
		}
		for (int ij = 0; ij < q; ij++) {
			ll r;
			int u;
			cin >> u >> r;
			u--;
			bool flag = 0;
			for (auto elem : pos[u]) {
				if (check(elem, r, p)) {
					flag = 1;
					break;
				}
			}
			if (flag) ans += '1';
			else ans += '0';
		}
		cout << ans << "\n";
	}
	//cin >> t;
}