#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int inf = 1000000000;

struct node {
    int x, y, sz, mn, mx;
    node *l, *r;
    node(int x_) {
        x = x_;
        y = rand();
        sz = 1;
        mn = x;
        mx = x;
        l = nullptr;
        r = nullptr;
    }
};

typedef node* treap;

int sz(treap t) {
    if(t) {
        return t->sz;
    }else {
        return 0;
    }
}

int mn(treap t) {
    if(t) {
        return t->mn;
    }else {
        return inf;
    }
}

int mx(treap t) {
    if(t) {
        return t->mx;
    }else {
        return -inf;
    }
}

void upd(treap t) {
    if(t) {
        t->sz = sz(t->l) + sz(t->r) + 1;
        t->mn = t->x;
        t->mn = min(t->mn, mn(t->l));
        t->mn = min(t->mn, mn(t->r));
        t->mx = t->x;
        t->mx = max(t->mx, mx(t->l));
        t->mx = max(t->mx, mx(t->r));
    }
}

void merge(treap &t, treap l, treap r) {
    if(!l) {
        t = r;
    }else if(!r) {
        t = l;
    }else if(l->y > r->y) {
        merge(l->r, l->r, r);
        t = l;
    }else {
        merge(r->l, l, r->l);
        t = r;
    }
    upd(t);
}

void split(treap t, treap &l, treap &r, int x, int add = 0) {
    if(!t) {
        l = nullptr;
        r = nullptr;
        return;
    }
    int cur = add + sz(t->l);
    if(x <= cur) {
        split(t->l, l, t->l, x, add);
        r = t;
    }else {
        split(t->r, t->r, r, x, cur + 1);
        l = t;
    }
    upd(t);
}

int getr(treap t, int x, int add = 0) {
    if(!t) {
        return -1;
    }
    int cur = add + sz(t->l);
    if(mn(t->r) <= x) {
        return getr(t->r, x, cur + 1);
    }else if(t->x <= x) {
        return cur;
    }else {
        return getr(t->l, x, add);
    }
}

int getl(treap t, int x, int add = 0) {
    if(!t) {
        return -1;
    }
    int cur = add + sz(t->l);
    if(mn(t->l) <= x) {
        return getl(t->l, x, add);
    }else if(t->x <= x) {
        return cur;
    }else {
        return getl(t->r, x, cur + 1);
    }
}

void push_back(treap &t, int x) {
    treap it = new node(x);
    merge(t, t, it);
}

void set_value(treap &t, int x, int pos) {
    treap t1, t2, t3;
    split(t, t1, t2, pos);
    split(t2, t2, t3, 1);
    t2->x = x;
    merge(t, t1, t2);
    merge(t, t, t3);
}

int get_value(treap &t, int l, int r, int k) {
    treap t1, t2, t3;
    split(t, t1, t2, l);
    split(t2, t2, t3, r - l + 1);
    int tt = getl(t2, k);

    int tt1 = getr(t1, k);
    int tt2 = getl(t3, k);
    merge(t, t1, t2);
    merge(t, t, t3);
    if(tt != -1) {
        return tt;
    }

    if(tt1 == -1) {
        return tt2;
    }else if(tt2 == -1) {
        return tt1;
    }else if(abs(l - tt1) < abs(r - tt2)) {
        return tt1;
    }else {
        return tt2;
    }
}

int get_val(treap &t, int pos) {
    treap t1, t2, t3;
    split(t, t1, t2, pos);
    split(t2, t2, t3, 1);
    int x = t2->x;
    merge(t, t1, t2);
    merge(t, t, t3);
    return x;
}

int getmx(treap &t, int l, int r) {
    treap t1, t2, t3;
    split(t, t1, t2, l);
    split(t2, t2, t3, r - l + 1);
    int mx = t2->mx;
    merge(t, t1, t2);
    merge(t, t, t3);
    return mx;
}

int main() {
    io();
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> a(n, vector<int>(m, 0));
    int t = 0;
    vector<vector<int>> d(n, vector<int>(m));
    while(q--) {
        t++;
        int type;
        cin >> type;
        if(type == 1) {
            int i;
            cin >> i;
            i--;
            for(int j = 0; j < m; j++) {
                a[i][j] = -t;
            }
        }else if(type == 2) {
            int i;
            cin >> i;
            i--;
            for(int j = 0; j < n; j++) {
                a[j][i] = -t;
            }
        }else {
            int x1, x2, y1, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            k -= t;
            for(int i = 0; i < n; i++) {
                for(int j = 0; j < m; j++) {
                    d[i][j] = inf;
                }
            }
            d[x1][y1] = 0;
            queue<pair<int, int>> q;
            q.push(make_pair(x1, y1));
            while(!q.empty()) {
                int x = q.front().first;
                int y = q.front().second;
                q.pop();
                if(x - 1 >= 0 && a[x - 1][y] <= k && d[x - 1][y] == inf) {
                    d[x - 1][y] = d[x][y] + 1;
                    q.push(make_pair(x - 1, y));
                }
                if(x + 1 < n && a[x + 1][y] <= k && d[x + 1][y] == inf) {
                    d[x + 1][y] = d[x][y] + 1;
                    q.push(make_pair(x + 1, y));
                }
                if(y - 1 >= 0 && a[x][y - 1] <= k && d[x][y - 1] == inf) {
                    d[x][y - 1] = d[x][y] + 1;
                    q.push(make_pair(x, y - 1));
                }
                if(y + 1 < m && a[x][y + 1] <= k && d[x][y + 1] == inf) {
                    d[x][y + 1] = d[x][y] + 1;
                    q.push(make_pair(x, y + 1));
                }
            }
            if(d[x2][y2] != inf) {
                cout << d[x2][y2] << "\n";
            }else {
                cout << -1 << "\n";
            }
        }
    }
    return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
 */