#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll m, n;
    cin >> m >> n;
    vector<ll> a((size_t) m);
    for (ll i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<vector<ll>> poses((size_t) n);
    for (ll i = 0; i < m; i++) {
        poses[a[i]].push_back(i);
    }
    vector<tuple<ll, ll, ll, vector<ll>>> ranges;
    for (ll i = 0; i < n; i++) {
        if (!poses[i].empty()) {
            ranges.emplace_back(i, poses[i].front(), poses[i].back(),
                                poses[i].size() == 1 ? vector<ll>() : vector<ll>(poses[i].begin() + 1,
                                                                                 poses[i].end() - 1));
        }
    }
    sort(ranges.begin(), ranges.end(), [](tuple<ll, ll, ll, vector<ll>> &a, tuple<ll, ll, ll, vector<ll>> &b) {
        if (get<2>(a) - get<1>(a) != get<2>(b) - get<1>(b)) {
            return get<2>(a) - get<1>(a) > get<2>(b) - get<1>(b);
        } else {
            return a < b;
        }
    });
    vector<ll> fen((size_t) m + 1, 0);
    auto update = [&](ll i, ll x) {
        for (i++; i <= m; i += i & -i) {
            fen[i] += x;
        }
    };
    auto query = [&](ll i) {
        ll x = 0;
        for (i++; i > 0; i -= i & -i) {
            x += fen[i];
        }
        return x;
    };
    bool possible = true;
    for (auto &range : ranges) {
        if (query(get<2>(range)) - (get<1>(range) == 0 ? 0 : query(get<1>(range) - 1)) > 0) {
            possible = false;
            break;
        }
        for (ll i : get<3>(range)) {
            update(i, 1);
        }
    }
    if (!possible) {
        cout << -1 << endl;
    } else {
        cout << ranges.size() << endl;
        for (auto &range : ranges) {
            cout << get<0>(range) + 1 << " " << get<1>(range) + 1 << " " << get<2>(range) + 1 << endl;
        }
    }
    return 0;
}
