#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

#define sz(x) ((int)(x).size())
#define INF 2000111222
#define pii pair<int, int>
#define MAXN 1000004
int n, m, q, t;

int ver[MAXN];
int hor[MAXN];

int d(int r1, int c1, int r2, int c2) {
    return abs(r1 - r2) + abs(c1 - c2);
}

void update_hor(int v, int tl, int tr, int pos) {
    hor[pos] = -t;
}

void update_ver(int v, int tl, int tr, int pos) {
    ver[pos] = -t;
}

int get_hor(int v, int tl, int tr, int pos) {
    return hor[pos];
}

int get_ver(int v, int tl, int tr, int pos) {
    return ver[pos];
}

int ver_left(int v, int tl, int tr, int l, int r, int k) {
    for(int i = l; i <= r; ++i)
        if(ver[i] + t <= k)
            return i;
    return 0;
}

int ver_right(int v, int tl, int tr, int l, int r, int k) {
    for(int i = r; i >= l; --i)
        if(ver[i] + t <= k)
            return i;
    return 0;
}

int max_ver(int v, int tl, int tr, int l, int r) {
    int x = -INF;
    for(int i = l; i <= r; ++i)
        x = max(x, ver[i]);
    return x;
}

int hor_left(int v, int tl, int tr, int l, int r, int k) {
    for(int i = l; i <= r; ++i)
        if(hor[i] + t <= k)
            return i;
    return 0;
}

int hor_right(int v, int tl, int tr, int l, int r, int k) {
    for(int i = r; i >= l; --i)
        if(hor[i] + t <= k)
            return i;
    return 0;
}

int max_hor(int v, int tl, int tr, int l, int r) {
    int x = -INF;
    for(int i = l; i <= r; ++i)
        x = max(x, hor[i]);
    return x;
}

void out() {
    for(int i = 1; i <= n; ++i)
        cout << hor[i] << " ";
    cout << endl;
    for(int i = 1; i <= m; ++i)
        cout << ver[i] << " ";
    cout << endl;
}

int query(int r1, int c1, int r2, int c2, int k) {
    char h1 = (get_hor(1, 1, n, r1) <= k - t), h2 = (get_hor(1, 1, n, r2) <= k - t);
    char v1 = (get_ver(1, 1, m, c1) <= k - t), v2 = (get_ver(1, 1, m, c2) <= k - t);
    if(!h1 && !v1 || !h2 && !v2)
        return -1;
    if((r1 == r2) && h1 || (c1 == c2) && v1 || h1 && v2 || h2 && v1) 
        return d(r1, c1, r2, c2);
    

    if(c1 > c2)
        swap(c1, c2);
    if(r1 > r2)
        swap(r1, r2);

    if(h1 && h2) {
        if(ver_left(1, 1, m, c1, c2, k) || max_hor(1, 1, n, r1, r2) + t <= k)
            return d(r1, c1, r2, c2);
        int right = ver_left(1, 1, m, c2, m, k);
        int left = ver_right(1, 1, m, 1, c1, k);
        int ans = INF;
        if(right) 
            ans = d(r1, c1, r2, c2) + 2 * (right - c2);
        if(left) 
            ans = min(ans, d(r1, c1, r2, c2) + 2 * (c1 - left));
        return (ans == INF ? -1 : ans);
    }
    else if(v1 && v2) {
        if(hor_left(1, 1, n, r1, r2, k) || max_ver(1, 1, m, c1, c2) + t <= k)
            return d(r1, c1, r2, c2);
        int right = hor_left(1, 1, n, r2, n, k);
        int left = hor_right(1, 1, n, 1, r1, k);
        int ans = INF;
        if(right) 
            ans = d(r1, c1, r2, c2) + 2 * (right - r2);
        if(left) 
            ans = min(ans, d(r1, c1, r2, c2) + 2 * (r1 - left));
        return (ans == INF ? -1 : ans);
    }
    return -1;
}

int main() {

    cin >> n >> m >> q;

    for(t = 1; t <= q; ++t) {
        int ch;
        cin >> ch;
        if(ch == 1) {
            int pos;
            cin >> pos;
            update_hor(1, 1, n, pos);
        }
        if(ch == 2) {
            int pos;
            cin >> pos;
            update_ver(1, 1, m, pos);
        }
        if(ch == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << query(r1, c1, r2, c2, k) << endl;
        }
    }
    return 0;
}