#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

#define sz(x) ((int)(x).size())
#define INF 2000111222
#define pii pair<int, int>
#define MAXN 1000004
#define mx first
#define mn second
int n, m, q, t;

pii ver[4*MAXN];
int ver2[MAXN];
pii hor[4*MAXN];
int hor2[MAXN];

int d(int r1, int c1, int r2, int c2) {
    return abs(r1 - r2) + abs(c1 - c2);
}

void update_hor(int v, int tl, int tr, int pos) {
    if(tl == pos && tr == pos) {
        hor[v].mx = hor[v].mn = -t;
        hor2[pos] = -t;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos > tm)
        update_hor(2*v + 1, tm + 1, tr, pos);
    else
        update_hor(2*v, tl, tm, pos);
    hor[v].mx = max(hor[2*v].mx, hor[2*v + 1].mx);
    hor[v].mn = min(hor[2*v].mn, hor[2*v + 1].mn);
}

void update_ver(int v, int tl, int tr, int pos) {
    if(tl == pos && tr == pos) {
        ver[v].mx = ver[v].mn = -t;
        ver2[pos] = -t;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos > tm)
        update_ver(2*v + 1, tm + 1, tr, pos);
    else
        update_ver(2*v, tl, tm, pos);
    ver[v].mx = max(ver[2*v].mx, ver[2*v + 1].mx);
    ver[v].mn = min(ver[2*v].mn, ver[2*v + 1].mn);
}

int get_hor(int v, int tl, int tr, int pos) {
    return hor2[pos];
}

int get_ver(int v, int tl, int tr, int pos) {
    return ver2[pos];
}

int ver_left(int v, int tl, int tr, int l, int r, int k) {
    if(l > tr || r < tl)
        return 0;
    if(tl == tr)
        return (ver[v].mn + t <= k ? tl : 0);
    if(tl == l && tr == r) {
        int tm = (tl + tr) / 2;
        if(ver[2*v].mn + t <= k)
            return ver_left(2*v, tl, tm, tl, tm, k);
        else if(ver[2*v + 1].mn + t <= k)
            return ver_left(2*v + 1, tm + 1, tr, tm + 1, tr, k);
        return 0;
    }
    int tm = (tl + tr) / 2;
    int ans = ver_left(2*v, tl, tm, l, min(tm, r), k);
    return (ans ? ans : ver_left(2*v + 1, tm + 1, tr, max(l, tm + 1), r, k));
}

int ver_right(int v, int tl, int tr, int l, int r, int k) {
    if(l > tr || r < tl)
        return 0;
    if(tl == tr)
        return (ver[v].mn + t <= k ? tl : 0);
    if(tl == l && tr == r) {
        int tm = (tl + tr) / 2;
        if(ver[2*v + 1].mn + t <= k)
            return ver_right(2*v + 1, tm + 1, tr, tm + 1, tr, k);
        else if(ver[2*v].mn + t <= k)
            return ver_right(2*v, tl, tm, tl, tm, k);
        return 0;
    }
    int tm = (tl + tr) / 2;
    int ans = ver_right(2*v + 1, tm + 1, tr, max(l, tm + 1), r, k);
    return (ans ? ans : ver_right(2*v, tl, tm, l, min(tm, r), k));
}

int max_ver(int v, int tl, int tr, int l, int r) {
    if(l > tr || r < tl)
        return -INF;
    if(tl == l && tr == r)
        return ver[v].mx;
    int tm = (tl + tr) / 2;
    return max(max_ver(2*v, tl, tm, l, min(tm, r)), 
               max_ver(2*v + 1, tm + 1, tr, max(tm + 1, l), r));
}

int hor_left(int v, int tl, int tr, int l, int r, int k) {
    if(l > tr || r < tl)
        return 0;
    if(tl == tr)
        return (hor[v].mn + t <= k ? tl : 0);
    if(tl == l && tr == r) {
        int tm = (tl + tr) / 2;
        if(hor[2*v].mn + t <= k)
            return hor_left(2*v, tl, tm, tl, tm, k);
        else if(hor[2*v + 1].mn + t <= k)
            return hor_left(2*v + 1, tm + 1, tr, tm + 1, tr, k);
        return 0;
    }
    int tm = (tl + tr) / 2;
    int ans = hor_left(2*v, tl, tm, l, min(tm, r), k);
    return (ans ? ans : hor_left(2*v + 1, tm + 1, tr, max(l, tm + 1), r, k));
}

int hor_right(int v, int tl, int tr, int l, int r, int k) {
    if(l > tr || r < tl)
        return 0;
    if(tl == tr)
        return (hor[v].mn + t <= k ? tl : 0);
    if(tl == l && tr == r) {
        int tm = (tl + tr) / 2;
        if(hor[2*v + 1].mn + t <= k)
            return hor_right(2*v + 1, tm + 1, tr, tm + 1, tr, k);
        else if(hor[2*v].mn + t <= k)
            return hor_right(2*v, tl, tm, tl, tm, k);
        return 0;
    }
    int tm = (tl + tr) / 2;
    int ans = hor_right(2*v + 1, tm + 1, tr, max(l, tm + 1), r, k);
    return (ans ? ans : hor_right(2*v, tl, tm, l, min(tm, r), k));
}

int max_hor(int v, int tl, int tr, int l, int r) {
    if(l > tr || r < tl)
        return -INF;
    if(tl == l && tr == r)
        return hor[v].mx;
    int tm = (tl + tr) / 2;
    return max(max_hor(2*v, tl, tm, l, min(tm, r)), 
               max_hor(2*v + 1, tm + 1, tr, max(tm + 1, l), r));
}

int query(int r1, int c1, int r2, int c2, int k) {
    char h1 = (get_hor(1, 1, n, r1) <= k - t), h2 = (get_hor(1, 1, n, r2) <= k - t);
    char v1 = (get_ver(1, 1, m, c1) <= k - t), v2 = (get_ver(1, 1, m, c2) <= k - t);
    if(!h1 && !v1 || !h2 && !v2)
        return -1;
    if((r1 == r2) && h1 || (c1 == c2) && v1 || h1 && v2 || h2 && v1) 
        return d(r1, c1, r2, c2);
    

    if(c1 > c2)
        swap(c1, c2);
    if(r1 > r2)
        swap(r1, r2);

    if(h1 && h2) {
        if(ver_left(1, 1, m, c1, c2, k) || max_hor(1, 1, n, r1, r2) + t <= k)
            return d(r1, c1, r2, c2);
        int right = ver_left(1, 1, m, c2, m, k);
        int left = ver_right(1, 1, m, 1, c1, k);
        int ans = INF;
        if(right) 
            ans = d(r1, c1, r2, c2) + 2 * (right - c2);
        if(left) 
            ans = min(ans, d(r1, c1, r2, c2) + 2 * (c1 - left));
        return (ans == INF ? -1 : ans);
    }
    else if(v1 && v2) {
        if(hor_left(1, 1, n, r1, r2, k) || max_ver(1, 1, m, c1, c2) + t <= k) 
            return d(r1, c1, r2, c2);
        int right = hor_left(1, 1, n, r2, n, k);
        int left = hor_right(1, 1, n, 1, r1, k);
        int ans = INF;
        if(right) 
            ans = d(r1, c1, r2, c2) + 2 * (right - r2);
        if(left) 
            ans = min(ans, d(r1, c1, r2, c2) + 2 * (r1 - left));
        return (ans == INF ? -1 : ans);
    }
    return -1;
}

int main() {

    cin >> n >> m >> q;

    for(t = 1; t <= q; ++t) {
        int ch;
        cin >> ch;
        if(ch == 1) {
            int pos;
            cin >> pos;
            update_hor(1, 1, n, pos);
        }
        if(ch == 2) {
            int pos;
            cin >> pos;
            update_ver(1, 1, m, pos);
        }
        if(ch == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << query(r1, c1, r2, c2, k) << endl;
        }
    }
    return 0;
}