#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

bool dfs(int v, int64_t dist, vector<vector<pair<int, int64_t>>>& adjlist, const int& f, const int& p, const int64_t& r) {
	if ((v == f) && (r <= dist) && (dist * (p - 1) <= p * r))
		return true;
	bool ans = false;
	for (int i = 0; i < adjlist[v].size(); ++i) {
		int to = adjlist[v][i].first;
		int64_t len = adjlist[v][i].second;
		if (to <= f)
			ans = ans || dfs(to, dist + len, adjlist, f, p, r);
	}
	return ans;
}

int main() {
	int t;
	cin >> t;
	for (int it = 0; it < t; ++it) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<vector<pair<int, int64_t>>> adjlist(n);
		for (int i = 0; i < m; ++i) {
			int from, to;
			int64_t len;
			cin >> from >> to >> len;
			adjlist[from - 1].emplace_back(to - 1, len);
		}
		string ans(q, '0');
		for (int i = 0; i < q; ++i) {
			int to;
			int64_t r;
			cin >> to >> r;
			--to;
			if (dfs(0, 0, adjlist, to, p, r))
				ans[i] = '1';
		}
		cout << ans << "\n";
	}
}
