#pragma GCC optimize("Ofast")
#pragma target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")


#include "bits/stdc++.h"

#define int long long

#define pb push_back
#define len(v) ((int)v.size())
#define x first
#define y second
#define mp make_pair

using namespace std;

typedef pair<int, int> pii;

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n, m, q;

const int N = (1 << 20);

struct Solver {
	int T[2 * N + 1];
	int S[2 * N + 1];
	void set(int i, int value) {
		i += N - 1;
		T[i] = value;
		S[i] = value;
		while (i > 0) {
			i = (i - 1) / 2;
			T[i] = max(T[i * 2 + 1], T[i * 2 + 2]);
			S[i] = min(S[i * 2 + 1], S[i * 2 + 2]);
		}
	}
	int query_min(int i, int tl, int tr, int ql, int qr) {
		if (ql <= tl && tr <= qr) return S[i];
		if (tr <= ql || qr <= tl) return 1e9;
		int m = (tl + tr) / 2;
		return min(query_min(i * 2 + 1, tl, m, ql, qr), query_min(i * 2 + 2, m, tr, ql, qr));
	}
	int queryR(int i, int tl, int tr, int j, int lower) {
		if (tr <= j) return -1e9;
		if (T[i] < lower) return -1e9;
		if (tl + 1 == tr) return tl;
		int m = (tl + tr) / 2;
		int t = queryR(i * 2 + 1, tl, m, j, lower);
		if (t != -1e9) return t;
		return queryR(i * 2 + 2, m, tr, j, lower);
	}
	vector<int> v;
	Solver(int n) {
		v.resize(n, -1);
		memset(T, -1, sizeof T);
		memset(S, -1, sizeof S);
	}
	void relax(int i, int t) {
		v[i] = t;
		set(i, t);
	}
	pii LR(int i, int lower) {
		pii rez = mp(-1e9, queryR(0, 0, N, i, lower));
		for (int j = i; j > -1; j--) {
			if (v[j] >= lower) {
				rez.x = j;
				break;
			}
		}
		return rez;
	}
	bool all_up(int l, int r, int lower) {
		return query_min(0, 0, N, l, r + 1) >= lower;
	}
};

void run() {
	cin >> n >> m >> q;
	Solver X(n);
	Solver Y(m);
	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int row;
			cin >> row;
			row--;
			X.relax(row, i);
		} else if (type == 2) {
			int col;
			cin >> col;
			col--;
			Y.relax(col, i);
		} else if (type == 3) {
			int t;
			pii from, to;
			cin >> from.x >> from.y >> to.x >> to.y >> t;
			from.x--;from.y--;to.x--;to.y--;

			pii fromX = X.LR(from.x, i - t);
			pii fromY = Y.LR(from.y, i - t);

			pii toX = X.LR(to.x, i - t);
			pii toY = Y.LR(to.y, i - t);


			int rez = 1e18;
			if (fromX.x == from.x) {
				if (toY.x == to.y) {
					rez = min(rez, abs(from.x - to.x) + abs(from.y - to.y));
				}
				if (toX.x == to.x) {
					for (int sub : vector<int>{fromY.x, fromY.y, toY.x, toY.y}) {
						rez = min(rez, abs(from.y - sub) + abs(from.x - to.x) + abs(to.y - sub));
					}
					if (X.all_up(min(from.x, to.x), max(from.x, to.x), i - t)) {
						rez = min(rez, abs(from.x - to.x) + abs(from.y - to.y));
					}
				}
			}
			if (fromY.x == from.y) {
				if (toX.x == to.x) {
					rez = min(rez, abs(from.x - to.x) + abs(from.y - to.y));
				}
				if (toY.y == to.y) {
					for (int sub : vector<int>{fromX.x, fromX.y, toX.x, toX.y}) {
						rez = min(rez, abs(from.x - sub) + abs(from.y - to.y) + abs(to.x - sub));
					}
					if (Y.all_up(min(from.y, to.y), max(from.y, to.y), i - t)) {
						rez = min(rez, abs(from.x - to.x) + abs(from.y - to.y));
					}
				}
			}
			cout << ((rez >= 1e7) ? -1LL : rez) << endl;
		}
	}
}