#include <stdio.h>
#include <algorithm>
#include <utility>
#include <vector>

std::vector<int> *graph;
int *ord, ind = 0, *used;

bool dfs(int v) {
	used[v] = 1;
	for (int u : graph[v]) {
		if (used[u] == 1) {
			return false;
		}
		if (used[u] == 0 && !dfs(u)) {
			return false;
		}
	}
	ord[ind++] = v;
	used[v] = 2;
	return true;
}

int main() {
	int m, n;
	scanf("%d%d", &m, &n);
	int a[m], l[n], r[n];
	for (int i = 0; i < n; i++) {
		l[i] = -1;
		r[i] = -1;
	}
	for (int i = 0; i < m; i++) {
		scanf("%d", &a[i]);
		a[i]--;
		if (l[a[i]] == -1) {
			l[a[i]] = i;
		}
		r[a[i]] = i;
	}
	graph = new std::vector<int>[n];
	int stack[n], ind1 = 0;
	for (int i = 0; i < m; i++) {
		while (ind1 > 0 && r[stack[ind1 - 1]] <= i) {
			ind1--;
		}
		if (ind1 > 0 && stack[ind1 - 1] != a[i]) {
			graph[a[i]].push_back(stack[ind1 - 1]);
		}
		if (l[a[i]] == i) {
			stack[ind1++] = a[i];
		}
	}
	ord = new int[n];
	used = new int[n]();
	int k = 0;
	for (int i = 0; i < n; i++) {
		if (used[i] == 0 && !dfs(i)) {
			printf("-1");
			return 0;
		}
		if (l[i] != -1) {
			k++;
		}
	}
	printf("%d\n", k);
	for (int i = 0; i < ind; i++) {
		if (l[ord[i]] != -1) {
			printf("%d %d %d\n", ord[i] + 1, l[ord[i]] + 1, r[ord[i]] + 1);
		}
	}
	return 0;
}
