#include <stdio.h>
#include <queue>
#include <utility>

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};
int n, m;

bool check(int x, int y) {
	return x >= 0 && y >= 0 && x < n && y < m;
}

int main() {
	int q;
	scanf("%d%d%d", &n, &m, &q);
	int r[n], c[m];
	for (int i = 0; i < n; i++) {
		r[i] = 0;
	}
	for (int i = 0; i < m; i++) {
		c[i] = 0;
	}
	int used[n][m], color = 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			used[i][j] = 0;
		}
	}
	for (int i = 0; i < q; i++) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			int rr;
			scanf("%d", &rr);
			r[rr - 1] = i + 1;
		} else if (t == 2) {
			int cc;
			scanf("%d", &cc);
			c[cc - 1] = i + 1;
		} else {
			int r1, c1, r2, c2, k;
			scanf("%d%d%d%d%d", &r1, &c1, &r2, &c2, &k);
			r1--, r2--, c1--, c2--;
			if (i + 1 - r[r1] - c[c1] > k) {
				printf("-1\n");
				continue;
			}
			used[r1][c1] = color;
			std::queue<std::pair<std::pair<int, int>, int> > q;
			q.push(std::make_pair(std::make_pair(r1, c1), 0));
			bool found = false;
			while (!q.empty() && !found) {
				std::pair<std::pair<int, int>, int> p = q.front();
				q.pop();
				for (int j = 0; j < 4 && !found; j++) {
					int x = p.first.first + dx[j];
					int y = p.first.second + dy[j];
					if (check(x, y) && used[x][y] != color && i + 1 - r[x] - c[y] <= k) {
						used[x][y] = color;
						if (x == r2 && y == c2) {
							found = true;
							printf("%d\n", p.second + 1);
						}
						q.push(std::make_pair(std::make_pair(x, y), p.second + 1));
					}
				}
			}
			if (!found) {
				printf("-1\n");
			}
			color++;
		}
	}
	return 0;	
}
