#include <stdio.h>
#include <set>
#include <algorithm>

struct tree {
	std::set<int> *arr;
	int _pow = 1;
	
	void init(int n) {
		while (_pow < n) {
			_pow *= 2;
		}
		arr = new std::set<int>[2 * _pow]();
	}
	
	std::pair<int, int> get(int v, int tl, int tr, int l, int r, int x) {
		if (tl == l && tr == r) {
			if (arr[v].empty()) {
				return std::make_pair(-1, -1);
			}
			std::set<int>::iterator it = arr[v].lower_bound(x);
			std::pair<int, int> ans = std::make_pair(-1, -1);
			if (it != arr[v].end()) {
				ans.second = *it;
			}
			if (it != arr[v].begin()) {
				it--;
				ans.first = *it;
			}
			return ans;
		}
		int m = tl + (tr - tl) / 2;
		if (l > m) {
			return get(2 * v + 1, m + 1, tr, l, r, x);
		}
		if (r <= m) {
			return get(2 * v, tl, m, l, r, x);
		}
		std::pair<int, int> p1 = get(2 * v, tl, m, l, m, x);
		std::pair<int, int> p2 = get(2 * v + 1, m + 1, tr, m + 1, r, x);
		return std::make_pair(std::max(p1.first, p2.first), std::min(p1.second, p2.second));
	}
	
	void update(int v, int tl, int tr, int ind, int val) {
		if (tl == tr) {
			arr[v].insert(val);
			return;
		}
		int m = tl + (tr - tl) / 2;
		if (ind <= m) {
			update(2 * v, tl, m, ind, val);
		} else {
			update(2 * v + 1, m + 1, tr, ind, val);
		}
		arr[v].insert(val);
	}
	
	std::pair<int, int> get(int l, int x) {
		return get(1, 1, _pow, l, _pow, x);
	}
	
	void update(int ind, int val) {
		update(1, 1, _pow, ind, val);
	}
};

struct tree1 {
	int *arr;
	int _pow = 1;
	
	void init(int n) {
		while (_pow < n) {
			_pow *= 2;
		}
		arr = new int[2 * _pow]();
	}
	
	int get(int v, int tl, int tr, int l, int r) {
		if (tl == l && tr == r) {
			return arr[v];
		}
		int m = tl + (tr - tl) / 2;
		if (l > m) {
			return get(2 * v + 1, m + 1, tr, l, r);
		}
		if (r <= m) {
			return get(2 * v, tl, m, l, r);
		}
		return std::min(get(2 * v, tl, m, l, m), get(2 * v + 1, m + 1, tr, m + 1, r));
	}
	
	void update(int v, int tl, int tr, int ind, int val) {
		if (tl == tr) {
			arr[v] = val;
			return;
		}
		int m = tl + (tr - tl) / 2;
		if (ind <= m) {
			update(2 * v, tl, m, ind, val);
		} else {
			update(2 * v + 1, m + 1, tr, ind, val);
		}
		arr[v] = std::min(arr[2 * v], arr[2 * v + 1]);
	}
	
	int get(int l, int r) {
		if (r < l) {
			std::swap(l, r);
		}
		return get(1, 1, _pow, l, r);
	}
	
	void update(int ind, int val) {
		update(1, 1, _pow, ind, val);
	}
};

int main() {
	int n, m, q;
	scanf("%d%d%d", &n, &m, &q);
	tree r, c;
	tree1 kekr, kekc;
	kekr.init(n);
	kekc.init(m);
	r.init(q);
	c.init(q);
	int rrr[n], ccc[m];
	for (int i = 0; i < n; i++) {
		rrr[i] = 0;
	}
	for (int i = 0; i < m; i++) {
		ccc[i] = 0;
	}
	for (int i = 0; i < q; i++) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			int rr;
			scanf("%d", &rr);
			r.update(i + 1, rr - 1);
			kekr.update(rr, i + 1);
			rrr[rr - 1] = i + 1;
		} else if (t == 2) {
			int cc;
			scanf("%d", &cc);
			c.update(i + 1, cc - 1);
			kekc.update(cc, i + 1);
			ccc[cc - 1] = i + 1;
		} else {
			int r1, c1, r2, c2, k;
			scanf("%d%d%d%d%d", &r1, &c1, &r2, &c2, &k);
			r1--, r2--, c1--, c2--;
			int mi = i + 1 - k;
			bool flag = true, flag1 = true;
			for (int j = c1; j <= c2; j++) {
				flag &= ccc[j] >= mi;
			}
			for (int j = c2; j <= c1; j++) {
				flag &= ccc[j] >= mi;
			}
			for (int j = r1; j <= r2; j++) {
				flag1 &= rrr[j] >= mi;
			}
			for (int j = r2; j <= r1; j++) {
				flag1 &= rrr[j] >= mi;
			}
			if (flag || flag1 || (ccc[c1] >= mi && rrr[r2] >= mi) || (rrr[r1] >= mi && ccc[c2] >= mi)) {
				printf("%d\n", std::abs(r1 - r2) + std::abs(c1 - c2));
				continue;
			}
			if (ccc[c1] >= mi && ccc[c2] >= mi) {
				std::pair<int, int> p1 = std::make_pair(-1, -1);// r.get(mi, r1);
				std::pair<int, int> p2 = std::make_pair(-1, -1);//r.get(mi, r2);
				for (int j = 0; j < r1; j++) {
					if (rrr[j] >= mi) {
						p1.first = j;
					}
				}
				for (int j = 0; j < r2; j++) {
					if (rrr[j] >= mi) {
						p2.first = j;
					}
				}
				for (int j = r1; j < n && p1.second == -1; j++) {
					if (rrr[j] >= mi) {
						p1.second = j;
					}
				}
				for (int j = r2; j < n && p2.second == -1; j++) {
					if (rrr[j] >= mi) {
						p2.second = j;
					}
				}
				int ans = 1e9;
				if (p1.first != -1) {
					ans = std::min(ans, std::abs(c2 - c1) + std::abs(p1.first - r1) + std::abs(p1.first - r2));
				}
				if (p1.second != -1) {
					ans = std::min(ans, std::abs(c2 - c1) + std::abs(p1.second - r1) + std::abs(p1.second - r2));
				}
				if (p2.first != -1) {
					ans = std::min(ans, std::abs(c2 - c1) + std::abs(p2.first - r1) + std::abs(p2.first - r2));
				}
				if (p2.second != -1) {
					ans = std::min(ans, std::abs(c2 - c1) + std::abs(p2.second - r1) + std::abs(p2.second - r2));
				}
				if (ans < 1e9) {
					printf("%d\n", ans);
				} else {
					printf("-1\n");
				}
			} else if (rrr[r1] >= mi && rrr[r2] >= mi) {
				std::pair<int, int> p1 = std::make_pair(-1, -1);//c.get(mi, c1);
				std::pair<int, int> p2 = std::make_pair(-1, -1);//c.get(mi, c2);
				for (int j = 0; j < c1; j++) {
					if (ccc[j] >= mi) {
						p1.first = j;
					}
				}
				for (int j = 0; j < c2; j++) {
					if (ccc[j] >= mi) {
						p2.first = j;
					}
				}
				for (int j = c1; j < n && p1.second == -1; j++) {
					if (ccc[j] >= mi) {
						p1.second = j;
					}
				}
				for (int j = c2; j < n && p2.second == -1; j++) {
					if (ccc[j] >= mi) {
						p2.second = j;
					}
				}
				int ans = 1e9;
				if (p1.first != -1) {
					ans = std::min(ans, std::abs(r2 - r1) + std::abs(p1.first - c1) + std::abs(p1.first - c2));
				}
				if (p1.second != -1) {
					ans = std::min(ans, std::abs(r2 - r1) + std::abs(p1.second - c1) + std::abs(p1.second - c2));
				}
				if (p2.first != -1) {
					ans = std::min(ans, std::abs(r2 - r1) + std::abs(p2.first - c1) + std::abs(p2.first - c2));
				}
				if (p2.second != -1) {
					ans = std::min(ans, std::abs(r2 - r1) + std::abs(p2.second - c1) + std::abs(p2.second - c2));
				}
				if (ans < 1e9) {
					printf("%d\n", ans);
				} else {
					printf("-1\n");
				}
			} else {
				printf("-1\n");
			}
		}
	}
	return 0;	
}
