#include <bits/stdc++.h>

using namespace std;

#define int long long

class SegmentTree {
public:
	int sz;
	vector<int> amin;
	vector<int> amax;

	SegmentTree(int n) {
		sz = n;
		amin.resize(4 * n);
		amax.resize(4 * n);
	}

	void set(int v, int vl, int vr, int i, int x) {
		if(vr - vl == 1) {
			amin[v] = x;
			amax[v] = x;
		} else {
			int vm = (vl + vr) / 2;
			if(i < vm) {
				set(v * 2, vl, vm, i, x);
			} else {
				set(v * 2 + 1, vm, vr, i, x);
			}
			amin[v] = min(amin[v * 2], amin[v * 2 + 1]);
			amax[v] = max(amax[v * 2], amax[v * 2 + 1]);
		}
	}
	void set(int i, int x) {
		set(1, 0, sz, i, x);
	}

	int getmin(int v, int vl, int vr, int l, int r) {
		if(vl == l && vr == r) {
			return amin[v];
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return getmin(v * 2, vl, vm, l, r);
		} else if(l >= vm) {
			return getmin(v * 2 + 1, vm, vr, l, r);
		} else {
			return min(
				getmin(v * 2, vl, vm, l, vm),
				getmin(v * 2 + 1, vm, vr, vm, r)
			);
		}
	}
	int getmin(int l, int r) {
		if(l == r) {
			return 1000000000LL;
		}
		return getmin(1, 0, sz, l, r);
	}
	int getmax(int v, int vl, int vr, int l, int r) {
		if(vl == l && vr == r) {
			return amax[v];
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return getmax(v * 2, vl, vm, l, r);
		} else if(l >= vm) {
			return getmax(v * 2 + 1, vm, vr, l, r);
		} else {
			return max(
				getmax(v * 2, vl, vm, l, vm),
				getmax(v * 2 + 1, vm, vr, vm, r)
			);
		}
	}
	int getmax(int l, int r) {
		if(l == r) {
			return -1000000000LL;
		}
		return getmax(1, 0, sz, l, r);
	}

	int get(int i) {
		return getmin(i, i + 1);
	}
};

signed main() {
	int n, m, q;
	cin >> n >> m >> q;

	SegmentTree ra(n);
	SegmentTree ca(m);
	for(int i = 1; i <= q; i++) {
		int a;
		cin >> a;
		if(a == 1) {
			int r;
			cin >> r;
			r--;
			ra.set(r, -i);
		} else if(a == 2) {
			int c;
			cin >> c;
			c--;
			ca.set(c, -i);
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--; c1--; r2--; c2--;
			k -= i;

			int ans = 1000000000LL;
			if(ra.get(r1) <= k && ra.get(r2) <= k) {
				if(ca.getmin(min(c1, c2), max(c1, c2) + 1) <= k) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				int cl = -1;
				int cr = min(c1, c2) + 1;
				while(cr - cl > 1) {
					int cm = (cl + cr) / 2;
					if(ca.getmin(cm, min(c1, c2) + 1) <= k) {
						cl = cm;
					} else {
						cr = cm;
					}
				}
				if(cl != -1) {
					ans = min(ans, abs(c1 - cl) + abs(c2 - cl) + abs(r1 - r2));
				}
				cl = max(c1, c2);
				cr = m;
				while(cr - cl > 1) {
					int cm = (cl + cr) / 2;
					if(ca.getmin(max(c1, c2), cm + 1) <= k) {
						cr = cm;
					} else {
						cl = cm;
					}
				}
				if(cr != m) {
					ans = min(ans, abs(c1 - cr) + abs(c2 - cr) + abs(r1 - r2));
				}
			}
			if(ca.get(c1) <= k && ca.get(c2) <= k) {
				if(ra.getmin(min(r1, r2), max(r1, r2) + 1) <= k) {
					ans = abs(r1 - r2) + abs(c1 - c2);
				}

				int rl = -1;
				int rr = min(r1, r2) + 1;
				while(rr - rl > 1) {
					int rm = (rl + rr) / 2;
					if(ra.getmin(rm, min(r1, r2) + 1) <= k) {
						rl = rm;
					} else {
						rr = rm;
					}
				}
				if(rl != -1) {
					ans = min(ans, abs(r1 - rl) + abs(r2 - rl) + abs(c1 - c2));
				}
				rl = max(r1, r2);
				rr = n;
				while(rr - rl > 1) {
					int rm = (rl + rr) / 2;
					if(ra.getmin(max(r1, r2), rm + 1) <= k) {
						rr = rm;
					} else {
						rl = rm;
					}
				}
				if(rr != n) {
					ans = min(ans, abs(r1 - rr) + abs(r2 - rr) + abs(c1 - c2));
				}
			}
			if(ca.get(c1) <= k && ra.get(r2) <= k) {
				ans = abs(r1 - r2) + abs(c1 - c2);
			}
			if(ca.get(c2) <= k && ra.get(r1) <= k) {
				ans = abs(r1 - r2) + abs(c1 - c2);
			}

			if(ca.getmax(min(c1, c2), max(c1, c2) + 1) <= k) {
				ans = abs(r1 - r2) + abs(c1 - c2);
			}
			if(ra.getmax(min(r1, r2), max(r1, r2) + 1) <= k) {
				ans = abs(r1 - r2) + abs(c1 - c2);
			}

			if(ans == 1000000000LL) {
				cout << "-1\n";
			} else {
				cout << ans << "\n";
			}
		}
	}

	return 0;
}
