#include "bits/stdc++.h"
#define ll long long
#define all(x) x.begin(), x.end()
#define ull unsigned long long
#define pb push_back


const ll inf = 1e18;


using namespace std;


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &cnt : arr) {
        in >> cnt;
    }
    return in;
};


struct stree {
    vector<ll> t;

    void upd(ll v, ll l, ll r, ll pos, ll val) {
        if (l == r) {
            t[v] = val;
            return;
        }
        ll mid = (l + r) / 2;
        if (pos <= mid) {
            upd(v * 2, l, mid, pos, val);
        } else {
            upd(v * 2, mid + 1, r, pos, val);
        }
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    ll query(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l and r <= qr) {
            return t[v];
        }
        if (ql > r or l > qr) {
            return inf;
        }
        ll mid = (l + r) / 2;
        return min(query(v * 2, l, mid, ql, qr), query(v * 2 + 1, mid + 1, r, ql, qr));
    }
};


void solve() {
    ll n, m, q;
    cin >> n >> m >> q;
    stree t;
    t.t.resize(4 * n);
    ll timer = 1;
    for (int i = 1; i <= q; i++) {
        ll type;
        cin >> type;
        if (type == 3) {
            ll x1, x2, y1, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            x2--;
            y1--;
            y2--;
            if (timer - t.query(1, 0, n - 1, min(x1, x2), max(x1, x2)) > k) {
                cout << -1 << "\n";
            } else {
                cout << abs(x1 - x2) + abs(y1 - y2) << "\n";
            }
        } else {
            ll r;
            cin >> r;
            t.upd(1, 0, n - 1, r - 1, i);
        }
        timer++;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    srand(time(0));
    cout.precision(30);
    solve();
    return 0;
}