#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>

using namespace std;

void re() {
	system("pause");
	exit(0);
}
#define re re();

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

vector <int> r, c;
int n, m;
int t = 0;

struct node {
	int type, num, fromx, fromy, dist;

	bool operator <(const node &b) const {
		if (dist != b.dist)
			return dist < b.dist;
		if (type != b.type)
			return type < b.type;
		return num < b.num;
	}
};

void finddist(node &a, node &b) {
	if (a.type == 0) {
		b.fromx = a.fromx;
		b.fromy = b.num;
		b.dist = abs(b.num - a.fromy) + a.dist;
	}
	else {
		b.fromx = b.num;
		b.fromy = a.fromy;
		b.dist = abs(b.num - a.fromx) + a.dist;
	}
}

int bfs(int x1, int y1, int x2, int y2, int k) {
	if (t - max(r[x2], c[y2]) > k)
		return -1;
	if (t - max(r[x1], c[y1]) > k)
		return -1;
	queue<pair<int, pii> > q;
	map<int, int> used;
	q.push({ 0,{x1,y1} });
	used[x1 * m + y1] = 1;
	while (q.size()) {
		int d = q.front().first;
		int x = q.front().second.first;
		int y = q.front().second.second;
		q.pop();
		if (x == x2 && y == y2)
			return d;
		if (x > 0 && used.find((x - 1) * m + y) == used.end() && t - max(r[x - 1], c[y]) <= k) {
			q.push({ d + 1, {x - 1, y} });
			used[(x - 1) * m + y] = 1;
		}
		if (x < n - 1 && used.find((x + 1)* m + y) == used.end() && t - max(r[x + 1], c[y]) <= k) {
			q.push({ d + 1, {x + 1, y} });
			used[(x + 1)*m + y] = 1;
		}
		if (y > 0 && used.find(x * m + y - 1) == used.end() && t - max(r[x], c[y - 1]) <= k) {
			q.push({ d + 1, {x, y - 1} });
			used[x * m + y - 1] = 1;
		}
		if (y < m - 1 && used.find(x * m + y + 1) == used.end() && t - max(r[x], c[y + 1]) <= k) {
			q.push({ d + 1, {x, y + 1 } });
			used[x * m + y + 1] = 1;
		}
	}
	return -1;
}

int main() {
	int q;
	cin >> n >> m >> q;
	r.resize(n);
	c.resize(m);
	for (t = 1; t <= q; t++) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			r[x - 1] = t;
		}
		if (type == 2) {
			int x;
			cin >> x;
			c[x - 1] = t;
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, y1--, x2--, y2--;
			cout << bfs(x1, y1, x2, y2, k) << '\n';
		}
	}
	re
}