#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

#define ll long long
#define ld long double
#define pi pair<int, int>
#define pll pair<ll, ll>
#define fs first
#define sc second
const int maxn = 300005;
const int inf = 1000000000;
pi segm[maxn];
int id[maxn];

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
	
	for (int i = 0; i < maxn; i++)
	{
		segm[i].fs = inf;
		segm[i].sc = -1;
	}
	int m, n;
	cin >> m >> n;
	vector<int> l;
	for (int i = 0; i < m; i++)
	{
		int x;
		cin >> x;
		if (id[x] == 0)
		{
			l.push_back(x);
			id[x] = 1;
		}
		else if (id[x] == 1)
		{
			while (l.back() != x)
			{
				id[l.back()] = 3;
				l.pop_back();
			}
		}
		else
		{
			cout << "-1";
			return 0;
		}
		segm[x].fs = min(segm[x].fs, i);
		segm[x].sc = max(segm[x].sc, i);
	}

	vector<pair<int, pi>> events;
	for (int i = 0; i < maxn; i++)
		if (segm[i].sc != -1)
		{
			events.push_back({ segm[i].fs, {0, i} });
			events.push_back({ segm[i].sc, {1, i} });
		}
	sort(events.begin(), events.end());
	vector<pi> last;
	vector<pair<int, pi>> ans;
	for (int i = 0; i < events.size(); i++)
	{
		if (events[i].sc.fs == 0)
			last.push_back({ events[i].fs, events[i].sc.sc });
		else
		{
			if (last.back().sc != events[i].sc.sc)
			{
				cout << "-1";
				return 0;
			}
			ans.push_back({ events[i].sc.sc, {last.back().fs, events[i].fs} });
			last.pop_back();
		}
	}

	cout << ans.size() << '\n';
	for (int i = ans.size() - 1; i > -1; i--) {
		cout << ans[i].fs << ' ' << ans[i].sc.fs + 1 << ' ' << ans[i].sc.sc + 1 << '\n';
	}

}