#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

int r_step[4] = {0, 0, 1, -1};
int c_step[4] = {1, -1, 0, 0};

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> r_clear(n, 0);
    vector<int> c_clear(m, 0);
    bool group5 = true;
    for (int i = 1; i <= q; i++)
    {
        int a;
        cin >> a;
        if (a == 1)
        {
            int r;
            cin >> r;
            r_clear[r - 1] = i;
        }
        else if (a == 2)
        {
            group5 = false;
            int c;
            cin >> c;
            c_clear[c - 1] = i;
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;
            if (group5)
            {
                bool good = true;
                for (int j = min(r1, r2); j <= max(r1, r2); j++)
                {
                    if (i - r_clear[j] > k)
                    {
                        cout << -1 << endl;
                        good = false;
                        break;
                    }
                }
                if (good)
                {
                    cout << abs(r2 - r1) + abs(c2 - c1) << endl;
                }
                continue;
            }
            if (i - max(r_clear[r1], c_clear[c1]) > k || i - max(r_clear[r2], c_clear[c2]) > k)
            {
                cout << -1 << endl;
                continue;
            }
            vector<vector<char> > used(n, vector<char>(m, 'N'));
            queue<pair<int, pair<int, int> > > q;
            q.push({0, {r1, c1}});
            used[r1][c1] = 'Y';
            bool good = false;
            while (!q.empty())
            {
                int r = q.front().second.first;
                int c = q.front().second.second;
                int d = q.front().first;
                q.pop();
                if (r == r2 && c == c2)
                {
                    good = true;
                    cout << d << endl;
                    break;
                }
                for (int j = 0; j < 4; j++)
                {
                    if (r + r_step[j] >= 0 && r + r_step[j] < n && c + c_step[j] >= 0 && c + c_step[j] < m && i - max(r_clear[r + r_step[j]], c_clear[c + c_step[j]]) <= k && used[r + r_step[j]][c + c_step[j]] == 'N')
                    {
                        q.push({d + 1, {r + r_step[j], c + c_step[j]}});
                        used[r + r_step[j]][c + c_step[j]] =  'Y';
                    }
                }
            }
            if (!good)
            {
                cout << -1 << endl;
            }
        }
    }
    return 0;
}
