#include <cstdio>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>

bool cmp(std::tuple <int, int, int> a, std::tuple <int, int, int> b) {
    int la = std::get<0>(a);
    int lb = std::get<0>(b);
    int ra = std::get<1>(a);
    int rb = std::get<1>(b);
    return ra - la > rb - lb;
}

bool cmp1(std::tuple <int, int, int> a, std::tuple <int, int, int> b) {
    int la = std::get<0>(a);
    int lb = std::get<0>(b);
    int ra = std::get<1>(a);
    int rb = std::get<1>(b);
    return ra - la <= rb - lb;
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int m, n;
    scanf("%d%d", &m, &n);
    std::vector <int> a(m);
    for (int i = 0; i < m; i++) {
        scanf("%d", &a[i]);
    }
    std::vector <int> l(n + 1, m + 1);
    std::vector <int> r(n + 1, -1);
    for (int i = 0; i < m; i++) {
        l[a[i]] = std::min(l[a[i]], i);
        r[a[i]] = std::max(r[a[i]], i);
    }
    std::vector <std::tuple<int, int, int>> segments;
    for (int i = 1; i <= n; i++) {
        if (r[i] != -1) {
            segments.emplace_back(l[i], r[i], i);
        }
    }
    std::vector <int> colors(m);
    std::vector <std::tuple<int, int, int>> seg = segments;
    std::sort(segments.begin(), segments.end(), cmp);
    std::sort(seg.begin(), seg.end(), cmp1);
    for (auto [l, r, c] : seg) {
        for (int i = l; i <= r; i++) {
            if (colors[i] != 0) {
                break;
            }
            colors[i] = c;
        }
        for (int i = r; i >= l; i--) {
            if (colors[i] != 0) {
                break;
            }
            colors[i] = c;
        }
    }
//    for (auto [l, r, c] : segments) {
//        for (int i = l; i <= r; i++) {
//            colors[i] = c;
//        }
//    }
//    for (int i = 0; i < m; i++) {
//        printf("%d ", colors[i]);
//    }
    if (colors != a) {
        printf("-1");
        return 0;
    }
    printf("%d\n", (int)segments.size());
    for (auto [l, r, c] : segments) {
        printf("%d %d %d\n", c, l + 1, r + 1);
    }
    return 0;
}
