#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <vector>
#include <algorithm>
#include <tuple>
#include <set>

bool cmp(std::tuple <int, int, int> a, std::tuple <int, int, int> b) {
    int la = std::get<0>(a);
    int lb = std::get<0>(b);
    int ra = std::get<1>(a);
    int rb = std::get<1>(b);
    return ra - la > rb - lb;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int m, n;
    scanf("%d%d", &m, &n);
    std::vector <int> a(m);
    for (int i = 0; i < m; i++) {
        scanf("%d", &a[i]);
    }
    std::vector <int> l(n + 1, m + 1);
    std::vector <int> r(n + 1, -1);
    for (int i = 0; i < m; i++) {
        l[a[i]] = std::min(l[a[i]], i);
        r[a[i]] = std::max(r[a[i]], i);
    }
    std::vector <std::tuple<int, int, int>> segments;
    for (int i = 1; i <= n; i++) {
        if (r[i] != -1) {
            segments.emplace_back(l[i], r[i], i);
        }
    }
//    for (auto [li, ri, ci] : segments) {
//        printf("%d %d %d\n", li, ri, ci);
//    }
//    for (int i = 0; i < segments.size(); i++) {
//        for (int j = i + 1; j < segments.size(); j++) {
//            int li = std::get<0>(segments[i]);
//            int ri = std::get<1>(segments[i]);
//            int lj = std::get<0>(segments[j]);
//            int rj = std::get<1>(segments[j]);
//            if (!check_intersection(li, ri, lj, rj)) {
//                printf("%d %d\n", i, j);
//                printf("-1");
//                return 0;
//            }
//        }
//    }
    std::sort(segments.begin(), segments.end(), cmp);
    std::vector <int> colors(m);
    std::vector < std::tuple<int, int, int>> seg = segments;
    std::reverse(seg.begin(), seg.end());
    std::set <int> notcolored;
    for (int i = 0; i < m; i++) {
        notcolored.insert(i);
    }
    for (auto [li, ri, c] : seg) {
        int x = li;
        if (colors[x] != 0) {
            continue;
        }
        while (x <= ri) {
            colors[x] = c;
            notcolored.erase(x);
            if (notcolored.lower_bound(x) == notcolored.end()) {
                break;
            }
            x = *notcolored.lower_bound(x);
        }
    }
//    for (int i = 0; i < m; i++) {
//        printf("%d ", colors[i]);
//    }
//    printf("\n");
//for (auto [l, r, c] : segments) {
 //       for (int i = l; i <= r; i++) {
//            colors[i] = c;
//        }
//    }
    if (colors != a) {
        printf("-1");
        return 0;
    }
    printf("%d\n", (int)segments.size());
    for (auto [li, ri, c] : segments) {
        printf("%d %d %d\n", c, li + 1, ri + 1);
    }
    return 0;
}
