#include <cstdio>
#include <queue>
#include <map>

const int MAXN = 1e6 + 10;
int row[MAXN];
int col[MAXN];

int main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int n, m, q;
    scanf("%d%d%d", &n, &m, &q);
    int req = 1;
    for (;q;--q) {
        int t;
        scanf("%d", &t);
        if (t == 1) {
            int r;
            scanf("%d", &r);
            row[r] = req;
        }
        if (t == 2) {
            int c;
            scanf("%d", &c);
            col[c] = req;
        }
        if (t == 3) {
            int r1, c1, r2, c2, k;
            scanf("%d%d%d%d%d", &r1, &c1, &r2, &c2, &k);
            std::queue <std::pair<int, int>> q;
            if (std::min(req - row[r1], req - col[c1]) <= k) {
                q.push({r1, c1});
            }
            std::map <std::pair<int, int>, int> dist;
            while (q.size()) {
                int x = q.front().first;
                int y = q.front().second;
                //printf("%d %d\n", x, y);
                if (x == r2 && y == c2) {
                    break;
                }
                q.pop();
                int dx[] = {-1, 1, 0, 0};
                int dy[] = {0, 0, -1, 1};
                for (int j = 0; j < 4; j++) {
                    int nx = x + dx[j];
                    int ny = y + dy[j];
                    if (nx > 0 && nx <= n && ny > 0 && ny <= m) {
                        if (std::min(req - row[nx], req - col[ny]) <= k) {
                            if (dist.find({nx, ny}) == dist.end()) {
                                q.emplace(nx, ny);
                                 dist[{nx, ny}] = dist[{x, y}] + 1;
                            }
                            if (dist[{nx, ny}] > dist[{x, y}] + 1) {
                                q.emplace(nx, ny);
                                dist[{nx, ny}] = dist[{x, y}] + 1;
                            }
                        }
                    }
                }
            }
            if (dist[{r2, c2}] == 0) {
                printf("-1\n");
            } else {
                printf("%d\n", dist[{r2, c2}]);
            }
            //printf("\n");
        }
        req++;
    }
    return 0;
}
