#include <cstdio>
#include <vector>
#include <queue>

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    int t;
    scanf("%d", &t);
    for (;t;t--) {

        int n, m, q, p;
        scanf("%d%d%d%d", &n, &m, &q, &p);
        std::vector <std::vector<std::pair<int, long long>>> g(n + 1);
        std::vector <std::vector<long long>> dists(n + 1);

        for (int i = 0; i < m; i++) {
            int v, u;
            long long d;
            scanf("%d%d%lld", &v, &u, &d);
            g[v].emplace_back(u, d);
        }
        dists[1].push_back(0);
        std::queue <int> que;
        que.push(1);
        std::vector<bool> used(n + 1);
        while (que.size()) {
            int v = que.front();
            used[v] = true;
            que.pop();
            for (auto dist : dists[v]) {
                for (auto [u, d] : g[v]) {
                    dists[u].push_back(dist + d);
                }
            }
            for (auto [u, d] : g[v]) {
                if (!used[u]) {
                    que.push(u);
                }
            }
        }

        for (;q;q--) {
            int f;
            long long r;
            scanf("%d%lld", &f, &r);
            bool ok = false;
            for (auto dist : dists[f]) {
                double left = r;
                double right = r * (double)p / (p - 1);
                if (left <= dist && dist <= right) {
                    printf("1");
                    ok = true;
                    break;
                }
            }
            if (!ok) {
                printf("0");
            }
        }
        printf("\n");
    }
    return 0;
}
