#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

int n, m, q;

std::vector<int> line, column;

int dist(int i1, int j1, int i2, int j2) {
    return std::abs(i1 - i2) + std::abs(j1 - j2);
}

int maxColumn(int l, int r) {
    if (l > r) {
        return maxColumn(r, l);
    }
    int max = column[l];
    for (int i = l + 1; i <= r; ++i) {
        max = std::max(max, column[i]);
    }
    return max;
}

int maxLine(int l, int r) {
    if (l > r) {
        return maxLine(r, l);
    }
    int max = line[l];
    for (int i = l + 1; i <= r; ++i) {
        max = std::max(max, line[i]);
    }
    return max;
}

int minColumn(int l, int r) {
    if (l > r) {
        return minColumn(r, l);
    }
    int min = column[l];
    for (int i = l + 1; i <= r; ++i) {
        min = std::min(min, column[i]);
    }
    return min;
}

int minLine(int l, int r) {
    if (l > r) {
        return minLine(r, l);
    }
    int min = line[l];
    for (int i = l + 1; i <= r; ++i) {
        min = std::min(min, line[i]);
    }
    return min;
}

int go(int i1, int j1, int i2, int j2, int k) {
    int st1 = 0, st2 = 0;
    if (line[i1] >= k) {
        st1 ^= 1;
    }
    if (line[i2] >= k) {
        st2 ^= 1;
    }
    if (column[i1] >= k) {
        st1 ^= 2;
    }
    if (column[i2] >= k) {
        st2 ^= 2;
    }
    if (st1 == 0 || st2 == 0) {
        return -1;
    }
    if ((st1 | st2) == 3) {
        return dist(i1, j1, i2, j2);
    }
    if (st1 == 1) {
        if (maxColumn(j1, j2) >= k || minLine(i1, i2) >= k) {
            return dist(i1, j1, i2, j2);
        }
    } else {
        if (maxLine(i1, i2) >= k || minColumn(j1, j2) >= k) {
            return dist(i1, j1, i2, j2);
        }
    }
    return -1;
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cout.precision(20);
//    freopen("input", "r", stdin);
    std::cin >> n >> m >> q;
    line.resize(n);
    column.resize(m);
    for (int time = 1; time <= q; ++time) {
        int t;
        std::cin >> t;
        if (t == 1) {
            int ind;
            std::cin >> ind;
            --ind;
            line[ind] = time;
            continue;
        }
        if (t == 2) {
            int ind;
            std::cin >> ind;
            --ind;
            column[ind] = time;
            continue;
        }
        int i1, j1, i2, j2, k;
        std::cin >> i1 >> j1 >> i2 >> j2 >> k;
        --i1;
        --j1;
        --i2;
        --j2;
        k = time - k;
        std::cout << go(i1, j1, i2, j2, k) << '\n';
    }
    return 0;
}