#include <bits/stdc++.h>
  
using namespace std;
  
#define pb push_back
#define ft first
#define sd second
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
#define sz(s) signed(s.size())
  
const int INF = 2e9;
  
struct Node { int val, mn, left, right; };
  
vector< Node > nodes;
  
int get() {
    nodes.pb({0, 0, -1, -1});
    return sz(nodes) - 1;
}
  
int get_left(int v) {
    if (nodes[v].left == -1) {
        int tmp = get();
        nodes[v].left = tmp;
    }
    return nodes[v].left;
}
  
int get_right(int v) {
    if (nodes[v].right == -1) {
        int tmp = get();
        nodes[v].right = tmp;
    }
    return nodes[v].right;
}
  
int get_val(int v) {
    if (v == -1) return 0;
    return nodes[v].val;
}
 
int get_mn(int v) {
    if (v == -1) return 0;
    return nodes[v].mn;
}
  
void update(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        nodes[v].val = val;
        nodes[v].mn = val;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (tm >= pos) {
        update(get_left(v), tl, tm, pos, val);
    } else {
        update(get_right(v), tm + 1, tr, pos, val);
    }
    nodes[v].val = max(get_val(nodes[v].left), get_val(nodes[v].right));
    nodes[v].mn = min(get_mn(nodes[v].left), get_mn(nodes[v].right));
}
 
 
int get1(int v, int tl, int tr, int left, int right) {
    if (left > right) return INF;
    if (v == -1) return 0;
    if (tl >= left && tr <= right) { return get_mn(v); }
    int tm = (tl + tr) >> 1;
    if (tm >= right) {
        return get1(nodes[v].left, tl, tm, left, right);
    } else if (left > tm) {
        return get1(nodes[v].right, tm + 1, tr, left, right);
    } else {
        return min(
                get1(nodes[v].left, tl, tm, left, right),
                get1(nodes[v].right, tm + 1, tr, left, right)
            );
    }
}
 
  
int get(int v, int tl, int tr, int left, int right) {
    if (v == -1) return 0;
    if (tl >= left && tr <= right) { return get_val(v); }
    int tm = (tl + tr) >> 1;
    if (tm >= right) {
        return get(nodes[v].left, tl, tm, left, right);
    } else if (left > tm) {
        return get(nodes[v].right, tm + 1, tr, left, right);
    } else {
        return max(
                get(nodes[v].left, tl, tm, left, right),
                get(nodes[v].right, tm + 1, tr, left, right)
            );
    }
}
 
void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    map<int, int> row, col;
    int root_row = get();
    int root_col = get();
    for (int i = 1; i <= q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            row[r] = - i;
            update(root_row, 1, n, r, - i);
        } else if (t == 2) {
            int c;
            cin >> c;
            col[c] = - i;
            update(root_col, 1, m, c, - i);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (max(row[r1] , col[c2]) <= k - i || max(row[r2], col[c1]) <= k - i) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
            if (get(root_row, 1, n, min(r1, r2), max(r1, r2)) <= k - i
                || get(root_col, 1, m, min(c1, c2), max(c1, c2)) <= k - i) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
  
            int ans = INF;
            if (max(col[c1], col[c2]) <= k - i) {
                if (get1(root_row, 1, n, min(r1, r2), n) <= k - i) {
                    int left = min(r1, r2) - 1, right = n;
                    while (left != right - 1) {
                        int mid = (left + right) >> 1;
                        if (get1(root_row, 1, n, min(r1, r2), mid) <= k - i) {
                            right = mid;
                        } else {
                            left = mid;
                        }
                    }
                    ans = min(ans, abs(c1 - c2) + abs(right - r1) + abs(right - r2));
                }
                if (get1(root_row, 1, n, 1, max(r1, r2)) <= k - i) {
                    int left = 1, right = max(r1, r2) + 1;
                    while (left != right - 1) {
                        int mid = (left + right) >> 1;
                        if (get1(root_row, 1, n, mid, max(r1, r2)) <= k - i) {
                            left = mid;
                        } else {
                            right = mid;
                        }
                    }
                    ans = min(ans, abs(c1 - c2) + abs(left - r1) + abs(left - r2));
                }
 
            }
            if (max(row[r1], row[r2]) <= k - i) {


                if (get1(root_col, 1, m, min(c1, c2), m) <= k - i) {
                    int left = min(c1, c2) - 1, right = m;
                    while (left != right - 1) {
                        int mid = (left + right) >> 1;
                        if (get1(root_col, 1, m, min(c1, c2), mid) <= k - i) {
                            right = mid;
                        } else {
                            left = mid;
                        }
                    }
                    ans = min(ans, abs(r1 - r2) + abs(right - c1) + abs(right - c2));
                }
                if (get1(root_col, 1, m, 1, max(c1, c2)) <= k - i) {
                    int left = 1, right = max(c1, c2) + 1;
                    while (left != right - 1) {
                        int mid = (left + right) >> 1;
                        if (get1(root_col, 1, m, mid, max(c1, c2)) <= k - i) {
                            left = mid;
                        } else {
                            right = mid;
                        }
                    }
                    ans = min(ans, abs(r1 - r2) + abs(left - c1) + abs(left - c2));
                }



            }
            cout << (ans == INF ? -1 : ans) << '\n';
        }
    }
  
}
  
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}