#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <iomanip>
#include <bitset>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;
const int MAX_R = 10010;

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("abm,mmx,avx,avx2,sse,sse2,ssse3,sse4,tune=native")

void solve() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;

	vector<vector<bool>> dp(n, vector<bool>(MAX_R, 0));
	dp[0][0] = 1;

	vector<vector<pair<int, int>>> g(n);

	for (int i = 0; i < m; i++) {
		int a, b;
		ll w;
		cin >> a >> b >> w;
		a--, b--;
		if (w < MAX_R)
			g[a].push_back({ b, w });
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < MAX_R; j++) {
			if (!dp[i][j])
				continue;
			for (auto p : g[i]) {
				if (j + p.second < MAX_R)
					dp[p.first][j + p.second] = 1;
			}
		}
	}

	string ans;
	while (q--) {
		int f;
		ll r;
		cin >> f >> r;
		f--;
		ll r1 = (ll)(((ld)p / (ld)(p - 1)) * (ld)r);
		bool ok = 0;
		for (ll i = r; i <= r1; i++)
			ok |= dp[f][i];

		//cout << "! " << r << ' ' << r1 << endl;
		ans += (char)('0' + ok);
	}
	cout << ans << endl;
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	auto ti = clock();
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

#ifdef LOCAL
	cout << "\nExecuted in "
		<< fixed << setprecision(5) << (ld)(clock() - ti) / (ld)CLOCKS_PER_SEC << " seconds" << endl;
#endif
	return 0;
}