#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define f first
#define s second
#define add push_back
#define sz(x) (int)(x).size()

const ll INF = (ll)1e9 + 2019;

const int N = 1e4 + 10;
int arr[N];
pii seg[N], t[N * 4];

void relax(int v) {
	t[v].f = min(t[v * 2].f, t[v * 2 + 1].f);
}

void full(int v, int l, int r, int x) {
	t[v].f = x;
	t[v].s = x;
}

void push(int v, int l, int r) {
	int m = (l + r) / 2;
	if (t[v].s != -1) {
		full(v * 2, l, m, t[v].s);
		full(v * 2 + 1, m + 1, r, t[v].s);
	}
	t[v].s = -1;
	relax(v);
}

void build(int v, int l, int r) {
	t[v] = {0, -1};
	if (l == r) {
		return;
	}
	int m = (l + r) / 2;
	build(v * 2, l, m);
	build(v * 2 + 1, m + 1, r);
	relax(v);
}

int query(int v, int l, int r, int a, int b) {
	if (a > r || l > b) {
		return INF;
	}
	if (a <= l && r <= b) {
		return t[v].f;
	}
	push(v, l, r);
	int m = (l + r) / 2;
	return min(query(v * 2, l, m, a, b), query(v * 2 + 1, m + 1, r, a, b));
}

void update(int v, int l, int r, int a, int b, int x) {
	if (a > r || l > b) {
		return;
	}
	if (a <= l && r <= b) {
		full(v, l, r, x);
		return;
	}
	push(v, l, r);
	int m = (l + r) / 2;
	update(v * 2, l, m, a, b, x);
	update(v * 2 + 1, m + 1, r, a, b, x);
	relax(v);
}

bool cmp(pii a, pii b) {
	return (a.s - a.f) > (b.s - b.f);
}

void mane() {
	int n, m;
	cin >> m >> n;
	for (int i = 0; i < N; i++) {
		seg[i] = {INF, -INF};
	}
	for (int i = 0; i < m; i++) {
		cin >> arr[i];
		seg[arr[i]].f = min(seg[arr[i]].f, i);
		seg[arr[i]].s = max(seg[arr[i]].s, i);
	}
	sort(seg, seg + n + 1, cmp);
	vector <pair <int, pii>> res;
	build(1, 0, N - 1);
	for (int i = 0; i <= n; i++) {
		if (seg[i].f == INF) {
			continue;
		}
		update(1, 0, N - 1, seg[i].f, seg[i].s, arr[seg[i].f]);
		res.add({arr[seg[i].f], seg[i]});
	}
	for (int i = 0; i < m; i++) {
		if (query(1, 0, N - 1, i, i) != arr[i]) {
			cout << -1;
			return;
		}
	}
	cout << sz(res) << endl;
	for (auto it : res) {
		cout << it.f << " " << it.s.f + 1 << " " << it.s.s + 1 << "\n";
	}
}

int main() {
	ios::sync_with_stdio(0);
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}