// #pragma GCC optimize("I_l_N_M")
//#pragma GCC optimize("Ofast,unroll-loops")

#include <iostream>
#include <cstdio>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

#define f first
#define s second
#define add push_back
#define sz(x) (int)(x).size()

const ll INF = (ll)1e9 + 2019;

const int N = 1e6 + 10;

struct SegTree {
	pii t[N * 4];

	void relax(int v) {
		t[v].f = min(t[v * 2].f, t[v * 2 + 1].f);
		t[v].s = max(t[v * 2].s, t[v * 2 + 1].s);
	}

	pii query(int v, int l, int r, int a, int b) {
		if (a > r || l > b) {
			return {INF, -INF};
		}
		if (a <= l && r <= b) {
			return t[v];
		}
		int m = (l + r) / 2;
		pii w1 = query(v * 2, l, m, a, b), w2 = query(v * 2 + 1, m + 1, r, a, b);
		return {min(w1.f, w2.f), max(w1.s, w2.s)};
	}

	void update(int v, int l, int r, int p, int x) {
		if (l == r) {
			t[v] = {x, x};
			return;
		}
		int m = (l + r) / 2;
		if (p <= m) {
			update(v * 2, l, m, p, x);
		} else {
			update(v * 2 + 1, m + 1, r, p, x);
		}
		relax(v);
	}

	int getL(int p, int x) {
		int l = 1, r = p + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (query(1, 1, N, m, p).s >= x) {
				l = m;
			} else {
				r = m;
			}
		}
		if (query(1, 1, N, l, p).s < x) {
			return -INF;
		}
		return l;
	}

	int getR(int p, int x) {
		int l = p - 1, r = N - 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (query(1, 1, N, p, m).s >= x) {
				r = m;
			} else {
				l = m;
			}
		}
		if (query(1, 1, N, p, r).s < x) {
			return INF;
		}
		return r;
	}
}tr, tc;

int rr[N], cc[N];

int dist(int r1, int c1, int r2, int c2) {
	return abs(r1 - r2) + abs(c1 - c2);
}

bool checkC(int c1, int c2, int v) {
	return tc.query(1, 1, N, min(c1, c2), max(c1, c2)).f >= v;
}

bool checkR(int r1, int r2, int v) {
	return tr.query(1, 1, N, min(r1, r2), max(r1, r2)).f >= v;
}

bool betwC(int c1, int c2, int v) {
	return tc.query(1, 1, N, min(c1, c2), max(c1, c2)).s >= v;
}

bool betwR(int r1, int r2, int v) {
	return tr.query(1, 1, N, min(r1, r2), max(r1, r2)).s >= v;
}

int getLC(int c, int m, int v) {
	return tc.getL(c, v);
	/*for (int i = c; i > 0; i--) {
		if (tc.query(1, 1, N, i, i).f >= v) {
			return i;
		}
	}
	return -INF;*/
}

int getRC(int c, int m, int v) {
	return tc.getR(c, v);
	/*for (int i = c; i <= m; i++) {
		if (tc.query(1, 1, N, i, i).f >= v) {
			return i;
		}
	}
	return INF;*/
}

int getUR(int r, int n, int v) {
	return tr.getL(r, v);
	/*for (int i = r; i > 0; i--) {
		if (tr.query(1, 1, N, i, i).f >= v) {
			return i;
		}
	}
	return -INF;*/
}

int getDR(int r, int n, int v) {
	return tr.getR(r, v);
	/*for (int i = r; i <= n; i++) {
		if (tr.query(1, 1, N, i, i).f >= v) {
			return i;
		}
	}
	return INF;*/
}

int query(int n, int m, int r1, int c1, int r2, int c2, int k, int tt) {
	int v = tt - k;
	if ((rr[r1] < v && cc[c1] < v) || (rr[r2] < v && cc[c2] < v)) {
		return -1;
	}
	if (checkR(r1, r2, v) || checkC(c1, c2, v)) {
		return dist(r1, c1, r2, c2);
	}
	int ans = INF;
	if (rr[r1] >= v || rr[r2] >= v) {
		if (betwC(c1, c2, v)) {
			ans = min(ans, dist(r1, c1, r2, c2));
		} else {
			int l = getLC(min(c1, c2), m, v), r = getRC(max(c1, c2), m, v);
			ans = min(ans, abs(r1 - r2) + abs(c1 - l) + abs(c2 - l));
			ans = min(ans, abs(r1 - r2) + abs(c1 - r) + abs(c2 - r));
		}
	}
	if (cc[c1] >= v || cc[c2] >= v) {
		if (betwR(r1, r2, v)) {
			ans = min(ans, dist(r1, c1, r2, c2));
		} else {
			int u = getUR(min(r1, r2), n, v), d = getDR(max(r1, r2), n, v);
			ans = min(ans, abs(c1 - c2) + abs(r1 - u) + abs(r2 - u));
			ans = min(ans, abs(c1 - c2) + abs(r1 - d) + abs(r2 - d));
		}
	}
	if (ans == INF) {
		ans = -1;
	}
	return ans;
}

void mane() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			tr.update(1, 1, N, r, i);
			rr[r] = i;
		}
		if (t == 2) {
			int c;
			cin >> c;
			tc.update(1, 1, N, c, i);
			cc[c] = i;
		}
		if (t == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			cout << query(n, m, r1, c1, r2, c2, k, i) << "\n";
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}
