#include<bits/stdc++.h>

using namespace std;

const int MAXN=1e6+123;

int q[MAXN];
int tree[MAXN*4][2];
int tree2[MAXN*4][2];
int used[MAXN];
int last[MAXN];

void Build(int i, int l, int r, int t) {
    if (l==r) {
        tree2[i][t]=tree[i][t]=0;
    }
    else {
        int m=(l+r)/2;
        Build(2*i+1, l, m, t);
        Build(2*i+2, m+1, r, t);
        tree2[i][t]=tree[i][t]=0;
    }
}

void Set(int i, int l, int r, int t, int pos, int x) {
    if (l==r) {
        tree2[i][t]=tree[i][t]=x;
    }
    else {
        int m=(l+r)/2;
        if (pos<=m) Set(2*i+1, l, m, t, pos, x);
        if (pos>m) Set(2*i+2, m+1, r, t, pos, x);
        tree[i][t]=max(tree[2*i+1][t], tree[2*i+2][t]);
        tree2[i][t]=min(tree2[2*i+1][t], tree2[2*i+2][t]);
    }
}

int Ans(int i, int l, int r, int t, int li, int ri) {
    if (l==li && r==ri) {
        return tree[i][t];
    }
    else {
        int m=(l+r)/2;
        int ans=-1e7;
        if (li<=m) ans=max(ans, Ans(2*i+1, l, m, t, li, min(m, ri)));
        if (ri>m) ans=max(ans, Ans(2*i+2, m+1, r, t, max(li, m+1), ri));
        return ans;
    }
}

int Left(int i, int l, int r, int t, int pos, int h) {
    if (pos>r || pos<l)
        return -1;
    if (l==r) {
        if (tree2[i][t]<=h)
            return l;
        else
            return -1;
    }
    else {
        if (tree2[i][t]>h)
            return -1;
        int m=(l+r)/2;
        int ans=Left(2*i+2, m+1, r, t, pos, h);
        if (ans!=-1)
            return ans;
        else
            return Left(2*i+1, l, m, t, pos, h);
    }
}

int Right(int i, int l, int r, int t, int pos, int h) {
    if (pos>r || pos<l)
        return -1;
    if (l==r) {
        if (tree2[i][t]<=h)
            return l;
        else
            return -1;
    }
    else {
        if (tree2[i][t]>h)
            return -1;
        int m=(l+r)/2;
        int ans=Right(2*i+1, l, m, t, pos, h);
        if (ans!=-1)
            return ans;
        else
            return Right(2*i+2, m+1, r, t, pos, h);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    Build(0, 0, n-1, 0);
    Build(0, 0, m-1, 1);
    int cnt=0;
    for (int i=0; i<q; i++) {
        cnt++;
        int t;
        cin >> t;
        if (t==1) {
            int id;
            cin >> id;
            id--;
            Set(0, 0, n-1, 0, id, -cnt);
        }
        if (t==2) {
            int id;
            cin >> id;
            id--;
            Set(0, 0, m-1, 1, id, -cnt);
        }
        if (t==3) {
            int x1, y1, x2, y2, h;
            cin >> y1 >> x1 >> y2 >> x2 >> h;
            x1--;
            y1--;
            x2--;
            y2--;
            if (Ans(0, 0, n-1, 0, min(y1, y2), max(y1, y2))+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }
            if (Ans(0, 0, m-1, 1, min(x1, x2), max(x1, x2))+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }
            if (Ans(0, 0, n-1, 0, y1, y1)+cnt<=h && Ans(0, 0, m-1, 1, x2, x2)+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }
            if (Ans(0, 0, m-1, 1, x1, x1)+cnt<=h && Ans(0, 0, n-1, 0, y2, y2)+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }
            if (y1==y2 && Ans(0, 0, n-1, 0, y1, y1)+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }
            if (x1==x2 && Ans(0, 0, m-1, 1, x1, x1)+cnt<=h) {
                cout << abs(x1-x2)+abs(y1-y2) << "\n";
                continue;
            }

            int ans=-1;
            /*if (Ans(0, 0, m-1, 1, x1, x1)+cnt<=h && Ans(0, 0, m-1, 1, x2, x2)+cnt<=h)
                for (int j=0; j<n; j++)
                    if (Ans(0, 0, n-1, 0, j, j)+cnt<=h)
                        if (ans==-1 || ans>abs(y1-j)+abs(y2-j)+abs(x1-x2))
                            ans=abs(y1-j)+abs(y2-j)+abs(x1-x2);
            */
            if (Ans(0, 0, n-1, 0, y1, y1)+cnt<=h && Ans(0, 0, n-1, 0, y2, y2)+cnt<=h)
                for (int j=0; j<m; j++)
                    if (Ans(0, 0, m-1, 1, j, j)+cnt<=h)
                        if (ans==-1 || ans>abs(x1-j)+abs(x2-j)+abs(y1-y2))
                            ans=abs(x1-j)+abs(x2-j)+abs(y1-y2);

            if (Ans(0, 0, m-1, 1, x1, x1)+cnt<=h && Ans(0, 0, m-1, 1, x2, x2)+cnt<=h) {
                int id=Left(0, 0, n-1, 0, y1, h-cnt);
                if (id!=-1) {
                    int ans_=abs(y1-id)+abs(y2-id)+abs(x1-x2);
                    if (ans==-1 || ans>ans_)
                        ans=ans_;
                }
                id=Right(0, 0, n-1, 0, y1, h-cnt);
                if (id!=-1) {
                    int ans_=abs(y1-id)+abs(y2-id)+abs(x1-x2);
                    if (ans==-1 || ans>ans_)
                        ans=ans_;
                }
            }

            /*if (Ans(0, 0, n-1, 0, y1, y1)+cnt<=h && Ans(0, 0, n-1, 0, y2, y2)+cnt<=h) {
                int id=Left(0, 0, m-1, 1, y1, h-cnt);
                if (id!=-1) {
                    int ans_=abs(x1-id)+abs(x2-id)+abs(y1-y2);
                    if (ans==-1 || ans>ans_)
                        ans=ans_;
                }
                id=Right(0, 0, m-1, 1, y1, h-cnt);
                if (id!=-1) {
                    int ans_=abs(x1-id)+abs(x2-id)+abs(y1-y2);
                    if (ans==-1 || ans>ans_)
                        ans=ans_;
                }
            }*/
            cout << ans << "\n";
        }
    }
}


