#include <iostream>

using namespace std;

const int MAXN = 1e6 + 5, MAXQ = 3e5 + 5;

int n, m, q;

template <typename T> inline T uax(T a, T b) {
	if (a > b) return a;
	else return b;
}

template <typename T> inline T uin(T a, T b) {
	if (a < b) return a;
	else return b;
}

struct st {
	int t[MAXN * 2], n;

	st() {}
	
	inline void update(int i, int x) {
		for (t[i += n] = x; i > 1; i >>= 1) t[i >> 1] = uax(t[i], t[i ^ 1]);
	}

	inline int get(int l, int r) {
		int res = 0;
		for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if (l & 1) res = uax(res, t[l++]);
			if (r & 1) res = uax(res, t[--r]);
		}
		return res;
	}
};

struct st2 {
	int t[MAXN * 2], n;

	st2() {}

	inline void update(int i, int x) {
		for (t[i += n] = x; i > 1; i >>= 1) t[i >> 1] = uin(t[i], t[i ^ 1]);
	}

	inline int get(int l, int r) {
		int res = MAXN * 5;
		for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if (l & 1) res = uin(res, t[l++]);
			if (r & 1) res = uin(res, t[--r]);
		}
		return res;
	}
};

st mxr, mxc;
st2 mnr, mnc;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);

	cin >> n >> m >> q;
	mxr.n = n;
	mnr.n = n;
	mxc.n = m;
	mnc.n = m;
	
	for (int t = 1; t <= q; ++t) {
		char tp;
		cin >> tp;
		if (tp == '1') {
			int nr;
			cin >> nr;
			mnr.update(nr, t);
			mxr.update(nr, t);
		}
		else if (tp == '2') {
			int nc;
			cin >> nc;
			mxc.update(nc, t);
			mnc.update(nc, t);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			int res = -1;
			
			if (r1 > r2) {
				swap(r1, r2);
				swap(c1, c2);
			}
			if (r1 == r2 && c1 > c2) {
				swap(c1, c2);
			}

			bool can_c1 = t - mxc.get(c1, c1 + 1) <= k, can_r1 = t - mxr.get(r1, r1 + 1) <= k;
			bool can_c2 = t - mxc.get(c2, c2 + 1) <= k, can_r2 = t - mxr.get(r2, r2 + 1) <= k;

			if (can_c1 && can_r2 || can_c2 && can_r1) {
				res = abs(r1 - r2) + abs(c1 - c2);
			}

			if (can_c1 && can_c2) {
				if (t - mnc.get(uin(c1, c2), uax(c1, c2) + 1) <= k) {
					res = abs(r1 - r2) + abs(c1 - c2);
				}
				else {
					int rb = uin(r1, r2);
					int rt = uax(r1, r2);

					if (t - mxr.get(rb, rt + 1) <= k) {
						res = abs(r1 - r2) + abs(c1 - c2);
					}
					else {
						int minr = MAXN * 5;
						if (t - mxr.get(1, rb + 1) <= k) {
							int l = rb, r = 1;
							while (l - r > 1) {
								int mid = (l + r) / 2;
								if (t - mxr.get(mid, rb + 1) <= k) r = mid;
								else l = mid;
							}
							minr = uin(minr, abs(c1 - c2) + abs(r - r1) + abs(r - r2));
						}
						if (t - mxr.get(rt, n + 1) <= k) {
							int l = rt, r = n;
							while (r - l > 1) {
								int mid = (l + r) / 2;
								if (t - mxr.get(rt, mid + 1) <= k) r = mid;
								else l = mid;
							}
							minr = uin(minr, abs(c1 - c2) + abs(r - r1) + abs(r - r2));
						}
						if (minr != MAXN * 5) {
							res = minr;
						}
					}
				}
			}

			if (can_r1 && can_r2) {
				if (t - mnr.get(uin(r1, r2), uax(r1, r2) + 1) <= k) {
					res = abs(r1 - r2) + abs(c1 - c2);
				}
				else {
					int cb = uin(c1, c2);
					int ct = uax(c1, c2);

					if (t - mxc.get(cb, ct + 1) <= k) {
						res = abs(r1 - r2) + abs(c1 - c2);
					}
					else {
						int minr = MAXN * 5;
						if (t - mxc.get(1, cb + 1) <= k) {
							int l = cb, r = 1;
							while (l - r > 1) {
								int mid = (l + r) / 2;
								if (t - mxc.get(mid, cb + 1) <= k) r = mid;
								else l = mid;
							}
							minr = uin(minr, abs(r1 - r2) + abs(r - c1) + abs(r - c2));
						}
						if (t - mxc.get(ct, m + 1) <= k) {
							int l = ct, r = m;
							while (r - l > 1) {
								int mid = (l + r) / 2;
								if (t - mxc.get(ct, mid + 1) <= k) r = mid;
								else l = mid;
							}
							minr = uin(minr, abs(r1 - r2) + abs(r - c1) + abs(r - c2));
						}
						if (minr != MAXN * 5) {
							res = minr;
						}
					}
				}
			}

			cout << res << "\n";
		}
	}
	return 0;
}

/*

4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6


*/