#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>

using namespace std;

const int MAXN = 5e5 + 5;

int n, m, q, p, QQ;
vector<pair<int, long long> > g[MAXN];
set<long long> dist[MAXN];

void dfs(int v = 1) {
	for (auto asd : g[v]) {
		int u = asd.first;
		long long ed = asd.second;
		for (int dn : dist[v]) {
			dist[u].insert(dn + ed);
		}
		dfs(u);
	}
}

signed main() {
	cin >> QQ;
	while (QQ--) {
		cin >> n >> m >> q >> p;

		//cleaning up
		for (int i = 0; i < n; ++i) {
			g[i].clear();
			dist[i].clear();
		}

		for (int i = 0; i < m; ++i) {
			int u, v, d;
			cin >> u >> v >> d;
			g[u].push_back({ v, d });
		}

		dist[1].insert(0);
		dfs();
		string ans = "";

		for (int i = 0; i < q; ++i) {
			int f;
			long long d;
			cin >> f >> d;
			auto best_it = lower_bound(dist[f].begin(), dist[f].end(), d);
			if (best_it != dist[f].end() && (*best_it) * (p - 1) <= d * p) ans += "1";
			else ans += "0";
		}

		cout << ans << "\n";
	}
	return 0;
}

/*

1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34


*/