/* cartsian tree or segment tree */

#include <bits/stdc++.h>
using namespace std;

#define vi vector<int>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define len(x) (int)(x).size()
#define pb push_back

//define int long long ???

const int MAXN = 1e6+100;
const int INFI = 2.14e9+100;

int n, m, q;
int cur_node = 0;

struct node { int L, R, mn, mx; };
//comp segmentTree
node nodes[MAXN * 4];


void read() {
    cin >> n >> m >> q;
}

//START SETTERS && GETTERS
int get_L(int v) { return (v == -1 ? -1 : nodes[v].L); }

int get_R(int v) { return (v == -1 ? -1 : nodes[v].R); }

int get_mn(int v) { return (v == -1 ? 0 : nodes[v].mn); }

int get_mx(int v) { return (v == -1 ? 0 : nodes[v].mx); }
//END SETTERS && GETTERS

//static class
struct CompSegmentTree {
    int vertexes, root;
    map<int, int> T;

    int create(int value) {
        nodes[cur_node].mn = value; nodes[cur_node].mx = value;
        nodes[cur_node].L = -1; nodes[cur_node].R = -1;
        return cur_node++;
    }

    //static class
    void init(int len) {
        vertexes = len;
        root = create(0);
    }

    int T_get_mn(int v, int L, int R, int x, int y) {
        if (L >= y || R <= x) {
            return INFI;
        } else if (L >= x && R <= y) {
            return get_mn(v);
        } else {
            int MID = L + (R - L) / 2;
            return min(T_get_mn(get_L(v), L, MID, x, y), T_get_mn(get_R(v), MID, R, x, y));
        }
    }

    void push(int v) {
        if (v != -1) {
            nodes[v].mn = min(get_mn(get_L(v)), get_mn(get_R(v)));
            nodes[v].mx = max(get_mx(get_L(v)), get_mx(get_R(v)));
        }
    }

    int update(int v, int L, int R, int x, int value) {
        if (x < L || x >= R) {
            return v;
        }
        if (v == -1) {
            v = create(0);
        }
        if (R - L == 1) {
            nodes[v].mn = value;
            nodes[v].mx = value;
            return v;
        } else {
            int PUDGE_V_MID = L + (R - L) / 2;
            nodes[v].L = update(nodes[v].L, L, PUDGE_V_MID, x, value);
            nodes[v].R = update(nodes[v].R, PUDGE_V_MID, R, x, value);
            push(v);
            return v;
        }
    }



    int T_find_exist_left(int v, int L, int R, int x, int cur_snow) {
        if (x <= L) {
            return -1;
        } else if (R <= x) {
            if (cur_snow > get_mx(v))
                return -1;
            if (R - L == 1) {
                return L;
            }
            int MID = L + (R - L) / 2;
            if (get_mx(get_R(v)) >= cur_snow) {
                return T_find_exist_left(get_R(v), MID, R, x, cur_snow);
            } else {
                return T_find_exist_left(get_L(v), L, MID, x, cur_snow);
            }
        } else {
            int MID = L + (R - L) / 2;
            //int MID = (L + R) / 2;
            int rf = T_find_exist_left(get_R(v), MID, R, x, cur_snow);
            if (rf == -1) {
                return T_find_exist_left(get_L(v), L, MID, x, cur_snow);
            } else {
                return rf;
            }
        }
    }

    int T_find_exist_right(int v, int L, int R, int x, int cur_snow) {
        if (x <= L) {
            if (cur_snow > get_mx(v))
                return -1;
            if (R - L == 1) {
                return L;
            }
            int MID = (L + R) / 2;
            if (get_mx(get_L(v)) >= cur_snow) {
                return T_find_exist_right(get_L(v), L, MID, x, cur_snow);
            } else {
                return T_find_exist_right(get_R(v), MID, R, x, cur_snow);
            }
        } else if (R <= x) {
            return -1;
        } else {
            int MID = L + (R - L) / 2;
            int lf = T_find_exist_right(get_L(v), L, MID, x, cur_snow);
            if (lf == -1) {
                return T_find_exist_right(get_R(v), MID, R, x, cur_snow);
            } else {
                return lf;
            }
        }
    }

    int find_exist_left(int x, int cur_snow) {
        return T_find_exist_left(root, 0, vertexes, x + 1, cur_snow);
    }
    void upd(int x, int cur_snow) {
        T[x] = cur_snow;
        update(root, 0, vertexes, x, cur_snow);
    }

    int find_exist_right(int x, int cur_snow) {
        return T_find_exist_right(root, 0, vertexes, x, cur_snow);
    }

    bool exist(int x, int cur_snow) {
        auto it = T.find(x);
        if (it == T.end()) {
            return 0;
        } else if (it != T.end())
            return T[x] >= cur_snow;
    }

    bool exist_on_range(int L, int R, int cur_snow) {
        if (L > R) swap(L, R);
        return T_get_mn(root, 0, vertexes, L, R + 1) >= cur_snow; //[;) -> [;]
    }
};

CompSegmentTree cols, rows;

int get_ans(int R1, int C1, int R2, int C2, int snow, int k) {
    int c_snow = snow - k;

    if (c_snow <= 0) return abs(C1 - C2) + abs(R1 - R2);
    //START DEBUG
    //cout << cols.exist(C1, c_snow) << " " <<  rows.exist(R1, c_snow) << endl;
    //cout << cols.exist(C2, c_snow) << " " <<  rows.exist(R2, c_snow) << endl;
    //END DEBUG
    if (!cols.exist(C1, c_snow) && !rows.exist(R1, c_snow)) return INFI;
    if (!cols.exist(C2, c_snow) && !rows.exist(R2, c_snow)) return INFI;
    int ans = INFI;
    //least way
    if (rows.exist_on_range(R1, R2, c_snow) || cols.exist_on_range(C1, C2, c_snow)) return abs(C1 - C2) + abs(R1 - R2);

    vi R1_vec = { rows.find_exist_right(R1, c_snow), rows.find_exist_left(R1, c_snow) };
    vi C1_vec = { cols.find_exist_right(C1, c_snow), cols.find_exist_left(C1, c_snow) };
    vi R2_vec = { rows.find_exist_right(R2, c_snow), rows.find_exist_left(R2, c_snow) };
    vi C2_vec = { cols.find_exist_right(C2, c_snow), cols.find_exist_left(C2, c_snow) };

    for (int c_R1 : R1_vec) for (int c_C1 : C1_vec) for (int c_R2 : R2_vec)  for (int c_C2 : C2_vec)
        if (c_R1 != -1 && c_C1 != -1 && c_R2 != -1 && c_C2 != -1) {
            int cur_dist =
            abs(c_R1 - c_R2) +
            abs(C2 - c_C2) +
            abs(C1 - c_C1) +
            abs(R1 - c_R1) +
            abs(R2 - c_R2) +
            abs(c_C1 - c_C2);

            ans = min(ans, cur_dist);
        }

    return ans;
}

void solve(int snow) {
    int t; cin >> t;
    if (t == 1) {
        int R_i; cin >> R_i;
        rows.upd(--R_i, snow);
    } else if (t == 2) {
        int C_i; cin >> C_i;
        cols.upd(--C_i, snow);
    } else if (t == 3) {
        int R_1_i, C_1_i, R_2_i, C_2_i, K_i;
        cin >> R_1_i >> C_1_i >> R_2_i >> C_2_i >> K_i;
        int ans = get_ans(--R_1_i, --C_1_i, --R_2_i, --C_2_i, snow, K_i);
        if (ans == INFI) cout << -1 << '\n'; else cout << ans << '\n';
    }
}

void init() {
    //freopen("input.txt", "r+", stdin);
//    freopen("output.txt", "w+", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void init_trees() {
    cols.init(m);
    rows.init(n);
}

signed main() {
    init();
    read();
    init_trees();
    for (int snow = 1; snow < q + 1; ++snow) {
        solve(snow);
    }
}
