#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <cassert>

using namespace std;

const int maxn = 3e5 + 5, inf = 1e9, sz = 1e6 + 2;

int n, m, q, Time = 0;
vector<int> a, b;
int tb[4 * sz], ta[4 * sz];

int get_tb(int v, int l, int r, int L, int R)
{
	if (L <= l && r <= R)
		return tb[v];
	else if (l >= R || r <= L)
		return Time;
	else
	{
		int m = (l + r) / 2;
		int a = get_tb(2 * v, l, m, L, R);
		int b = get_tb(2 * v + 1, m, r, L, R);
		return min(a, b);
	}
}

int get_ta(int v, int l, int r, int L, int R)
{
	if (L <= l && r <= R)
		return ta[v];
	else if (l >= R || r <= L)
		return Time;
	else
	{
		int m = (l + r) / 2;
		int a = get_ta(2 * v, l, m, L, R);
		int b = get_ta(2 * v + 1, m, r, L, R);
		return min(a, b);
	}
}

int rc(int i, int j, int x, int y, int k)
{
	if (j > y)
	{
		swap(i, x);
		swap(j, y);
	}
	int l = 0, r = min(maxn, m - j), mid;
	while (l + 1 < r)
	{
		mid = (l + r) / 2;
		int nw = get_tb(1, 0, sz, j, j + mid + 1);
		if (Time - nw <= k)
			l = mid;
		else
			r = mid;
	}
	if (Time - a[i] <= k)
		l = m - j - 1;
	int L = 0, R = min(maxn, y);
	while (L + 1 < R)
	{
		mid = (L + R) / 2;
		int nw = get_tb(1, 0, sz, j - mid, j + 1);
		if (Time - nw <= k)
			L = mid;
		else
			R = mid;
	}
	if (Time - a[x] <= k)
		L = y;
	int f = j, s = j + l, F = y - L, S = y;
	f = max(f, F), s = min(s, S);
	if (s <= f)
		return inf;
	int nw = get_tb(1, 0, sz, s, f + 1);
	if (Time - nw <= k)
		return abs(x - i) + abs(y - j);
	return inf;
}

void upd_tb(int v, int l, int r, int pl)
{
	if (l + 1 == r)
	{
		tb[v] = Time;
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		upd_tb(2 * v, l, m, pl);
	else
		upd_tb(2 * v + 1, m, r, pl);
	tb[v] = min(tb[2 * v], tb[2 * v + 1]);
}

void upd_ta(int v, int l, int r, int pl)
{
	if (l + 1 == r)
	{
		ta[v] = Time;
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		upd_ta(2 * v, l, m, pl);
	else
		upd_ta(2 * v + 1, m, r, pl);
	ta[v] = min(ta[2 * v], ta[2 * v + 1]);
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n >> m >> q;
	a.resize(n, 0);
	b.resize(m, 0);

	for (int i = 1; i <= q; i++)
	{
		Time = i;
		int nw;
		cin >> nw;
		if (nw == 3)
		{
			int s_x, s_y, e_x, e_y, k;
			cin >> s_x >> s_y >> e_x >> e_y >> k;
			int f = rc(--s_x, --s_y, --e_x, --e_y, k);
			int s = inf;
			//s = RC(--s_x, --s_y, --e_x, --e_y, k);
			int ans = min(f, s);
			if (ans == inf)
			{
				cout << -1;
			}
			else
			{
				cout << ans;
			}
			cout << '\n';
		}
		else if (nw == 2)
		{
			int J;
			cin >> J;
			b[--J] = i;
			upd_tb(1, 0, sz, J);
		}
		else
		{
			int I;
			cin >> I;
			a[--I] = i;
		}
	}


	return 0;
}