#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <cassert>

using namespace std;

const int maxn = 3e5 + 5, inf = 1e9, sz = 1e6 + 5;

int n, m, q, Time = 0;
vector<int> a, b;
int tb[4 * sz], ta[4 * sz];


int get_tb(int v, int l, int r, int L, int R)
{
	if (L <= l && r <= R)
		return tb[v];
	else if (l >= R || r <= L)
		return Time;
	else
	{
		int m = (l + r) / 2;
		int a = get_tb(2 * v, l, m, L, R);
		int b = get_tb(2 * v + 1, m, r, L, R);
		return min(a, b);
	}
}

int get_ta(int v, int l, int r, int L, int R)
{
	if (L <= l && r <= R)
		return ta[v];
	else if (l >= R || r <= L)
		return Time;
	else
	{
		int m = (l + r) / 2;
		int a = get_ta(2 * v, l, m, L, R);
		int b = get_ta(2 * v + 1, m, r, L, R);
		return min(a, b);
	}
}

pair<int, int> get_pos_tb(int i, int j, int k)
{
	if (Time - a[i] <= k)
		return { 0, m };
	int l = j, r = min(maxn, m + 1), mid;
	while (l + 1 < r)
	{
		mid = (l + r) / 2;
		int nw = get_tb(1, 0, sz, l, r);
		if (Time - nw <= k)
			l = mid;
		else
			r = mid;
	}
	int R = 0, L = min(maxn, j);
	while (L + 1 < R)
	{
		mid = (L + R) / 2;
		int nw = get_tb(1, 0, sz, j - mid, j + 1);
		if (Time - nw <= k)
			L = mid;
		else
			R = mid;
	}
	return { L, l };
}

int rc(int i, int j, int x, int y, int k)
{
	if (j > y)
	{
		swap(i, x);
		swap(j, y);
	}
	pair<int, int> F = get_pos_tb(i, j, k), S = get_pos_tb(x, y, k);
	int f = max(S.first, F.first), s = min(S.second, F.second);
	f = max(f, j), s = min(s, y);
	if (s < f)
		return inf;
	int nw = get_tb(1, 0, sz, f, s + 1);
	if (Time - nw <= k)
		return abs(x - i) + abs(y - j);
	return inf;
}

void upd_tb(int v, int l, int r, int pl)
{
	if (l + 1 == r)
	{
		tb[v] = Time;
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		upd_tb(2 * v, l, m, pl);
	else
		upd_tb(2 * v + 1, m, r, pl);
	tb[v] = min(tb[2 * v], tb[2 * v + 1]);
}

void upd_ta(int v, int l, int r, int pl)
{
	if (l + 1 == r)
	{
		ta[v] = Time;
		return;
	}
	int m = (l + r) / 2;
	if (pl < m)
		upd_ta(2 * v, l, m, pl);
	else
		upd_ta(2 * v + 1, m, r, pl);
	ta[v] = min(ta[2 * v], ta[2 * v + 1]);
}

int slow(int i, int j, int x, int y, int k)
{
	int nw = inf;
	vector<bool> can(m, false);
	bool nw_can = true;
	for (int ps = j; ps >= max(j - 2, 0); ps--)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = j; ps < m; ps++)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	if (Time - a[i] <= k)
		can.assign(m, true);
	vector<bool> Can(m, false);
	nw_can = true;
	for (int ps = y; ps >= max(y - 2, 0); ps--)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = y; ps < min(m, y + 2); ps++)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	if (Time - a[x] <= k)
		Can.assign(m, true);
	for (int ps = 0; ps < m; ps++)
	{
		if (can[ps] && Can[ps] && Time - b[ps] <= k)
			nw = min(nw, abs(ps - j) + abs(ps - y) + abs(x - i));
	}
	return nw;
}
int SLOW(int i, int j, int x, int y, int k)
{
	int nw = inf;
	vector<bool> can(n, false);
	bool nw_can = true;
	for (int ps = i; ps >= max(0, i - 2); ps--)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = i; ps < min(n, i + 2); ps++)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	if (Time - b[j] <= k)
		can.assign(n, true);
	vector<bool> Can(n, false);
	nw_can = true;
	for (int ps = x; ps >= max(0, x - 2); ps--)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = x; ps < min(n, x + 2); ps++)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	if (Time - b[y] <= k)
		Can.assign(n, true);
	for (int ps = 0; ps < n; ps++)
	{
		if (can[ps] && Can[ps] && Time - a[ps] <= k)
			nw = min(nw, abs(ps - x) + abs(ps - i) + abs(j - y));
	}
	return nw;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	for (int i = 0; i < 4 * sz; i++)
	{
		ta[i] = 0, tb[i] = 0;
	}

	cin >> n >> m >> q;
	a.resize(n, 0);
	b.resize(m, 0);

	for (int i = 1; i <= q; i++)
	{
		Time = i;
		int nw;
		cin >> nw;
		if (nw == 3)
		{
			int s_x, s_y, e_x, e_y, k;
			cin >> s_x >> s_y >> e_x >> e_y >> k;
			//int f = rc(--s_x, --s_y, --e_x, --e_y, k);
			//int s = inf;
			//s = RC(--s_x, --s_y, --e_x, --e_y, k);
			int ans = slow(--s_x, --s_y, --e_x, --e_y, k);
			ans = min(SLOW(s_x, s_y,e_x, e_y, k), ans);
			if (ans == inf)
			{
				cout << -1;
			}
			else
			{
				cout << ans;
			}
			cout << '\n';
		}
		else if (nw == 2)
		{
			int J;
			cin >> J;
			b[--J] = i;
			upd_tb(1, 0, sz, J);
		}
		else
		{
			int I;
			cin >> I;
			a[--I] = i;
			upd_ta(1, 0, sz, I);
		}
	}


	return 0;
}