#include <bits/stdc++.h>

using namespace std;

typedef pair <int, int> pii;

#define all(a) a.begin(), a.end()
#define mp make_pair
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);
template <typename T1, typename T2> inline void chkMin(T1 &x, T2 y) {if (x > y) x = y;}

const int MAXN = 1e6 + 100, INF = 1e9;

struct seg_tree{
	int mxN;
	vector <pii> t;
	seg_tree(){}
	seg_tree(int n){
		mxN = 1;
		while (mxN < n){
			mxN <<= 1;
		}
		t.assign(mxN << 1, mp(-1, -1));
	}
	void update(int v){
		if (v >= mxN) return;
		t[v].first = min(t[v * 2].first, t[v * 2 + 1].first);
		t[v].second = max(t[v * 2].second, t[v * 2 + 1].second);
		return;
	}
	void set_val(int v, int tl, int tr, int x, int val){
		if (x > tr || tl > x) return;
		if (tl == tr){
			t[v] = mp(val, val);
			return;
		}
		int tm = (tl + tr) / 2;
		set_val(v * 2, tl, tm, x, val);
		set_val(v * 2 + 1, tm + 1, tr, x, val);
		update(v);
		return;
	}
	int get_min(int v, int tl, int tr, int l, int r){
		if (tl > r || l > tr) return INF;
		if (l <= tl && tr <= r){
			return t[v].first;
		}
		int tm = (tl + tr) / 2;
		return min(get_min(v * 2, tl, tm, l, r), get_min(v * 2 + 1, tm + 1, tr, l, r));
	}
	int get_max(int v, int tl, int tr, int l, int r){
		if (tl > r || l > tr) return -INF;
		if (l <= tl && tr <= r){
			return t[v].second;
		}
		int tm = (tl + tr) / 2;
		return max(get_max(v * 2, tl, tm, l, r), get_max(v * 2 + 1, tm + 1, tr, l, r));
	}
};


int n, m, q;

int last_column[MAXN], last_row[MAXN];
seg_tree tree[2];

int get_ans(int now){
	int r1, c1, r2, c2, k;
	cin >> r1 >> c1 >> r2 >> c2 >> k; r1--, c1--, r2--, c2--;
	// cout << k << ' ' << now << ' ';
	if (k < now - last_row[r1] && k < now - last_column[c1]){
		return -1;
	}
	if (k < now - last_row[r2] && k < now - last_column[c2]){
		return -1;
	}
	if (k >= now - last_row[r1] && k >= now - last_column[c2]){
		return abs(r1 - r2) + abs(c1 - c2);
	}
	if (k >= now - last_row[r2] && k >= now - last_column[c1]){
		return abs(r1 - r2) + abs(c1 - c2);
	}
	if (k >= now - last_column[c1] && k >= now - last_column[c2]){
		int L = min(c1, c2), R = max(c1, c2);
		int mn = tree[1].get_min(1, 0, tree[1].mxN - 1, L, R);
		if (mn >= now - k){
			return abs(r1 - r2) + abs(c1 - c2);
		}
		int ans = INF;
		L = min(r1, r2), R = max(r1, r2);
		int mx = tree[0].get_max(1, 0, tree[0].mxN - 1, L, R);
		if (mx >= now - k){
			return abs(r1 - r2) + abs(c1 - c2);
		}

		int l = -1, r = L;
		while (r - l > 1){
			int x = (l + r) / 2;
			mx = tree[0].get_max(1, 0, tree[0].mxN - 1, x, L);
			if (mx >= now - k){
				l = x;
			}
			else{
				r = x;
			}
		}
		if (l != -1){
			chkMin(ans, abs(r1 - l) + abs(c1 - c2) + abs(l - r2));
		}

		l = R, r = n;
		while (r - l > 1){
			int x = (l + r) / 2;
			mx = tree[0].get_max(1, 0, tree[0].mxN - 1, R, x);
			if (mx >= now - k){
				r = x;
			}
			else{
				l = x;
			}
		}
		if (r != n){
			chkMin(ans, abs(r1 - r) + abs(c1 - c2) + abs(r - r2));
		}
		if (ans == INF) {
			ans = -1;
		}
		return ans;
	}
	if (k >= now - last_row[r1] && k >= now - last_row[r2]) {
		int L = min(r1, r2), R = max(r1, r2);
		int mn = tree[0].get_min(1, 0, tree[0].mxN - 1, L, R);
		if (mn >= now - k){
			return (abs(c1 - c2) + abs(r1 - r2));
		}

		L = min(c1, c2), R = max(c1, c2);
		int mx = tree[1].get_max(1, 0, tree[1].mxN - 1, L, R);
		if (mx >= now - k){
			return abs(c1 - c2) + abs(r1 - r2);
		}

		int ans = INF;
		int l = -1, r = L;
		while (r - l > 1){
			int x = (l + r) / 2;
			int mx = tree[1].get_max(1, 0, tree[1].mxN - 1, x, L);
			if (mx >= now - k){
				l = x;
			}
			else{
				r = x;
			}
		}
		if (l != -1){
			chkMin(ans, abs(c1 - l) + abs(r1 - r2) + abs(l - c2));
		}

		l = R, r = m;
		while (r - l > 1){
			int x = (l + r) / 2;
			int mx = tree[1].get_max(1, 0, tree[1].mxN - 1, R, x);
			if (mx >= now - k){
				r = x;
			}
			else{
				l = x;
			}
		}
		if (r != m){
			chkMin(ans, abs(c1 - r) + abs(r1 - r2) + abs(r - c2));
		}
		if (ans == INF){
			ans = -1;
		}
		return ans;
	}
	assert(0);
	return -1;
}

void add_row(int now){
	int i;
	cin >> i; i--;
	last_row[i] = now;
	tree[0].set_val(1, 0, tree[0].mxN - 1, i, now);
	return;
}

void add_column(int now){
	int i;
	cin >> i; i--;
	last_column[i] = now;
	tree[1].set_val(1, 0, tree[1].mxN - 1, i, now);
	return;
}

int main(){
	i_o;
	cin >> n >> m >> q;
	tree[0] = seg_tree(n);
	tree[1] = seg_tree(m);
	for (int i = 0; i < n; i++){
		last_row[i] = -1;
	}
	for (int i = 0; i < m; i++){
		last_column[i] = -1;
	}
	for (int i = 0; i < q; i++){
		int t;
		cin >> t;
		if (t == 1){
			add_row(i);
		}
		if (t == 2){
			add_column(i);
		}
		if (t == 3){
			cout << get_ans(i) << '\n';
		}
	}
	return 0;
}