#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

const int INF = (int) 1e9;

int masc[1000005], masr[1000005];
pair <int, int> row[4000005], column[4000005];

void build(pair <int, int> tree[], int v, int lef, int rig)
{
    tree[v] = mp(0, 0);
    if (lef == rig) return;
    int mid = (lef + rig) / 2;
    build(tree, 2 * v, lef, mid);
    build(tree, 2 * v + 1, mid + 1, rig);
    return;
}

void update(pair <int, int> tree[], int v, int lef, int rig, int pos, int val)
{
    if (lef == rig)
    {
        tree[v] = mp(val, val);
        return;
    }
    int mid = (lef + rig) / 2;
    if (pos <= mid) update(tree, 2 * v, lef, mid, pos, val);
    else update(tree, 2 * v + 1, mid + 1, rig, pos, val);
    tree[v].x = max(tree[2 * v].x, tree[2 * v + 1].x);
    tree[v].y = min(tree[2 * v].y, tree[2 * v + 1].y);
    return;
}

int get_max(pair <int, int> tree[], int v, int lef, int rig, int A, int B)
{
    if (lef > B || rig < A) return 0;
    if (A <= lef && rig <= B) return tree[v].x;
    int mid = (lef + rig) / 2;
    return max(get_max(tree, 2 * v, lef, mid, A, B), get_max(tree, 2 * v + 1, mid + 1, rig, A, B));
}

int get_rig(pair <int, int> tree[], int v, int lef, int rig, int pos, int val)
{
    if (lef > pos) return rig + 1;
    if (tree[v].x < val) return rig + 1;
    if (lef == rig) return lef;

    int mid = (lef + rig) / 2;
    int ans = get_rig(tree, 2 * v + 1, mid + 1, rig, pos, val);
    if (ans != rig + 1) return ans;
    ans = get_rig(tree, 2 * v, lef, mid, pos, val);
    if (ans != mid + 1) return ans;
    return rig + 1;
}

int get_lef(pair <int, int> tree[], int v, int lef, int rig, int pos, int val)
{
    if (rig < pos) return lef - 1;
    if (tree[v].x < val) return lef - 1;
    if (lef == rig) return lef;

    int mid = (lef + rig) / 2;
    int ans = get_lef(tree, 2 * v, lef, mid, pos, val);
    if (ans != lef - 1) return ans;
    ans = get_lef(tree, 2 * v + 1, mid + 1, rig, pos, val);
    if (ans != mid) return ans;
    return lef - 1;
}

int get_min(pair <int, int> tree[], int v, int lef, int rig, int A, int B)
{
    if (lef > B || rig < A) return INF;
    if (A <= lef && rig <= B) return tree[v].y;
    int mid = (lef + rig) / 2;
    return min(get_min(tree, 2 * v, lef, mid, A, B), get_min(tree, 2 * v + 1, mid + 1, rig, A, B));
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    build(row, 1, 1, n);
    build(column, 1, 1, m);

    for (int rep = 1; rep <= q; rep++)
    {
        int typ;
        cin >> typ;
        if (typ == 1)
        {
            int num;
            cin >> num;
            update(row, 1, 1, n, num, rep);
            masr[num] = rep;
        }
        if (typ == 2)
        {
            int num;
            cin >> num;
            update(column, 1, 1, m, num, rep);
            masc[num] = rep;
        }
        if (typ == 3)
        {
            pair <int, int> A, B;
            int val;
            cin >> A.x >> A.y >> B.x >> B.y >> val;
            if (masr[A.x] >= rep - val && masc[B.y] >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
            if (masr[B.x] >= rep - val && masc[A.y] >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
            int ans = 2 * (m + n) + 1;
            if (masr[A.x] >= rep - val && masr[B.x] >= rep - val)
            {
                int lef = min(A.y, B.y), rig = max(A.y, B.y);
                int up  = min(A.x, B.x), down = max(A.x, B.x);
                int mx = get_max(column, 1, 1, m, lef, rig);
                if (mx >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
                if (down - up <= 1) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
                int mn = get_min(row, 1, 1, n, up + 1, down - 1);
                if (mn >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}

                if (lef != 1)
                {
                    int pos = get_rig(column, 1, 1, m, lef - 1, rep - val);
                    if (pos != m + 1) ans = min(ans, A.y - pos + B.y - pos + abs(A.x - B.x));
                }
                if (rig != m)
                {
                    int pos = get_lef(column, 1, 1, m, rig + 1, rep - val);
                    if (pos != 0) ans = min(ans, pos - A.y + pos - B.y + abs(A.x - B.x));
                }
            }

            if (masc[A.y] >= rep - val && masc[B.y] >= rep - val)
            {
                int lef = min(A.x, B.x), rig = max(A.x, B.x);
                int up = min(A.y, B.y), down = max(A.y, B.y);
                int mx = get_max(row, 1, 1, n, lef, rig);
                if (mx >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
                if (down - up <= 1) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}
                int mn = get_min(column, 1, 1, m, up + 1, down - 1);
                if (mn >= rep - val) {cout << abs(A.x - B.x) + abs(A.y - B.y) << '\n'; continue;}

                if (lef != 1)
                {
                    int pos = get_rig(row, 1, 1, n, lef - 1, rep - val);
                    if (pos != n + 1) ans = min(ans, A.x - pos + B.x - pos + abs(A.y - B.y));
                }
                if (rig != n)
                {
                    int pos = get_lef(row, 1, 1, n, rig + 1, rep - val);
                    if (pos != 0) ans = min(ans, pos - A.x + pos - B.x + abs(A.y - B.y));
                }
            }
            if (ans == 2 * (m + n) + 1) cout << -1 << '\n';
            else cout << ans << '\n';
        }
    }
    return 0;
}

