#include <iostream>

using namespace std;

struct tree
{
    int l;
    int r;
    int minn;
    int maxx;
    tree* left;
    tree* right;
    tree(int l, int r) : l(l), r(r)
    {
        minn = maxx = 0;
        if(r - l > 1)
        {
            int m = (r + l) / 2;
            left = new tree(l, m);
            right = new tree(m, r);
        }
    }
    void set(int pos, int val)
    {
        if(pos < l || pos >= r)
            return;
        else if(r - l == 1)
            minn = maxx = val;
        else
        {
            left->set(pos, val);
            right->set(pos, val);
            minn = min(left->minn, right->minn);
            maxx = max(left->maxx, right->maxx);
        }
    }
    int get_max(int l, int r)
    {
        if(r <= this->l || l >= this->r)
            return -1;
        else if(l <= this->l && r >= this->r)
            return maxx;
        else
            return max(left->get_max(l, r), right->get_max(l, r));
    }
    int get_min(int l, int r)
    {
        if(r <= this->l || l >= this->r)
            return -1;
        else if(l <= this->l && r >= this->r)
            return minn;
        else
            return min(left->get_min(l, r), right->get_min(l, r));
    }
    int farthest_larger(int pos, int val)
    {
        if(pos <= l || maxx < val)
            return -1;
        if(r - l == 1)
            return l;
        int ans = right->farthest_larger(pos, val);
        if(ans == -1)
            ans = left->farthest_larger(pos, val);
        return ans;
    }
    int nearest_larger(int pos, int val)
    {
        if(pos >= r || maxx < val)
            return -1;
        if(r - l == 1)
            return l;
        int ans = left->nearest_larger(pos, val);
        if(ans == -1)
            ans = right->nearest_larger(pos, val);
        return ans;
    }
};

int main()
{
    int n, m, q;
    cin >> n >> m >> q;
    tree rows(0, n), cols(0, m);
    for(int turn = 1; turn <= q; turn++)
    {
        int cmd;
        cin >> cmd;
        if(cmd == 1)
        {
            int row;
            cin >> row;
            rows.set(row - 1, turn);
        }
        else if(cmd == 2)
        {
            int col;
            cin >> col;
            cols.set(col - 1, turn);
        }
        else if(cmd == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            int t = turn - k;
            bool a_row = rows.get_max(x1, x1 + 1) >= t;
            bool a_col = cols.get_max(y1, y1 + 1) >= t;
            bool b_row = rows.get_max(x2, x2 + 1) >= t;
            bool b_col = cols.get_max(y2, y2 + 1) >= t;
            int dx = abs(x1 - x2);
            int dy = abs(y1 - y2);
            int minn = (1 << 31) - 1;
            if(!(a_row || a_col) || !(b_row || b_col))
                cout << "-1";
            else if((a_row && b_col) || (b_row && a_col))
                cout << dx + dy;
            else if(a_row && b_row)
            {
                if(cols.get_max(min(y1, y2), max(y1, y2) + 1) >= t || rows.get_min(min(x1, x2), max(x1, x2) + 1) >= t)
                    cout << dx + dy;
                else
                {
                    int pos = cols.farthest_larger(min(y1, y2), t);
                    if(pos != -1)
                        minn = min(minn, dx + dy + 2 * (min(y1, y2) - pos));
                    pos = cols.nearest_larger(max(y1, y2) + 1, t);
                    if(pos != -1)
                        minn = min(minn, dx + dy + 2 * (pos - max(y1, y2)));
                    cout << minn;
                }
            }
            else if(a_col && b_col)
            {
                if(rows.get_max(min(x1, x2), max(x1, x2) + 1) >= t || cols.get_min(min(y1, y2), max(y1, y2) + 1) >= t)
                    cout << dx + dy;
                else
                {
                    int pos = rows.farthest_larger(min(x1, x2), t);
                    if(pos != -1)
                        minn = min(minn, dx + dy + 2 * (min(x1, x2) - pos));
                    pos = rows.nearest_larger(max(x1, x2) + 1, t);
                    if(pos != -1)
                        minn = min(minn, dx + dy + 2 * (pos - max(x1, x2)));
                    cout << minn;
                }
            }
            cout << endl;
        }
    }
    return 0;
}
