#include <iostream>
#include <set>
#include <map>
#include <vector>

using namespace std;

set<long long>* dfs(map<int, set<long long>*>& cache, vector<pair<int, long long> >* graph, int i)
{
    auto it = cache.find(i);
    if(it != cache.end())
        return it->second;
    set<long long>* ans = new set<long long>;
    cache[i] = ans;
    if(i == 0)
        ans->insert(0);
    for(pair<int, long long> j : graph[i])
    {
        set<long long>* jset = dfs(cache, graph, j.first);
        for(long long k : *jset)
            ans->insert(k + j.second);
    }
    return ans;
}

void solve()
{
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    map<int, set<long long>*> cache;
    vector<pair<int, long long> > graph[n];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        long long t;
        cin >> a >> b >> t;
        graph[b - 1].emplace_back(a - 1, t);
    }
    string ans(q, '0');
    for(int i = 0; i < q; i++)
    {
        int f;
        long long r;
        cin >> f >> r;
        set<long long>& si = *dfs(cache, graph, f - 1);
        long long r2 = (r * p) / (p - 1);
        ans[i] = ((si.lower_bound(r) == si.upper_bound(r2))?'0':'1');
    }
    cout << ans << endl;
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
        solve();
    return 0;
}
