#include <iostream>
#include <bitset>
#include <map>
#include <vector>

using namespace std;

bitset<10001>* dfs(map<int, bitset<10001>*>& cache, vector<pair<int, int> >* graph, int i)
{
    auto it = cache.find(i);
    if(it != cache.end())
        return it->second;
    bitset<10001>* ans = new bitset<10001>;
    cache[i] = ans;
    if(i == 0)
        ans[0] = true;
    for(pair<int, int> j : graph[i])
    {
        bitset<10001>& jset = *dfs(cache, graph, j.first);
        (*ans) |= (jset << j.second);
    }
    return ans;
}

void solve()
{
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    map<int, bitset<10001>*> cache;
    vector<pair<int, int> > graph[n];
    for(int i = 0; i < m; i++)
    {
        int a, b;
        int t;
        cin >> a >> b >> t;
        graph[b - 1].emplace_back(a - 1, t);
    }
    string ans(q, '0');
    for(int i = 0; i < q; i++)
    {
        int f;
        int r;
        cin >> f >> r;
        bitset<10001>& si = *dfs(cache, graph, f - 1);
        int r2 = (r * p) / (p - 1);
        ans[i] = ((r == 0?si._Find_first():si._Find_next(r - 1))>r2?'0':'1');
    }
    cout << ans << endl;
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
        solve();
    return 0;
}
