#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <set>

//#define DEBUG

using namespace std;

struct paint {
	int len, L, R, c;
	paint(int len = 0, int L = 0, int R = 0, int c = -1) : len(len), L(L), R(R), c(c) {}
	bool operator < (const paint &p)const& {
		return len > p.len;
	}
};

struct event {
	int x, c, time, type;
	event(int x = -1, int c = -1, int time = -1, int type = -1) : x(x), c(c), time(time), type(type) {}
	bool operator < (const event &e)const& {
		return x == e.x ? type > e.type : x < e.x;
	}
};

int main() {
	int n, m;
	cin >> m >> n;
	vector <int> a(m);
	vector <int> first(n + 1, m), last(n + 1, -1);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		first[a[i]] = min(first[a[i]], i);
		last[a[i]] = i;
	}
	vector <paint> p;
	vector <event> scan;
	for (int i = 1; i < n + 1; i++) {
		if (first[i] != m && last[i] != -1) {
			p.emplace_back(last[i] - first[i] + 1, first[i], last[i], i);
		}
	}
	sort(p.begin(), p.end());
	for (int i = 0; i < p.size(); i++) {
		scan.emplace_back(p[i].L, p[i].c, i, 1);
		scan.emplace_back(p[i].R, p[i].c, i, -1);
	}
	sort(scan.begin(), scan.end());
	vector <int> new_a(m, -1);
	set <pair <int, int>> q;
	for (int i = 0; i < scan.size(); i++) {
		if (scan[i].type == 1) {
			q.insert({ -scan[i].time, scan[i].c });
			new_a[scan[i].x] = q.begin()->second;
		}
		else {
			new_a[scan[i].x] = q.begin()->second;
			q.erase({ -scan[i].time, scan[i].c });
		}
	}
	deque <int> d;
	while (new_a[0] == -1) {}
	for (int i = 0; i < m; i++) {
		if (new_a[i] == -1) {
			new_a[i] = d.back();
		}
		else {
			if (first[new_a[i]] == last[new_a[i]]) continue;
			if (d.empty() || d.back() != new_a[i]) d.push_back(new_a[i]);
			else d.pop_back();
		}
	}
	if (new_a != a) {
		cout << -1;
	}
	else {
		cout << p.size() << '\n';
		for (int i = 0; i < p.size(); i++) {
			cout << p[i].c << ' ' << p[i].L + 1 << ' ' << p[i].R + 1 << '\n';
		}
	}
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}