#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <set>
#include <cmath>

//#define DEBUG

using namespace std;

vector <int> dx = { 0, 0, 1, -1 };
vector <int> dy = { 1, -1, 0, 0 };

bool correct(int x, int y, int n, int m) {
	return x > -1 && y > -1 && x < n && y < m;
}

int main() {
	int n, m, q;
	cin >> n >> m >> q;
	vector <vector <int>> fild(n, vector <int>(m, -1));
	for (int i = 0; i < q; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			for (int j = 0; j < m; j++) {
				fild[r - 1][j] = i;
			}
		}
		if (type == 2) {
			int c;
			cin >> c;
			for (int j = 0; j < n; j++) {
				fild[j][c - 1] = i;
			}
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, x2--, y1--, y2--;
			if (fild[x1][y1] + k < i || fild[x2][y2] + k < i) {
				cout << -1 << '\n';
				continue;
			}
			deque <pair <int, int>> q;
			vector <vector <int>> dist(n, vector <int>(m, 2 * (n + m)));
			dist[x1][y1] = 0;
			q.push_back({ x1, y1 });
			while (!q.empty()) {
				auto top = q[0];
				q.pop_front();
				for (int j = 0; j < 4; j++) {
					if (correct(top.first + dx[j], top.second + dy[j], n, m) && fild[top.first + dx[j]][top.second + dy[j]] + k >= i
						&& dist[top.first + dx[j]][top.second + dy[j]] == 2 * (n + m)) {
						dist[top.first + dx[j]][top.second + dy[j]] = dist[top.first][top.second] + 1;
						q.push_back({ top.first + dx[j], top.second + dy[j] });
					}
				}
				if (dist[x2][y2] != 2 * (n + m)) {
					break;
				}
			}
			if (dist[x2][y2] != 2 * (n + m)) {
				cout << dist[x2][y2] << '\n';
			}
			else {
				cout << -1 << '\n';
			}
		}
	}

#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}