#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <set>
#include <string>
#include <cassert>

//#define DEBUG

using namespace std;

vector <vector <pair <int, int>>> G;
vector <vector <pair <int, int>>> quer;
string ans;

void dfs(int v, int dist, int p) {
	vector <pair <int, int>> tmp;
	for (auto u : quer[v]) {
		if (dist >= u.first && dist * (p - 1) <= p * u.first) {
			ans[u.second] = '1';
		}
		else {
			tmp.emplace_back(u);
		}
	}
	quer[v] = tmp;
	for (auto u : G[v]) {
		dfs(u.first, dist + u.second, p);
	}
}

int main() {
	int t;
	cin >> t;
	for (int k = 0; k < t; k++) {
		int n, m, p, q;
		cin >> n >> m >> q >> p;
		G.clear();
		G.resize(n);
		for (int i = 0; i < m; i++) {
			int b, e, w;
			cin >> b >> e >> w;
			G[b - 1].push_back({ e - 1, w });
		}
		ans.clear();
		ans.resize(q, '0');
		quer.clear();
		quer.resize(n);
		for (int i = 0; i < q; i++) {
			int v, w;
			cin >> v >> w;
			quer[v - 1].emplace_back(w, i);
		}
		dfs(0, 0, p);
		cout << ans << '\n';
	}

#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}