#pragma GCC optimaze("Ofast")


#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;
typedef long long ll;

const int N = 1e6, INF = 1e8;

int tree[4][3 * N];
int nn[2], ux[N], uy[N];

inline void upd(int v, int grl, int grr, int fl, int l, int x) {
	if (grr < l || grl > l)
		return;
	if (l == grl && l == grr) {
		tree[fl][v] = x;
		return;
	}
	int m = (grr + grl) / 2;
	upd(v * 2, grl, m, fl, l, x), upd(v * 2 + 1, m + 1, grr, fl, l, x);
	if(fl > 1)
		tree[fl][v] = min(tree[fl][v * 2], tree[fl][v * 2 + 1]);
	else
		tree[fl][v] = max(tree[fl][v * 2], tree[fl][v * 2 + 1]);
}

inline int get(int v, int grl, int grr, int fl, int l, int r) {
	if (grr < l || grl > r)
		return ((fl > 1) ? INF : -INF);
	if (l <= grl && grr <= r)
		return tree[fl][v];
	int m = (grr + grl) / 2;
	if (fl > 1) {
		return min(get(v * 2, grl, m, fl, l, r), get(v * 2 + 1, m + 1, grr, fl, l, r));
	}
	else {
		return max(get(v * 2, grl, m, fl, l, r), get(v * 2 + 1, m + 1, grr, fl, l, r));
	}
}

inline int find_pref(int xl, int xr, int fl, int p) {
	int l = xl - 1, r = xr, m, g;
	while (r - l > 1) {
		m = (r + l) / 2;
		g = get(1, 0, nn[fl] - 1, fl, m, xr);
		if (g >= p)
			l = m;
		else
			r = m;
	}
	return l;
}

inline int find_suf(int xl, int xr, int fl, int p) {
	int l = xl, r = xr + 1, m, g;
	while (r - l > 1) {
		m = (r + l) / 2;
		g = get(1, 0, nn[fl] - 1, fl, xl, m);
		if (g >= p)
			r = m;
		else
			l = m;
	}
	return r;
}

int main() {
	//ios_base::sync_with_stdio(false);
	int n, m, q;
	bool fl = false, fx1, fx2, fy1, fy2;
	scanf("%d%d%d", &n, &m, &q);
	nn[0] = n, nn[1] = m;
	for (int i = 1, t, x1, x2, y1, y2, k; i <= q; ++i) {
		scanf("%d", &t);
		if (t == 3) {
			scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
			--x1, --y1, --x2, --y2;
		}
		scanf("%d", &k);
		if (t == 1) {
			upd(1, 0, n - 1, 0, k - 1, i);
			upd(1, 0, n - 1, 2, k - 1, i);
			ux[k - 1] = i;
		}
		else if (t == 2) {
			fl = true;
			upd(1, 0, m - 1, 1, k - 1, i);
			upd(1, 0, m - 1, 3, k - 1, i);
			uy[k - 1] = i;
		}
		else {
			if (i - get(1, 0, n - 1, 2, min(x1, x2), max(x1, x2)) <= k || i - get(1, 0, m - 1, 3, min(y1, y2), max(y1, y2)) <= k) {
				printf("%d\n", abs(x2 - x1) + abs(y2 - y1));
			}
			else {
				fx1 = (i - ux[x1]) <= k;
				fx2 = (i - ux[x2]) <= k;
				//bool fxx = (i - get(1, 0, n - 1, 0, min(x1, x2), max(x1, x2))) <= k;
				fy1 = (i - uy[y1]) <= k;
				fy2 = (i - uy[y2]) <= k;
				//bool fyy = (i - get(1, 0, m - 1, 1, min(y1, y2), max(y1, y2))) <= k;
				if ((fx1 && fy2) || (fx2 && fy1)) {
					printf("%d\n", abs(x2 - x1) + abs(y2 - y1));
				}
				else {

					int d = INF;
					if (fl) {
						if (fx1 && fx2) {
							int l = find_pref(0, y1, 1, i - k);
							int r = find_suf(y1, m - 1, 1, i - k);
							int d1 = ((l >= 0) ? abs(y1 - l) + abs(y2 - l) + abs(x2 - x1) : INF);
							int d2 = ((r < m) ? abs(y1 - r) + abs(y2 - r) + abs(x2 - x1) : INF);
							d = min({ d, d1, d2 });
						}
						if (fy1 && fy2) {
							int l = find_pref(0, x1, 0, i - k);
							int r = find_suf(x1, n - 1, 0, i - k);
							int d1 = ((l >= 0) ? abs(x1 - l) + abs(x2 - l) + abs(y2 - y1) : INF);
							int d2 = ((r < n) ? abs(x1 - r) + abs(x2 - r) + abs(y2 - y1) : INF);
							d = min({ d, d1, d2 });
						}
					}
					if (d == INF)
						d = -1;
					printf("%d\n", d);
				}
			}
		}
	}
	return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6


*/