#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

void init(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define printvi(arr) for (int x: arr) cout << x << " "; cout << endl;
#define myreverse(arr) reverse(arr.begin(), arr.end())
#define pii pair<int, int>
#define vpii vector<pii>
#define vb vector<bool>
#define vvb vector<vb>
#define F first
#define S second

const int maxn = 3e5 + 2;
const int inf = 2 * 1024 * 1024 * 1023 - 1;
int main() {
    init();
    int n, m, q;
    cin >> n >> m >> q;
    if (q <= 10005){
        vpii rc;
        rc.pb({-1, -1});
        vi ir, ic;
        vb usedr(n), usedc(m);
        for (int i = 1; i <= q; ++i){
            int z;
            cin >> z;
            if (z == 1){
                int r;
                cin >> r;
                r--;
                rc.pb({r, 1});
            }
            if (z == 2){
                int c;
                cin >> c;
                c--;
                rc.pb({c, 2});
            }
            if (z == 3){
                rc.pb({-1, -1});
                int r1, c1, r2, c2, k;
                cin >> r1 >> c1 >> r2 >> c2 >> k;
                r1--, c1--;
                r2--, c2--;
                if (k >= i){
                    cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                    continue;
                }
                int l = i - k;
                for (int r0: ir) usedr[r0] = 0;
                for (int c0: ic) usedc[c0] = 0;
                ir.clear();
                ic.clear();
                for (int j = l; j < rc.size(); ++j){
                    if (rc[j].S == -1) continue;
                    if (rc[j].S == 1){
                        ir.pb(rc[j].F);
                        usedr[rc[j].F] = 1;
                    } else {
                        ic.pb(rc[j].F);
                        usedc[rc[j].F] = 1;
                    }
                }
                vvb g(n, vb(m));
                for (int r: ir){
                    for (int c = 0; c < m; ++c) g[r][c] = 1;
                }
                for (int c: ic){
                    for (int r = 0; r < n; ++r) g[r][c] = 1;
                }
                if (!g[r1][c1]){
                    cout << -1 << endl;
                    continue;
                }
                vvi d(n, vi(m));
                queue<pii> q;
                q.push({r1, c1});
                vvb used(n, vb(m));
                used[r1][c1] = 1;
                while(!q.empty()){
                    pii xy = q.front();
                    q.pop();
                    int r = xy.F, c = xy.S;
                    if (r > 0 && g[r - 1][c] && !used[r - 1][c]){
                        d[r - 1][c] = d[r][c] + 1;
                        used[r - 1][c] = 1;
                        q.push({r - 1, c});
                    }
                    if (r + 1 < n && g[r + 1][c] && !used[r + 1][c]){
                        d[r + 1][c] = d[r][c] + 1;
                        used[r + 1][c] = 1;
                        q.push({r + 1, c});
                    }
                    if (c > 0 && g[r][c - 1] && !used[r][c - 1]){
                        d[r][c - 1] = d[r][c] + 1;
                        used[r][c - 1] = 1;
                        q.push({r, c - 1});
                    }
                    if (c + 1 < m && g[r][c + 1] && !used[r][c + 1]){
                        d[r][c + 1] = d[r][c] + 1;
                        used[r][c + 1] = 1;
                        q.push({r, c + 1});
                    }
                }
                if (!used[r2][c2]){
                    cout << -1 << endl;
                    continue;
                }
                cout << d[r2][c2] << endl;
            }
        }
        return 0;
    }
    return 0;
}
/*
 4 3 9
 3 2 1 3 3 1
 3 2 1 3 3 1
 2 1
 2 3
 1 1
 3 2 1 3 3 3
 3 2 1 3 3 3
 2 2
 3 2 1 3 3 6
 */
