#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int MAXN = 500005;
vector<pll> G[MAXN];

ll ps[MAXN];
ll d[MAXN];

mt19937 rng(time(0));

struct node {
    ll x;
    int y;
    ll sum;

    node *l, *r;

    node() {}
    node(ll _x) {
        x = _x;
        sum = x;
        y = rng();
    }
};

ll sum(node *t) {
    return t ? t->sum : 0;
}

void upd(node *&t) {
    if (t) {
        t->sum = t->x + sum(t->l) + sum(t->r);
    }
}

node* merge(node *a, node *b) {
    if (!a) return b;
    if (!b) return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}

pair<node*, node*> split(node *t, ll x) {
    if (!t) return {0, 0};
    if (t->x < x) {
        auto p = split(t->r, x);
        t->r = p.fi;
        upd(t);
        return {t, p.se};
    } else {
        auto p = split(t->l, x);
        t->l = p.se;
        upd(t);
        return {p.fi, t};
    }
}

pair<node*, node*> splitsum(node *t, ll x) {
    if (!t) return {0, 0};
    if (t->sum < x) {
        auto p = split(t->r, x);
        t->r = p.fi;
        upd(t);
        return {t, p.se};
    } else {
        auto p = split(t->l, x);
        t->l = p.se;
        upd(t);
        return {p.fi, t};
    }
}

void add(node *&t, ll x) {
    auto p = split(t, x);
    t = merge(p.fi, merge(new node(x), p.se));
}


void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    ll pp = p - 1;
    for (int j = 0; j < m; ++j) {
        ll d;
        int v, u;
        cin >> v >> u >> d;
        G[v].pb({u, d});
    }
    
    ps[1] = 0;
    d[1] = 0;
    for (int v = 1; v <= n - 1; ++v) {
        ll d1 = G[v][0].se;
        ll d2 = G[v][1].se;
        if (d1 > d2) swap(d1, d2);
        ps[v + 1] = ps[v] + d1;
        d[v] = d2 - d1;
    }

    vector<pair<pll, int>> que;

    for (int i = 0; i < q; ++i) {
        int v;
        ll r;
        cin >> v >> r;
        que.pb({{v, r}, i});

        
        ll s = 0;
        vector<ll> p;
        for (int i = 1; i < v; ++i) p.pb(d[i]);
        sort(all(p));
        reverse(all(p));
        for (auto &y : p) {
            if (s + y <= x) s += y;
        }
        cout << (r - ps[v] <= s && s <= r + r - ps[v] ? '1' : '0');
    }

    sort(all(que));

    node* T = 0;
    int t = 0;
    for (int v = 1; v <= n; ++v) {
        add(T, d[v]);
        while (t < que.size() && que[t].fi.fi == v) {
            ll x = que[t].fi.se;
            int id = que[t].se;

            ll x = (ll)(r * (ll)p) / (p - 1) - ps[v];

             auto p = splitsum(T, x);

            ll s = sum(p.fi);
            T = merge(p.fi, p.se);

            cout << (r - ps[v] <= s && s <= x ? '1' : '0');

            ++t;
        }
    }

    cout << '\n';

    for (int v = 1; v <= n; ++v) {
        G[v].clear();
    }
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}