#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define ever (;;)
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()
#define debug(v) cout << #v << ' ' << v << endl;
#define debugV(v) cout << #v << " : "; for (auto& i : v) cout << i << ' '; cout << endl;

const int INF = 1e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 150;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

int rnd(int a, int b) {
    uniform_int_distribution<> dis(a, b);
    return dis(myRand);
}

int table[MAXN][MAXN], n, m;
int d[MAXN][MAXN];

int bfs(int r1, int c1, int r2, int c2, int k) {
    if (table[r1][c1] > k || table[r2][c2] > k)
        return -1;
    queue<pii> q;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            d[i][j] = INF;
    q.push(mp(r1, c1));
    d[r1][c1] = 0;
    while (!q.empty()) {
        pii v = q.front();
        q.pop();
        if (v.f + 1 < n && d[v.f + 1][v.s] == INF && table[v.f + 1][v.s] <= k) {
            d[v.f + 1][v.s] = d[v.f][v.s] + 1;
            q.push(mp(v.f + 1, v.s));
        }
        if (v.f - 1 >= 0 && d[v.f - 1][v.s] == INF && table[v.f - 1][v.s] <= k) {
            d[v.f - 1][v.s] = d[v.f][v.s] + 1;
            q.push(mp(v.f - 1, v.s));
        }
        if (v.s + 1 < m && d[v.f][v.s + 1] == INF && table[v.f][v.s + 1] <= k) {
            d[v.f][v.s + 1] = d[v.f][v.s] + 1;
            q.push(mp(v.f, v.s + 1));
        }
        if (v.s - 1 >= 0 && d[v.f][v.s - 1] == INF && table[v.f][v.s - 1] >= k) {
            d[v.f][v.s - 1] = d[v.f][v.s] + 1;
            q.push(mp(v.f, v.s - 1));
        }
    }
    if (d[r2][c2] == INF)
        return -1;
    return d[r2][c2];
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int q, type, r1, c1, r2, c2, k, x;
    cin >> n >> m >> q;
    while (q --> 0) {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
                table[i][j]++;
        cin >> type;
        if (type == 1) {
            cin >> x;
            x--;
            for (int j = 0; j < m; ++j)
                table[x][j] = 0;
        } else if (type == 2) {
            cin >> x;
            x--;
            for (int i = 0; i < n; ++i)
                table[i][x] = 0;
        } else {
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << bfs(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k) << '\n';
        }
    }
}
