#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MX = 4*1e6 + 10;
const int inf = 1e9 + 10;
int a[MX][2], nn[2];
int tree[MX][2];

void build(int i, int l, int r, int t)
{
    tree[i][t] = 0;
    if (l+1 == r) return;
    int mid = (l+r)/2;
    build(2*i+1, l, mid, t);
    build(2*i+2, mid, r, t);
}

void put(int i, int l, int r, int t, int pos, int val)
{
    if (l+1 == r) {tree[i][t] = val; return; }
    int mid = (l+r)/2;
    if (pos < mid) put(2*i+1, l, mid, t, pos, val);
    else put(2*i+2, mid, r, t, pos, val);

    tree[i][t] = min(tree[2*i+1][t], tree[2*i+2][t]);
}

int get(int i, int l, int r, int t, int ll, int rr)
{
    if (r <= ll || rr <= l) return inf;
    if (ll <= l && r <= rr) return tree[i][t];
    int mid = (l+r)/2;
    return min(get(2*i+1, l, mid, t, ll, rr), get(2*i+2, mid, r, t, ll, rr));
}

int f(int x, int y, int xx, int yy, int t, int c)
{
    int res = inf, tt = (t+1)%2;
    //int fl = 1;
    //for (int i = min(y, yy); i <= max(y, yy); i++)
        //if (a[i][tt] < c) fl = 0;

    if (get(0, 0, nn[tt], tt, min(y, yy), max(y, yy)) >= c) { return abs(x-xx) + abs(y-yy); }
    if (a[x][t] >= c && a[yy][tt] >= c) return abs(x-xx) + abs(y-yy);
    if (a[x][t] < c || a[xx][t] < c) return inf;
    // if (abs(x-xx) <= 1) return abs(y-yy) + abs(x-xx);


    for (int i = 0; i < nn[tt]; i++)
    {
        if (a[i][tt] >= c)
        {
            res = min(res, abs(i-y) + abs(x-xx) + abs(i-yy));
            //break;
        }
    }

    return res;
}

int main()
{
    int n, m;
    cin >> n >> m;
    nn[0] = n;
    nn[1] = m;

    for (int i = 0; i < n; i++) a[i][0] = 0;
    for (int j = 0; j < m; j++) a[j][1] = 0;

    build(0, 0, n, 0);
    build(0, 0, m, 1);

    int q;
    cin >> q;

    for (int i = 0; i < q; i++)
    {
        int cc;
        cin >> cc;
        if (cc == 1)
        {
            int r;
            cin >> r;
            a[r-1][0] = i+1;
            put(0, 0, n, 0, r-1, i+1);
        }
        if (cc == 2)
        {
            int w;
            cin >> w;
            a[w-1][1] = i+1;
            put(0, 0, m, 1, w-1, i+1);
        }
        if (cc == 3)
        {
            int x, y, xx, yy, k;
            cin >> x >> y >> xx >> yy >> k;
            x--;
            y--;
            xx--;
            yy--;
            int res = f(x, y, xx, yy, 0, i+1-k);
            //cout << res << " " << i+1-k << "!\n";
            res = min(res, f(y, x, yy, xx, 1, i+1-k));

            if (res == inf) cout << "-1\n";
            else cout << res << "\n";
        }
    }
    return 0;
}
