#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define left(v) (v << 1) + 1
#define right(v) (v << 1) + 2

class LST {
    vector<int> push;
    int n;

    void update(int l, int r, int v) {
        if (r - l == 1) {
            return;
        }

        if (push[v]) {
            push[left(v)] = push[right(v)] = push[v];
            push[v] = 0;
        }
    }

    void set(int x, int L, int R, int l, int r, int v = 0) {
        update(l, r, v);

        if (l == L && r == R) {
            push[v] = x;

            return;
        }

        int mid = (l + r) >> 1;

        if (R <= mid) {
            set(x, L, R, l, mid, left(v));
        } else if (L >= mid) {
            set(x, L, R, mid, r, right(v));
        } else {
            set(x, L, mid, l, mid, left(v));
            set(x, mid, R, mid, r, right(v));
        }
    }

    int get(int i, int l, int r, int v = 0) {
        if (r - l == 1 || push[v]) {
            return push[v];
        }

        int mid = (l + r) >> 1;

        if (i < mid) {
            return get(i, l, mid, left(v));
        }

        return get(i, mid, r, right(v));
    }

public:
    LST(int n) : n(n) {
        push.resize(4 * n);
    }

    void set(int x, int L, int R) {
        set(x, L, R, 0, n);
    }

    int get(int i) {
        return get(i, 0, n);
    }
};


int main() {
    int n, m;
    cin >> n >> m;

    ++m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> first(m, -1);
    for (int i = 0; i < n; ++i) {
        if (first[a[i]] == -1) {
            first[a[i]] = i;
        }
    }

    vector<int> last(m, -1);
    for (int i = n - 1; i >= 0; --i) {
        if (last[a[i]] == -1) {
            last[a[i]] = i;
        }
    }

    LST tree(n);

    vector<int> cs, ls, rs;

    for (int i = 0; i < n; ++i) {
        if (i == first[a[i]]) {
            tree.set(a[i], first[a[i]], last[a[i]] + 1);
            cs.push_back(a[i]);
            ls.push_back(first[a[i]] + 1);
            rs.push_back(last[a[i]] + 1);
        } else {
            if (a[i] != tree.get(i)) {
                cout << -1;

                return 0;
            }
        }
    }

    cout << cs.size() << '\n';
    for (int i = 0; i < cs.size(); ++i) {
        cout << cs[i] << ' ' << ls[i] << ' ' << rs[i] << '\n';
    }

    return 0;
}


/*

7 10
10 5 5 10 4 2 4

*/