#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


struct E {
    signed to;
    int w;

    E(signed to, int w) : to(to), w(w) {};
};


struct S {
    int L, R;

    S(int L, int R) : L(L), R(R) {};

    bool operator<(const S &s) const {
        return L < s.L;
    }
};


vector<E> es;
vector<vector<signed>> graph;
vector<vector<S>> vss;
vector<signed> used;


void merge(vector<S> &ss) {
    if (ss.empty()) {
        return;
    }

    sort(ss.begin(), ss.end());

    vector<S> res;

    int curl = ss[0].L, curr = ss[0].R;
    for (S &s : ss) {
        if (s.L > curr + 1) {
            res.emplace_back(curl, curr);
            curl = s.L;
            curr = s.R;
        } else {
            curr = max(curr, s.R);
        }
    }

    res.emplace_back(curl, curr);

    ss = res;
}


bool belongs(int x, vector<S> &ss) {
    for (S s : ss) {
        if (x >= s.L && x <= s.R) {
            return true;
        }
    }

    return false;
}


void dfs(signed v) {
    for (int e : graph[v]) {
        signed u = es[e].to;

        if (!used[u]) {
            dfs(u);
        }

        int w = es[e].w;

        for (S &s : vss[u]) {
            vss[v].emplace_back(s.L - w, s.R - w);
        }
    }

    merge(vss[v]);

    used[v] = true;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    signed t;
    cin >> t;

    while (t--) {
        int n, m, q, p, r = -1;
        cin >> n >> m >> q >> p;

        es.clear();
        graph.clear();
        graph.resize(n);

        signed v, u;
        int d;

        for (int i = 0; i < m; ++i) {
            cin >> v >> u >> d;

            --v;
            --u;

            es.emplace_back(u, d);
            graph[v].push_back(es.size() - 1);
        }

        signed f;
        int cr;

        vector<signed> qs(q);

        for (int i = 0; i < q; ++i) {
            cin >> f >> cr;

            --f;

            if (r == -1) {
                r = cr;
            }

            qs[i] = f;
        }

        vector<signed> res(n);

        for (int i = 0; i < n; ++i) {
            vss.clear();
            vss.resize(n);
            used.assign(n, 0);
            vss[i].emplace_back(r, r * p / (p - 1));
            used[i] = true;
            dfs(0);

            res[i] = belongs(0, vss[0]);
        }

        for (int i = 0; i < q; ++i) {
            cout << res[qs[i]];
        }

        cout << '\n';
    }

    return 0;
}


/*

1
3 3 3 2
1 2 20
2 3 1
1 3 10
1 10
2 10
3 10

1
4 4 4 2
1 2 5
2 4 1
1 3 3
3 4 3
1 10
2 10
3 10
4 10

*/