#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>


using namespace std;


#define int long long


const int MAXN = 10000;


struct E {
    int to, w;

    E(int to, int w) : to(to), w(w) {};
};


vector<E> es;
vector<vector<int>> graph;
vector<bitset<MAXN>> ds;
vector<int> used;


void dfs(int v) {
    for (int e : graph[v]) {
        int u = es[e].to;

        if (!used[u]) {
            dfs(u);
        }

        ds[v] |= ds[u] << es[e].w;
    }

    used[v] = true;
}


signed main() {
    int t;
    cin >> t;

    while (t--) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;

        es.clear();
        graph.clear();
        graph.resize(n);
        ds.clear();
        ds.resize(n);

        ds[0][0] = 1;

        int v, u, d;

        for (int i = 0; i < m; ++i) {
            cin >> v >> u >> d;

            --v;
            --u;

            es.emplace_back(v, d);
            graph[u].push_back(es.size() - 1);
        }

        used.assign(n, 0);

        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i);
            }
        }
        
        int f, r;

        for (int i = 0; i < q; ++i) {
            cin >> f >> r;

            --f;

            int ub = r * p / (p - 1) + 1;

            bool b = false;
            for (int j = r; j < ub; ++j) {
                if (ds[f][j]) {
                    b = true;

                    break;
                }
            }

            cout << b;
        }

        cout << '\n';
    }

    return 0;
}


/*

1
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9

*/