#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<random>
#include<cmath>
#include<ctime>
using namespace std;
//#define int long long
#define elif else if
vector<int>otrtreeX;
vector<int>mxtreeX;
vector<int>otrtreeY;
vector<int>mxtreeY;
int nX = 1;
int nY = 1;
void updX(int l, int r, int ind, int x, int nw)
{
	if (x >= r || x < l)
		return;
	if (l == r - 1)
	{
		otrtreeX[ind] = nw;
		mxtreeX[ind] = nw;
		return;
	}
	int m = (l + r) / 2;
	updX(l, m, ind * 2, x, nw);
	updX(m, r, ind * 2 + 1, x, nw);
	otrtreeX[ind] = min(otrtreeX[ind * 2], otrtreeX[ind * 2 + 1]);
	mxtreeX[ind] = max(mxtreeX[ind * 2], mxtreeX[ind * 2 + 1]);
}
void updY(int l, int r, int ind, int x, int nw)
{
	if (x >= r || x < l)
		return;
	if (l == r - 1)
	{
		otrtreeY[ind] = nw;
		mxtreeY[ind] = nw;
		return;
	}
	int m = (l + r) / 2;
	updY(l, m, ind * 2, x, nw);
	updY(m, r, ind * 2 + 1, x, nw);
	otrtreeY[ind] = min(otrtreeY[ind * 2], otrtreeY[ind * 2 + 1]);
	mxtreeY[ind] = max(mxtreeY[ind * 2], mxtreeY[ind * 2 + 1]);
}
int getX(int l, int r, int ind, int lQ, int rQ)
{
	if (rQ <= l || r <= lQ)
	{
		return 1e9;
	}
	if (lQ <= l && r <= rQ)
	{
		return otrtreeX[ind];
	}
	int m = (l + r) / 2;
	return min(getX(l, m, ind * 2, lQ, rQ), getX(m, r, ind * 2 + 1, lQ, rQ));
}
int getXmx(int l, int r, int ind, int lQ, int rQ)
{
	if (rQ <= l || r <= lQ)
	{
		return -5;
	}
	if (lQ <= l && r <= rQ)
	{
		return mxtreeX[ind];
	}
	int m = (l + r) / 2;
	return max(getXmx(l, m, ind * 2, lQ, rQ), getXmx(m, r, ind * 2 + 1, lQ, rQ));
}
int getY(int l, int r, int ind, int lQ, int rQ)
{
	if (rQ <= l || r <= lQ)
	{
		return 1e9;
	}
	if (lQ <= l && r <= rQ)
	{
		return otrtreeY[ind];
	}
	int m = (l + r) / 2;
	return min(getY(l, m, ind * 2, lQ, rQ), getY(m, r, ind * 2 + 1, lQ, rQ));
}
int getYmx(int l, int r, int ind, int lQ, int rQ)
{
	if (rQ <= l || r <= lQ)
	{
		return -5;
	}
	if (lQ <= l && r <= rQ)
	{
		return mxtreeY[ind];
	}
	int m = (l + r) / 2;
	return max(getYmx(l, m, ind * 2, lQ, rQ), getYmx(m, r, ind * 2 + 1, lQ, rQ));
}
int32_t main()
{
	ios_base::sync_with_stdio(0);
	//mt19937 rnd(time(0));
	int n, m, q;
	cin >> n >> m >> q;
	nX = nY = 1;
	while (nX < n)
	{
		nX *= 2;
	}
	while (nY < m)
	{
		nY *= 2;
	}
	otrtreeX.assign(nX * 2, -1);
	mxtreeX.assign(nX * 2, -1);
	otrtreeY.assign(nY * 2, -1);
	mxtreeY.assign(nY * 2, -1);
	vector<int>lX(n, -1), lY(m, -1);
	for (int i = 0; i < q; ++i)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int k;
			cin >> k;
			--k;
			updX(1, nX + 1, 1, k + 1, i);
			lX[k] = i;
		}
		elif(t == 2)
		{
			int k;
			cin >> k;
			--k;
			updY(1, nY + 1, 1, k + 1, i);
			lY[k] = i;
		}
		elif (t == 3)
		{
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			int fr = i - k;//only by paths that appeared between FR and now
			if (fr < 0)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			--x1;
			--x2;
			--y1;
			--y2;
			if (getX(1, nX + 1, 1, min(x1, x2) + 1, max(x1, x2) + 2) >= fr || getY(1, nY + 1, 1, min(y1, y2) + 1, max(y1, y2) + 2) >= fr)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			int h1 = (lX[x1] >= fr), v1 = (lY[y1] >= fr), h2 = (lX[x2] >= fr), v2 = (lY[y2] >= fr);
			if ((h1 && v2) || (h2 && v1))
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			if (h1 == v1 && h1 == 0)
			{
				cout << "-1\n";
				continue;
			}
			elif(h2 == v2 && h2 == 0)
			{
				cout << "-1\n";
				continue;
			}
			if (v1&&v2&&getXmx(1, nX + 1, 1, min(x1, x2) + 1, max(x1, x2) + 2) >= fr)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			if (h1&&h2&&getYmx(1, nY + 1, 1, min(y1, y2) + 1, max(y1, y2) + 2) >= fr)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			//cout << "hmmmmm\n";
			if (v1&&v2)
			{
				int pdist = n + m + 666;
				for (int i = min(x1, x2) - 1; i >= 0; --i)
				{
					if (lX[i] >= fr)
					{
						pdist = min(pdist, min(x1, x2) - i);
						break;
					}
				}
				for (int i = max(x1, x2) + 1; i < n; ++i)
				{
					if (lX[i] >= fr)
					{
						pdist = min(pdist, i - max(x1, x2));
						break;
					}
				}
				if (pdist == n + m + 666)
				{
					cout << "-1\n";
					continue;
				}
				cout << pdist * 2 + abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			else
			{
				int pdist = n + m + 666;
				for (int i = min(y1, y2) - 1; i >= 0; --i)
				{
					if (lY[i] >= fr)
					{
						pdist = min(pdist, min(y1, y2) - i);
						break;
					}
				}
				for (int i = max(y1, y2) + 1; i < m; ++i)
				{
					if (lY[i] >= fr)
					{
						pdist = min(pdist, i - max(y1, y2));
						break;
					}
				}
				if (pdist == n + m + 666)
				{
					cout << "-1\n";
					continue;
				}
				cout << pdist * 2 + abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
		}
	}
	return 0;
}