#include <iostream>
#include <deque>
#include <map>

using namespace std;

typedef pair<int, int> Cell;

int *cTI, *cTJ;

int getTime(int curTime, int i, int j) {
    return curTime - max(cTI[i], cTJ[j]);
}

int dI[] = {1, -1, 0, 0};
int dJ[] = {0, 0, 1, -1};

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    cTI = new int[n];
    cTJ = new int[m];
    fill(cTI, cTI + n, 0);
    fill(cTJ, cTJ + m, 0);
    for (int curTime = 1; curTime <= q; ++curTime) {
        int type;
        cin >> type;
        if (type == 1) {
            int i;
            cin >> i;
            i--;
            cTI[i] = curTime;
        } else if (type == 2) {
            int j;
            cin >> j;
            j--;
            cTJ[j] = curTime;
        } else if (type == 3) {
            int i1, j1, i2, j2, k;
            cin >> i1 >> j1 >> i2 >> j2 >> k;
            i1--, j1--, i2--, j2--;
            deque<Cell> queue;
            map<Cell, int> dist;
            queue.emplace_back(i1, j1);
            if (getTime(curTime, i1, j1) > k) {
                cout << "-1\n";
                continue;
            }
            dist[{i1, j1}] = 0;
            while (!queue.empty()) {
                auto &[i, j] = queue.front();
                queue.pop_front();
                for (int st = 0; st < 4; ++st) {
                    int newI = i + dI[st];
                    int newJ = j + dJ[st];
                    if (newI >= 0 && newI < n && newJ >= 0 && newJ < m) {
                        int snow = getTime(curTime, newI, newJ);
                        if (snow <= k) {
                            int curD = dist[{i, j}] + 1;
                            Cell c = {newI, newJ};
                            bool contains = (dist.find(c) != dist.end());
                            if (curD < dist[c] || !contains) {
                                queue.emplace_back(newI, newJ);
                                dist[{newI, newJ}] = dist[{i, j}] + 1;
                            }
                        }
                    }
                }
            }
            if (dist.find({i2, j2}) == dist.end()) {
                cout << "-1\n";
            } else {
                cout << dist[{i2, j2}] << "\n";
            }
        }
    }


    return 0;
}