#include <iostream>
#include <deque>
#include <map>
#include <cassert>
#include <queue>

#define FAST_MEM (int)5e8

#ifdef FAST_MEM

char mem[FAST_MEM];
int allPos = 0;

void *operator new(size_t n) {
    char *res = mem + allPos;
    allPos += n;
    assert(allPos <= FAST_MEM);
    return (void *) res;
}

void operator delete(void *) noexcept {

}

#endif

using namespace std;

typedef pair<int, int> Cell;

int *cTI, *cTJ;

int getTime(int curTime, int i, int j) {
    return curTime - max(cTI[i], cTJ[j]);
}

int dI[] = {1, -1, 0, 0};
int dJ[] = {0, 0, 1, -1};

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    cTI = new int[n];
    cTJ = new int[m];
    fill(cTI, cTI + n, 0);
    fill(cTJ, cTJ + m, 0);
    map<Cell, int> dist;
    vector<Cell> queue(n * m + 5);
    int qPos = 0;
    int startQ = 0;
    for (int curTime = 1; curTime <= q; ++curTime) {

        int type;
        cin >> type;
        if (type == 1) {
            int i;
            cin >> i;
            i--;
            cTI[i] = curTime;
        } else if (type == 2) {
            int j;
            cin >> j;
            j--;
            cTJ[j] = curTime;
        } else if (type == 3) {
            int i1, j1, i2, j2, k;
            cin >> i1 >> j1 >> i2 >> j2 >> k;
            i1--, j1--, i2--, j2--;
            qPos = 0;
            startQ = 0;
            queue[qPos++] = {i1, j1};
            dist.clear();
            if (getTime(curTime, i1, j1) > k) {
                cout << "-1\n";
                continue;
            }
            dist[{i1, j1}] = 0;
            while (startQ < qPos) {
                auto &[i, j] = queue[startQ++];
                for (int st = 0; st < 4; ++st) {
                    int newI = i + dI[st];
                    int newJ = j + dJ[st];
                    if (newI >= 0 && newI < n && newJ >= 0 && newJ < m) {
                        int snow = getTime(curTime, newI, newJ);
                        if (snow <= k) {
                            int curD = dist[{i, j}] + 1;
                            Cell c = {newI, newJ};
                            bool contains = (dist.find(c) != dist.end());
                            if (curD < dist[c] || !contains) {
                                queue[qPos++] = {newI, newJ};
                                dist[{newI, newJ}] = dist[{i, j}] + 1;
                            }
                        }
                    }
                }
            }
            if (dist.find({i2, j2}) == dist.end()) {
                cout << "-1\n";
            } else {
                cout << dist[{i2, j2}] << "\n";
            }
        }
    }


    return 0;
}