#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

struct Edge {
    int to;
    ll w;

    Edge(int to, ll w) : to(to), w(w) {}
};

ll p;

vector<vector<Edge>> g;
vector<vector<pair<ll, int>>> queries;
vector<int> ans;
vector<ll> cost;

ll divide(ll a, ll b) {
    return (a + b - 1) / b;
}

void dfs(int v, int startFrom = 0) {
    for (auto &[u, w]:g[v]) {
        int costSz = cost.size();
        for (int i = startFrom; i < costSz; ++i) {
            cost.push_back(cost[i] + w);
        }
        dfs(u, costSz);
        while (cost.size() > costSz) {
            cost.pop_back();
        }
    }
    for (auto &[time, ind]:queries[v]) {
        ll l = time;
        ll r = (time * p) / (p - 1);
        for (int j = startFrom; j < cost.size(); j++) {
            ll c = cost[j];
            if (l <= c && c <= r) {
                ans[ind] = 1;
            }
        }
    }
}

void solve() {
    int n, m, q;
    cin >> n >> m >> q >> p;
    g.clear();
    g.resize(n);
    ans.clear();
    ans.resize(q);
    queries.clear();
    queries.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        ll d;
        cin >> d;
        g[v].push_back(Edge(u, d));
    }
    for (int i = 0; i < q; ++i) {
        int to;
        ll r;
        cin >> to >> r;
        to--;
        queries[to].emplace_back(r, i);
    }
    cost.clear();
    cost.push_back(0);
    dfs(0);
    for (int x:ans) {
        cout << x;
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

    return 0;
}