import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class D {

    public boolean query(int x) throws Exception {
        out.println("? " + x);
        out.flush();
        return nextToken().startsWith("Y");
    }

    boolean broken = false;

    public boolean realQuery(int x) throws Exception {
        int cnt = 0;
        if (query(x)) {
            cnt++;
        }
        if (broken) {
            return cnt > 0;
        }
        if (query(x)) {
            cnt++;
        }
        if (cnt == 2) {
            return true;
        }
        if (cnt == 0) {
            return false;
        }
        broken = true;
        if (query(x)) {
            cnt++;
        }
        return cnt >= 2;
    }

    public void solve() throws Exception {
        int n = nextInt();
        while (true) {
            broken = false;
            int l = 1;
            int r = n + 1;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (realQuery(m)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            out.println("! " + l);
            out.flush();
            String ans = nextToken();
            if (ans.equals("Done")) {
                return;
            }
        }
    }

    public void run() throws Exception {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        solve();
        br.close();
        out.close();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws Exception {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws Exception {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws Exception {
        new D().run();
    }
}
