#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int INF = 1e9;

struct tree {
	int n = 0;
	vector<pair<int, int>> tr; //min max
	
	tree (int n1) {
		n = n1;
		tr.resize(n * 4);
	}
	
	void upd (int i, int x, int v = 0, int vl = 0, int vr = -1) {
		if (vr == -1)
			vr = n;
		if (vr <= i || vl > i)
			return;
		if (vr - vl == 1) {
			tr[v] = {x, x};
			return;
		}
		int m = (vr + vl) / 2;
		upd(i, x, v * 2 + 1, vl, m);
		upd(i, x, v * 2 + 2, m, vr);
		tr[v].first = min(tr[v * 2 + 1].first, tr[v * 2 + 2].first);
		tr[v].second = max(tr[v * 2 + 1].second, tr[v * 2 + 2].second);
	}

	int get_min (int l, int r, int v = 0, int vl = 0, int vr = -1) {
		if (vr == -1)
			vr = n;
		if (vr <= l || r <= vl)
			return INF;
		if (l <= vl && vr <= r)
			return tr[v].first;
		int m = (vr + vl) / 2;
		return std::min(get_min(l, r, v * 2 + 1, vl, m), get_min(l, r, v * 2 + 2, m, vr));
	}

	int get_prev (int i, int x, int v = 0, int vl = 0, int vr = -1) {
		if (vr == -1)
			vr = n;
		if (vl > i)
			return -INF;
		int m = (vr + vl) / 2;
		if (vr > i + 1) {
			return std::max(get_prev(i, x, v * 2 + 1, vl, m), get_prev(i, x, v * 2 + 2, m, vr));
		}
		if (vr - vl == 1) {
			if (tr[v].second >= x)
				return vl;
			return -INF;
		}
		if (tr[v * 2 + 2].second >= x)
			return get_prev(i, x, v * 2 + 2, m, vr);
		return get_prev(i, x, v * 2 + 1, vl, m);
	}

	int get_suf (int i, int x, int v = 0, int vl = 0, int vr = -1) {
		if (vr == -1)
			vr = n;
		if (vr <= i)
			return INF;
		int m = (vr + vl) / 2;
		if (vl < i) {
			return std::min(get_suf(i, x, v * 2 + 1, vl, m), get_suf(i, x, v * 2 + 2, m, vr));
		}
		if (vr - vl == 1) {
			if (tr[v].second >= x)
				return vl;
			return INF;
		}
		if (tr[v * 2 + 1].second >= x)
			return get_suf(i, x, v * 2 + 1, vl, m);
		return get_suf(i, x, v * 2 + 2, m, vr);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m, q;
	cin >> n >> m >> q;
	
	vector<int> row(n), col(m);
	
	for (int t = 1; t <= q; ++t) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int r;
			cin >> r;
			row[r - 1] = t;
		}
		if (tp == 2) {
			int c;
			cin >> c;
			col[c - 1] = t;
		}
		if (tp == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --c1, --r2, --c2;
			int ra, ca, rb, cb;
			ra = row[r1];
			rb = row[r2];
			ca = col[c1];
			cb = col[c2];
			
			if ((ra < t - k && ca < t - k) || (rb < t - k && cb < t - k)) {
				cout << "-1\n";
				continue;
			}
			if ((ra >= t - k && cb >= t - k) || (rb >= t - k && ca >= t - k)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			if (r1 > r2) {
				swap(r1, r2);
				swap(c1, c2);
				swap(ra, rb);
				swap(ca, cb);
			}
			int m = INF;
			for (int i = r1; i <= r2; ++i)
				m = min(m, row[i]);
			if (m >= t - k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			if (c1 > c2) {
				swap(c1, c1);
				swap(r1, r1);
				swap(ra, rb);
				swap(ca, cb);
			}
			m = INF;
			for (int i = c1; i <= c2; ++i)
				m = min(m, col[i]);
			if (m >= t - k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			if (ra >= t - k && rb >= t - k) {
				
				if (c1 > c2) {
					swap(c1, c2);
					swap(r1, r2);
					swap(ra, rb);
					swap(ca, cb);
				}
				int s1 = -INF, s2 = INF;
				for (int i = 0; i <= c2; ++i)
					if (col[i] >= t - k)
						s1 = i;
				for (int i = col.size() - 1; i >= c1; --i)
					if (col[i] >= t - k)
						s2 = i;
				if (s1 == -INF && s2 == INF) {
					cout << "-1\n";
					continue;
				}
				int ans = abs(r1 - r2) + std::min(abs(s1 - c1) + abs(s1 - c2), abs(s2 - c1) + abs(s2 - c2));
				cout << ans << '\n';
				continue;
			}
			if (ca >= t - k && cb >= t - k) {
				
				if (r1 > r2) {
					swap(c1, c2);
					swap(r1, r2);
					swap(ra, rb);
					swap(ca, cb);
				}
				int s1 = -INF, s2 = INF;
				for (int i = 0; i <= r2; ++i)
					if (row[i] >= t - k)
						s1 = i;
				for (int i = row.size() - 1; i >= r1; --i)
					if (row[i] >= t - k)
						s2 = i;
				//s1 = row.get_prev(r2, t - k);
				//s2 = row.get_suf(r1, t - k);
				if (s1 == -INF && s2 == INF) {
					cout << "-1\n";
					continue;
				}
				int ans = abs(c1 - c2) + std::min(abs(s1 - r1) + abs(s1 - r2), abs(s2 - r1) + abs(s2 - r2));
				cout << ans << '\n';
				continue;
			}
			assert(false);
		}
	}

	return 0;
}
