//#define GLIBXX_DEBUG

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int INF = 1e9;

vector<vector<int>> f;
vector<pair<int, int>> move1 = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}};

int n, m;

int bfs (int x, int y, int xf, int yf, int k) {
	vector<pair<int, int>> q = {{x, y}};
	if (f[x][y] < k)
		return -1;
	map<pair<int, int>, bool> used;
	used[{x, y}] = true;
	map<pair<int, int>, int> dist;
	while (!q.empty() && dist[q.back()] < 2 * (n + m)) {
		auto p = q.back();
		q.pop_back();
		int x = p.first, y = p.second;
		if (x == xf && y == yf)
			return dist[{x, y}];
		for (auto p1 : move1) {
			int x1 = x + p1.first, y1 = y + p1.second;
			if (x1 < 0 || x1 > f.size() - 1 || y1 < 0 || y1 > f[0].size() - 1)
				continue;
			if (f[x1][y1] >= k && !used[{x1, y1}]) {
				used[{x1, y1}] = true;
				dist[{x1, y1}] = dist[{x, y}] + 1;
				q.push_back({x1, y1});
			}
		}
	}
	return -1;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	
	int q;
	cin >> n >> m >> q;
	f.resize(n, vector<int> (m));
	for (int t = 1; t <= q; ++t) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int r;
			cin >> r;
			--r;
			for (int i = 0; i < m; ++i)
				f[r][i] = t;
		}
		if (tp == 2) {
			int c;
			cin >> c;
			--c;
			for (int i = 0; i < n; ++i)
				f[i][c] = t;
		}
		if (tp == 3) {
			int r1, r2, c1, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			--r1, --r2, --c1, --c2;
			int ans = bfs(r1, c1, r2, c2, t - k);
			cout << ans << '\n';
		}
	}
	return 0;
}
