#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")

#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

const int SZ = 5000 + 10;
const ll INF = 5e17;
const int LEN = 5e5 + 100;

int n, m, q;
ll p;
bool dp[SZ][SZ];

void slow_solve()
{
    int x, y;
    ll d;
    vector< pair<int, ll> > v[20];
    set<ll> st[20];
    st[0].insert(0);

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        v[y].push_back({x, d});
    }

    int from;
    ll cost;
    set<ll>::iterator it;
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            from = v[i][j].first;
            cost = v[i][j].second;
            for (it = st[from].begin(); it != st[from].end(); it++)
            {
                st[i].insert(cost + *it);
            }
        }
    }

    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

        it = st[x].lower_bound(d);
        if (it == st[x].end())
        {
            cout << 0;
            continue;
        }
        cost = *it;
        if (cost * (p - 1ll) <= p * d) cout << 1;
        else cout << 0;
    }
}

void dp_solve()
{
    int x, y;
    ll d;
    vector< pair<int, ll> > v[SZ];

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        v[y].push_back({x, d});
    }

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < SZ; j++)
        {
            dp[i][j] = false;
        }
    }
    dp[0][0] = true;

    int from;
    ll cost;
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < v[i].size(); j++)
        {
            from = v[i][j].first;
            cost = v[i][j].second;
            for (int pos = 0; pos < SZ; pos++)
            {
                if (!dp[from][pos]) continue;
                if ((pos + cost) >= SZ) break;
                dp[i][pos + cost] = true;
            }
        }
    }

    for (int i = 0; i < q; i++)
    {
        cin >> x >> d;
        x--;

        int ind;
        ind = d;

        bool used = false;
        while (true)
        {
            if (ind >= SZ) break;
            if ((p - 1) * ind > p * d) break;
            if (dp[x][ind])
            {
                used = true;
                break;
            }
            ind++;
        }

        if (used) cout << 1;
        else cout << 0;
    }
}

int get_rand()
{
    int res = rand();
    res *= rand();
    return res;
}

void two_solve()
{
    int x, y;
    ll d;

    ll down[LEN];
    ll up[LEN];

    for (int i = 0; i < n; i++)
    {
        down[i] = INF;
        up[i] = 0;
    }

    for (int i = 0; i < m; i++)
    {
        cin >> x >> y >> d;
        x--;
        y--;
        down[y] = min(down[y], d);
        up[y] = max(up[y], d);
    }

    ll p[LEN];
    p[0] = 0;
    for (int i = 1; i < n; i++)
    {
        p[i] = p[i - 1] + down[i];
        up[i] -= down[i];
    }
    set<int> used;

    for (int step = 0; step < q; step++)
    {
        cin >> x >> d;
        ll D = 2ll * d;
        x--;
        used.clear();

        ll cur;
        cur = p[x];

        bool cur_ans = false;
        for (int iter = 0; iter < 20000; iter++)
        {
            int pos;
            pos = 1 + (get_rand() % x);

            if (cur >= d && cur <= D)
            {
                cur_ans = true;
                break;
            }
            if (cur < d && (used.find(pos) == used.end()))
            {
                used.insert(pos);
                cur += up[pos];
                continue;
            }
            if (cur > D && used.size() > 0)
            {
                cur -= up[*used.begin()];
                used.erase(used.begin());
            }
        }
        if (cur_ans) cout << 1;
        else cout << 0;
    }
}

int main()
{
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
    {
        cin >> n >> m >> q >> p;
        if (n <= 10 && m <= 10)
        {
            slow_solve();
            cout << "\n";
            continue;
        }
        if (m == (2 * n - 2) && p == 2 && q <= 10)
        {
            two_solve();
            cout << "\n";
            continue;
        }
        else
        {
            dp_solve();
            cout << "\n";
            continue;
        }
    }


    return 0;
}
