#include <bits/stdc++.h>

using namespace std;

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 100;
int row[MAXN], col[MAXN], arrR[MAXN], arrC[MAXN], rpos[MAXN * 4], cpos[MAXN * 4];

void update_rpos(int v, int tl, int tr, int pos, int val) {
	if (tl + 1 == tr) {
		rpos[v] = val;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos < tm) {
		update_rpos(v * 2 + 1, tl, tm, pos, val);
	}
	else {
		update_rpos(v * 2 + 2, tm, tr, pos, val);
	}
	rpos[v] = min(rpos[v * 2 + 1], rpos[v * 2 + 2]);
}

int get_rpos(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l) {
		return 0;
	}
	if (tl >= l && tr <= r) {
		return rpos[v];
	}
	int tm = (tl + tr) >> 1;
	int a = get_rpos(v * 2 + 1, tl, tm, l, r);
	int b = get_rpos(v * 2 + 2, tm, tr, l, r);
	return min(a, b);
}

void update_cpos(int v, int tl, int tr, int pos, int val) {
	if (tl + 1 == tr) {
		cpos[v] = val;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos < tm) {
		update_cpos(v * 2 + 1, tl, tm, pos, val);
	}
	else {
		update_cpos(v * 2 + 2, tm, tr, pos, val);
	}
	cpos[v] = min(cpos[v * 2 + 1], cpos[v * 2 + 2]);
}

int get_cpos(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l) {
		return 0;
	}
	if (tl >= l && tr <= r) {
		return cpos[v];
	}
	int tm = (tl + tr) >> 1;
	int a = get_cpos(v * 2 + 1, tl, tm, l, r);
	int b = get_cpos(v * 2 + 2, tm, tr, l, r);
	return min(a, b);
}

signed main() {
	FAST_IO();
	int n, m, q;
	cin >> n >> m >> q;
	fill(row, row + MAXN, -INF);
	fill(col, col + MAXN, -INF);
	int mx = 0;
	set<int> rows, cols;
	for (int i = 1; i <= q; ++i) {
		mx++;
		int t;
		cin >> t;
		if (t == 1) {
			int r;
			cin >> r;
			row[r] = i;
			arrR[i] = r;
			update_rpos(0, 0, n, r - 1, i);
		}
		else if (t == 2) {
			int c;
			cin >> c;
			col[c] = i;
			arrC[i] = c;
			update_cpos(0, 0, m, c - 1, i);
		}
		else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			if (k >= mx) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			int need = mx - k;
			if (row[r1] < need && col[c1] < need || row[r2] < need && col[c2] < need) {
				cout << -1 << '\n';
				continue;
			}
			if (row[r1] >= need && col[c2] >= need || row[r2] >= need && col[c1] >= need) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue; 
			}
			if (r1 == r2 && row[r1] >= need || c1 == c2 && col[c1] >= need) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			if (row[r1] >= need && row[r2] >= need) {
               	if (get_rpos(0, 0, n, min(r1, r2) - 1, max(r1, r2)) >= need) {
               		cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                    continue; 
               	}
                int ans = INF;
                for (int j = need; j < i; ++j) {
                    if (arrC[j] == 0) {
                        continue;
                    }   
                    ans = min(ans, abs(r1 - r2) + abs(c1 - arrC[j]) + abs(c2 - arrC[j]));
                }
                cout << (ans == INF ? -1 : ans) << '\n';
                continue;
            }
            if (col[c1] >= need && col[c2] >= need) {
                set<int> setik;
                int ans = INF;
                for (int j = need; j < i; ++j) {
                    if (arrC[j] >= min(c1, c2) && arrC[j] <= max(c1, c2)) {
                        setik.insert(arrC[j]);
                    }
                    if (arrR[j] == 0) {
                        continue;
                    }   
                    ans = min(ans, abs(c1 - c2) + abs(r1 - arrR[j]) + abs(r2 - arrR[j]));
                }
                if (setik.size() == abs(c1 - c2) + 1) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                    continue; 
                }
                cout << (ans == INF ? -1 : ans) << '\n';
                continue;
            }
            assert(false);
		}
	}
}