#include <bits/stdc++.h>
 
using namespace std;
 
void FAST_IO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

struct node {
	int sum;
	node *l, *r;

	node() : sum(0), l(nullptr), r(nullptr) {};
};
 
const int INF = 1e9 + 7;
const int MAXN = 1e6 + 100;
int row[MAXN], col[MAXN], arrR[MAXN], arrC[MAXN], rpos[MAXN * 4], cpos[MAXN * 4];
node *treeR[MAXN], *treeC[MAXN];
 
void update_rpos(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        rpos[v] = val;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos < tm) {
        update_rpos(v * 2 + 1, tl, tm, pos, val);
    }
    else {
        update_rpos(v * 2 + 2, tm, tr, pos, val);
    }
    rpos[v] = min(rpos[v * 2 + 1], rpos[v * 2 + 2]);
}
 
int get_rpos(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l) {
        return INF;
    }
    if (tl >= l && tr <= r) {
        return rpos[v];
    }
    int tm = (tl + tr) >> 1;
    int a = get_rpos(v * 2 + 1, tl, tm, l, r);
    int b = get_rpos(v * 2 + 2, tm, tr, l, r);
    return min(a, b);
}
 
void update_cpos(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        cpos[v] = val;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos < tm) {
        update_cpos(v * 2 + 1, tl, tm, pos, val);
    }
    else {
        update_cpos(v * 2 + 2, tm, tr, pos, val);
    }
    cpos[v] = min(cpos[v * 2 + 1], cpos[v * 2 + 2]);
}
 
int get_cpos(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l) {
        return INF;
    }
    if (tl >= l && tr <= r) {
        return cpos[v];
    }
    int tm = (tl + tr) >> 1;
    int a = get_cpos(v * 2 + 1, tl, tm, l, r);
    int b = get_cpos(v * 2 + 2, tm, tr, l, r);
    return min(a, b);
}
 
void build(node *&root, int tl, int tr) {
	root = new node();
	if (tl + 1 == tr) {
		return;
	}	
	int tm = (tl + tr) >> 1;
	build(root->l, tl, tm);
	build(root->r, tm, tr);
}

void update(node *&root, node *&prev, int tl, int tr, int pos) {
	root = new node();
	if (tl + 1 == tr) {
		root->sum = prev->sum + 1;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos < tm) {
		root->r = prev->r;
		update(root->l, prev->l, tl, tm, pos);
	}
	else {
		root->l = prev->l;
		update(root->r, prev->r, tm, tr, pos);
	}
	root->sum = root->l->sum + root->r->sum;
}

int getBig(node *&root, node *&prev, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l || root->sum - prev->sum == 0) {
		return -1;
	}
	if (tl + 1 == tr) {
		return tl;
	}
	int tm = (tl + tr) >> 1;
	int res = getBig(root->l, prev->l, tl, tm, l, r);
	if (res == -1) {
		return getBig(root->r, prev->r, tm, tr, l, r);
	}
	else {
		return res;
	}
}

int getSmall(node *&root, node *&prev, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l || root->sum - prev->sum == 0) {
		return -1;
	}
	if (tl + 1 == tr) {
		return tl;
	}
	int tm = (tl + tr) >> 1;
	int res = getSmall(root->r, prev->r, tm, tr, l, r);
	if (res == -1) {
		return getSmall(root->l, prev->l, tl, tm, l, r);
	}
	else {
		return res;
	}
}

signed main() {
    FAST_IO();
    int n, m, q;
    cin >> n >> m >> q;
    int mx = 0;
    build(treeR[0], 0, n);
    build(treeC[0], 0, m);
    for (int i = 1; i <= q; ++i) {
        mx++;
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            row[r] = i;
            arrR[i] = r;
            update_rpos(0, 0, n, r - 1, i);
            update(treeR[i], treeR[i - 1], 0, n, r - 1);
            treeC[i] = treeC[i - 1];
        }
        else if (t == 2) {
            int c;
            cin >> c;
            col[c] = i;
            arrC[i] = c;
            update_cpos(0, 0, m, c - 1, i);
            treeR[i] = treeR[i - 1];
            update(treeC[i], treeC[i - 1], 0, m, c - 1);
        }
        else {
        	treeR[i] = treeR[i - 1];
        	treeC[i] = treeC[i - 1];
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            if (k >= mx) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
            int need = mx - k;
            if (row[r1] < need && col[c1] < need || row[r2] < need && col[c2] < need) {
                cout << -1 << '\n';
                continue;
            }
            if (row[r1] >= need && col[c2] >= need || row[r2] >= need && col[c1] >= need) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue; 
            }
            if (r1 == r2 && row[r1] >= need || c1 == c2 && col[c1] >= need) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
            if (row[r1] >= need && row[r2] >= need) {
                if (get_rpos(0, 0, n, min(r1, r2) - 1, max(r1, r2)) >= need) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                    continue; 
                }
                int ans = INF;
                int bg = getBig(treeC[i], treeC[need - 1], 0, m, min(c1, c2) - 1, m);
                if (bg != -1) {
                	ans = min(ans, abs(r1 - r2) + abs(c1 - bg - 1) + abs(c2 - bg - 1));
                }
                int sm = getSmall(treeC[i], treeC[need - 1], 0, m, 0, min(c1, c2));
                if (sm != -1) {
                	ans = min(ans, abs(r1 - r2) + abs(c1 - sm - 1) + abs(c2 - sm - 1));
                }
                cout << (ans == INF ? -1 : ans) << '\n';
                continue;
            }
            if (col[c1] >= need && col[c2] >= need) {
                if (get_cpos(0, 0, m, min(c1, c2) - 1, max(c1, c2)) >= need) {
                    cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                    continue; 
                }
                int ans = INF;
                int bg = getBig(treeR[i], treeR[need - 1], 0, n, min(r1, r2) - 1, n);
                if (bg != -1) {
                	ans = min(ans, abs(c1 - c2) + abs(r1 - bg - 1) + abs(r2 - bg - 1));
                }
                int sm = getSmall(treeR[i], treeR[need - 1], 0, n, 0, min(r1, r2));
                if (sm != -1) {
                	ans = min(ans, abs(c1 - c2) + abs(r1 - sm - 1) + abs(r2 - sm - 1));
                }
                cout << (ans == INF ? -1 : ans) << '\n';
                continue;
            }
            assert(false);
        }
    }
}