#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,avx,avx2,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
   
using namespace std;
using namespace __gnu_pbds;
   
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T> using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
  
#define all(x) (x).begin(), (x).end()
//#define int long long
  
void FAST_IO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
  
const int MAXN = 5e5 + 100;
vector<ll> in[MAXN];
vector<pll> qs[MAXN];
ll t[MAXN * 4];
int ans[MAXN];

void update(int v, int tl, int tr, int pos, ll val) {
	if (tl + 1 == tr) {
		t[v] += val;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos < tm) {
		update(v * 2 + 1, tl, tm, pos, val);
	}
	else {
		update(v * 2 + 2, tm, tr, pos, val);
	}
	t[v] = t[v * 2 + 1] + t[v * 2 + 2];
}

ll getf(int v, int tl, int tr, ll need) {
	if (tl + 1 == tr) {
		return t[v];
	}
	int tm = (tl + tr) >> 1;
	if (t[v * 2 + 1] >= need) {
		return getf(v * 2 + 1, tl, tm, need);
	}
	else {
		return getf(v * 2 + 2, tm, tr, need - t[v * 2 + 1]) + t[v * 2 + 1];
	}
}

int getpos(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l || t[v] == 0) {
		return -1;
	}
	if (tl + 1 == tr) {
		return tl;
	}
	int tm = (tl + tr) >> 1;
	int res = getpos(v * 2 + 1, tl, tm, l, r);
	if (res == -1) {
		return getpos(v * 2 + 2, tm, tr, l, r);
	}
	else {
		return res;
	}
}

void solve() {
    int n, m, q, p;
    scanf("%d%d%d%d", &n, &m, &q, &p);
    for (int i = 0; i < n; ++i) {
        in[i].clear();
        qs[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll w;
        scanf("%d%d%lld", &u, &v, &w);
        u--;
        v--;
        in[v].push_back(w);
    }
    for (int i = 0; i < q; ++i) {
    	int to;
    	ll lf;
    	scanf("%d%lld", &to, &lf);
    	to--;
    	qs[to].push_back({lf, i});
    }
    vector<ll> dx;
    for (int i = 1; i < n; ++i) {
    	sort(all(in[i]));
    	dx.push_back(in[i][1] - in[i][0]);
    }
    sort(all(dx));
    dx.resize(unique(all(dx)) - dx.begin());
    int sz = dx.size();
    fill(t, t + sz * 4, 0);
    ll cur = 0;
    for (int i = 1; i < n; ++i) {
    	cur += in[i][0];
    	int pos = lower_bound(all(dx), in[i][1] - in[i][0]) - dx.begin();
    	update(0, 0, sz, pos, dx[pos]);
    	for (auto &[lf, id] : qs[i]) {
    		if (cur > 2 * lf) {
    			ans[id] = 0;
    			continue;
    		}
    		if (cur >= lf) {
    			ans[id] = 1;
    			continue;
    		}
    		if (cur + t[0] < lf) {
    			ans[id] = 0;
    			continue;
    		}
    		ll res = getf(0, 0, sz, lf - cur);
    		if (cur + res <= 2 * lf) {
    			ans[id] = 1;
    			continue;
    		}
    		ll need = cur + res - 2 * lf;
    		int p = lower_bound(all(dx), need) - dx.begin();
    		pos = getpos(0, 0, sz, p, sz);
    		res -= dx[pos];
    		if (cur + res >= lf) {
    			ans[id] = 1;
    		}
    		else {
    			ans[id] = 0;
    		}
    	}
    }
    for (int i = 0; i < q; ++i) {
    	printf("%c", '0' + ans[i]);
    }
    printf("\n");
}
  
signed main() {
    FAST_IO();
    int t;
    scanf("%d", &t);
    while (t--) {
        solve();
    }
}