#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 5050;
vector<pii> g[MAXN];
vector<int> order;
set<int> poss[MAXN];
bool used[MAXN];
int mx;

void toposort(int u) {
	used[u] = true;
	for (auto &[to, w] : g[u]) {
		if (!used[to]) {
			toposort(to);
		}
	}
	order.push_back(u);
}

void relax(int u) {
	for (auto &[to, w] : g[u]) {
		for (int x : poss[u]) {
			if (x + w <= mx) {
				poss[to].insert(x + w);
			}
		}
	}
}

void solve() {
	int n, m, q, p;
    cin >> n >> m >> q >> p;
    mx = (5000 * p) / (p - 1);
    for (int i = 0; i < n; ++i) {
    	g[i].clear();
    	poss[i].clear();
    	used[i] = false;
    }
    order.clear();
    for (int i = 0; i < m; ++i) {
    	int u, v;
    	int w;
    	cin >> u >> v >> w;
    	u--;
    	v--;
    	g[u].push_back({v, w});
    }
    toposort(0);
    reverse(all(order));
    poss[0].insert(0);
    for (int i : order) {
    	relax(i);
    }
  	while (q--) {
  		int to;
  		int lf;
  		cin >> to >> lf;
  		to--;
  		int rg = (lf * p) / (p - 1);
  		auto it = poss[to].lower_bound(lf);
  		bool flag = (it != poss[to].end() && *it <= rg);
  		cout << char('0' + flag);
  	}
  	cout << '\n';
}

signed main() {
    FAST_IO();
    int t;
    cin >> t;
    while (t--) {
    	solve();
    }
}