#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#define dst abs(u.x1 - u.x2) + abs(u.y1 - u.y2)
#define x first
#define y second
#define mp make_pair
using namespace std;
const int inf = 1e9;
const int N = 3e5;

struct query_t
{
    int x1, y1, x2, y2, l, r;
    query_t(int x1, int y1, int x2, int y2, int l, int r): x1(x1), y1(y1), x2(x2), y2(y2), l(l), r(r) {}
};

int n, m, q;

int ans_query(query_t u, vector<pair<int,int>>& horev, vector<pair<int,int>>& vertev)
{
    if (u.l < 0)
        return dst;
    bool a[n][m];
    for (int i = 0; i < n; ++i)
        fill(a[i], a[i] + m, 0);
    auto hl = lower_bound(horev.begin(), horev.end(), mp(u.l, 0)), hr = lower_bound(horev.begin(), horev.end(), mp(u.r, 0));
    auto vl = lower_bound(vertev.begin(), vertev.end(), mp(u.l, 0)), vr = lower_bound(vertev.begin(), vertev.end(), mp(u.r, 0));
    for (auto it = hl; it != hr; it++)
    {
        int r = (*it).y;
        fill(a[r], a[r] + m, 1);
    }
    for (auto it = vl; it != vr; it++)
    {
        int r = (*it).y;
        for (int i = 0; i < n; ++i)
            a[i][r] = 1;
    }
    if (!a[u.x1][u.y1])
        return -1;
    queue<pair<int,int>> q;
    bool used[n][m];
    int md[n][m];
    for (int i = 0; i < n; ++i)
        fill(used[i], used[i] + m, false);
    q.push({u.x1, u.y1});
    for (int i = 0; i < n; ++i)
        fill(md[i], md[i] + m, inf);
    md[u.x1][u.y1] = 0;
    while (q.size())
    {
        pair<int,int> f = q.front();
        int dr = md[f.x][f.y] + 1;
        q.pop();
        used[f.x][f.y] = true;
        if (f.x && a[f.x-1][f.y] && !used[f.x-1][f.y] && dr < md[f.x-1][f.y])
            md[f.x-1][f.y] = dr, q.push({f.x-1, f.y});
        if (f.x < n - 1 && a[f.x+1][f.y] && !used[f.x+1][f.y] && dr < md[f.x+1][f.y])
            md[f.x+1][f.y] = dr, q.push({f.x+1, f.y});
        if (f.y && a[f.x][f.y-1] && !used[f.x][f.y-1] && dr < md[f.x][f.y-1])
            md[f.x][f.y-1] = dr, q.push({f.x, f.y-1});
        if (f.y < m - 1 && a[f.x][f.y+1] && !used[f.x][f.y+1] && dr < md[f.x][f.y+1])
            md[f.x][f.y+1] = dr, q.push({f.x, f.y+1});
    }
    return used[u.x2][u.y2] ? md[u.x2][u.y2] : -1;
}

void solve()
{
    vector<pair<int,int>> vertev, horev;
    vector<query_t> all;
    for (int i = 0; i < q; ++i)
    {
        int t, r;
        cin >> t;
        if (t == 1)
        {
            cin >> r, --r;
            horev.emplace_back(i, r);
        }
        if (t == 2)
        {
            cin >> r, --r;
            vertev.emplace_back(i, r);
        }
        if (t == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k, --x1, --y1, --x2, --y2;
            all.emplace_back(x1, y1, x2, y2, i - k, i);
        }
    }
    for (auto x: all)
        cout << ans_query(x, horev, vertev) << '\n';
}

int main()
{
    cin >> n >> m >> q;
    solve();
    return 0;
}
