#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#ifdef LOCAL
	#define debug(x) std::cout << #x << ": " << x << '\n';
#endif
typedef long long ll;
#ifndef LOCAL
	const int N = 1e6 + 100;
#endif
#ifdef LOCAL
	const int N = 100;
#endif
int cntR[N], cntC[N];
struct vertex {
	int min, max;
	vertex() { min = 1e9, max = -1e9; }

	vertex(int x) {
		min = max = x;
	}
	vertex(int a, int b) {
		min = a, max = b;
	}

	friend vertex operator+(vertex a, vertex b) {
		return vertex(std::min(a.min, b.min), std::max(a.max, b.max));
	}
};
struct seg_tree {
	vertex tree[4 * N];
	seg_tree() {}

	void upd(int v, int tl, int tr, int i, int x) {
		if (tl == tr) {
			tree[v] = vertex(x);
			return;
		}
		int tm = (tl + tr) / 2;
		if (tm >= i) {
			upd(v * 2, tl, tm, i, x);
		}
		else {
			upd(v * 2 + 1, tm + 1, tr, i, x);
		}
		tree[v] = tree[v * 2] + tree[v * 2 + 1];
	}
	vertex get(int v, int tl, int tr, int l, int r) {
		if (l > r) return vertex();
		if (tl == l && tr == r) return tree[v];
		int tm = (tl + tr) / 2;
		return get(v * 2, tl, tm, l, std::min(r, tm)) + get(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r);
	}
};
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0); std::cout.tie(0);
	int n, m, q;
	std::cin >> n >> m >> q;
	seg_tree treeR, treeC;
	FOR(i, n) {
		treeR.upd(1, 0, n - 1, i, 0);
	}
	FOR(i, m) {
		treeC.upd(1, 0, m - 1, i, 0);
	}
	for (int j = 1; j <= q; ++j) {
		int type;
		std::cin >> type;
		if (type == 1) {
			int R;
			std::cin >> R;
			--R;
			cntR[R] = j;
			treeR.upd(1, 0, n - 1, R, j);
		}
		if (type == 2) {
			int C;
			std::cin >> C;
			--C;
			cntC[C] = j;
			treeC.upd(1, 0, m - 1, C, j);
		}
		if (type == 3) {
			int i1, j1, i2, j2, k;
			std::cin >> i1 >> j1 >> i2 >> j2 >> k;
			--i1; --j1; --i2; --j2;
			if (j <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			// bool fl = false;
			bool fl = (j - treeC.get(1, 0, m - 1, std::min(j1, j2), std::max(j1, j2)).min) <= k;
			// for (int q = std::min(j1, j2); q <= std::max(j1, j2); ++q) {
			// 	fl &= ((j - cntC[q]) <= k);
			// }
			bool fl2 = (j - treeR.get(1, 0, n - 1, std::min(i1, i2), std::max(i1, i2)).min) <= k;
			// for (int q = std::min(i1, i2); q <= std::max(i1, i2); ++q) {
			// 	fl2 &= ((j - cntR[q]) <= k);
			// }
			// debug(fl << ' ' << fl2)
			if (fl || fl2) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			// debug(j - cntC[2]);
			if ((j - cntC[j1]) <= k && (j - cntR[i2]) <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			if ((j - cntC[j2]) <= k && (j - cntR[i1]) <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			ll answ = 1e18;
			if ((j - cntR[i1]) <= k && (j - cntR[i2]) <= k) {
				if ((j - treeC.get(1, 0, m - 1, 0, j1).max) <= k) {
					int l = 0, r = j1 + 1;
					while (r - l > 1) {
						int tm = (l + r) / 2;
						if ((j - treeC.get(1, 0, m - 1, tm, j1).max) <= k) {
							l = tm;
						}
						else {
							r = tm;
						}
					}
					answ = std::min(answ, llabs(j1 - l) + llabs(j2 - l) + llabs(i1 - i2));
				}
				if ((j - treeC.get(1, 0, m - 1, j1, m - 1).max) <= k) {
					int l = j1 - 1, r = m - 1;
					while (r - l > 1) {
						int tm = (l + r) / 2;
						if ((j - treeC.get(1, 0, m - 1, j1, tm).max) <= k) {
							r = tm;
						}
						else {
							l = tm;
						}
					}
					answ = std::min(answ, llabs(j1 - r) + llabs(j2 - r) + llabs(i1 - i2));
				}
			}
			if ((j - cntC[j1]) <= k && (j - cntC[j2]) <= k) {
				if ((j - treeR.get(1, 0, n - 1, 0, i1).max) <= k) {
					int l = 0, r = i1 + 1;
					while (r - l > 1) {
						int tm = (l + r) / 2;
						if ((j - treeR.get(1, 0, n - 1, tm, i1).max) <= k) {
							l = tm;
						}
						else {
							r = tm;
						}
					}
					answ = std::min(answ, llabs(i1 - l) + llabs(i2 - l) + llabs(j1 - j2));
				}
				if ((j - treeR.get(1, 0, n - 1, i1, n - 1).max) <= k) {
					int l = i1 - 1, r = n - 1;
					while (r - l > 1) {
						int tm = (l + r) / 2;
						if ((j - treeR.get(1, 0, n - 1, i1, tm).max) <= k) {
							r = tm;
						}
						else {
							l = tm;
						}
					}
					answ = std::min(answ, llabs(i1 - r) + llabs(i2 - r) + llabs(j1 - j2));
				}
			}
			if (answ == 1e18) {
				std::cout << -1 << '\n';
			}
			else {
				std::cout << answ << '\n';
			}
		}
	}
}