#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> g;
vector<int> visited;

bool has_cycle(int v) {
	visited[v] = 1;
	for (int u : g[v]) {
		if (visited[u] == 1) {
			return true;
		} else if (visited[u] == 0) {
			if (has_cycle(u)) {
				return true;
			}
		}
	}
	visited[v] = 2;
	return false;
}

vector<int> topsort_ord;

void dfs(int v) {
	visited[v] = 1;
	for (int u : g[v]) {
		if (!visited[u]) {
			dfs(u);
		}
	}
	topsort_ord.push_back(v);
}


int main() {
	int m, n;
	cin >> m >> n;
	vector<int> arr(m);
	for (int i = 0; i < m; i++) {
		cin >> arr[i];
		arr[i]--;
	}
	vector<pair<int, int>> events;
	vector<int> first(n, -1), last(n, -1);
	for (int i = 0; i < m; i++) {
		if (first[arr[i]] == -1) {
			first[arr[i]] = i;
		}
		last[arr[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		if (first[i] != -1) {
			events.push_back({first[i], 1});
			events.push_back({last[i], -1});
		}
	}
	vector<int> is_first(m), is_last(m);
	for (pair<int, int> ev : events) {
		if (ev.second == 1) {
			is_first[ev.first] = 1;
		} else {
			is_last[ev.first] = 1;
		}
	}
	vector<int> stack;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		if (!stack.size()) {
			stack.push_back(i);
		} else if (arr[i] != arr[stack.back()]) {
			if (last[arr[i]] > last[arr[stack.back()]]) {
				cout << -1 << endl;
				return 0;
			}
			g[arr[stack.back()]].push_back(arr[i]);
			if (is_first[i]) {
				stack.push_back(i);
			}
		}
		if (is_last[i]) {
			stack.pop_back();
		}
	}
	visited.resize(n);
	for (int i = 0; i < n; i++) {
		if (!visited[i]) {
			if (has_cycle(i)) {
				cout << -1 << endl;
				return 0;
			}
		}
	}
	for (int i = 0; i < n; i++) {
		visited[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		if (!visited[i]) {
			dfs(i);
		}
	}
	for (int i = topsort_ord.size() - 1; i >= 0; i--) {
		if (first[i] != -1) {
			cout << i + 1 << " " << first[i] + 1 << " " << last[i] + 1 << endl;
		}
	}
	return 0;
}

		

