#include <bits/stdc++.h>
using namespace std;

#define int long long

const int INF = 1e18;

struct my_data {
	int minn, maxx, left, right;

	my_data() {};
	my_data(int minn, int maxx, int left, int right) : minn(minn), maxx(maxx), left(left), right(right) {};
};

my_data combine(my_data d1, my_data d2) {
	int maxx = max(d1.maxx, d2.maxx);
	int minn = min(d1.minn, d2.minn);
	int left;
	if (d1.minn = minn) {
		left = d1.left;
	} else {
		left = d2.left;
	}
	int right;
	if (d2.minn = minn) {
		right = d2.right;
	} else {
		right = d1.right;
	}
	return my_data(minn, maxx, left, right);
}

struct SegTree {
	vector<my_data> tree;
	vector<int> mod;
	
	void build(int v, int l, int r) {
		if (l + 1 == r) {
			tree[v] = my_data(0, 0, l, l);
		} else {
			int m = l + (r - l) / 2;
			build(2 * v + 1, l, m);
			build(2 * v + 2, m, r);
			tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
		}
	}


	SegTree (int n) {
		tree.resize(4 * n);
		build(0, 0, n);
		mod.resize(4 * n);
	}

	void push(int v, int l, int r) {
		tree[v].minn += mod[v];
		tree[v].maxx += mod[v];
		if (l + 1 != r) {
			mod[2 * v + 1] += mod[v];
			mod[2 * v + 2] += mod[v];
		}
		mod[v] = 0;
	}

	void add() {
		mod[0]++;
	}

	void set(int v, int l, int r, int ind, int val) {
		push(v, l, r);
		if (ind < l || ind >= r) {
			return;
		}
		if (l + 1 == r) {
			tree[v].minn = val;
			tree[v].maxx = val;
		} else {
			int m = l + (r - l) / 2;
			set(2 * v + 1, l, m, ind, val);
			set(2 * v + 2, m, r, ind, val);
			tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
		}
	}

	my_data query(int v, int l, int r, int ql, int qr) {
		push(v, l, r);
		if (ql >= r || qr <= l) {
			return my_data(INF, -INF, INF, -INF);
		}
		if (ql <= l && r <= qr) {
			return tree[v];
		}
		int m = l + (r - l) / 2;
		return combine(query(2 * v + 1, l, m, ql, qr), query(2 * v + 2, m, r, ql, qr));
	}
};

			
			

main() {
	int n, m, q;
	cin >> n >> m >> q;
	SegTree row(n), col(m);
	for (int i = 0; i < q; i++) {
		row.add();
		col.add();
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			row.set(0, 0, n, r - 1, 0);
		} else if (type == 2) {
			int c;
			cin >> c;
			col.set(0, 0, n, c - 1, 0);
		} else {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >>c2 >> k;
			r1--;
			r2--;
			c1--;
			c2--;

			if (row.query(0, 0, n, r1, r1 + 1).maxx <= k && col.query(0, 0, m, c2, c2 + 1).maxx <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
			} else if (col.query(0, 0, m, c1, c1 + 1).maxx <= k && row.query(0, 0, n, r2, r2 + 1).maxx <= k) {
				cout << abs(r1 - r2) + abs(c1 - c2) << endl;
			} else if (row.query(0, 0, n, r1, r1 + 1).maxx <= k && row.query(0, 0, n, r2, r2 + 1).maxx <= k) {
				if (row.query(0, 0, n, min(r1, r2), max(r1, r2) + 1).maxx <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				} else if (col.query(0, 0, m, min(c1, c2), max(c1, c2) + 1).minn <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				} else {
					my_data d1 = col.query(0, 0, n, 0, min(c1, c2));
					my_data d2 = col.query(0, 0, n, max(c1, c2) + 1, n);
					int min_ans = INF;
					if (d1.minn <= k) {
						min_ans = min(min_ans, abs(r1 - r2) + abs(c1 - d1.right) + abs(c2 - d1.right));
					} 
					if (d2.minn <= k) {
						min_ans = min(min_ans, abs(r1 - r2) + abs(c1 - d2.left) + abs(c2 - d2.left));
					}
					if (min_ans != INF) {
						cout << min_ans << endl;
					} else {
						cout << -1 << endl;
					}
				}
			} else if (col.query(0, 0, m, c1, c1 + 1).maxx <= k && col.query(0, 0, m, c2, c2 + 1).maxx <= k) {
				if (col.query(0, 0, m, min(c1, c2), max(c1, c2) + 1).maxx <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				} else if (row.query(0, 0, n, min(r1, r2), max(r1, r2) + 1).minn <= k) {
					cout << abs(r1 - r2) + abs(c1 - c2) << endl;
				} else {
					my_data d1 = row.query(0, 0, n, 0, min(r1, r2));
					my_data d2 = row.query(0, 0, n, max(r1, r2) + 1, n);
					int min_ans = INF;
					if (d1.minn <= k) {
						min_ans = min(min_ans, abs(c1 - c2) + abs(r1 - d1.right) + abs(r2 - d1.right));
					}
					if (d2.minn <= k) {
						min_ans = min(min_ans, abs(c1 - c2) + abs(r1 - d2.left) + abs(r2 - d2.left));
					}
					if (min_ans != INF) {
						cout << min_ans << endl;
					} else {
						cout << -1 << endl;
					}
				}
			} else {
				cout << -1 << endl;
			}
		}
	}
}

