#include <bits/stdc++.h>
using namespace std;

#define int long long

int n, m, q;

vector<vector<int>> diff;
int seconds = 1;

int val(int i, int j) { return seconds + diff[i][j]; }

void cleanrow(int row) {
	for ( int i = 0; i < m; ++i )
		diff[row][i] = -seconds;
}

void cleancol(int col) {
	for ( int i = 0; i < n; ++i )
		diff[i][col] = -seconds;
}

vector<pair<int, int>> neighbours(int x, int y, int k) {
	vector<pair<int, int>> ans;
	if ( x + 1 < n && val(x+1, y) <= k ) ans.push_back({x+1, y});
	if ( x - 1 >= 0 && val(x-1, y) <= k ) ans.push_back({x-1, y});
	if ( y + 1 < n && val(x, y+1) <= k ) ans.push_back({x, y+1});
	if ( y - 1 >= 0 && val(x, y-1) <= k ) ans.push_back({x, y-1});
	return ans;
}

int bfs(int x, int y, int x1, int y1, int k) {

	if ( val(x, y) > k )
		return -1;
	if ( val(x1, y1) > k )
		return -1;

	if ( x == x1 && y == y1 )
		return 0;
	set<pair<int, int>> visited;
	deque<pair<pair<int, int>, int>> deq;

	visited.insert({x, y});
	deq.push_back({{x, y}, 0});

	while ( !deq.empty() ) {
		int dst;
		pair<int, int> q;
		tie(q, dst) = deq.back();
		deq.pop_back();

		vector<pair<int, int>> neibs = neighbours(q.first, q.second, k);
		for ( int i = 0; i < neibs.size(); ++i ) {
			pair<int, int> neib = neibs[i];
			if ( visited.count(neib) == 0 ) {
				visited.insert(neib);
				deq.push_back({neib, dst+1});
				if ( neib.first == x1 && neib.second == y1 )
					return dst+1;
			}
		}
	}
	return -1;
}

signed main() {
	cin >> n >> m >> q;
	diff = vector<vector<int>>(n, vector<int>(m, 0));

	for ( int step = 0; step < q; ++step ) {
		int type;
		cin >> type;
		if ( type == 1 ) {
			int row;
			cin >> row;
			row--;
			cleanrow(row);
		} else if ( type == 2 ) {
			int col;
			cin >> col;
			col--;
			cleancol(col);
		} else {
			int x, y, x1, y1, k;
			cin >> x >> y >> x1 >> y1 >> k;
			x--; y--; x1--; y1--;
			int ans = bfs(x, y, x1, y1, k);
			cout << ans << endl;
		}

		seconds++;
	}
	return 0;
}