#include<algorithm>
#include<iostream>
#include<utility>
#include<vector>
using namespace std;

const int N = 1e6 + 1;

int row[N], colon[N], row_mx = 0, colon_mx = 0;

//[...)
int get_row_min(int l, int r)
{
	int res = 1e9;
	for (int i = l; i < r; i++) res = min(res, row[i]);
	return res;
}

int get_row_max(int l, int r)
{
	int res = 0;
	for (int i = l; i < r; i++) res = max(res, row[i]);
	return res;
}

int right_row_lb(int p, int k)
{
	for (int i = p + 1; i < N; i++) if (row[i] >= k) return i;
	return 1e8;
}

int left_row_lb(int p, int k)
{
	for (int i = p - 1; i >= 0; i--) if (row[i] >= k) return i;
	return -1e8;
}

//[...)
int get_colon_min(int l, int r)
{
	int res = 1e9;
	for (int i = l; i < r; i++) res = min(res, colon[i]);
	return res;
}

int get_colon_max(int l, int r)
{
	int res = 0;
	for (int i = l; i < r; i++) res = max(res, colon[i]);
	return res;
}

int right_colon_lb(int p, int k)
{
	for (int i = p + 1; i < N; i++) if (colon[i] >= k) return i;
	return 1e8;
}

int left_colon_lb(int p, int k)
{
	for (int i = p - 1; i >= 0; i--) if (colon[i] >= k) return i;
	return -1e8;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, q, op, t = 0;
	cin >> n >> m >> q;

	while (cin >> op)
	{
		++t;
		if (op == 1)
		{
			int p;
			cin >> p;
			row[p] = t;
			row_mx = t;
		}
		else if (op == 2)
		{
			int p;
			cin >> p;
			colon[p] = t;
			colon_mx = t;
		}
		else
		{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			k = t - k;
			if (row[r1] < k && colon[c1] < k || row[c2] < k && colon[c2] < k)
			{
				cout << "-1\n";
				continue;
			}

			if (row[r1] >= k && colon[c2] >= k || colon[c1] >= k && row[r2] >= k)
			{
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}
			
			if (row[r1] >= k && row[r2] >= k)
			{
				int r_mn = get_row_max(min(r1, r2), max(r1, r2) + 1);
				if (colon_mx < k && r_mn < k)
				{
					cout << "-1\n";
					continue;
				}

				if (r_mn >= k || get_colon_max(min(c1, c2), max(c1, c2) + 1) >= k)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}

				cout << abs(c1 - c2) + abs(r1 - r2) + 2 * min(min(c1, c2) - left_colon_lb(min(c1, c2), k), right_colon_lb(max(c1, c2), k) - max(c1, c2)) << '\n';
			}

			if (colon[c1] >= k && colon[c2] >= k)
			{
				int c_mn = get_colon_min(min(c1, c2), max(c1, c2) + 1);
				if (row_mx < k && c_mn < k)
				{
					cout << "-1\n";
					continue;
				}

				if (c_mn >= k || get_row_max(min(r1, r2), max(r1, r2) + 1) >= k)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}

				cout << abs(c1 - c2) + abs(r1 - r2) + 2 * min(min(r1, r2) - left_row_lb(min(r1, r2), k), right_row_lb(max(r1, r2), k) - max(r1, r2)) << '\n';
			}
		}
	}
}