#include<algorithm>
#include<iostream>
#include<utility>
#include<vector>
#include<string>
#include<bitset>
#include<assert.h>
using namespace std;

const int N = 1e6 + 1, INF = 1e8;

int row[N], colon[N];

pair<int, int> row_t[4 * N], colon_t[4 * N];
//min, max
void recalc_row_t(int v)
{
	row_t[v].first = min(row_t[2 * v].first, row_t[2 * v + 1].first);
	row_t[v].second = max(row_t[2 * v].second, row_t[2 * v + 1].second);
}

void recalc_colon_t(int v)
{
	colon_t[v].first = min(colon_t[2 * v].first, colon_t[2 * v + 1].first);
	colon_t[v].second = max(colon_t[2 * v].second, colon_t[2 * v + 1].second);
}

void upd_row_t(int v, int l, int r, int P, int X)
{
	if (P < l || r <= P) return;
	if (r - l == 1)
	{
		row_t[v] = { X, X };
		return;
	}

	upd_row_t(2 * v, l, (l + r) / 2, P, X);
	upd_row_t(2 * v + 1, (l + r) / 2, r, P, X);
	recalc_row_t(v);
}

void upd_colon_t(int v, int l, int r, int P, int X)
{
	if (P < l || r <= P) return;
	if (r - l == 1)
	{
		colon_t[v] = { X, X };
		return;
	}

	upd_colon_t(2 * v, l, (l + r) / 2, P, X);
	upd_colon_t(2 * v + 1, (l + r) / 2, r, P, X);
	recalc_colon_t(v);
}

pair<int, int> get_row_t(int v, int l, int r, int L, int R)
{
	if (R <= l || r <= L) return { INF, -INF };
	if (L <= l && r <= R) return row_t[v];
	auto[mn_l, mx_l] = get_row_t(2 * v, l, (l + r) / 2, L, R);
	auto[mn_r, mx_r] = get_row_t(2 * v + 1, (l + r) / 2, r, L, R);
	return { min(mn_l, mn_r), max(mx_l, mx_r) };
}

pair<int, int> get_colon_t(int v, int l, int r, int L, int R)
{
	if (R <= l || r <= L) return { INF, -INF };
	if (L <= l && r <= R) return colon_t[v];
	auto[mn_l, mx_l] = get_colon_t(2 * v, l, (l + r) / 2, L, R);
	auto[mn_r, mx_r] = get_colon_t(2 * v + 1, (l + r) / 2, r, L, R);
	return { min(mn_l, mn_r), max(mx_l, mx_r) };
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, q, op, t = 0;
	cin >> n >> m >> q;

	while (cin >> op)
	{
		++t;
		if (op == 1)
		{
			int p;
			cin >> p;
			row[p] = t;
			upd_row_t(1, 1, n + 1, p, t);
		}
		else if (op == 2)
		{
			int p;
			cin >> p;
			colon[p] = t;
			upd_colon_t(1, 1, m + 1, p, t);
		}
		else
		{
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			k = t - k;
			
			if (row[r1] >= k && colon[c2] >= k || row[r2] >= k && colon[c1] >= k)
			{
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				continue;
			}

			if (row[r1] >= k && row[r2] >= k)
			{
				int r_mn = 1e8;
				if (r1 > r2) swap(r1, r2);
				if (c1 > c2) swap(c1, c2);
				r_mn = get_row_t(1, 1, n + 1, r1, r2 + 1).first;
				if (r_mn >= k)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}
				
				bool flag = false;
				flag = get_colon_t(1, 1, m + 1, c1, c2 + 1).second >= k;
				if (flag)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}

				long long ans = 1e8;
				long long l = 0, r = c1;
				while (r - l > 1)
				{
					long long mid = (l + r) / 2;
					if (get_colon_t(1, 1, m + 1, mid, c1).second >= k)
					{
						l = mid;
					}
					else
					{
						r = mid;
					}
				}

				if (l != 0) ans = c1 - l;

				l = c2, r = m + 2;

				while (r - l > 1)
				{
					long long mid = (l + r) / 2;
					if (get_colon_t(1, 1, m + 1, c2, mid + 1).second >= k)
					{
						r = mid;
					}
					else
					{
						l = mid;
					}
				}

				/*
				long long pos = -1;
				for (int i = c2; i <= n; i++)
				{
					if (colon[i] >= k)
					{
						pos = i;
						break;
					}
				}

				if (pos != -1) ans = min(pos - c2, ans);
				*/
				if (l != m + 1) ans = min(l - c2, ans);
				if (ans == 1e8)
				{
					cout << "-1\n";
					continue;
				}
				else
				{
					cout << abs(r1 - r2) + abs(c1 - c2) + 2 * ans << '\n';
					continue;
				}
			}

			if (colon[c1] >= k && colon[c2] >= k)
			{
				if (r1 > r2) swap(r1, r2);
				if (c1 > c2) swap(c1, c2);
				int c_mn = 1e8;
				c_mn = get_colon_t(1, 1, m + 1, c1, c2 + 1).first;
				if (c_mn >= k)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}

				bool flag = false;
				flag = get_row_t(1, 1, n + 1, r1, r2 + 1).second >= k;

				if (flag)
				{
					cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					continue;
				}

				int pos = -1, ans = 1e8;
				for (int i = r1; i >= 1; i--)
				{
					if (row[i] >= k)
					{
						pos = i;
						break;
					}
				}

				if (pos != -1) ans = r1 - pos;
				pos = -1;

				for (int i = r2; i <= n; i++)
				{
					if (row[i] >= k)
					{
						pos = i;
						break;
					}
				}

				if (pos != -1) ans = min(pos - r2, ans);
				if (ans == 1e8)
				{
					cout << "-1\n";
					continue;
				}
				else
				{
					cout << abs(r1 - r2) + abs(c1 - c2) + 2 * ans << '\n';
					continue;
				}
			}

			cout << "-1\n";
		}
	}
}