#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define fi first
#define se second
#define un (unsigned)
const ll INF = INT_MAX;
const ll INFll = LLONG_MAX;
void solveA();
void solveB();

int N, M;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

#ifdef INOUT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> N >> M;

    if (N <= 50) {
        solveB();
    } else {
        solveA();
    }

    return 0;
}

struct req {
    int t, k;
    pair<int, int> s, f;
};

struct segment {
    int l, r, max, add;
};

vector<segment> t;

void push(int v) {
    if (t[v].add != 0) {
        t[v].max += t[v].add;

        if (t[v].l != t[v].r) {
            t[2 * v].add += t[v].add;
            t[2 * v + 1].add += t[v].add;
        }

        t[v].add = 0;
    }
}

void t_build (int v, int l, int r) {
    t[v].l = l; t[v].r = r;
    if (l != r) {
        int m = (l + r) / 2;

        t_build(2 * v, l, m);
        t_build(2 * v + 1, m + 1, r);
    }
}

int t_max(int v, const int &l, const int &r) {
    push(v);
    if (t[v].r < l || r < t[v].l) {
        return -1;
    } else if (l <= t[v].l && t[v].r <= r) {
        return t[v].max;
    } else {
        return max(t_max(2 * v, l, r), t_max(2 * v+ 1, l, r));
    }
}

void t_add(int v, const int &l, const int &r) {
    push(v);
    if (t[v].r < l || r < t[v].l) {
        return;
    } else if (l <= t[v].l && t[v].r <= r) {
        t[v].add = 1;
        push(v);
    } else {
        t_add(2 * v, l, r);
        t_add(2 * v + 1, l, r);
    }
}

void t_set(int v, const int &l, const int &r) {
    push(v);
    if (t[v].r < l || r < t[v].l) {
        return;
    } else if (l <= t[v].l && t[v].r <= r) {
        t[v].max = 0;
    } else {
        t_set(2 * v, l, r);
        t_set(2 * v + 1, l, r);

        t[v].max = max(t[2 * v].max, t[2 * v + 1].max);
    }
}

void solveA() {
    int q; cin >> q;

    vector<req> reqs(un q);
    for (int i = 0; i < q; i++) {
        cin >> reqs[i].t;
        if (reqs[i].t == 3) {
            cin >> reqs[i].s.fi >> reqs[i].s.se >> reqs[i].f.fi >> reqs[i].f.se >> reqs[i].k;
        } else {
            cin >> reqs[i].k;
        }
    }

    t.resize(un 4 * N + 1);
    t_build(1, 1, N);

    for (int i = 0; i < q; i++) {
        t_add(1, 1, N);

        if (reqs[i].t == 1) {
            t_set(1, reqs[i].k, reqs[i].k);
        } else {
            if (t_max(1, min(reqs[i].s.fi,  reqs[i].f.fi), max(reqs[i].f.fi, reqs[i].s.fi)) <= reqs[i].k) {
                cout << abs(reqs[i].s.fi - reqs[i].f.fi) + abs(reqs[i].s.se - reqs[i].f.se) << '\n';
            } else {
                cout << -1 << '\n';
            }
        }
    }
}

vector<pair<int, int>> xy = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int table[10013][10013];
bool mark[10013][10013];

int path(const pair<int, int> &a, const pair<int, int> &b, const int &k) {
    if (table[a.fi][a.se] <= k) {

        queue<pair<pair<int, int>, int>> work;
        set<pair<int, int>> mark;

        work.push({a, 0});
        mark.insert(a);

        while (!work.empty()) {
            pair<int, int> v = work.front().fi;
            int d = work.front().se;
            work.pop();

            for (pair<int, int> add: xy) {
                int tox = v.fi + add.fi, toy = v.se + add.se;
                if (tox >= 1 && tox <= N && toy >= 1 && toy <= M && mark.find({tox, toy}) == mark.end() &&
                    table[tox][toy] <= k) {
                    mark.insert({tox, toy});
                    work.push({{tox, toy}, d + 1});

                    if (b == make_pair(tox, toy))
                        return d + 1;
                }
            }
        }
    }

    return -1;
}

void add() {
    for (int o = 1; o <= N; o++) {
        for (int p = 1; p <= M; p++)
            table[o][p]++;
    }
}

void solveB() {
    int q; cin >> q;

    vector<req> reqs(un q);
    for (int i = 0; i < q; i++) {
        cin >> reqs[i].t;
        if (reqs[i].t == 3) {
            cin >> reqs[i].s.fi >> reqs[i].s.se >> reqs[i].f.fi >> reqs[i].f.se >> reqs[i].k;
        } else {
            cin >> reqs[i].k;
        }
    }

    for (int i = 0; i < q; i++) {
        add();

        if (reqs[i].t == 1) {
            for (int j = 1; j <= M; j++)
                table[reqs[i].k][j] = 0;
        } else if (reqs[i].t == 2) {
            for (int j = 1; j <= N; j++)
                table[j][reqs[i].k] = 0;
        } else {
            cout << path(reqs[i].s, reqs[i].f, reqs[i].k) << '\n';
        }
    }
}