#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

typedef long long ll;

ll const T = 1024 * 1024;

ll a[2 * T], b[2 * T], a2[2 * T], b2[2 * T], p2[2 * T], p3[2 * T];

ll min1(ll i1, ll i2) {
	if (i1 > i2) {
		return 1e9;
	}
	else if (i1 % 2 == 1) {
		return min(a[i1], min1(i1 + 1, i2));
	}
	else if (i2 % 2 == 0) {
		return min(a[i2], min1(i1, i2 - 1));
	}
	else {
		return min1(i1 / 2, i2 / 2);
	}
}

void ad1(ll i1) {
	if (i1 > 0) {
		if (i1 < T) {
			a[i1] = min(a[2 * i1], a[2 * i1 + 1]);
		}
		ad1(i1 / 2);
	}
}

ll max1(ll i1, ll i2) {
	if (i1 > i2) {
		return -1e9;
	}
	else if (i1 % 2 == 1) {
		return max(a2[i1], max1(i1 + 1, i2));
	}
	else if (i2 % 2 == 0) {
		return max(a2[i2], max1(i1, i2 - 1));
	}
	else {
		return max1(i1 / 2, i2 / 2);
	}
}

void ad11(ll i1) {
	if (i1 > 0) {
		if (i1 < T) {
			a2[i1] = max(a2[2 * i1], a2[2 * i1 + 1]);
		}
		ad11(i1 / 2);
	}
}

ll min2(ll i1, ll i2) {
	if (i1 > i2) {
		return 1e9;
	}
	else if (i1 % 2 == 1) {
		return min(b[i1], min2(i1 + 1, i2));
	}
	else if (i2 % 2 == 0) {
		return min(b[i2], min2(i1, i2 - 1));
	}
	else {
		return min2(i1 / 2, i2 / 2);
	}
}

void ad2(ll i1) {
	if (i1 > 0) {
		if (i1 < T) {
			b[i1] = min(b[2 * i1], b[2 * i1 + 1]);
		}
		ad2(i1 / 2);
	}
}

ll max2(ll i1, ll i2) {
	if (i1 > i2) {
		return -1e9;
	}
	else if (i1 % 2 == 1) {
		return max(b2[i1], max2(i1 + 1, i2));
	}
	else if (i2 % 2 == 0) {
		return max(b2[i2], max2(i1, i2 - 1));
	}
	else {
		return max2(i1 / 2, i2 / 2);
	}
}

void ad22(ll i1) {
	if (i1 > 0) {
		if (i1 < T) {
			b2[i1] = max(b2[2 * i1], b2[2 * i1 + 1]);
		}
		ad22(i1 / 2);
	}
}

ll findmin1(ll i1, ll t, ll q) {
	if (i1 >= T) {
		if (a[i1] <= q) return i1;
		else return -1;
	}
	ll l1 = (i1 - p3[i1]) * p2[i1];
	ll r1 = l1 + p2[i1];
	if (l1 > t) return -1;
	if ((l1 + r1 > 2 * t) || (a[2 * i1 + 1] > q)) return findmin1(2 * i1, t, q);
	ll w = findmin1(2 * i1 + 1, t, q);
	if (w == -1) {
		return findmin1(2 * i1, t, q);
	}
	else return w;
}

ll findmin2(ll i1, ll t, ll q) {
	if (i1 >= T) {
		if (a[i1] <= q) return i1;
		else return -1;
	}
	ll l1 = (i1 - p3[i1]) * p2[i1];
	ll r1 = l1 + p2[i1];
	if (r1 <= t) return -1;
	if ((l1 + r1 <= 2 * t) || (a[2 * i1] > q)) return findmin2(2 * i1 + 1, t, q);
	ll w = findmin2(2 * i1, t, q);
	if (w == -1) {
		return findmin2(2 * i1 + 1, t, q);
	}
	else return w;
}

ll findmin3(ll i1, ll t, ll q) {
	if (i1 >= T) {
		if (b[i1] <= q) return i1;
		else return -1;
	}
	ll l1 = (i1 - p3[i1]) * p2[i1];
	ll r1 = l1 + p2[i1];
	if (l1 > t) return -1;
	if ((l1 + r1 > 2 * t) || (b[2 * i1 + 1] > q)) return findmin3(2 * i1, t, q);
	ll w = findmin3(2 * i1 + 1, t, q);
	if (w == -1) {
		return findmin3(2 * i1, t, q);
	}
	else return w;
}

ll findmin4(ll i1, ll t, ll q) {
	if (i1 >= T) {
		if (b[i1] <= q) return i1;
		else return -1;
	}
	ll l1 = (i1 - p3[i1]) * p2[i1];
	ll r1 = l1 + p2[i1];
	if (r1 <= t) return -1;
	if ((l1 + r1 <= 2 * t) || (b[2 * i1] > q)) return findmin4(2 * i1 + 1, t, q);
	ll w = findmin4(2 * i1, t, q);
	if (w == -1) {
		return findmin4(2 * i1 + 1, t, q);
	}
	else return w;
}

void pow2() {
	ll t = 1;
	for (ll i = 1; i < 2 * T; i++) {
		if (2 * t <= i) {
			t *= 2;
		}
		p3[i] = t;
		p2[i] = T / t;
	}
}

int main() {
	pow2();
	ll n, m, q;
	cin >> n >> m >> q;
	for (ll i = 0; i < 2 * T; i++) {
		a[i] = 1e9;
		b[i] = 1e9;
		a2[i] = -1e9;
		b2[i] = -1e9;
	}
	for (ll i = T; i < T + n; i++) {
		a[i] = 0;
		ad1(i);
		a2[i] = 0;
		ad11(i);
	}
	for (ll i = T; i < T + m; i++) {
		b[i] = 0;
		ad2(i);
		b2[i] = 0;
		ad22(i);
	}
	vector<ll> ans;
	ll p;
	for (ll i = 1; i <= q; i++) {
		cin >> p;
		if (p == 1) {
			ll t;
			cin >> t;
			a[T + t - 1] = -i;
			a2[T + t - 1] = -i;
			ad1(T + t - 1);
			ad11(T + t - 1);
		}
		else if (p == 2) {
			ll t;
			cin >> t;
			b[T + t - 1] = -i;
			b2[T + t - 1] = -i;
			ad2(T + t - 1);
			ad22(T + t - 1);
		}
		else {
			ll x1, y1, x2, y2, t;
			cin >> x1 >> y1 >> x2 >> y2 >> t;
			x1 += T - 1;
			y1 += T - 1;
			x2 += T - 1;
			y2 += T - 1;
			t = t - i;
			ll q1, q2;
			q1 = min(a[x1], a[x2]);
			q2 = min(b[y1], b[y2]);
			if (((a[x1] > t) && (b[y1] > t)) || ((a[x2] > t) && (b[y2] > t))) {
				ans.push_back(-1);
			}
			else if ((q1 <= t) && (q2 <= t)) {
				ans.push_back(abs(x1 - x2) + abs(y1 - y2));
			}
			else if (q2 > t) {
				if (x1 > x2) {
					swap(x1, x2);
					swap(y1, y2);
				}
				ll min5;
				if (y1 < y2) {
					min5 = min2(y1, y2);
				}
				else {
					min5 = min2(y2, y1);
				}
				if (min5 <= t) {
					ans.push_back(abs(x1 - x2) + abs(y1 - y2));
				}
				else {
					ll max5 = max1(x1, x2);
					if (max5 <= t) {
						ans.push_back(abs(x1 - x2) + abs(y1 - y2));
					}
					else {
						if (y1 > y2) {
							swap(x1, x2);
							swap(y1, y2);
						}
						ll f1 = findmin3(1, y1 - T, t);
						ll f2 = findmin4(1, y2 - T, t);
						if ((f1 == -1) && (f2 == -1)) {
							ans.push_back(-1);
						}
						else if (f2 == -1) {
							ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (y1 - f1));
						}
						else if (f1 == -1) {
							ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (f2 - y2));
						}
						else {
							if (y1 - f1 < f2 - y2) {
								ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (y1 - f1));
							}
							else {
								ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (f2 - y2));
							}
						}
					}
				}
			}
			else if (q1 > t) {
				if (y1 > y2) {
					swap(x1, x2);
					swap(y1, y2);
				}
				ll min5;
				if (x1 < x2) {
					min5 = min1(x1, x2);
				}
				else {
					min5 = min1(x2, x1);
				}
				if (min5 <= t) {
					ans.push_back(abs(x1 - x2) + abs(y1 - y2));
				}
				else {
					ll max5 = max2(y1, y2);
					if (max5 <= t) {
						ans.push_back(abs(x1 - x2) + abs(y1 - y2));
					}
					else {
						if (x1 > x2) {
							swap(x1, x2);
							swap(y1, y2);
						}
						ll f1 = findmin1(1, x1 - T, t);
						ll f2 = findmin2(1, x2 - T, t);
						if ((f1 == -1) && (f2 == -1)) {
							ans.push_back(-1);
						}
						else if (f2 == -1) {
							ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (x1 - f1));
						}
						else if (f1 == -1) {
							ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (f2 - x2));
						}
						else {
							if (x1 - f1 < f2 - x2) {
								ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (x1 - f1));
							}
							else {
								ans.push_back(abs(x1 - x2) + abs(y1 - y2) + 2 * (f2 - x2));
							}
						}
					}
				}
			}
		}
	}
	for (auto i : ans) {
		cout << i << '\n';
	}
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/