#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstdio>
#include <climits>
#include <cmath>
struct bracket
{
	int kind, type, pos;
	bool operator < (const bracket& rhs) const
	{
		return std::tie(rhs.kind, rhs.type, rhs.pos) < std::tie(kind, type, pos);
	}
};
int main(int argc, char*argv[])
{
	int m, n; std::cin >> m >> n;
	std::vector<int> target(n);
	std::vector<int> last(m);
	std::vector<int> first(m, -1);
	//n kinds of brackets
	//ignore all in middle
	for(int i = 0; i < m; i++) 
	{
		scanf("%d", &target[i]);
		target[i]--;
		last[target[i]] = i;
		if(first[target[i]] == -1) first[target[i]] = i;
	}
	std::vector<bracket> seq;
	std::map<bracket, bracket> matches;
	for(int i = 0; i < m; i++)
	{
		bool any = false;
		if(i == first[target[i]]) seq.push_back({1, target[i], i}), any = true;
		if(i == last[target[i]]) seq.push_back({2, target[i], i}), any = true;
		if(!any) seq.push_back({3, target[i], i});
	}
	int sl = seq.size();
	//for(int i = 0; i < sl; i++) printf("bracket: k=%d, t=%d, p=%d\n", seq[i].kind, seq[i].type, seq[i].pos);
	//check if valid
	std::vector<bracket> stack;
	for(int i = 0; i < sl; i++)
	{
		if(seq[i].kind == 1)
			stack.push_back(seq[i]);
		if(seq[i].kind == 2)
		{
			if(stack.back().type != seq[i].type)
			{
				std::cout << -1;
				return 0;
			}
			matches[stack.back()] = seq[i];
			matches[seq[i]] = stack.back();
			if(seq[i].pos - stack.back().pos + 1 > m) //too long
			{
				std::cout << -1;
				return 0;
			}
			stack.pop_back();
		}
		if(seq[i].kind == 3)
			if(seq[i].type != stack.back().type)
			{
				std::cout << -1;
				return 0;
			}
	}
	//now restore answer. when enterring bracket, paint it
	std::set<int> colors; for(int i = 0; i < m; i++) colors.insert(target[i]);
	std::cout << colors.size() << '\n';
	for(int i = 0; i < sl; i++)
	{
		if(seq[i].kind != 1) continue;
		printf("%d %d %d\n", seq[i].type + 1, seq[i].pos + 1, matches[seq[i]].pos + 1);
	}
	return 0;	
}
