#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstdio>
#include <climits>
#include <cmath>
#include <random>
std::vector<int> tree;
std::vector<std::vector<std::pair<int,int64_t>>> graph;
int64_t min = 0, max = 0;
int64_t to;
bool done = false;
void dfs(int ver, int64_t curLen, int prev = -1)
{
	//printf("ver=%d, curLen=%lld, prev = %d\n", ver, curLen, prev);
	tree[ver] = true;
	if(ver == to && curLen >= min && curLen <= max)
		done = true;
	if(done) {tree[ver] = false; return;}
	for(auto p : graph[ver])
		if(!tree[p.first])
			dfs(p.first, curLen + p.second, ver);
	tree[ver] = false;
}
int main(int argc, char*argv[])
{
	int _t; std::cin >> _t;
	for(int _i = 0; _i < _t; _i++)
	{
		int n, m, q, p; std::cin >> n >> m >> q >> p;
		graph.resize(n);
		for(int i = 0; i < n; i++) graph[i] = std::vector<std::pair<int,int64_t>>();
		tree.resize(n);
		for(int i = 0; i < m; i++)
		{
			int64_t a, b, len; std::cin >> a >> b >> len;
			a--; b--; 
			graph[a].push_back({b, len});
		}
		for(int i = 0; i < q; i++)
		{
			int64_t r; std::cin >> to >> r;
			to--;
			min = r;
			max = r * p / (p - 1);
			//printf("min=%lld, max=%lld\n", min, max);
			dfs(0, 0);
			std::cout << done;
			done = false;
		}
		std::cout << '\n';
	}
	return 0;
}
