#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <functional>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int ask(int x) {
	cout << "? " << x + 1 << endl;
	string out;
	cin >> out;
	if (out == "Yes") {
		return 1;
	}
	else {
		return 0;
	}
}

void guess(int x) {
	cout << "! " << x + 1 << endl;
	string out;
	cin >> out;
	if (out == "Done") {
		exit(0);
	}
}

typedef vector<pair<int, int> > base;

int n;
map<base, int> dp, p, M;

void apply(base &b, int x, int q_id, int type) {
	b.push_back(b.back());
	for (int i = 0; i < b.size(); ++i) {
		if ((i == q_id) ^ type) {
			chkmax(b[i].first, x);
		}
		else {
			chkmin(b[i].second, x - 1);
		}
		if (b[i].first > b[i].second) {
			b[i] = {1, 0};
		}
	}
}

int check(base &b) {
	int res = -1;
	for (int i = 0; i < b.size(); ++i) {
		if (b[i].first < b[i].second) {
			return -2;
		}
		if (b[i].first > b[i].second) {
			continue;
		}
		if (res == -1) {
			res = b[i].first;
		}
		else {
			return -2;
		}
	}
	return res;
}

const int INF = 1e9;
const int C = 8;
int ptr;

void print(base x) {
	for (auto pp : x) {
		cerr << pp.first << " " << pp.second << endl;
	}
}

int calc_dp(base b) {
	if (b.size() > C) {
		return INF;
	}
	int ch = check(b);
	if (ch != -2) {
		return 0;
	}
	auto it = dp.find(b);
	if (it != dp.end()) {
		return it->second;
	}
	int res = INF, cur_p = -1;
	for (int x = 0; x < n; ++x) {
		base by = b;
		apply(by, x, (int)b.size() - 1, 1);
		int r1 = calc_dp(by);
		if (r1 >= res) {
			continue;
		}
		base bn = b;
		apply(bn, x, (int)b.size() - 1, 0);
		int r2 = calc_dp(bn);
		if (chkmin(res, max(r1, r2) + 1)) {
			cur_p = x;
		}
	}
	dp[b] = res;
	p[b] = cur_p;
	return res;
}

void precalc() {
	base base0 = {{0, n - 1}};
	calc_dp(base0);
	//cerr << dp[base0] << endl;
}

void go() {
	base cur = {{0, n - 1}};
	for (int i = 0; true; ++i) {
		int pos = check(cur);
		assert(pos != -1);
		if (pos != -2) {
			guess(pos);
			return;
		}
		int x = p[cur];
		int res = ask(x);
		apply(cur, x, i, res);
	}
}

int main() {
	fast_io();
	cin >> n;
	precalc();
	while (true) {
		go();
	}
}
