#include <bits/stdc++.h>

using namespace std;

struct ST{
    int n;
    vector<pair<int, int> > a;

    ST(int n){
        this->n = n;
        this->a.assign(n * 4, {0, 0});
    }

    void upd(int i, int x){
        this->upd(i, x, 0, this->n, 0);
    }

    void upd(int i, int x, int vl, int vr, int v){
        if (vr - vl == 1){
            this->a[v] = {x, x};
            return;
        }
        int m = (vl + vr) / 2;
        if (i < m){
            this->upd(i, x, vl, m, v * 2 + 1);
        }
        else {
            this->upd(i, x, m, vr, v * 2 + 2);
        }
        this->a[v] = {min(a[v * 2 + 1].first, a[v * 2 + 2].first), max(a[v * 2 + 1].second, a[v * 2 + 2].second)};
    }

    int get(int i){
        return this->get(i, 0, this->n, 0);
    }

    int get(int i, int vl, int vr, int v){
        if (vr - vl == 1){
            return this->a[v].first;
        }
        int m = (vl + vr) / 2;
        if (i < m){
            return this->get(i, vl, m, v * 2 + 1);
        } else {
            return this->get(i, m, vr, v * 2 + 2);
        }
    }

    int get_min(int l, int r){
        if (l <= r){
            return this->get_min(l, r + 1, 0, this->n, 0);
        } else {
            return this->get_min(r, l + 1, 0, this->n, 0);
        }
    }

    int get_min(int l, int r, int vl, int vr, int v){
        if (vl == l && vr == r){
            return this->a[v].first;
        }
        if (l >= vr || r <= vl){
            return 1e9;
        }
        int m = (vl + vr) / 2;
        return min(this->get_min(l, min(r, m), vl, m, v * 2 + 1), this->get_min(max(l, m), r, m, vr, v * 2 + 2));
    }

    int get_left_gt(int i, int x){
        return this->get_left_gt(i, x, 0, this->n, 0);
    }

    int get_left_gt(int i, int x, int vl, int vr, int v){
        if (this->a[v].second < x || i < vl){
            return -1;
        }
        if (vr - vl == 1){
            return vl;
        }
        int m = (vl + vr) / 2;
        int res = this->get_left_gt(i, x, m, vr, v * 2 + 2);
        if (res == -1){
            res = this->get_left_gt(i, x, vl, m, v * 2 + 1);
        }
        return res;
    }

    int get_right_gt(int i, int x){
        return this->get_right_gt(i, x, 0, this->n, 0);
    }

    int get_right_gt(int i, int x, int vl, int vr, int v){
        if (this->a[v].second < x || i >= vr){
            return -1;
        }
        if (vr - vl == 1){
            return vl;
        }
        int m = (vl + vr) / 2;
        int res = this->get_right_gt(i, x, vl, m, v * 2 + 1);
        if (res == -1){
            res = this->get_right_gt(i, x, m, vr, v * 2 + 2);
        }
        return res;
    }
};

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m, q, qt, x1, y1, x2, y2, k;
    cin >> n >> m >> q;
    int t = 1;
    ST rows(n);
    ST cols(m);
    for (int i = 0; i < q; ++i){
        cin >> qt;
        if (qt == 1){
            cin >> x1;
            rows.upd(x1 - 1, t);
        } else if (qt == 2){
            cin >> y1;
            cols.upd(y1 - 1, t);
        } else {
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            --x1;
            --y1;
            --x2;
            --y2;
            int hx1 = t - rows.get(x1);
            int hx2 = t - rows.get(x2);
            int hy1 = t - cols.get(y1);
            int hy2 = t - cols.get(y2);
            if ((hx1 <= k && hy2 <= k) || (hx2 <= k && hy1 <= k)){
                cout << abs(x1 - x2) + abs(y1 -  y2) << "\n";
            } else if ((hx1 > k && hy1 > k) || (hx2 > k && hy2 > k)){
                cout << "-1\n";
            } else {
                if (t - rows.get_min(x1, x2) <= k || t - cols.get_min(y1, y2) <= k){
                    cout << abs(x1 - x2) + abs(y1 -  y2) << "\n";
                } else {
                    int res1 = 1e9;
                    int res2 = 1e9;
                    if (hx1 <= k && hx2 <= k){
                        int m1 = cols.get_left_gt(max(y1, y2), t - k);
                        int m2 = cols.get_right_gt(min(y1, y2), t - k);
                        if (m1 != -1) {
                            res1 = abs(x1 - x2) + abs(y1 - m1) + abs(y2 - m1);
                        }
                        if (m2 != -1){
                            res1 = min(res1, abs(x1 - x2) + abs(y1 - m2) + abs(y2 - m2));
                        }
                    }
                    if (hy1 <= k && hy2 <= k){
                        int m1 = rows.get_left_gt(max(x1, x2), t - k);
                        int m2 = rows.get_right_gt(min(x1, x2), t - k);
                        if (m1 != -1) {
                            res2 = abs(y1 - y2) + abs(x1 - m1) + abs(x2 - m1);
                        }
                        if (m2 != -1){
                            res2 = min(res2, abs(y1 - y2) + abs(x1 - m2) + abs(x2 - m2));
                        }
                    }
                    int res = min(res1, res2);
                    cout << (res == 1e9 ? -1 : res) << "\n";
                }
            }
        }
        ++t;
    }
    cout << endl;
    return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
