#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unroll-all-loops")

#include <bits/stdc++.h>

using namespace std;

#define take(x) (x >= tk)

void update_min(vector<int> & t, int i, int val, int v, int L, int R) {
	if (L > i || R <= i)
		return;
	else if (L + 1 == R) {
		t[v] = val;
	} else {
		int M = (L + R) / 2;
		update_min(t, i, val, 2 * v + 1, L, M);
		update_min(t, i, val, 2 * v + 2, M, R);
		t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	}
}

int seg_min(vector<int> & t, int l, int r, int v, int L, int R) {
	if (r <= L || R <= l)
		return 1e9+7;
	else if (l <= L && r >= R)
		return t[v];
	else {
		int M = (L + R) / 2;
		return min(seg_min(t, l, r, 2 * v + 1, L, M), seg_min(t, l, r, 2 * v + 2, M, R));
	}
}

void update_max(vector<int> & t, int i, int val, int v, int L, int R) {
	if (L > i || R <= i)
		return;
	else if (L + 1 == R) {
		t[v] = val;
	} else {
		int M = (L + R) / 2;
		update_max(t, i, val, 2 * v + 1, L, M);
		update_max(t, i, val, 2 * v + 2, M, R);
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	}
}

int seg_max(vector<int> & t, int l, int r, int v, int L, int R) {
	if (r <= L || R <= l)
		return -(1e9+7);
	else if (l <= L && r >= R)
		return t[v];
	else {
		int M = (L + R) / 2;
		return max(seg_max(t, l, r, 2 * v + 1, L, M), seg_max(t, l, r, 2 * v + 2, M, R));
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> xlast(n, -1);
	vector<int> ylast(m, -1);

	vector<int> txlast_min(4 * n, -1);
	vector<int> txlast_max(4 * n, -1);
	vector<int> tylast_min(4 * m, -1);
	vector<int> tylast_max(4 * m, -1);
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x; x--;
			xlast[x] = i;
			update_min(txlast_min, x, i, 0, 0, n);
			update_max(txlast_max, x, i, 0, 0, n);
		} else if (t == 2) {
			int y;
			cin >> y; y--;
			ylast[y] = i;
			update_min(tylast_min, y, i, 0, 0, m);
			update_max(tylast_max, y, i, 0, 0, m);
		} else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;
			int tk = i - k;
			int ans = 1e9 + 7;
			if (take(xlast[x1]) && take(ylast[y2])) {
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}
			if (take(ylast[y1]) && take(xlast[x2])) {
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}

			bool xgood = take(seg_min(txlast_min, min(x1, x2), max(x1, x2) + 1, 0, 0, n));
			bool ygood = take(seg_min(tylast_min, min(y1, y2), max(y1, y2) + 1, 0, 0, m));
			if (xgood || ygood) {
				cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
				continue;
			}

			if (take(xlast[x1]) && take(xlast[x2])) {
				if (take(seg_max(tylast_max, min(y1, y2), max(y1, y2) + 1, 0, 0, m))) {
					cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
					continue;
				}

				int L = 0, R = min(y1, y2);
				if (R > L && take(seg_max(tylast_max, L, R, 0, 0, m))) {
					while (L + 1 != R) {
						int M = (L + R) / 2;
						if (take(seg_max(tylast_max, M, R, 0, 0, m)))
							L = M;
						else
							R = M;
					}
					if (take(ylast[L]))
						ans = min(ans, abs(x1 - x2) + abs(y1 - L) + abs(y2 - L));
				}
				L = max(y1, y2), R = m - 1;
				if (R > L && take(seg_max(tylast_max, L + 1, R + 1, 0, 0, m))) {
					while (L + 1 != R) {
						int M = (L + R) / 2;
						if (take(seg_max(tylast_max, L + 1, M + 1, 0, 0, m)))
							R = M;
						else
							L = M;
					}
					if (take(ylast[R]))
						ans = min(ans, abs(x1 - x2) + abs(y1 - R) + abs(y2 - R));
				}
			}

			if (take(ylast[y1]) && take(ylast[y2])) {
				if (take(seg_max(txlast_max, min(x1, x2), max(x1, x2) + 1, 0, 0, n))) {
					cout << abs(y1 - y2) + abs(x1 - x2) << '\n';
					continue;
				}

				int L = 0, R = min(x1, x2);
				if (R > L && take(seg_max(txlast_max, L, R, 0, 0, n))) {
					while (L + 1 != R) {
						int M = (L + R) / 2;
						if (take(seg_max(txlast_max, M, R, 0, 0, n)))
							L = M;
						else
							R = M;
					}
					if (take(xlast[L]))
						ans = min(ans, abs(y1 - y2) + abs(x1 - L) + abs(x2 - L));
				}
				L = max(x1, x2), R = n - 1;
				if (R > L && take(seg_max(txlast_max, L + 1, R + 1, 0, 0, n))) {
					while (L + 1 != R) {
						int M = (L + R) / 2;
						if (take(seg_max(txlast_max, L + 1, M + 1, 0, 0, n)))
							R = M;
						else
							L = M;
					}
					if (take(xlast[R]))
						ans = min(ans, abs(y1 - y2) + abs(x1 - R) + abs(x2 - R));
				}
			}

			cout << (ans == 1e9 + 7 ? -1 : ans) << '\n';
		}
	}
}