#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 239;

struct St {
	int sz;
	vector<int> t;

	void pull(int v) {
		t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	} 

	void build(int v, int l, int r, const vector<int> &a) {
		if (l + 1 == r) {
			t[v] = a[l];
		} else {
			int m = (r + l) >> 1;
			build(2 * v + 1, l, m, a);
			build(2 * v + 2, m, r, a);
			pull(v);
		}
	}

	int query(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) {
			return INF;
		} else if (ql <= l && r <= qr) {
			return t[v];
		} else {
        	int m = (r + l) >> 1;
        	auto f = query(2 * v + 1, l, m, ql, qr);
        	auto s = query(2 * v + 2, m, r, ql, qr);
        	return min(f, s);
        }
	}

	void set(int v, int l, int r, int pos, int val) {
		if (l + 1 == r) {
			assert(l == pos);
        	t[v] = val;
        } else {
        	int m = (r + l) >> 1;
        	if (pos < m) {
            	set(2 * v + 1, l, m, pos, val);
            } else {
            	set(2 * v + 2, m, r, pos, val);
            }
            pull(v);
        }
	}

	int get(int l, int r) {
		r++;
		return query(0, 0, sz, l, r);
	}

	void set(int pos, int val) {
		set(0, 0, sz, pos, val);
	}

	St(vector<int> &a) {
		sz = (int)a.size();
		t.resize(4 * sz);
		build(0, 0, sz, a);
	}
};

struct Ft {
  	int sz;
	vector<int> t;

	void pull(int v) {
		t[v] = max(t[2 * v + 1], t[2 * v + 2]);
	} 

	void build(int v, int l, int r, const vector<int> &a) {
		if (l + 1 == r) {
			t[v] = a[l];
		} else {
			int m = (r + l) >> 1;
			build(2 * v + 1, l, m, a);
			build(2 * v + 2, m, r, a);
			pull(v);
		}
	}

	int query(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) {
			return -INF;
		} else if (ql <= l && r <= qr) {
			return t[v];
		} else {
        	int m = (r + l) >> 1;
        	auto f = query(2 * v + 1, l, m, ql, qr);
        	auto s = query(2 * v + 2, m, r, ql, qr);
        	return max(f, s);
        }
	}

	void set(int v, int l, int r, int pos, int val) {
		if (l + 1 == r) {
			assert(l == pos);
        	t[v] = val;
        } else {
        	int m = (r + l) >> 1;
        	if (pos < m) {
            	set(2 * v + 1, l, m, pos, val);
            } else {
            	set(2 * v + 2, m, r, pos, val);
            }
            pull(v);
        }
	}

	int get(int l, int r) {
		r++;
		return query(0, 0, sz, l, r);
	}

	void set(int pos, int val) {
		set(0, 0, sz, pos, val);
	}

	Ft(vector<int> &a) {
		sz = (int)a.size();
		t.resize(4 * sz);
		build(0, 0, sz, a);
	}
};

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> r(n);
	vector<int> c(m);
	St rs(r);
	St cs(c);
	Ft rf(r);
	Ft cf(c);
	int cnt = 1;
	for (int u = 0; u < q; u++) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int rw;
			cin  >> rw;
			rw--;
			r[rw] = cnt;
			rs.set(rw, cnt);
			rf.set(rw, cnt);
		} else if (tp == 2) {
			int cl;
			cin >> cl;
			cl--;
			c[cl] = cnt;
			cs.set(cl, cnt);
			cf.set(cl, cnt);	
		} else if (tp == 3) {
			int r1, c1, r2, c2, k;
			cin >> r1 >> c1 >> r2 >> c2 >> k;
			r1--;
			c1--;
			r2--;
			c2--;
			int mnc = cs.get(min(c1, c2), max(c1, c2));
			int mnr = rs.get(min(r1, r2), max(r1, r2));
			auto okr = [&](int i) {
				bool f1 = cnt - r[i] <= k;
				return f1;
			};
			auto okc = [&](int j) {
				bool f1 = cnt - c[j] <= k;
				return f1;				
			};
			if (cnt - mnc <= k || cnt - mnr <= k) {
           		cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				cnt++;
				continue; 	
            }
			if (!okr(r1) && !okc(c1)) {
				cout << -1 << '\n';
				cnt++;
				continue;	
			}		
			if (!okr(r2) && !okc(c2)) {
				cout << -1 << '\n';
				cnt++;
				continue;
			}
			if (okr(r1) && okc(c2)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				cnt++;
				continue;
			}
			if (okr(r2) && okc(c1)) {
				cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
				cnt++;
				continue;
			}
			if (okr(r1) && okr(r2)) {
				if (cf.get(min(c1, c2), max(c1, c2)) >= cnt - k) {
                	cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					cnt++;
					continue; 
                }
                int fca = -INF;
                int sca = INF;
                if (cf.get(0, min(c1, c2) - 1) >= cnt - k) {
                	int l = 0;
                	int r = min(c1, c2);
                	while (r - l > 1) {
                    	int mid = (r + l) >> 1;
                    	 if (cf.get(mid, min(c1, c2) - 1) >= cnt - k) {
                    	 	l = mid;
                    	 } else {
                    	 	r = mid;
                    	 }
                    }
                    fca = l;
                }
                if (cf.get(max(c1, c2) + 1, m - 1) >= cnt - k) {
                	int l = max(c1, c2) - 1;
                	int r = m - 1;
                	while (r - l > 1) {
                		int mid = (r + l) >> 1;
                		if (cf.get(max(c1, c2) + 1, mid) >= cnt - k) {
                			r = mid;		
                		} else {
                			l = mid;
                		}	
                	}
                	sca = r;
                }
                int ans = INF;
                if (fca != -INF) {
                	ans = min(ans, abs(c1 - fca) + abs(r1 - r2) + abs(fca - c2)); 
                }
                if (sca != INF) {
                	ans = min(ans, abs(c1 - sca) + abs(r1 - r2) + abs(sca - c2)); 
                } 
                if (ans == INF) {
					cout << -1 << '\n';
				} else {
					cout << ans << '\n';
				}
			} else {
				if (rf.get(min(r1, r2), max(r1, r2)) >= cnt - k) {
                	cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
					cnt++;
					continue; 
                }
                int fca = -INF;
                int sca = INF;
                if (rf.get(0, min(r1, r2) - 1) >= cnt - k) {
                	int l = 0;
                	int r = min(r1, r2);
                	while (r - l > 1) {
                    	int mid = (r + l) >> 1;
                    	 if (rf.get(mid, min(r1, r2) - 1) >= cnt - k) {
                    	 	l = mid;
                    	 } else {
                    	 	r = mid;
                    	 }
                    }
                    fca = l;
                }
                if (rf.get(max(r1, r2) + 1, n - 1) >= cnt - k) {
                	int l = max(r1, r2) - 1;
                	int r = n - 1;
                	while (r - l > 1) {
                		int mid = (r + l) >> 1;
                		if (rf.get(max(r1, r2) + 1, mid) >= cnt - k) {
                			r = mid;		
                		} else {
                			l = mid;
                		}	
                	}
                	sca = r;
                }
                int ans = INF;
                if (fca != -INF) {
                	ans = min(ans, abs(r1 - fca) + abs(c1 - c2) + abs(fca - r2));
                }
                if (sca != INF) {
                	ans = min(ans, abs(r1 - sca) + abs(c1 - c2) + abs(sca - r2));
                } 
                if (ans == INF) {
					cout << -1 << '\n';
				} else {
					cout << ans << '\n';
				}
   			}
		} else {
			assert(false);
		}
		cnt++;
	}	
}