#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18 + 239;

vector<vector<pair<int, int>>> g;

int dfs(int cur, int to, int limit) {
	if (0 > limit) {
		return -INF;
	}
	int ans = -INF;                              
	if (cur == to) {
		ans = max(ans, (int)0);	
	}
	for (auto t : g[cur]) {
		int cand = dfs(t.first, to, limit - t.second);
		if (cand != -INF) {
			ans = max(ans, cand + t.second);
		}
	}
	return ans;
}

void solve1(int n, int m, int q, int p, vector<pair<int, int>> qr) {
	for (auto cc : qr) {
		int f, r;
		tie(f, r) = cc;
		f--;
		int limit = (p * r) / (p - 1);
		int sl = dfs(0, f, limit);
		if (r <= sl && sl <= limit) {
        	cout << 1;
        } else {
        	cout << 0;
        }
	}
	cout << endl;
}
   
const int MAXN = 5003;
const int MAXR = 10002;

int can[MAXR][MAXR];

int timer = 1;
	
void dfs2(int cur, int cur_dist) {
	if (cur_dist >= MAXR) return;
	if (can[cur][cur_dist] != timer) {
     	can[cur][cur_dist] = timer;
     	for (auto t : g[cur]) {
     		dfs2(t.first, cur_dist + t.second);
     	}  
	}	
}

void solve2(int n, int m, int q, int p, vector<pair<int, int>> qr) {
	timer++;
	dfs2(0, 0);
	for (auto cc : qr) {
    	int f, r;
    	tie(f, r) = cc;
    	f--;
    	int sl = -1;
    	int limit = (p * r) / (p - 1);
    	for (int i = 0; i <= limit; i++) {
    		if (can[f][i] == timer) sl = i;
    	}
    	if (r <= sl && sl <= limit) {
        	cout << 1;
        } else {
        	cout << 0;
        }
    }           
    cout << endl;
}

void solve3(int n, int m, int q, int p, vector<pair<int, int>> qr) {
	assert(p == 2);
	vector<vector<int>> f(n);
	vector<int> s(n, -1);
	for (int i = 0; i < n; i++) {
		for (auto t : g[i]) {
			if (t.first == i + 1) {
				f[i + 1].push_back(t.second);
			}	
		}
	}
	for (int i = 1; i < n; i++) {
		assert(f[i].size() == 2);
		sort(f[i].begin(), f[i].end());
    	s[i] = f[i][1] - f[i][0];
    }
    //cerr << "ok" << endl;
	for (auto cc : qr) {
		int i, r;
		tie(i, r) = cc;
		i--;
		int sm = 0;
		vector<int> cn;
		for (int j = 1; j <= i; j++) {
			sm += f[j][0];
			cn.push_back(s[j]);
		}
		sort(cn.rbegin(), cn.rend());
		for (auto t : cn) {
			if (2 * r - (sm + t) >= 0) {
				sm += t;
			}
		}
		if (r <= sm && sm <= 2 * r) {
			cout << 1;
		} else {
			cout << 0;
		}
	}
	cout << endl;
}

void solve() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	g.clear();
	g.resize(n);
	int mr = -1;
	for (int i = 0; i < m; i++) {
		int u, v, d;
		cin >> u >> v >> d;
		u--;
		v--;
		g[u].push_back({v, d});
	}
	vector<pair<int, int>> qr(q);
	for (auto &t : qr) {
		cin >> t.first >> t.second;
		mr = max(mr, t.second);
	}
	if (mr <= 5002 && false) {
		solve2(n, m, q, p, qr);
	} else if (n <= 10 && m <= 10 && q <= 10 && false) {
		solve1(n, m, q, p, qr);
	} else {
		//assert(false);
		solve3(n, m, q, p, qr);
	}
}    	
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	
	 int t;
	 cin >> t;
	 while (t--) {
	 	solve();
	 }
}