#include <bits/stdc++.h>
 
#define __LOCAL
 
#ifdef __LOCAL
#define DBG(X) cerr << #X << "=" << (X) << endl;
#else
#define DBG(X) 42;
#endif
 
const int INT_INF = (int)2e9;
 
using namespace std;
 
#define endl '\n'
 
void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
 
const int MAX_N = (int)1e6 + 777;
 
int row[MAX_N], col[MAX_N];
int n, m, q;
 
struct MergeSortTree
{
    int* vals;
    int sz;
    set<int> t[4 * MAX_N];
    int cntz[4 * MAX_N];
 
    MergeSortTree(int* _vals, int _sz): vals(_vals), sz(_sz)
    {
        build(0, 0, sz - 1);
    }
 
    void build(int v, int tl, int tr)
    {
    	cntz[v] = 0;

        for(int i = tl; i <= tr; ++i)
        {
            t[v].insert(vals[i]);
 
            if(!vals[i])
            	++cntz[v];
        }
 
        if(tl != tr)
        {
            int tm = (tl + tr) / 2;
 
            build(2 * v + 1, tl, tm);
            build(2 * v + 2, tm + 1, tr);
        }
    }
 
    int getright(int v, int tl, int tr, int l, int r, int x)
    {
        if(t[v].lower_bound(x) == t[v].end())
            return -1;
 
        if(tl == tr)
        {
            return tl;
        }
        else
        {
            int tm = (tl + tr) / 2;
 
            if(r <= tm)
                return getright(2 * v + 1, tl, tm, l, r, x);
 
            if(l >= tm + 1)
                return getright(2 * v + 2, tm + 1, tr, l, r, x);
 
            int idx1 = getright(2 * v + 2, tm + 1, tr, tm + 1, r, x);
 
            if(idx1 != -1)
                return idx1;
 
            return getright(2 * v + 1, tl, tm, l, tm, x);
        }
    }
 
    int getleft(int v, int tl, int tr, int l, int r, int x)
    {
        if(t[v].lower_bound(x) == t[v].end())
            return -1;
 
        if(tl == tr)
        {
            return tl;
        }
        else
        {
            int tm = (tl + tr) / 2;
 
            if(r <= tm)
                return getleft(2 * v + 1, tl, tm, l, r, x);
 
            if(l >= tm + 1)
                return getleft(2 * v + 2, tm + 1, tr, l, r, x);
 
            int idx1 = getleft(2 * v + 1, tl, tm, l, tm, x);
 
            if(idx1 != -1)
                return idx1;
 
            return getleft(2 * v + 2, tm + 1, tr, tm + 1, r, x);
        }
    }
 
    int getmin(int v, int tl, int tr, int l, int r)
    {
        if(tl == l && tr == r)
        {
            return *(t[v].begin());
        }
        else
        {
            int tm = (tl + tr) / 2;
 
            if(r <= tm)
                return getmin(2 * v + 1, tl, tm, l, r);
 
            if(l >= tm + 1)
                return getmin(2 * v + 2, tm + 1, tr, l, r);
 
            int val1 = getmin(2 * v + 1, tl, tm, l, tm);
            int val2 = getmin(2 * v + 2, tm + 1, tr, tm + 1, r);
 
            return min(val1, val2);
        }
    }
 
    void change(int v, int tl, int tr, int i, int nval)
    {
    	if(vals[i])
    	{
			t[v].erase(vals[i]);
    	}
    	else
    	{
    		--cntz[v];

    		if(!cntz[v])
    			t[v].erase(vals[i]);
    	}
 
    	t[v].insert(nval);

        if(tl == tr)
        {
            vals[i] = nval;
        }
        else
        {
            int tm = (tl + tr) / 2;
 
            if(i <= tm)
                change(2 * v + 1, tl, tm, i, nval);
            else
                change(2 * v + 2, tm + 1, tr, i, nval);
        }
    }
};
 
void solve()
{
    //for(int i = 0; i < MAX_N; ++i)
        //row[i] = col[i] = 1;
 
    cin >> n >> m >> q;
 
    MergeSortTree trow(row, n);
    MergeSortTree tcol(col, m);
 
    for(int h = 1; h <= q; ++h)
    {
        int type;
        cin >> type;
 
        if(type == 1)
        {
            int r;
            cin >> r;
 
            //row[r] = h;
            trow.change(0, 1, n, r, h);
        }
        else if(type == 2)
        {
            int c;
            cin >> c;
 
            //col[c] = h;
            tcol.change(0, 1, m, c, h);
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
 
            int x = h - k;
            int ans = INT_INF;
 
            /*bool rowfl = true, colfl = true;
 
            for(int r = min(r1, r2); r <= max(r1, r2); ++r)
                rowfl &= (row[r] >= x);
 
            for(int c = min(c1, c2); c <= max(c1, c2); ++c)
                colfl &= (col[c] >= x);*/
 
            bool rowfl = trow.getmin(0, 1, n, min(r1, r2), max(r1, r2)) >= x;
            bool colfl = tcol.getmin(0, 1, m, min(c1, c2), max(c1, c2)) >= x;
 
            if(row[r1] >= x && col[c2] >= x)
                ans = min(ans, abs(r1 - r2) + abs(c1 - c2));
 
            if(row[r2] >= x && col[c1] >= x)
                ans = min(ans, abs(r1 - r2) + abs(c1 - c2));
 
            if(rowfl || colfl || (x <= 0))
                ans = min(ans, abs(r1 - r2) + abs(c1 - c2));
 
            if(row[r1] >= x && row[r2] >= x)
            {
                /*for(int c = 1; c <= m; ++c)
                    if(col[c] >= x)
                        ans = min(ans, abs(c - c1) + abs(r1 - r2) + abs(c - c2));*/
 
                vector<int> temp;
 
                temp.push_back(tcol.getright(0, 1, m, 1, min(c1, c2), x));
                temp.push_back(tcol.getright(0, 1, m, min(c1, c2), max(c1, c2), x));
                temp.push_back(tcol.getleft(0, 1, m, max(c1, c2), m, x));
 
                for(auto c: temp)
                    if(c != -1)
                        ans = min(ans, abs(c - c1) + abs(r1 - r2) + abs(c - c2));
            }
 
            if(col[c1] >= x && col[c2] >= x)
            {
                /*for(int r = 1; r <= n; ++r)
                    if(row[r] >= x)
                        ans = min(ans, abs(r - r1) + abs(c1 - c2) + abs(r - r2));*/
 
                vector<int> temp;
 
                temp.push_back(trow.getright(0, 1, n, 1, min(r1, r2), x));
                temp.push_back(trow.getright(0, 1, n, min(r1, r2), max(r1, r2), x));
                temp.push_back(trow.getleft(0, 1, n, max(r1, r2), n, x));
 
                for(auto r: temp)
                	if(r != -1)
                    	ans = min(ans, abs(r - r1) + abs(c1 - c2) + abs(r - r2));
            }
 
            cout << (ans >= INT_INF ? -1 : ans) << endl;
        }
    }
}
 
int main()
{
    fastio();
    solve();
    return 0;
}