#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int n, m, q;
int a[101][101];

bool ok(int x, int y)
{
    return (1 <= x && x <= n && 1 <= y && y <= m);
}
int cx[4] = {-1, 0, 1, 0};
int cy[4] = {0, -1, 0, 1};
/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 1 2 3 3 6
*/

int dist(int x1, int y1, int x2, int y2, int k)
{
    vector<pair<int, int> > q;
    int d[101][101];
    pair<int, int> p[101][101];
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++)
            d[i][j] = -1;
    if (a[x1][y1] <= k)
    {
        q.push_back({x1, y1});
        d[x1][y1] = 0;
    }
    for (int i = 0; i < q.size(); i++)
    {
        int x = q[i].first;
        int y = q[i].second;
        for (int j = 0; j < 4; j++)
        {
            int X = x + cx[j];
            int Y = y + cy[j];
            if (ok(X, Y) && d[X][Y] == -1 && a[X][Y] <= k)
            {
                q.push_back({X, Y});
                p[X][Y] = {cx[j], cy[j]};
                d[X][Y] = d[x][y] + 1;
            }
        }
    }
    vector<pair<int, int> > moves;
    if (d[x2][y2] == -1)
        return -1;
    int xx2 = x2, yy2 = y2;
    while (xx2 != x1 || yy2 != y1)
    {
        int nx2 = xx2 - p[xx2][yy2].first;
        int ny2 = yy2 - p[xx2][yy2].second;
        moves.push_back({- p[xx2][yy2].first, - p[xx2][yy2].second});
        xx2 = nx2;
        yy2 = ny2;
    }
    reverse(moves.begin(), moves.end());
    int op = 0;
    for (int i = 0; i + 1 < moves.size(); i++)
    {
        if (moves[i].first != moves[i + 1].first || moves[i].second != moves[i + 1].second)
            op++;
        //cout << moves[i].first << " " << moves[i].second << endl;
    }
    //cout << endl;
    if (op > 2)
    {
        cout << 100 / 0;
    }
    return d[x2][y2];
}

int main()
{
    cin >> n >> m >> q;
    for (int i = 0; i < q; i++)
    {
        int t = 0;
        cin >> t;
        for (int i = 1; i <= n; i++)
        {
            for (int j = 1; j <= m; j++)
            {
                a[i][j]++;
                //cout << a[i][j];
            }
            //cout << endl;
        }
        if (t == 1)
        {
            int x;
            cin >> x;
            for (int j = 1; j <= m; j++)
                a[x][j] = 0;
        }
        if (t == 2)
        {
            int x;
            cin >> x;
            for (int j = 1; j <= n; j++)
                a[j][x] = 0;
        }
        if (t == 3)
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            cout << dist(x1, y1, x2, y2, k) << "\n";
        }
    }
}
