#include <bits/stdc++.h>
using namespace std;

struct SegTree{
    vector<int> t;
    int n;

    SegTree(int n): n(n) {
        t.resize(4 * n);
    }

    void merge(int v) {
        t[v] = max(t[(v << 1) + 1], t[(v << 1) + 2]);
    }

    void upd(int i, int x, int v, int vl, int vr) {
        if (vr - vl == 1) {
            t[v] = x;
            return;
        }
        int vm = (vl + vr) >> 1;
        if (i < vm)
            upd(i, x, (v << 1) + 1, vl, vm);
        else
            upd(i, x, (v << 1) + 2, vm, vr);
        merge(v);
    }

    void upd(int i, int x) {
        upd(i, x, 0, 0, n);
    }

    int down_first(int x, int v, int vl, int vr) {
        if (vr - vl == 1)
            return vl;
        int vm = (vl + vr) >> 1;
        if (t[(v << 1) + 1] >= x)
            return down_first(x, (v << 1) + 1, vl, vm);
        return down_first(x, (v << 1) + 2, vm, vr);
    }

    int get_first(int l, int r, int x, int v, int vl, int vr) {
        if (vl >= r || vr <= l)
            return -1;
        if (vl >= l && vr <= r) {
            if (t[v] >= x)
                return down_first(x, v, vl, vr);
            return -1;
        }
        int vm = (vl + vr) >> 1;
        int ans1 = get_first(l, r, x, (v << 1) + 1, vl, vm);
        if (ans1 != -1)
            return ans1;
        return get_first(l, r, x, (v << 1) + 2, vm, vr);
    }

    int get_first(int l, int r, int x) {
        if (l > r)
            swap(l, r);
        return get_first(l, r + 1, x, 0, 0, n);
    }

    int down_last(int x, int v, int vl, int vr) {
        if (vr - vl == 1)
            return vl;
        int vm = (vl + vr) >> 1;
        if (t[(v << 1) + 2] >= x)
            return down_last(x, (v << 1) + 2, vm, vr);
        return down_last(x, (v << 1) + 1, vl, vm);
    }

    int get_last(int l, int r, int x, int v, int vl, int vr) {
        if (vl >= r || vr <= l)
            return -1;
        if (vl >= l && vr <= r) {
            if (t[v] >= x)
                return down_last(x, v, vl, vr);
            return -1;
        }
        int vm = (vl + vr) >> 1;
        int ans1 = get_last(l, r, x, (v << 1) + 2, vm, vr);
        if (ans1 != -1)
            return ans1;
        return get_last(l, r, x, (v << 1) + 1, vl, vm);
    }

    int get_last(int l, int r, int x) {
        if (l > r)
            swap(l, r);
        return get_last(l, r + 1, x, 0, 0, n);
    }
};

struct SegTree2{
    vector<int> t;
    int n;

    SegTree2(int n): n(n) {
        t.resize(4 * n);
    }

    void merge(int v) {
        t[v] = min(t[(v << 1) + 1], t[(v << 1) + 2]);
    }

    void upd(int i, int x, int v, int vl, int vr) {
        if (vr - vl == 1) {
            t[v] = x;
            return;
        }
        int vm = (vl + vr) >> 1;
        if (i < vm)
            upd(i, x, (v << 1) + 1, vl, vm);
        else
            upd(i, x, (v << 1) + 2, vm, vr);
        merge(v);
    }

    void upd(int i, int x) {
        upd(i, x, 0, 0, n);
    }

    int get(int l, int r, int v, int vl, int vr) {
        if (vl >= r || vr <= l)
            return INT_MAX;
        if (vl >= l && vr <= r)
            return t[v];
        int vm = (vl + vr) >> 1;
        return min(get(l, r, (v << 1) + 1, vl, vm), get(l, r, (v << 1) + 2, vm, vr));
    }

    int get(int l, int r) {
        if (l > r)
            swap(l, r);
        return get(l, r + 1, 0, 0, n);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    SegTree ups1(m), ups2(n);
    SegTree2 mins1(m), mins2(n);
    vector<int> R(n), C(m);

    int tm = 0;

    while (q--) {
        ++tm;
        cout.flush();

        int tp;
        cin >> tp;

        if (tp == 1) {
            int r;
            cin >> r;
            --r;
            ups2.upd(r, tm);
            mins2.upd(r, tm);
            R[r] = tm;
        }

        else if (tp == 2) {
            int c;
            cin >> c;
            --c;
            ups1.upd(c, tm);
            mins1.upd(c, tm);
            C[c] = tm;
        }

        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            --r1, --c1, --r2, --c2;

            if (min(tm - R[r1], tm - C[c1]) > k || min(tm - R[r2], tm - C[c2]) > k) {
                cout << "-1\n";
                continue;
            }

            if (tm - R[r1] <= k) {
                if (tm - C[c2] <= k || ups1.get_first(c1, c2, tm - k) != -1 || mins2.get(r1, r2) >= tm - k) {
                    cout << abs(c2 - c1) + abs(r2 - r1) << '\n';
                    continue;
                }
            }

            if (tm - C[c1] <= k) {
                if (tm - R[r2] <= k || ups2.get_first(r1, r2, tm - k) != -1 || mins1.get(c1, c2) >= tm - k) {
                    cout << abs(r2 - r1) + abs(c2 - c1) << '\n';
                    continue;
                }
            }

            int ANS1 = -1, ANS2 = -1;

            if (tm - R[r1] <= k) {

                int mx = max(c1, c2), mn = min(c1, c2);

                int ans1 = -1, ans2 = -1;
                //if (mx + 1 < m)
                    ans1 = ups1.get_first(mx + 1, m - 1, tm - k);
                //if (mn - 1 >= 0)
                    ans2 = ups1.get_first(0, mn - 1, tm - k);

                if (!(ans1 == -1 && ans2 == -1)) {

                    int ans = min(ans1 != -1 ? abs(c1 - ans1) + abs(c2 - ans1) : INT_MAX,
                                  ans2 != -1 ? abs(c1 - ans2) + abs(c2 - ans2) : INT_MAX);
                    ANS1 = ans + abs(r1 - r2);
                }
            }

            if (tm - C[c1] <= k) {

                int mx = max(r1, r2), mn = min(r1, r2);

                int ans1 = -1, ans2 = -1;
                //if (mx + 1 < n)
                    ans1 = ups2.get_first(mx + 1, n - 1, tm - k);
                //if (mn - 1 >= 0)
                    ans2 = ups2.get_first(0, mn - 1, tm - k);

                if (!(ans1 == -1 && ans2 == -1)) {

                    int ans = min(ans1 != -1 ? abs(r1 - ans1) + abs(r2 - ans1) : INT_MAX,
                                  ans2 != -1 ? abs(r1 - ans2) + abs(r2 - ans2) : INT_MAX);
                    ANS2 = ans + abs(c1 - c2);
                }
            }

            if (ANS1 != -1 && ANS2 != -1) {
                cout << min(ANS1, ANS2) << '\n';
            }
            else {
                cout << ANS1 + ANS2 + 1 << '\n';
            }
        }
    }
    /*
3 3 228
1 3
2 1
2 3
3 2 1 1 3 3
2 1
1 1
3 2 1 1 1 3
3 2 1 1 3 228
     */
}
