#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <deque>
using namespace std;
#define int long long

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector <int> l1(n, -1), l2(m, -1);
	for (int i = 0; i < q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			l1[r - 1] = i;
		}
		else if (type == 2) {
			int r;
			cin >> r;
			l2[r - 1] = i;
		}
		else {
			vector <vector <int>> dist(n, vector <int>(m, -1));
			deque <pair <int, int>> st;
			int sx, sy, tx, ty, k;
			cin >> sx >> sy >> tx >> ty >> k;
			--sx, --sy, --tx, --ty;
			if (i - max(l1[sx], l2[sy]) <= k) st.push_back({ sx, sy }), dist[sx][sy] = 0;
			while (st.size() && dist[tx][ty] == -1) {
				vector <pair <int, int>> son;
				auto now = st.front();
				st.pop_front();
				int mx = now.first, my = now.second;
				if (mx != 0) son.push_back({ mx - 1, my });
				if (mx != n - 1) son.push_back({ mx + 1, my });
				if (my != 0) son.push_back({ mx, my - 1 });
				if (my != m - 1) son.push_back({ mx, my + 1 });
				for (auto& v : son) {
					if (i - max(l1[v.first], l2[v.second]) > k || dist[v.first][v.second] != -1) continue;
					dist[v.first][v.second] = dist[mx][my] + 1;
					st.push_back({ v.first, v.second });
				}
			}
			cout << dist[tx][ty] << endl;
		}
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef _DEBUG
	cout << "Execution time: " << (clock() + 0.0) / 1000 << "s.\n";
#endif
}