#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <deque>
#pragma optimize("Ofast");
#pragma optimize("unroll-loops");
using namespace std;
#define int long long

struct node {
	int l, r;
	int mx;
	int mn;
	node *cl, *cr;
};

node* build(int l, int r) {
	node * root = new node;
	root->l = l, root->r = r;
	root->mx = -1;
	root->mn = -1;
	if (l != r) {
		int x = (l + r) / 2;
		root->cl = build(l, x);
		root->cr = build(x + 1, r);
	}
	return root;
}

int querymx(int l, int r, node* root) {
	if (l > r) swap(l, r);
	if (l > root->r || r < root->l) return -1e9;
	if (l <= root->l && root->r <= r) return root->mx;
	return max(querymx(l, r, root->cl), querymx(l, r, root->cr));
}

int querymn(int l, int r, node* root) {
	if (l > r) swap(l, r);
	if (l > root->r || r < root->l) return 1e9;
	if (l <= root->l && root->r <= r) return root->mn;
	return min(querymn(l, r, root->cl), querymn(l, r, root->cr));
}

void change(int x, int val, node* root) {
	if (x < root->l || x > root->r) return;
	else if (root->l == x && root->r == x) {
		root->mx = val;
		root->mn = val;
	}
	else {
		change(x, val, root->cl);
		change(x, val, root->cr);
		root->mx = max(root->cl->mx, root->cr->mx);
		root->mn = min(root->cl->mn, root->cr->mn);
	}
}

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector <int> l1(n, -1), l2(m, -1);
	node *lroot = build(0, n - 1);
	node *rroot = build(0, m - 1);
	for (int i = 0; i < q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			l1[r - 1] = i;
			change(r - 1, i, lroot);
		}
		else if (type == 2) {
			int r;
			cin >> r;
			l2[r - 1] = i;
			change(r - 1, i, rroot);
		}
		else {
			int sx, sy, tx, ty, k;
			cin >> sx >> sy >> tx >> ty >> k;
			--sx, --sy, --tx, --ty;
			if (i - l1[sx] <= k && i - l2[ty] <= k ||
				i - l2[sy] <= k && i - l1[tx] <= k ||
				i - querymn(sy, ty, rroot) <= k ||
				i - querymn(sx, tx, lroot) <= k) {
				cout << abs(sx - tx) + abs(sy - ty) << "\n";
			}
			else {
				int res = 1e9;
				if (i - l2[sy] <= k && i - l2[ty] <= k) {
					if (i - querymx(sx, tx, lroot) <= k) res = abs(sx - tx) + abs(sy - ty);
					int l = 0, r = 1e9;
					while (r - l > 1) {
						int x = (l + r) / 2;
						if (i - querymx(max(0ll, sx - x), min(n - 1, sx + x), lroot) <= k) r = x;
						else l = x;
					}
					int y1 = max(0ll, sx - r);
					if (i - l1[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
					y1 = min(n - 1, sx + r);
					if (i - l1[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}


					l = 0, r = 1e9;
					while (r - l > 1) {
						int x = (l + r) / 2;
						if (i - querymx(max(0ll, tx - x), min(n - 1, tx + x), lroot) <= k) r = x;
						else l = x;
					}
					y1 = max(0ll, tx - r);
					if (i - l1[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
					y1 = min(n - 1, tx + r);
					if (i - l1[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
				}

				if (i - l1[sx] <= k && i - l1[tx] <= k) {
					if (i - querymx(sy, ty, rroot) <= k) res = abs(sx - tx) + abs(sy - ty);
					int l = 0, r = 1e9;
					while (r - l > 1) {
						int x = (l + r) / 2;
						if (i - querymx(max(0ll, sy - x), min(m - 1, sy + x), rroot) <= k) r = x;
						else l = x;
					}
					int y1 = max(0ll, sy - r);
					if (i - l2[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
					y1 = min(m - 1, sy + r);
					if (i - l2[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}

					l = 0, r = 1e9;
					while (r - l > 1) {
						int x = (l + r) / 2;
						if (i - querymx(max(0ll, ty - x), min(m - 1, ty + x), rroot) <= k) r = x;
						else l = x;
					}
					y1 = max(0ll, ty - r);
					if (i - l2[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
					y1 = min(m - 1, ty + r);
					if (i - l2[y1] <= k) {
						res = min(res, abs(sx - tx) + abs(sy - ty) + r + r);
					}
				}
				cout << (res == 1e9 ? -1 : res) << "\n";
			}
		}
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef _DEBUG
	cout << "Execution time: " << (clock() + 0.0) / 1000 << "s.\n";
#endif
}