#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <deque>
using namespace std;


struct node {
	int l, r;
	int mx;
	node *cl, *cr;
};

node* build(int l, int r) {
	node * root = new node;
	root->l = l, root->r = r;
	root->mx = -1;
	if (l != r) {
		int x = (l + r) / 2;
		root->cl = build(l, x);
		root->cr = build(x + 1, r);
	}
	return root;
}

int query(int l, int r, node* root) {
	if (l > root->r || r < root->l) return -1e9;
	if (l <= root->l && root->r <= r) return root->mx;
	return max(query(l, r, root->cl), query(l, r, root->cr));
}

void change(int x, int val, node* root) {
	if (x < root->l || x > root->r) return;
	else if (root->l == x && root->r == x) {
		root->mx = val;
	}
	else {
		change(x, val, root->cl);
		change(x, val, root->cr);
		root->mx = max(root->cl->mx, root->cr->mx);
	}
}

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	vector <int> l1(n, -1);
	node *root = build(0, n - 1);
	for (int i = 0; i < q; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			l1[r - 1] = i;
			change(r - 1, i, root);
		}
		else {
			int sx, sy, tx, ty, k;
			cin >> sx >> sy >> tx >> ty >> k;
			--sx, --sy, --tx, --ty;
			if (sx > tx) swap(sx, tx);
			if (i - query(sx, tx, root) <= k) cout << abs(sx - tx) + abs(tx - ty);
			else cout << -1;
		}
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef _DEBUG
	cout << "Execution time: " << (clock() + 0.0) / 1000 << "s.\n";
#endif
}