#include <bits/stdc++.h>

using namespace std;

#define INF 4e6

struct DO {
    vector<pair<int, int>> t;
    int n;

    pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
        return {min(a.first, b.first), max(a.second, b.second)};
    }

    DO() {

    }

    DO(int n) : n(n) {
        t.resize(n * 4, {0, 0});
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (l == r - 1) {
            t[v] = {val, val};
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    pair<int, int> get(int v, int tl, int tr, int l, int r) {
        if (r <= tl || l >= tr) {
            return {INF, -INF};
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int m = (tr + tl) / 2;
        return merge(get(v * 2, tl, m, l, r), get(v * 2 + 1, m, tr, l, r));
    }
};

DO hor, ver;


void hor_init(int n) {
    hor = DO(n + 1);
    hor.update(n, -INF);
}

void ver_init(int m) {
    ver = DO(m + 1);
    ver.update(m, -INF);
}

void hor_upd(int x, int val) {
    hor.update(x, val);
}

void ver_upd(int x, int val) {
    ver.update(x, val);
}

bool is_on_hor(int x, int k) {
    return hor.get(x, x + 1).second <= k;
}

bool is_on_ver(int x, int k) {
    return ver.get(x, x + 1).second <= k;
}

bool hor_go(int x1, int x2, int k) {
    if (x1 > x2) {
        swap(x1, x2);
    }
    return (hor.get(x1, x2 + 1).second <= k);
}

bool ver_go(int x1, int x2, int k) {
    if (x1 > x2) {
        swap(x1, x2);
    }
    return (ver.get(x1, x2 + 1).second <= k);
}

int hor_left(int x, int k) {
    int l = x;
    int r = hor.n;
    while (r - 1 > l) {
        int m = (r + l) / 2;
        if (hor.get(x, m + 1).first <= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return r == hor.n - 1 ? -1 : r;
}

int hor_right(int x, int k) {
    int l = -1;
    int r = x;
    while (r - 1 > l) {
        int m = (r + l) / 2;
        if (hor.get(m, x).first <= k) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int ver_down(int x, int k) {
    int l = x;
    int r = ver.n;
    while (r - 1 > l) {
        int m = (r + l) / 2;
        if (ver.get(x, m + 1).first <= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return r == ver.n - 1 ? -1 : r;
}

int ver_up(int x, int k) {
    int l = -1;
    int r = x;
    while (r - 1 > l) {
        int m = (r + l) / 2;
        if (ver.get(m, x).first <= k) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


int dist(int x1, int y1, int x2, int y2) {
    return abs(x1 - x2) + abs(y1 - y2);
}

signed main() {
    bool flag = false;
    int n, m, q;
    cin >> n >> m >> q;
    if (q > 1e5) {
        flag = true;
    }
    hor_init(m);
    ver_init(n);
    for (int step = 1; step <= q; ++step) {
        int cmd;
        cin >> cmd;
        if (cmd == 1) {
            int x;
            cin >> x;
            ver_upd(x - 1, -step);
        } else if (cmd == 2) {
            int x;
            cin >> x;
            hor_upd(x - 1, -step);
        } else {
            int x1, y1, x2, y2, k;
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            k -= step;
            x1--;
            x2--;
            y1--;
            y2--;
            bool bhor1, bhor2, bver1, bver2;
            bhor1 = is_on_hor(x1, k);
            bhor2 = is_on_hor(x2, k);
            bver1 = is_on_ver(y1, k);
            bver2 = is_on_ver(y2, k);
            if ((!bhor1) && (!bver1)) {
                cout << "-1\n";
                continue;
            }
            if ((!bhor2) && (!bver2)) {
                cout << "-1\n";
                continue;
            }
            if (bhor1 && bver2) {
                cout << dist(x1, y1, x2, y2) << "\n";
                continue;
            }
            if (bver1 && bhor2) {
                cout << dist(x1, y1, x2, y2) << "\n";
                continue;
            }
            if (bhor1) {
                if (hor_go(x1, x2, k)) {
                    cout << dist(x1, y1, x2, y2) << "\n";
                    continue;
                }
                int ans = INF;
                int yU = ver_up(y1, k);
                int yD = ver_down(y1, k);
                if (yU != -1) {
                    ans = min(ans, dist(x1, y1, x1, yU) + dist(x1, yU, x2, y2));
                }
                if (yD != -1) {
                    ans = min(ans, dist(x1, y1, x1, yD) + dist(x1, yD, x2, y2));
                }
                cout << (ans == INF ? -1 : ans) << "\n";
                continue;
            }
            if (bver1) {
                if (ver_go(y1, y2, k)) {
                    cout << dist(x1, y1, x2, y2) << "\n";
                    continue;
                }
                if (flag) {
                    cout << -1 << "\n";
                }
                int ans = INF;
                int xL = hor_left(x1, k);
                int xR = hor_right(x1, k);
                if (xL != -1) {
                    ans = min(ans, dist(x1, y1, xL, y1) + dist(xL, y1, x2, y2));
                }
                if (xR != -1) {
                    ans = min(ans, dist(x1, y1, xR, y1) + dist(xR, y1, x2, y2));
                }
                cout << (ans == INF ? -1 : ans) << "\n";
                continue;
            }
            cout << "undetected\n";
        }
    }
    return 0;
}