#include <bits/stdc++.h>

using namespace std;

#define int long long
#define INF 1e6

vector<int> hor, ver;

void hor_init(int n) {
    hor.resize(n);
}

void ver_init(int m) {
    ver.resize(m);
}

void hor_upd(int x, int val) {
    hor[x] = val;
}

void ver_upd(int x, int val) {
    ver[x] = val;
}

bool is_on_hor(int x, int k) {
    return hor[x] <= k;
}

bool is_on_ver(int x, int k) {
    return ver[x] <= k;
}

bool hor_go(int x1, int x2, int k) {
    if (x1 > x2) {
        swap(x1, x2);
    }
    for (int i = x1; i <= x2; ++i) {
        if (hor[i] > k) {
            return 0;
        }
    }
    return 1;
}

bool ver_go(int x1, int x2, int k) {
    if (x1 > x2) {
        swap(x1, x2);
    }
    for (int i = x1; i <= x2; ++i) {
        if (ver[i] > k) {
            return 0;
        }
    }
    return 1;
}

int hor_left(int x, int k) {
    for (int i = x; i >= 0; --i) {
        if (hor[i] <= k) {
            return i;
        }
    }
    return -1;
}

int hor_right(int x, int k) {
    for (int i = x; i < hor.size(); ++i) {
        if (hor[i] <= k) {
            return i;
        }
    }
    return -1;
}

int ver_up(int y, int k) {
    for (int i = y; i >= 0; --i) {
        if (ver[i] <= k) {
            return i;
        }
    }
    return -1;
}

int ver_down(int y, int k) {
    for (int i = y; i < ver.size(); ++i) {
        if (ver[i] <= k) {
            return i;
        }
    }
    return -1;
}


int dist(int x1, int y1, int x2, int y2) {
    return abs(x1 - x2) + abs(y1 - y2);
}

signed main() {
    int n, m, q;
    cin >> n >> m >> q;
    hor_init(m);
    ver_init(n);
    for (int step = 1; step <= q; ++step) {
        int cmd;
        cin >> cmd;
        if (cmd == 1) {
            int x;
            cin >> x;
            ver_upd(x - 1, -step);
        } else if (cmd == 2) {
            int x;
            cin >> x;
            hor_upd(x - 1, -step);
        } else {
            int x1, y1, x2, y2, k;
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            k -= step;
            x1--;
            x2--;
            y1--;
            y2--;
            bool bhor1, bhor2, bver1, bver2;
            bhor1 = is_on_hor(x1, k);
            bhor2 = is_on_hor(x2, k);
            bver1 = is_on_ver(y1, k);
            bver2 = is_on_ver(y2, k);
            if ((!bhor1) && (!bver1)) {
                cout << "-1\n";
                continue;
            }
            if ((!bhor2) && (!bver2)) {
                cout << "-1\n";
                continue;
            }
            if (bhor1 && bver2) {
                cout << dist(x1, y1, x2, y2) << "\n";
                continue;
            }
            if (bver1 && bhor2) {
                cout << dist(x1, y1, x2, y2) << "\n";
                continue;
            }
            if (bhor1) {
                if (hor_go(x1, x2, k)) {
                    cout << dist(x1, y1, x2, y2) << "\n";
                    continue;
                }
                int ans = INF;
                int yU = ver_up(y1, k);
                int yD = ver_down(y1, k);
                if (yU != -1) {
                    ans = min(ans, dist(x1, y1, x1, yU) + dist(x1, yU, x2, y2));
                }
                if (yD != -1) {
                    ans = min(ans, dist(x1, y1, x1, yD) + dist(x1, yD, x2, y2));
                }
                cout << (ans == INF ? -1 : ans) << "\n";
                continue;
            }
            if (bver1) {
                if (ver_go(y1, y2, k)) {
                    cout << dist(x1, y1, x2, y2) << "\n";
                    continue;
                }
                int ans = INF;
                int xL = hor_left(x1, k);
                int xR = hor_right(x1, k);
                if (xL != -1) {
                    ans = min(ans, dist(x1, y1, xL, y1) + dist(xL, y1, x2, y2));
                }
                if (xR != -1) {
                    ans = min(ans, dist(x1, y1, xR, y1) + dist(xR, y1, x2, y2));
                }
                cout << (ans == INF ? -1 : ans) << "\n";
                continue;
            }
            cout << "undetected\n";
        }
    }
    return 0;
}