#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <assert.h>
#include <algorithm>
#include <queue>

using namespace std;

struct inf {
	int v, p;
	int v2, p2;
};
int n, m, q;
inf* h1;
inf* h2;
int* H1;
int* H2;

void update1(int i, int v, int L = 0, int R = n - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) {
		h1[id].v = v;
		h1[id].v2 = v;
	}
	else {
		int M = (R + L) / 2;
		update1(i, v, L, M, id * 2);
		update1(i, v, M + 1, R, id * 2 + 1);
		if (h1[id * 2].v > h1[id * 2 + 1].v)
			h1[id] = h1[id * 2];
		else h1[id] = h1[id * 2 + 1];
		if (h1[id * 2].v2 > h1[id * 2 + 1].v2) {
			h1[id].v2 = h1[id * 2 + 1].v2;
		}
		else h1[id].v2 = h1[id * 2].v2;
	}
}

void update2(int i, int v, int L = 0, int R = m - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) {
		h2[id].v = v;
		h2[id].v2 = v;
	}
	else {
		int M = (R + L) / 2;
		update2(i, v, L, M, id * 2);
		update2(i, v, M + 1, R, id * 2 + 1);
		if (h2[id * 2].v > h2[id * 2 + 1].v)
			h2[id] = h2[id * 2];
		else h2[id] = h2[id * 2 + 1];
		if (h2[id * 2].v2 > h2[id * 2 + 1].v2) {
			h2[id].v2 = h2[id * 2 + 1].v2;
		}
		else h2[id].v2 = h2[id * 2].v2;
	}
}

int max1(int l, int r, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1e9;
	if (l <= L && R <= r) return h1[id].v;
	int M = (R + L) / 2;
	return max(max1(l, r, L, M, id * 2), max1(l, r, M + 1, R, id * 2 + 1));
}

int max2(int l, int r, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1e9;
	if (l <= L && R <= r) return h2[id].v;
	int M = (R + L) / 2;
	return max(max2(l, r, L, M, id * 2), max2(l, r, M + 1, R, id * 2 + 1));
}

int min1(int l, int r, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return 1e9;
	if (l <= L && R <= r) return h1[id].v2;
	int M = (R + L) / 2;
	return min(min1(l, r, L, M, id * 2), min1(l, r, M + 1, R, id * 2 + 1));
}

int min2(int l, int r, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return 1e9;
	if (l <= L && R <= r) return h2[id].v2;
	int M = (R + L) / 2;
	return min(min2(l, r, L, M, id * 2), min2(l, r, M + 1, R, id * 2 + 1));
}
void build1(int L = 0, int R = n - 1, int id = 1) {
	if (L == R) {
		h1[id].v = 0;
		h1[id].v2 = 0;
		h1[id].p = L;
	}
	else {
		int M = (R + L) / 2;
		build1(L, M, id * 2);
		build1(M + 1, R, id * 2 + 1);
		if (h1[id * 2].v > h1[id * 2 + 1].v)
			h1[id] = h1[id * 2];
		else h1[id] = h1[id * 2 + 1];
	}
}

void build2(int L = 0, int R = m - 1, int id = 1) {
	if (L == R) {
		h2[id].v = 0;
		h2[id].v2 = 0;
		h2[id].p = L;
	}
	else {
		int M = (R + L) / 2;
		build2(L, M, id * 2);
		build2(M + 1, R, id * 2 + 1);
		if (h2[id * 2].v > h2[id * 2 + 1].v)
			h2[id] = h2[id * 2];
		else h2[id] = h2[id * 2 + 1];
	}
}

int getFirstMore2(int l, int r, int k, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H2[L] <= k) return -1;
		if (L == R && H2[L] > k) return L;
		int M = (R + L) / 2;
		if (h2[id * 2].v > k) return getFirstMore2(l, r, k, L, M, id * 2);
		else return getFirstMore2(l, r, k, M + 1, R, id * 2 + 1);
	}
	int M = (R + L) / 2;
	int res = getFirstMore2(l, r, k, L, M, id * 2);
	if (res != -1) return res;
	return getFirstMore2(l, r, k, M + 1, R, id * 2 + 1);
}

int getFirstMore1(int l, int r, int k, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H1[L] <= k) return -1;
		if (L == R && H1[L] > k) return L;
		int M = (R + L) / 2;
		if (h1[id * 2].v > k) return getFirstMore1(l, r, k, L, M, id * 2);
		else return getFirstMore1(l, r, k, M + 1, R, id * 2 + 1);
	}
	int M = (R + L) / 2;
	int res = getFirstMore1(l, r, k, L, M, id * 2);
	if (res != -1) return res;
	return getFirstMore1(l, r, k, M + 1, R, id * 2 + 1);
}
int getLastMore1(int l, int r, int k, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H1[L] <= k) return -1;
		if (L == R && H1[L] > k) return L;
		int M = (R + L) / 2;
		if (h1[id * 2 + 1].v > k) return getLastMore1(l, r, k, M + 1, R, id * 2 + 1);
		else return getLastMore1(l, r, k, L, M, id * 2);
	}
	int M = (R + L) / 2;
	int res = getLastMore1(l, r, k, M + 1, R, id * 2 + 1);
	if (res != -1) return res;
	return getLastMore1(l, r, k, L, M, id * 2);
}

int getLastMore2(int l, int r, int k, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H2[L] <= k) return -1;
		if (L == R && H2[L] > k) return L;
		int M = (R + L) / 2;
		if (h2[id * 2 + 1].v > k) return getLastMore2(l, r, k, M + 1, R, id * 2 + 1);
		else return getLastMore2(l, r, k, L, M, id * 2);
	}
	int M = (R + L) / 2;
	int res = getLastMore2(l, r, k, M + 1, R, id * 2 + 1);
	if (res != -1) return res;
	return getLastMore2(l, r, k, L, M, id * 2);
}

int getFirstMin2(int l, int r, int k, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H2[L] > k) return -1;
		if (L == R && H2[L] <= k) return L;
		int M = (R + L) / 2;
		if (h2[id * 2].v2 <= k) return getFirstMin2(l, r, k, L, M, id * 2);
		else return getFirstMin2(l, r, k, M + 1, R, id * 2 + 1);
	}
	int M = (R + L) / 2;
	int res = getFirstMin2(l, r, k, L, M, id * 2);
	if (res != -1) return res;
	return getFirstMin2(l, r, k, M + 1, R, id * 2 + 1);
}

int getFirstMin1(int l, int r, int k, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H1[L] > k) return -1;
		if (L == R && H1[L] <= k) return L;
		int M = (R + L) / 2;
		if (h1[id * 2].v2 <= k) return getFirstMin1(l, r, k, L, M, id * 2);
		else return getFirstMin1(l, r, k, M + 1, R, id * 2 + 1);
	}
	int M = (R + L) / 2;
	int res = getFirstMin1(l, r, k, L, M, id * 2);
	if (res != -1) return res;
	return getFirstMin1(l, r, k, M + 1, R, id * 2 + 1);
}
int getLastMin1(int l, int r, int k, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H1[L] > k) return -1;
		if (L == R && H1[L] <= k) return L;
		int M = (R + L) / 2;
		if (h1[id * 2 + 1].v2 <= k) return getLastMin1(l, r, k, M + 1, R, id * 2 + 1);
		else return getLastMin1(l, r, k, L, M, id * 2);
	}
	int M = (R + L) / 2;
	int res = getLastMin1(l, r, k, M + 1, R, id * 2 + 1);
	if (res != -1) return res;
	return getLastMin1(l, r, k, L, M, id * 2);
}

int getLastMin2(int l, int r, int k, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) {
		if (L == R && H2[L] > k) return -1;
		if (L == R && H2[L] <= k) return L;
		int M = (R + L) / 2;
		if (h2[id * 2 + 1].v <= k) return getLastMin2(l, r, k, M + 1, R, id * 2 + 1);
		else return getLastMin2(l, r, k, L, M, id * 2);
	}
	int M = (R + L) / 2;
	int res = getLastMin2(l, r, k, M + 1, R, id * 2 + 1);
	if (res != -1) return res;
	return getLastMin2(l, r, k, L, M, id * 2);
}

int main() {
	scanf("%d %d %d", &n, &m, &q);
	h1 = new inf[4 * n];
	H1 = new int[n];
	H2 = new int[m];
	h2 = new inf[4 * m];
	for (int i = 0; i < m; i++) H2[i] = 0;
	for (int i = 0; i < n; i++) H1[i] = 0;
	build1();
	build2();
	int t;
	int pos;
	int x1, y1, x2, y2, k;
	int d1, d2;
	int now;
	int maxh;
	int l1, r1, l2, r2;
	int res1, res2;
	for (int l = 0; l < q; l++) {
		scanf("%d", &t);
		if (t != 3) {
			scanf("%d", &pos);
			pos--;
			if (t == 1) {
				//h1[pos] = -l - 1;
				H1[pos] = -l - 1;
				update1(pos, -l - 1);
			}
			else {
				//h2[pos] = -l - 1;
				H2[pos] = -l - 1;
				update2(pos, -l - 1);
			}
		}
		else {
			scanf("%d %d %d %d %d", &x1, &y1, &x2, &y2, &k);
			x1--; y1--;
			x2--; y2--;
			res2 = 1e9;
			k -= (l + 1);
			if (x1 == x2 && y1 == y2) {
				res2 = 0;
			}
			else if (min(H1[x1], H2[y1]) > k || min(H1[x2], H2[y2]) > k) {
				res2 = -1;
			}
			d1 = 1e9, d2 = 1e9;
			l1 = y1; r1 = y1;
			l2 = y2; r2 = y2;
			if (H1[x1] <= k) {
				l1 = 0;
				r1 = m - 1;
			}
			else {
				/*maxh = -1e9;
				for (int i = y1; i < m; i++) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x1], maxh) <= k) r1 = i;
					else break;
				}*/
				r1 = getFirstMore2(y1, m - 1, k) - 1;
				if(r1 == -2) r1 = m - 1;
				/*maxh = -1e9;
				for (int i = y1; i >= 0; i--) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x1], maxh) <= k) l1 = i;
					else break;
				}*/
				l1 = getLastMore2(0, y1, k) + 1;
				if (l1 > y1) l1 = y1;
			}
			if (H1[x2] <= k) {
				l2 = 0;
				r2 = m - 1;
			}
			else {
				/*
				maxh = -1e9;
				for (int i = y2; i < m; i++) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x2], maxh) <= k) r2 = i;
					else break;
				}*/
				r2 = getFirstMore2(y2, m - 1, k) - 1;
				if (r2 == -2) r2 = m - 1;
				/*maxh = -1e9;
				for (int i = y2; i >= 0; i--) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x2], maxh) <= k) l2 = i;
					else break;
				}*/
				l2 = getLastMore2(0, y2, k) + 1;
				if (l2 > y2) l2 = y2;
			}
			l1 = max(l1, l2);
			r1 = min(r1, r2);
			if (l1 <= r1) {
				/*maxh = -1e9;
				for (int i = min(x1, x2); i <= max(x1, x2); i++) {
					if (h1[i] > maxh) maxh = h1[i];
				}*/
				maxh = max1(min(x1, x2), max(x1, x2));
				if (maxh <= k) d1 = abs(x1 - x2) + abs(y1 - y2);
				else {
					if (y1 > y2) swap(y1, y2);
					if (min2(l1, r1) > k) {
						printf("-1\n");
						continue;
					}
					else if(min2(y1, y2) <= k) d1 = abs(x1 - x2) + abs(y1 - y2);
					int tmp = getLastMin2(0, y1, k);
					if (tmp != -1) {
						d1 = min(d1, abs(y1 - tmp) + abs(y2 - tmp) + abs(x1 - x2));
					}
					tmp = getFirstMin2(y2, m - 1, k);
					if (tmp != -1) {
						d1 = min(d1, abs(y1 - tmp) + abs(y2 - tmp) + abs(x1 - x2));
					}
				}
			}
			l1 = x1; r1 = x1;
			l2 = x2; r2 = x2;
			if (H2[y1] <= k) {
				l1 = 0;
				r1 = n - 1;
			}
			else {
				/*
				maxh = -1e9;
				for (int i = x1; i < n; i++) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y1], maxh) <= k) r1 = i;
					else break;
				}*/
				r1 = getFirstMore1(x1, n - 1, k) - 1;
				if (r1 == -2) r1 = n - 1;
				/*maxh = -1e9;
				for (int i = x1; i >= 0; i--) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y1], maxh) <= k) l1 = i;
					else break;
				}*/
				l1 = getLastMore1(0, x1, k) + 1;
				if (l1 > x1) l1 = x1;
			}
			if (H2[y2] <= k) {
				l2 = 0;
				r2 = n - 1;
			}
			else {
				/*
				maxh = -1e9;
				for (int i = x2; i < n; i++) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y2], maxh) <= k) r2 = i;
					else break;
				}*/
				r2 = getFirstMore1(x2, n - 1, k) - 1;
				if (r2 == -2) r2 = n - 1;
				/*
				maxh = -1e9;
				for (int i = x2; i >= 0; i--) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y2], maxh) <= k) l2 = i;
					else break;
				}*/
				l2 = getLastMore1(0, x2, k) + 1;
				if (l2 > x2) l2 = x2;
			}
			l1 = max(l1, l2);
			r1 = min(r1, r2);
			if (l1 <= r1) {
				/*maxh = -1e9;
				for (int i = min(y1, y2); i <= max(y1, y2); i++) {
					if (h2[i] > maxh) maxh = h2[i];
				}*/
				maxh = max2(min(y1, y2), max(y1, y2));
				if (maxh <= k) d2 = abs(x1 - x2) + abs(y1 - y2);
				else {
					if (x1 > x2) swap(x1, x2);
					if (min1(l1, r1) > k) {
						printf("-1\n");
						continue;
					}
					else if (min1(x1, x2) <= k) d1 = abs(x1 - x2) + abs(y1 - y2);
					int tmp = getLastMin1(0, x1, k);
					if(tmp != -1){
						d2 = min(d2, abs(x1 - tmp) + abs(x2 - tmp) + abs(y1 - y2));
					}
					tmp = getFirstMin1(x2, n - 1, k);
					if (tmp != -1) {
						d2 = min(d2, abs(x1 - tmp) + abs(x2 - tmp) + abs(y1 - y2));
					}
				}
			}
			if (d2 < d1) d1 = d2;
			if (res2 == 1e9) {
				if (d1 == 1e9) res2 = -1;
				else res2 = d1;
			}
			printf("%d\n", res2);
		}
	}
	system("pause");
	return 0;
}