#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef struct Node* pNode;
struct Node {
    int left, right;
    pNode child_left, child_right;
    int value;

    Node(int left, int right)
        : left(left), right(right) {
        child_left = child_right = nullptr;
        value = 0;
    }
};

pNode build(int left, int right) {
    pNode root = new Node(left, right);
    if (right - left == 1) {
        return root;
    }
    root->child_left = build(left, (left + right) / 2);
    root->child_right = build((left + right) / 2, right);
    return root;
}

void update(pNode root, int index) {
    if (root->right <= index || root->left > index) {
        return;
    }
    if (root->right - root->left == 1) {
        root->value = -1;
        return;
    }
    update(root->child_left, index);
    update(root->child_right, index);
    root->value = -1;
}

int get(pNode root, int left, int right) {
    if (root->left >= right || root->right <= left) {
        return 2;
    }
    if (root->left >= left && root->right <= right) {
        return root->value;
    }
    return min(get(root->child_left, left, right), get(root->child_right, left, right));
}

int main() {
#ifdef _DEBUG
    ifstream cin("input.txt");
    ofstream cout("output.txt");
#else
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> m >> n;
    vector<int> a(n);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
    }
    vector<vector<int>> index(n);
    for (int i = 0; i < m; ++i) {
        index[a[i]].emplace_back(i);
    }
    pNode root = build(0, m);
    vector<pair<int, pair<int, int>>> ans;
    for (int i = 0; i < m; ++i) {
        int x = a[i];
        if (x != -1) {
            if (get(root, index[x][0], index[x].back() + 1) == -1) {
                cout << -1 << endl;
                return 0;
            }
            for (auto j : index[x]) {
                a[j] = -1;
                update(root, j);
            }
            ans.emplace_back(x + 1, make_pair(index[x][0] + 1, index[x].back() + 1));
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) {
        cout << i.first << " " << i.second.first << " " << i.second.second << "\n";
    }
    return 0;
}
