#include <bits/stdc++.h>

using namespace std;

//#define endl '\n'

////////////////////////////////////////////////////
typedef pair<int, int> ii;
typedef pair<ii, int> iii;

const int INF = (int)1e9 + 1;

#define all(a) a.begin(), a.end()
#define sz(a) ((int)a.size())
#define fi first
#define se second
////////////////////////////////////////////////////


const int MAX_N = (int)1e6;

struct node {
    int mx, mn;
    node(int mx = -1, int mn = -1) : mx(mx), mn(mn) { }
};

node comb(node &a, node &b) {
    return {max(a.mx, b.mx), min(a.mn, b.mn)};
}

node th[MAX_N * 4];
node tv[MAX_N * 4];

void update(node t[], int v, int tl, int tr, int pos, int val) {
    if (tl == tr)
        t[v] = node(val, val);
    else {
        int tm = (tl + tr) / 2;
        if (pos <= tm)
            update(t, v * 2, tl, tm, pos, val);
        else
            update(t, v * 2 + 1, tm + 1, tr, pos, val);
        t[v] = comb(t[v * 2], t[v * 2 + 1]);
    }
}

int query_mx(node t[], int v, int tl, int tr, int l, int r) {
    if (l > r)
        return -INF;
    if (tl == l && tr == r)
        return t[v].mx;
    int tm = (tl + tr) / 2;
    return max(query_mx(t, v * 2, tl, tm, l, min(r, tm)),
               query_mx(t, v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}
int query_mn(node t[], int v, int tl, int tr, int l, int r) {
    if (l > r)
        return INF;
    if (tl == l && tr == r)
        return t[v].mn;
    int tm = (tl + tr) / 2;
    return min(query_mn(t, v * 2, tl, tm, l, min(r, tm)),
               query_mn(t, v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

int query_pref1(node t[], int v, int tl, int tr, int pos, int k) {
    if (tl == tr)
        return tl;
    int tm = (tl + tr) / 2;
    if (t[v * 2 + 1].mx >= k)
        return query_pref1(t, v * 2 + 1, tm + 1, tr, pos, k);
    else
        return query_pref1(t, v * 2, tl, tm, pos, k);
}
int query_pref0(node t[], int v, int tl, int tr, int pos, int k) {
    if (tl == tr)
        return -1;
    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        int res = query_pref0(t, v * 2, tl, tm, pos, k);
        return res;
    } else {
        int res = query_pref0(t, v * 2 + 1, tm + 1, tr, pos, k);
        if (res == -1) {
            if (t[v * 2].mx >= k)
                return query_pref1(t, v * 2, tl, tm, pos, k);
            else
                return -1;
        } else
            return res;
    }
}


int query_suff1(node t[], int v, int tl, int tr, int pos, int k) {
    if (tl == tr)
        return tl;
    int tm = (tl + tr) / 2;
    if (t[v * 2 + 1].mx >= k)
        return query_suff1(t, v * 2 + 1, tm + 1, tr, pos, k);
    else
        return query_suff1(t, v * 2, tl, tm, pos, k);
}
int query_suff0(node t[], int v, int tl, int tr, int pos, int k) {
    if (tl == tr)
        return -1;
    int tm = (tl + tr) / 2;
    if (pos <= tm) {
        int res = query_suff0(t, v * 2, tl, tm, pos, k);
        if (res == -1) {
            if (t[v * 2 + 1].mx >= k)
                return query_suff1(t, v * 2 + 1, tm + 1, tr, pos, k);
            else
                return -1;
        } else
            return res;
    } else {
        int res = query_suff0(t, v * 2 + 1, tm + 1, tr, pos, k);
        return res;
    }
}

int n, m, q;

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    cin >> n >> m >> q;
    /*if (n == 4 && m == 3 && q == 9) {
        cout << 3 << endl << -1 << endl << 5 << endl << -1 << endl << 3 << endl;
        return 0;
    }*/
    for (int i = 0; i < q; ++i) {
        int c;
        cin >> c;
        if (c == 1) {
            int x;
            cin >> x, --x;
            update(th, 1, 0, n - 1, x, i);
        } else if (c == 2) {
            int y;
            cin >> y, --y;
            update(tv, 1, 0, m - 1, y, i);
        } else if (c == 3) {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            --x1, --y1, --x2, --y2;
            k = max(-1, i - k);

            int res = 0;
            int h1 = query_mx(th, 1, 0, n - 1, x1, x1);
            int v1 = query_mx(tv, 1, 0, m - 1, y1, y1);
            int h2 = query_mx(th, 1, 0, n - 1, x2, x2);
            int v2 = query_mx(tv, 1, 0, m - 1, y2, y2);
            //cout << h1 << " " << v1 << " " << h2 << " " << v2 << ": " << k << endl;

            if (h1 < k && v1 < k || h2 < k && v2 < k)
                res = -1;
            else if (h1 >= k && v2 >= k || v1 >= k && h2 >= k)
                res = abs(x1 - x2) + abs(y1 - y2);
            else {
                node *th = ::th;
                node *tv = ::tv;
                int n = ::n;
                int m = ::m;
                if (v1 >= k && v2 >= k) {
                    swap(h1, v1);
                    swap(h2, v2);
                    swap(x1, y1);
                    swap(x2, y2);
                    swap(th, tv);
                    swap(n, m);
                }

                int mx = query_mx(tv, 1, 0, m - 1, min(y1, y2), max(y1, y2));
                int mn = query_mn(th, 1, 0, n - 1, min(x1, x2), max(x1, x2));
                if (mx >= k || mn >= k)
                    res = abs(x1 - x2) + abs(y1 - y2);
                else {
                    int l = min(y1, y2), r = max(y1, y2);
                    int pref = query_pref0(tv, 1, 0, m - 1, l, k);
                    int suff = query_suff0(tv, 1, 0, m - 1, r, k);
                    res = INF;
                    if (pref != -1)
                        res = min(res, abs(x1 - x2) + (l - pref) + (r - pref));
                    if (suff != -1)
                        res = min(res, abs(x1 - x2) + (suff - l) + (suff - r));
                    if (res == INF)
                        res = -1;
                }
            }

            //cout << "! " << res << endl;
            cout << res << endl;
        }
    }

    return 0;
}


/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6

*/
