#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define pb push_back
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
typedef vector<int> vint;
int getInt() { int a; cin >> a; return a; }
const int oo = 1e9;
vector<pair<int, int>> rows, cols;

inline int f(int x, int a, int b) { return (x == -1) ? oo : (abs(x - a) + abs(x - b)); }

struct segTreeIntMin {
    vint val;
    int query(int l, int r, int cur = 1, int ll = 1, int rr = oo) {
        rr = min(rr, sz(val) >> 1);
        if (l > r)
            return oo;
        if (l == ll && r == rr)
            return val[cur];

        int mid = (ll + rr) >> 1;
        return min(query(l, min(r, mid), cur << 1, ll, mid), query(max(mid + 1, l), r, cur << 1 | 1, mid + 1, rr));
    }

    void upd(int p, int v) {
        val[p + (sz(val) >> 1) - 1] = v;
        for (int cur = (p + (sz(val) >> 1) - 1) >> 1; cur; cur >>= 1)
            val[cur] = min(val[cur << 1], val[cur << 1 | 1]);
    }

    segTreeIntMin(int n) {
        while (n & (n - 1))
            n++;
        val = vint(n * 2, 0);
    }
};

struct segTreeSet {
    vector<set<int>> val;
    int queryMore(int l, int r, int lim, int cur = 1, int ll = 1, int rr = oo) { ///min x >= lim
        rr = min(rr, sz(val) >> 1);
        if (l > r)
            return oo;
        if (l == ll && r == rr) {
            auto d = val[cur].lower_bound(lim);
            if (d == val[cur].end())
                return oo;
            else
                return (*d);
        }

        int mid = (ll + rr) >> 1;
        return min(queryMore(l, min(r, mid), lim, cur << 1, ll, mid), queryMore(max(mid + 1, l), r, lim, cur << 1 | 1, mid + 1, rr));
    }

    int queryLess(int l, int r, int lim, int cur = 1, int ll = 1, int rr = oo) { ///max x <= lim
        rr = min(rr, sz(val) >> 1);
        if (l > r)
            return -1;
        if (l == ll && r == rr) {
            auto d = val[cur].upper_bound(lim);
            if (d == val[cur].begin())
                return -1;
            else
                return (*(--d));
        }

        int mid = (ll + rr) >> 1;
        return max(queryLess(l, min(r, mid), lim, cur << 1, ll, mid), queryLess(max(mid + 1, l), r, lim, cur << 1 | 1, mid + 1, rr));
    }

    void upd(int p, int v) {
        for (int cur = p + (sz(val) >> 1) - 1; cur; cur >>= 1)
            val[cur].insert(v);
    }

    segTreeSet(int n) {
        while (n & (n - 1))
            n++;
        val = vector<set<int>>(n * 2);
    }
};

void run() {
    int n, m, q;
    cin >> n >> m >> q;

    segTreeIntMin col(m + 1), row(n + 1);
    segTreeSet rows(q + 1), cols(q + 1);

    int rowMp[n + 1], colMp[m + 1];
    memset(rowMp, 0, sizeof rowMp);
    memset(colMp, 0, sizeof colMp);

    for (int h = 1; h <= q; h++) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            rows.upd(h, r);
            row.upd(r, h);
            rowMp[r] = h;
        } else if (t == 2) {
            int c;
            cin >> c;
            cols.upd(h, c);
            col.upd(c, h);
            colMp[c] = h;
        } else {
            assert(t == 3);
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;

            ///min l, h - l = k; l = h - k
            int l = max(0, h - k), r = h;

            bool hasr1 = rowMp[r1] >= l, hasc1 = colMp[c1] >= l,
                 hasr2 = rowMp[r2] >= l, hasc2 = colMp[c2] >= l;
            bool allCols = col.query(min(c1, c2), max(c1, c2)) >= l, allRows = row.query(min(r1, r2), max(r1, r2)) >= l;

            l = max(l, 1);

            int closestCol = -1;
            int var1 = cols.queryMore(l, r, min(c1, c2)), var2 = cols.queryLess(l, r, min(c1, c2));
            if (f(var1, c1, c2) > f(var2, c1, c2))
                closestCol = var2;
            else
                closestCol = var1;

            int closestRow = -1;
            var1 = rows.queryMore(l, r, min(r1, r2)); var2 = rows.queryLess(l, r, min(r1, r2));
            if (f(var1, r1, r2) > f(var2, r1, r2))
                closestRow = var2;
            else
                closestRow = var1;

            int ans = oo;
            if ((hasr1 && hasc2) || (hasc1 && hasr2) || allCols || allRows)
                ans = min(ans, abs(r1 - r2) + abs(c1 - c2));

            if (hasr1 && hasr2 && closestCol != -1)
                ans = min(ans, abs(c1 - closestCol) + abs(r1 - r2) + abs(closestCol - c2));

            if (hasc1 && hasc2 && closestRow != -1)
                ans = min(ans, abs(r1 - closestRow) + abs(c1 - c2) + abs(r2 - closestRow));

            if (ans == oo)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
    }
}
/* 3 -1 5 -1 3
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
