#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

const int M = (int)2e5;
const ll INF = (ll)1e18;

int get_dif(int h, pair<int, int> d) {
	if (h > d.second)
		return h - d.second;
	if (h < d.first)
		return d.first - h;
	return 0;
}

bool is_inside(pair<int, int> s1, pair<int, int> s2) {
	return s2.first >= s1.first && s2.second <= s1.second;
}

int m, n, k;
vector<int> h[M];
vector<pair<int, int>> d, tmp;
vector<ll> ans;
ll sum;

void solve(int l, int r, int kl, int kr) {
	if (r - l < 1)
		return;

	int c = (l + r) / 2, kc;
	ll cur;

	ans[c] = INF;
	for (int i = kl; i < kr; i++) {
		cur = 0;
		for (int j = 0; j < m; j++)
			cur += (ll)get_dif(h[j][2 * c], d[i]) + (ll)get_dif(h[j][2 * c + 1], d[i]);
		if (ans[c] > cur) {
			kc = i;
			ans[c] = cur;
		}
	}
	if (r - l == 1)
		return;
	solve(l, c, kl, kc + 1);
	solve(c + 1, r, kc, kr);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> m >> n >> k;
	tmp.resize(k);
	for (int i = 0; i < k; i++)
		cin >> tmp[i].first >> tmp[i].second;
	for (int i = 0; i < m; i++)
		h[i].resize(2 * n);
	for (int i = 0; i < m; i++)
		for (int j = 0; j < 2 * n; j++)
			cin >> h[i][j];

	for (int i = 0; i < m; i++)
		sort(h[i].begin(), h[i].end());

	sort(tmp.begin(), tmp.end(), [](auto p1, auto p2) {
		if (p1.first != p2.first)
			return p1.first < p2.first;
		return p1.second > p2.second;
	});
	d.push_back(tmp[0]);
	for (int i = 1; i < k; i++)
		if (!is_inside(d.back(), tmp[i]))
			d.push_back(tmp[i]);
	k = (int)d.size();

	ans.resize(n);
	solve(0, n, 0, k);

	sum = 0;
	for (ll i : ans)
		sum += i;
	cout << sum << endl;

	//system("pause");
	return 0;
}