#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>

#define ll long long
#define endl '\n'

using namespace std;

const int N = (int)1e6;
const ll P = 998244353;
const int NONE = (int)2e9;

struct Trap {
	int x, y, w;
	friend istream &operator>>(istream &in, Trap &t) {
		in >> t.x >> t.y >> t.w;
		t.x--;
		t.y--;
		return in;
	}
	bool operator<(Trap &other) {
		return y < other.y;
	}
};

int n, m, k, pos;
int dp[2][7][N];
ll ans;
vector<Trap> tr;

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	for (int i = 0; i < 7; i++)
		for (int j = 0; j < N; j++)
			dp[0][i][j] = dp[1][i][j] = NONE;

	cin >> n >> m >> k;
	tr.resize(k);
	for (int i = 0; i < k; i++)
		cin >> tr[i];

	pos = -8 + tr[0].y;
	pos = min(pos, 0);
	sort(tr.begin(), tr.end());
	for (int i = 0; i < k; i++) {
		if (i == 0 || tr[i].y - tr[i - 1].y > 8)
			pos += 8;
		else
			pos += tr[i].y - tr[i - 1].y;
		dp[0][tr[i].x][pos] = dp[1][tr[i].x][pos] = tr[i].w;
	}
	m = pos + 1;

	for (int i = 0; i < n; i++)
		dp[0][i][m] = dp[1][i][m] = 0;
	for (int j = 0; j < m; j++)
		dp[0][n][j] = dp[1][n][j] = 0;

	for (int i = n - 1; i >= 0; i--)
		for (int j = m - 1; j >= 0; j--) {
			if (dp[0][i][j] == NONE)
				dp[0][i][j] = min(dp[1][i + 1][j], dp[1][i][j + 1]);
			if (dp[1][i][j] == NONE)
				dp[1][i][j] = max(dp[0][i + 1][j], dp[0][i][j + 1]);
		}

	/*cerr << endl;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			cerr << dp[0][i][j] << ' ';
		cerr << endl;
	}*/

	//cout << endl;
	ans = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			ans = (ans + P * 2 + (ll)dp[0][i][j]) % P;
	cout << ans << endl;

	//system("pause");
	return 0;
}