#include <bits/stdc++.h>

#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define sz(x) int(x.size())

using namespace std;

template<typename T>
bool uax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool uin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

typedef long long ll;

const ll mod = 998244353;
const ll inf = ll(1e18);

ll n, m, k;
vector<vector<ll>> a, dp, ndp;

ll get(ll r, ll c) {
    if (r < 0 || c < 0 || r >= n || c >= m) {
        return 0;
    }
    if (a[r][c] == inf) {
        return dp[r][c];
    }
    return a[r][c];
}

ll nget(ll r, ll c) {
    if (r < 0 || c < 0 || r >= n || c >= m) {
        return 0;
    }
    if (a[r][c] == inf) {
        return ndp[r][c];
    }
    return a[r][c];
}

void read() {
    cin >> n >> m >> k;
    dp.resize(n, vector<ll>(m, inf));
    ndp.resize(n, vector<ll>(m, inf));
    a.resize(n, vector<ll>(m, inf));
    for (ll i = 0; i < k; ++i) {
        ll r, c, x;
        cin >> r >> c >> x;
        --r; --c;
        a[r][c] = x;
    }
}

void solve() {
    ll cnt = 0;
    for (ll r = n - 1; r >= 0; --r) {
        for (ll c = m - 1; c >= 0; --c) {
            if (a[r][c] != inf) {
                dp[r][c] = a[r][c];
                ndp[r][c] = a[r][c];
                continue;
            }
            dp[r][c] = min(nget(r + 1, c), nget(r, c + 1));
            ndp[r][c] = max(get(r + 1, c), get(r, c + 1));
        }
    }
    for (int r = 0; r < n; ++r) {
        for (int c = 0; c < m; ++c) {
            cnt += dp[r][c] + mod;
            cnt %= mod;
        }
    }
    cout << cnt << "\n";
}

int main() {
#ifdef MY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
    return 0;
}
