#include <iostream>
#include <algorithm>
#include <climits>

struct Range {
    long start;
    long end;

    static bool compare(Range& r1, Range& r2) {
        return r1.start < r2.start || (r1.start == r2.start && r1.end <= r2.end);
    }
};

int main() {
    long group_count, table_count, type_count;
    std::cin >> group_count >> table_count >> type_count;

    Range* types = new Range[type_count];
    for (long type = 0; type < type_count; type++)
        std::cin >> types[type].start >> types[type].end;

    std::sort(types, types + type_count, Range::compare);

    long* heights = new long[2 * group_count * table_count];
    for (long group = 0; group < group_count; group++) {
        for (long h = 0; h < 2 * table_count; h++)
            std::cin >> heights[group * 2 * table_count + h];
        std::sort(heights + group * 2 * table_count, heights + (group + 1) * 2 * table_count);
    }

    if (table_count == 1) {
        // Sub-problem 1
        long min_sum = LONG_MAX;

        for (long type = 0; type < type_count; type++) {
            long current_sum = 0;
            for (long i = 0; i < 2 * group_count * table_count; i++) {
                long h = heights[i];
                if (h < types[type].start)
                    current_sum += types[type].start - h;
                else if (h > types[type].end)
                    current_sum += h - types[type].end;
            }

            if (current_sum < min_sum)
                min_sum = current_sum;
        }

        std::cout << min_sum << std::endl;
    } else if (group_count == 1) {
        // Sub-problem 2
        long sum = 0;

        for (long i = 0; i < 2 * table_count; i += 2) {
            long current_min = LONG_MAX;
            for (long type = 0; type < type_count; type++) {
                long h1 = heights[i];
                long h2 = heights[i + 1];

                long a1;
                if (h1 < types[type].start)
                    a1 = types[type].start - h1;
                else if (h1 > types[type].end)
                    a1 = h1 - types[type].end;
                else
                    a1 = 0;

                long a2;
                if (h2 < types[type].start)
                    a2 = types[type].start - h1;
                else if (h2 > types[type].end)
                    a2 = h2 - types[type].end;
                else
                    a2 = 0;

                if (a1 + a2 < current_min)
                    current_min = a1 + a2;
            }
            sum += current_min;
        }

        std::cout << sum << std::endl;
    } else {
        std::cout << "???" << std::endl;
    }

    return 0;
}