#include <iostream>
#include <string>

bool match(std::string pat, long pat_hash, char* result, long start, long hash) {
    if (pat_hash == hash) {
        for (long i = 0; i < pat.size(); i++) {
            if (pat[i] != result[start + i])
                return false;
        }
        return true;
    }
    return false;
}

int main() {
    long pat_len, blocks;
    std::cin >> pat_len >> blocks;

    std::string pat;
    std::getline(std::cin, pat);
    std::getline(std::cin, pat);

    char result[1000000];
    long result_len = 0;
    for (long block = 0; block < blocks; block++) {
        long type;
        std::cin >> type;
        if (type == 1) {
            std::string to_add;
            std::getline(std::cin, to_add);

            std::copy(to_add.begin() + 1, to_add.end(), result + result_len);
            result_len += to_add.size() - 1;
        } else {
            long pos, len;
            std::cin >> pos >> len;

            for (long index = 0; index < len; index++) {
                result[result_len + index] = result[pos - 1 + index];
            }
            result_len += len;
        }
    }

    long hash = 0;
    for (long i = 0; i < pat_len; i++)
        hash = (hash + pat[i] - 'a') % 997;

    long current_hash = 0;
    for (long i = 0; i < pat_len; i++)
        current_hash = (current_hash + result[i] - 'a') % 997;

    long count = match(pat, hash, result, 0, current_hash) ? 1 : 0;
    for (long i = 0; i < result_len - pat_len; i++) {
        current_hash = ((current_hash - result[i] + result[i + pat_len]) % 997 + 997) % 997;
        count += match(pat, hash, result, i + 1, current_hash) ? 1 : 0;
    }

    std::cout << count << std::endl;

    return 0;
}