#include <iostream>
#include <vector>

const long long MOD = 998244353;

int main(void) {
    int n = 0, m = 0, k = 0;
    std::cin >> n >> m >> k;
    std::vector <int> r(k), c(k), v(k);
    int **dpMin = new int *[n];
    int **dpMax = new int *[n];
    bool **used = new bool *[n];
    for (int i = 0; i < n; i++) {
        dpMin[i] = new int[m];
        dpMax[i] = new int[m];
        used[i] = new bool[m];
        for (int j = 0; j < m; j++)
            used[i][j] = 0;
    }

    for (int i = 0; i < k; i++) {
        std::cin >> r[i] >> c[i] >> v[i];
        r[i]--; c[i]--;
        used[r[i]][c[i]] = 1;
        dpMin[r[i]][c[i]] = v[i];
        dpMax[r[i]][c[i]] = v[i];
    }

    if (!used[n - 1][m - 1])
        dpMin[n - 1][m - 1] = dpMax[n - 1][m - 1] = 0;
    for (int i = m - 2; i >= 0; i--)
        if (!used[n - 1][i]) {
            dpMin[n - 1][i] = std::min(0, dpMax[n - 1][i + 1]);
            dpMax[n - 1][i] = std::max(0, dpMin[n - 1][i + 1]);
        }
    for (int i = n - 2; i >= 0; i--)
        if (!used[i][m - 1]) {
            dpMin[i][m - 1] = std::min(0, dpMax[i + 1][m - 1]);
            dpMax[i][m - 1] = std::max(0, dpMin[i + 1][m - 1]);
        }

    for (int i = n - 2; i >= 0; i--)
        for (int j = m - 2; j >= 0; j--)
            if (!used[i][j]) {
                dpMin[i][j] = std::min(dpMax[i][j + 1], dpMax[i + 1][j]);
                dpMax[i][j] = std::max(dpMin[i][j + 1], dpMin[i + 1][j]);
            }

    long long sum = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            sum = (sum + dpMin[i][j]) % MOD;
            if (sum < 0)
                sum += MOD;
            //std::cout << dpMin[i][j] << "(" << dpMax[i][j] << ")\t";
        }
        //std::cout << std::endl;
    }
    std::cout << sum << std::endl;
    return 0;
}
