#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
const int INF = 1e9;
const int MOD = 1e9 + 7;
mt19937 rng(time(0));
int n, m, k;

vector<vector<int>> h;
vector<vector<int>> hehe;
vector<pair<int, int>> seg;
ll ans[MAXN];


inline int cost(int x, int l, int r) {
    if (x <= l) {
        return l - x; 
    }
    if (x >= r) {
        return x - r;
    }
    return 0;
}
 
inline ll calc(int i, int j) {
    ll kek = 0;
    for (int t = 0; t < 2 * m; t++) {
        kek += cost(hehe[i][t], seg[j].first, seg[j].second);
        kek += cost(hehe[i][t], seg[j].first, seg[j].second);
    }
    return kek;
}
 
inline bool check(int i, int j) {
    ll kek = calc(i, j);
    if (kek < ans[i]) {
        ans[i] = kek;
        return 1;
    }
    return 0;
}
 

void init() {
	h.assign(m, vector<int>(2 * n));
	for (int i = 0; i < MAXN; i++) {
		ans[i] = 1ll * INF * INF;
	}
}

void solve() {
	init();
	seg.resize(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
		seg[i].second *= -1;
	}
	sort(seg.begin(), seg.end());
	for (int i = 0; i < k; i++) {
		seg[i].second *= -1;
	}
	int maxr = 0;
	vector<int> bl(k);
	for (int i = 0; i < k; i++) {
		if (seg[i].second <= maxr) {
			bl[i] = 1;
		}
		maxr = max(maxr, seg[i].second);
	}
	vector<pair<int, int>> nx;
	for (int i = 0; i < k; i++) {
		if (bl[i] == 0) {
			nx.push_back(seg[i]);
		}
	}
	seg.swap(nx);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> h[i][j];
		}
		sort(h[i].begin(), h[i].end());
	}
	hehe.assign(n, vector<int> (2 * m));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			hehe[j][i * 2] = h[i][j * 2];
			hehe[j][i * 2 + 1] = h[i][j * 2 + 1];
		}
	}
	for (int i = 0; i < n; ++i) {
		sort(hehe[i].begin(), hehe[i].end());
	}
	k = seg.size();
	ll res = 0;
	for (int i = 0; i < n; i++) {
		int id;
		{
			int l = 0;
			int r = k;
			while (l + 1 < r) {
				int mid = (l + r) >> 1;
				int cnt_a = lower_bound(hehe[i].begin(), hehe[i].end(), seg[mid].first - 1) - hehe[i].begin();
				int cnt_b = hehe[i].end() - upper_bound(hehe[i].begin(), hehe[i].end(), seg[mid].second);
				if (cnt_a > cnt_b) {
					r = mid;
				}
				else {
					l = mid;
				}
			}
			id = l;
		}
		for (int x = max(0, id - 30); x <= min(k - 1, id + 30); x++) {
			check(i, x);
		}
		res += ans[i];
	}
	cout << res / 2 << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> m >> n >> k) {
		solve();
	}
	return 0;
}


