#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 2e3;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
const int MAXK = 1e5 + 10;
#define int ll
const int INF = 1e9 + 4;
const int MOD = 998244353;
mt19937 rng(time(0));
int n, m, k;

int ans = 0;

int x[MAXK];
int y[MAXK];
int v[MAXK];


int g[MAXN][MAXN];
int dp[MAXN][MAXN][2];

void init() {
	for (int i = 0; i < MAXN; i++) {
        for (int j = 0; j < MAXN; j++) {
            g[i][j] = INF;
        }
    }
}

void solve() {
	init();
	vector<int> coords;
	for (int i = 0; i < k; i++) {
		cin >> x[i] >> y[i] >> v[i];
		for (int j = 0; j < 20; j++) {
			if (y[i] - j > 0) {
				coords.push_back(y[i] - j);
			}
		}
	}
	coords.push_back(1);
	sort(coords.begin(), coords.end());
	coords.resize(unique(coords.begin(), coords.end()) - coords.begin());
	for (int i = 0; i < k; i++) {
		y[i] = lower_bound(coords.begin(), coords.end(), y[i]) - coords.begin() + 1;
		g[x[i]][y[i]] = v[i];
		cerr << v[i] << ' ';
	}
	cerr << '\n';
	for (int i = 1; i <= n; i++) {
    	for (int j = 1; j <= coords.size(); j++) {
    		cerr << g[i][j] << ' ';
    	}
    	cerr << '\n';
    }
    for (int i = n; i >= 1; i--) {
        for (int j = coords.size(); j >= 1; j--) {
            if (g[i][j] != INF) {
                dp[i][j][0] = dp[i][j][1] = g[i][j];
            }
            else {
                dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
                dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);                
            }
            ans += (1ll * dp[i][j][0] * (coords[j - 1] - (j == 1 ? 0 : coords[j - 2]))) % MOD;
            ans %= MOD;
            ans += MOD;
            ans %= MOD;
        }
    }
    for (int i = 1; i <= n; i++) {
    	for (int j = 1; j <= coords.size(); j++) {
    		cerr << dp[i][j][0] << ' ';
    	}
    	cerr << '\n';
    }
	cout << ans << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("C.in", "r", stdin);
		freopen("C.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> k) {
		solve();
	}
	return 0;
}


