#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define endl '\n'
#define int long long

vector<vector<int> > v;
vector<vector<int> > g0;
vector<vector<int> > g1;
const int INF = 1e9 + 7;
int n, m, k;

int rec0(int i, int j) {
	if (i == n) return 0;
	if (j == m) return 0;
	if (g0[i][j] != INF) return g0[i][j];
	if (v[i][j] != INF) {
		return g0[i][j] = v[i][j];
	}

	int cnt = i + j;
	if (cnt % 2 == 0) {
		g0[i][j] = min(rec0(i + 1, j), rec0(i, j + 1));
	}
	else {
		g0[i][j] = max(rec0(i + 1, j), rec0(i, j + 1));
	}
	return g0[i][j];
}

int rec1(int i, int j) {
	if (i == n) return 0;
	if (j == m) return 0;
	if (g1[i][j] != INF) return g1[i][j];
	if (v[i][j] != INF) {
		return g1[i][j] = v[i][j];
	}

	int cnt = i + j;
	if (cnt % 2 == 1) {
		g1[i][j] = min(rec1(i + 1, j), rec1(i, j + 1));
	}
	else {
		g1[i][j] = max(rec1(i + 1, j), rec1(i, j + 1));
	}
	return g1[i][j];
}

const int MOD = 998244353;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> k;
	v.resize(n, vector<int>(m, INF));
	g0.resize(n, vector<int>(m, INF));
	g1.resize(n, vector<int>(m, INF));
	for (int i = 0; i < k; i++) {
		int x, y, c;
		cin >> x >> y >> c;
		v[--x][--y] = c;
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (g0[i][j] == INF) rec0(i, j);
			if (g1[i][j] == INF) rec1(i, j);
		}
	}

	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if ((i + j) % 2 == 0) {
				ans += g0[i][j];
				//cout << g0[i][j] << " ";
				while (ans < 0) {
					ans += MOD;
				}
				ans %= MOD;
			}
			else {
				ans += g1[i][j];
				//cout << g1[i][j] << " ";
				while (ans < 0) {
					ans += MOD;
				}
				ans %= MOD;
			}
		}
		//cout << endl;
	}
	cout << ans;
}