#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

#define endl '\n'
#define int long long

vector<vector<int> > v;
vector<vector<int> > g0;
vector<vector<int> > g1;
const int INF = 1e9 + 7;
int n, m, k;

int rec0(int i, int j) {
	if (i == n) return 0;
	if (j == m) return 0;
	if (g0[i][j] != INF) return g0[i][j];
	if (v[i][j] != INF) {
		return g0[i][j] = v[i][j];
	}

	int cnt = i + j;
	if (cnt % 2 == 0) {
		g0[i][j] = min(rec0(i + 1, j), rec0(i, j + 1));
	}
	else {
		g0[i][j] = max(rec0(i + 1, j), rec0(i, j + 1));
	}
	return g0[i][j];
}

int rec1(int i, int j) {
	if (i == n) return 0;
	if (j == m) return 0;
	if (g1[i][j] != INF) return g1[i][j];
	if (v[i][j] != INF) {
		return g1[i][j] = v[i][j];
	}

	int cnt = i + j;
	if (cnt % 2 == 1) {
		g1[i][j] = min(rec1(i + 1, j), rec1(i, j + 1));
	}
	else {
		g1[i][j] = max(rec1(i + 1, j), rec1(i, j + 1));
	}
	return g1[i][j];
}

const int MOD = 998244353;

void add(int& ans, int delta) {
	ans += delta;
	while (ans < 0) ans += MOD;
	ans %= MOD;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> k;

	int maxon = 1000;
	v.resize(maxon, vector<int>(maxon, INF));
	g0.resize(maxon, vector<int>(maxon, INF));
	g1.resize(maxon, vector<int>(maxon, INF));
	int deltax = max(n - maxon, 0ll);
	int deltay = max(m - maxon, 0ll);
	for (int i = 0; i < k; i++) {
		int x, y, c;
		cin >> x >> y >> c;
		v[--x - deltax][--y - deltay] = c;
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (g0[i][j] == INF) rec0(i, j);
			if (g1[i][j] == INF) rec1(i, j);
		}
	}

	int ans = 0;
	int sum1 = 0;
	int summ = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if ((i + j) % 2 == 0) {
				if (j == 0) add(sum1, g0[i][j]);
				if (j == 0 && i == n - 1) add(summ, g0[i][j]);
				add(ans, g0[i][j]);
			}
			else {
				if (j == 0) add(ans, g1[i][j]);
				if (j == 0 && i == n - 1) add(summ, g1[i][j]);
				add(ans, g1[i][j]);
			}
		}
		//cout << endl;
	}
	add(ans, (sum1 + max(n - maxon, 0ll) * summ)  * max(0ll, m - maxon));
	cout << ans;
}