#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> dp;
vector<vector<bool>> found;
vector<vector<bool>> trap;
int n, m, k;

const ll MOD = 998244353;

ll calc(int x, int y)
{
    if (found[x][y])
        return dp[x][y];

    ll down = 0;
    ll right = 0;
    if (x != n - 1)
        down = max(calc(x + 1, y + 1), calc(x + 2, y));
    if (y != m - 1)
        right = max(calc(x + 1, y + 1), calc(x, y + 2));
    if (trap[x + 1][y])
        down = dp[x + 1][y];
    if (trap[x][y + 1])
        right = dp[x][y + 1];

    dp[x][y] = min(down, right);
    found[x][y] = true;
    return dp[x][y];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m >> k;

    dp.resize(n + 1, vector<ll>(m + 1, 0));
    found.resize(n + 1, vector<bool>(m + 1, false));
    trap.resize(n + 1, vector<bool>(m + 1, false));
    for (int i = 0; i < k; i++)
    {
        int x, y;
        ll c;
        cin >> x >> y >> c;
        x--;
        y--;

        dp[x][y] = c;
        found[x][y] = true;
        trap[x][y] = true;
    }

    for (int i = 0; i <= n; i++)
    {
        dp[i][m] = 0;
        found[i][m] = true;
        trap[i][m] = true;
    }
    for (int i = 0; i <= m; i++)
    {
        dp[n][i] = 0;
        found[n][i] = true;
        trap[n][i] = true;
    }

    ll ans = 0;
    for (int i = 0; i <= n; i++)
    {
        for (int j = 0; j <= m; j++)
        {
            ans += calc(i, j);
            ans += 2ll * MOD;
            ans %= MOD;
        }
    }

    cout << ans << endl;

    return 0;
}