#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll mod = 998244353ll;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<bool>> out(n + 1, vector<bool>(m + 1));
    vector<vector<ll>> cost(n + 1, vector<ll>(m + 1));
    for (int i = 0; i <= n; ++i) {
        out[i][m] = true;
    }
    for (int i = 0; i <= m; ++i) {
        out[n][i] = true;
    }
    for (int i = 0; i < k; ++i) {
        int a, b, x;
        cin >> a >> b >> x;
        out[a - 1][b - 1] = true;
        cost[a - 1][b - 1] = x;
    }

    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>>(m + 1, {(ll)1e18, (ll)-1e18}));
    ll ans = 0;
    for (int i = n; i >= 0; --i) {
        for (int j = m; j >= 0; --j) {
            for (int l = 0; l < 2; ++l) {
                if (out[i][j]) {
                    dp[i][j][l] = cost[i][j];
                    if (l == 0) {
                        ans += dp[i][j][l];
                        ans %= mod;
                    }
                    continue;
                }
                if (l == 0) {
                    dp[i][j][l] = min(dp[i + 1][j][1 - l], dp[i][j + 1][1 - l]);
                    ans += dp[i][j][l];
                    ans %= mod;
                }
                else {
                    dp[i][j][l] = max(dp[i + 1][j][1 - l], dp[i][j + 1][1 - l]);
                }
            }
        }
    }
    cout << (ans + mod) % mod << endl;
}