#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct Hash {
    ll p = 31, mod = 200720077;
    int n;
    vector<ll> power, hash;
    Hash(string &s) {
        n = s.length();
        power.resize(n + 1);
        hash.resize(n + 1);
        power[0] = 1;
        for (int i = 0; i < n; ++i) {
            power[i + 1] = power[i] * p % mod;
        }
        for (int i = 0; i < n; ++i) {
            hash[i + 1] = (hash[i] * p % mod + (s[i] - 'a' + 1));
        }
    }
    ll get_hash(int l, int r) {
        return (hash[r] - hash[l] * power[r - l] % mod + 2 * mod) % mod;
    }
};

int main() {
    int m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    string s;
    for (int i = 0; i < n; ++i) {
        int q;
        cin >> q;
        if (q == 1) {
            string x;
            cin >> x;
            s += x;
        }
        else {
            int pos, len;
            cin >> pos >> len;
            for (int j = 0; j < len; ++j) {
                s += s[pos - 1 + j];
            }
        }
    }

    Hash hp(p), hs(s);
    int ans = 0;
    for (int i = 0; i < (int)s.length() - m + 1; ++i) {
        if (hp.get_hash(0, m) == hs.get_hash(i, i + m)) {
            ans++;
        }
    }
    cout << ans << endl;
}