// B.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
using ll = long long;

ll dist(int i, int l, int r) {
	if (i >= l && i <= r) return 0;
	if (i < l) return l - i;
	if (i > r) return i - r;
	return 1e9;
}

bool cmp(pair<int, int> a, pair<int, int> b) {
	return make_pair(a.first, -a.second) < make_pair(b.first, -b.second);
}

int main()
{
	ios::sync_with_stdio(0);
	//ifstream cin("input.txt");
	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int> > seg(k);
	for (int i = 0; i < k; i++) {
		cin >> seg[i].first >> seg[i].second;
	}
	sort(seg.begin(), seg.end(), cmp);
	vector<pair<int, int> > seg1;
	for (int i = 0; i < k; i++) {
		if (seg1.empty() || seg1.back().second < seg[i].second) {
			seg1.push_back(seg[i]);
		}
	}
	k = (int)seg1.size();
	vector<vector<pair<int, int> > > pairs(n, vector<pair<int, int> >(m));
	for (int i = 0; i < m; i++) {
		vector<int> cur(2 * n);
		for (int j = 0; j < 2 * n; j++) {
			cin >> cur[j];
		}
		sort(cur.begin(), cur.end());
		for (int j = 0; j < n; j++) {
			pairs[j][i] = { cur[2 * j], cur[2 * j + 1] };
		}
	}
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		vector<int> all;
		for (int j = 0; j < m; j++) {
			all.push_back(pairs[i][j].first);
			all.push_back(pairs[i][j].second);
		}
		sort(all.begin(), all.end());
		int sz = (int)all.size();
		vector<ll> pref(sz + 1), suf(sz + 1);
		for (int j = 0; j < sz; j++) {
			pref[j + 1] = pref[j] + all[j];
		}
		for (int j = sz - 1; j >= 0; j--) {
			suf[j] = suf[j + 1] + all[j];
		}
		ll mn = 1e18;
		int j = 0;
		while (j < k) {
			int l1 = lower_bound(all.begin(), all.end(), seg1[j].first) - all.begin();
			int r1 = upper_bound(all.begin(), all.end(), seg1[j].second) - all.begin();
			int l = j, r = k;
			while (r - l > 1) {
				int m1 = (l + r) / 2;
				int l2 = lower_bound(all.begin(), all.end(), seg1[m1].first) - all.begin();
				int r2 = upper_bound(all.begin(), all.end(), seg1[m1].second) - all.begin();
				if (l1 == l2 && r1 == r2) {
					l = m1;
				}
				else {
					r = m1;
				}
			}
			for (int j1 = j; j1 < r; j1++) {
				mn = min(mn, -pref[l1] + suf[r1] + (ll)l1 * seg1[j1].first - (ll)(all.size() - r1) * seg1[j1].second);
			}
			j = r;
		}
		/*for (int j = 0; j < k; j++) {
			int l = lower_bound(all.begin(), all.end(), seg1[j].first) - all.begin();
			int r = upper_bound(all.begin(), all.end(), seg1[j].second) - all.begin();
			mn = min(mn, -pref[l] + suf[r] + (ll)l * seg1[j].first - (ll)(all.size() - r) * seg1[j].second);
		}*/
		ans += mn;
	}
	cout << ans << endl;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
