#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

long long n, m, k;
long long mod = 998244353;

bool keker(pair<pair<long long, long long>, long long> a, pair<pair<long long, long long>, long long> b){
    if(a.first.second!=b.first.second)
        return a.first.second>b.first.second;
    return a.first.first>b.first.first;
}

long long solve(vector<pair<pair<long long, long long>, long long> > jij){
    vector<vector<int> > a(n+1, vector<int>(m+1, 1000000007));
    vector<vector<pair<int, int> > > d(n+1, vector<pair<int, int> >(m+1));
    for(int i = 0; i<k; i++){
        int x = jij[i].first.first, y = jij[i].first.second, c = jij[i].second;
        a[x][y] = c;
    }
    for(int i = 0; i<=n; i++){
        a[i][m] = 0;
        d[i][m] = {0, 0};
    }
    for(int i = 0; i<=m; i++){
        a[n][i] = 0;
        d[n][i] = {0, 0};
    }
    long long ans = 0;
    for(int i = n-1; i>=0; i--){
        for(int j = m-1; j>=0; j--){
            if(clock()>2.95*CLOCKS_PER_SEC)
                return ans;
            if(a[i][j]!=1000000007){
                d[i][j] = {a[i][j], a[i][j]};
                ans += a[i][j];
                continue;
            }
            if(d[i+1][j].first>d[i][j+1].first)
                d[i][j].second = d[i+1][j].first;
            else
                d[i][j].second = d[i][j+1].first;
            if(d[i+1][j].second>d[i][j+1].second)
                d[i][j].first = d[i][j+1].second;
            else
                d[i][j].first = d[i+1][j].second;
            ans += d[i][j].first;
        }
    }
    return ((ans%mod)+mod)%mod;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> k;
    vector<pair<pair<long long, long long>, long long> > a(k);
    for(long long i = 0; i<k; i++){
        cin >> a[i].first.first >> a[i].first.second >> a[i].second;
        a[i].first.first--;
        a[i].first.second--;
    }
    sort(a.begin(), a.end(), keker);
    vector<pair<long long, long long> > pr(n+1, {0, 0}), tk(n+1, {0, 0});
    long long it = m-1, it1 = n;
    long long ans = 0;
    for(long long i = 0; i<k; i++){
        //cout << a[i].first.first << ':' << a[i].first.second << endl;
        if(it>a[i].first.second){
            for(long long j = it1-1; j>=0; j--){
                tk[j].first = min(pr[j].second, tk[j+1].second);
                tk[j].second = max(pr[j].first, tk[j+1].first);
                ans = (ans+tk[j].first+mod)%mod;
            }
            pr = tk;
            tk.assign(n, {0, 0});
        }
        else{
            for(long long j = it1-1; j>a[i].first.first; j--){
                tk[j].first = min(pr[j].second, tk[j+1].second);
                tk[j].second = max(pr[j].first, tk[j+1].first);
                ans = (ans+tk[j].first+mod)%mod;
            }
        }
        //cout << i << ' ' << it << ':' << a[i].first.second << endl;
        //cout << ans << ':';
        for(long long j = 0; j<min(20*n, it-a[i].first.second-1); j++){
            //cout << "jij" << j << endl;
            for(long long y = n-1; y>=0; y--){
                tk[y].first = min(pr[y].second, tk[y+1].second);
                tk[y].second = max(pr[y].first, tk[y+1].first);
                //cout << y << ") " <<
                ans = (ans+tk[y].first+mod)%mod;
            }
            pr = tk;
            tk.assign(n, {0, 0});
        }
        //cout << ans << endl;
        //cout << pr[1].second << ' ';
        if(it>a[i].first.second){
            for(long long j = n-1; j>a[i].first.first; j--){
                tk[j].first = min(pr[j].second, tk[j+1].second);
                tk[j].second = max(pr[j].first, tk[j+1].first);
                //cout << j << ':' << pr[j].second << endl;
                ans = (ans+tk[j].first+mod)%mod;
            }
        }
        tk[a[i].first.first] = {a[i].second, a[i].second};
        it = a[i].first.second;
        it1 = a[i].first.first;
        ans = (ans+a[i].second+mod)%mod;
        //cout << ans << endl;
    }
    for(long long j = it1-1; j>=0; j--){
        tk[j].first = min(pr[j].second, tk[j+1].second);
        tk[j].second = max(pr[j].first, tk[j+1].first);
        ans = (ans+tk[j].first+mod)%mod;
        //cout << tk[j].first << ' ';
    }
    pr = tk;
    tk.assign(n, {0, 0});
    for(long long j = 0; j<min(20*n, it); j++){
        //cout << ans << endl;
        for(long long y = n-1; y>=0; y--){
            tk[y].first = min(pr[y].second, tk[y+1].second);
            tk[y].second = max(pr[y].first, tk[y+1].first);
            ans = (ans+tk[y].first+mod)%mod;
        }
        pr = tk;
        tk.assign(n, {0, 0});
    }
    int keke = solve(a);
    if(clock()>2.95*CLOCKS_PER_SEC)
        keke = ans;
    if(ans!=keke)
        cout << keke;
    else
        cout << ans;

    return 0;
}
/*
5 5 9
5 1 2
5 2 10
5 3 0
5 4 5
5 5 0
4 5 -5
3 5 3
2 5 1
1 5 20

3 3 1
3 3 -1
*/
