#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <math.h>
#include <iomanip>

#define ll long long
#define ld long double
#define ep emplace_back
#define F first
#define S second

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

const ll inf = 1e18;

ll dist(pair<ll, ll> p, ll x){
	if (x <= p.F)
		return p.F - x;
	else if (x <= p.S)
		return 0;
	else
		return x - p.S;
}

const int N = 2e5 + 10;
vector<ll> Gr[N], pref[N];
pair<ll, ll> lr[N];
int m, n, k;
ll dp[N];

ll get(int i, int j){
	int L = lower_bound(Gr[i].begin(), Gr[i].end(), lr[j].F) - Gr[i].begin();
	int R = lower_bound(Gr[i].begin(), Gr[i].end(), lr[j].S) - Gr[i].begin();
	
	ll ans = 0;
	int siz = Gr[i].size();

	if (L)
		ans += lr[j].F * L - pref[i][L - 1];
	if (R < siz)
		ans += pref[i][siz - 1] - pref[i][R] + Gr[i][R] - lr[j].S * (siz - R);

	//cout << i << ' ' << j << ' ' << ans << endl;
	return ans;
}

void calc(int lk, int rk, int i, int l, int r){
	int from = lk;
	ll mn = inf;
	for (int j = lk; j < rk; j++){
		ll tmp = get(i, j);
		if (tmp < mn)
			mn = tmp, from = j;
	}

	dp[i] = mn;
	if (l < i)
		calc(lk, from + 1, (l + i) / 2, l, i);
	if (i + 1 < r)
		calc(from, rk, (i + 1 + r) / 2, i + 1, r);
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> m >> n >> k;
	int i;
	for (i = 0; i < k; i++)
		cin >> lr[i].F >> lr[i].S;
	sort(lr, lr + k);

	int j;
	vector<int> tmp(2 * n);
	for (i = 0; i < m; i++){
		for (j = 0; j < n; j++)
			cin >> tmp[j * 2] >> tmp[j * 2 + 1];
		sort(tmp.begin(), tmp.end());
		for (j = 0; j < n; j++)
			Gr[j].ep(tmp[2 * j]), Gr[j].ep(tmp[2 * j + 1]);
	}

	for (i = 0; i < n; i++)
		sort(Gr[i].begin(), Gr[i].end());
	for (i = 0; i < n; i++){
		pref[i].resize(Gr[i].size());
		pref[i][0] = Gr[i][0];
		for (j = 1; j < Gr[i].size(); j++)
			pref[i][j] = pref[i][j - 1] + Gr[i][j];
	}

	calc(0, k, n / 2, 0, n);

	ll ans = 0;
	for (i = 0; i < n; i++)
		ans += dp[i];

	cout << ans;
}