﻿/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse3,tune=native")*/

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll
const int INF = 1e18;

int getComf(int f, const pair<int, int> &prt)
{
	if (f < prt.first)
		return prt.first - f;
	if (f > prt.second)
		return f - prt.second;
	return 0;
}

bool comp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first)
		return a.first < b.first;
	return	a.second > b.second;
}

int getResult(const vector <int> &persons, const pair<int, int> &table)
{
	int res = 0;
	for (int i = 0; i < persons.size(); i++)
	{
		res += getComf(persons[i], table);
	}
	return res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int m, n, k;
	cin >> m >> n >> k;
	vector <pair<int, int>> table(k);
	
	for (int i = 0; i < k; i++)
	{
		cin >> table[i].first >> table[i].second;
	}
	sort(all(table), comp);
	vector <pair<int, int>> use;
	int start = -1, finish = -1;
	for (int i = 0; i < table.size(); i++)
	{
		if (table[i].second < finish)
		{
			continue;
		}
		if (table[i].second > finish)
		{
			start = table[i].first;
			finish = table[i].second;
			use.push_back(table[i]);
		}
	}
	table = use;
	k = table.size();
	
	vector <vector <int>> a(m, vector <int>(n * 2));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
		{
			cin >> a[i][j];
		}
		sort(all(a[i]));
	}



	int ans = 0;
	for (int j = 0; j < 2 * n; j += 2)
	{
		//cout << "it is j " << j << endl;
		int bestRes = INF;
		vector <int> persons;
		persons.reserve(2 * m);
		for (int i = 0; i < m; i++)
		{
			persons.push_back(a[i][j]);
			persons.push_back(a[i][j + 1]);
		}

		sort(all(persons));
		int l = 0, r = k - 1;
		while (r - l > 1000)
		{
			int L = l + (r - l) / 3;
			int R = r - (r - l) / 3;

			int lRes = getResult(persons, table[L]);
			int rRes = getResult(persons, table[R]);

			if (lRes > rRes)
			{
				l = L;
			}
			else
			{
				r = R;
			}
		}
		for (int i = l; i <= r; i++)
		{
			bestRes = min(bestRes, getResult(persons, table[i]));
		}
		
		ans += bestRes;
	}
	cout << ans;
	return 0;

}