﻿/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse3,tune=native")*/

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define int ll
const int INF = 1e18;
const int MOD = 998244353;

int getComf(int f, const pair<int, int> &prt)
{
	if (f < prt.first)
		return prt.first - f;
	if (f > prt.second)
		return f - prt.second;
	return 0;
}

bool comp(pair<int, int> a, pair<int, int> b)
{
	if (a.first != b.first)
		return a.first < b.first;
	return	a.second > b.second;
}

int getResult(const vector <int> &persons, const pair<int, int> &table)
{
	int res = 0;
	for (int i = 0; i < persons.size(); i++)
	{
		res += getComf(persons[i], table);
	}
	return res;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <vector <int>> mini(n + 2, vector <int>(m + 2, INF));
	vector <vector <int>> maxi(n + 2, vector <int>(m + 2, -INF));

	for (int i = 0; i < k; i++)
	{
		int x, y, v;
		cin >> x >> y >> v;
		mini[x][y] = maxi[x][y] = v;
	}

	for (int j = 1; j <= m; j++)
	{
		maxi[n + 1][j] = 0;
		mini[n + 1][j] = 0;
	}

	for (int j = 1; j <= n; j++)
	{
		maxi[j][m + 1] = 0;
		mini[j][m + 1] = 0;
	}

	for (int i = n; i >= 1; i--)
	{
		for (int j = m; j >= 1; j--)
		{
			if (mini[i][j] != INF)
			{
				continue;
			}
			maxi[i][j] = max(mini[i + 1][j], mini[i][j + 1]);
			mini[i][j] = min(maxi[i + 1][j], maxi[i][j + 1]);
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			ans += mini[i][j];
			ans = (ans + MOD) % MOD;
		}
	}
	/*for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			cout << maxi[i][j] << " ";
		}
		cout << endl;
	}
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			cout << mini[i][j] << " ";
		}
		cout << endl;
	}*/
	
	cout << (ans + MOD) % MOD;
	return 0;

}