#define _CRT_SECURE_NO_WARNINGS

#include <set>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const long long N = (long long)2e6 + 7;
const long long INF = (long long)1e9 + 7;
long long MOD = 998244353;

#define mp make_pair

////////////////////////////////////////////

long long m, n;
string p, w;

vector <long long> z_func(const string &s) {
	vector <long long> z(s.size());
	long long l = 0, r = 0, n = s.size();
	for (long long i = 1; i < n; i++) {
		if (i <= r)
			z[i] = min(z[i - l], r - i);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] > r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> m >> n >> p;
	string st = "";
	cin >> w >> w;
	long long cnt = 1;
	for (long long i = 1; i < n; i++) {
		long long x, y, z;
		cin >> x >> y >> z;
		cnt += z / (long long)w.size();
	}
	long long x = cnt;
	while ((long long)st.size() < m && x > 0) {
		st += w, x--;
	}
	if ((long long)st.size() < m) {
		cout << 0;
		return 0;
	}
	long long full = 1LL * cnt * w.size() / st.size() - 1;
	string s1 = p + '$' + st + st;
	auto z = z_func(s1);
	long long in = 0;
	for (long long i = 0; i < (long long)s1.size(); i++) {
		if (i <= m + (long long)st.size() && z[i] >= m)
			in++;
	}
	long long ans = full * in;
	long long use = full * st.size();
	string s2 = p + '$';
	while (use != 1LL * cnt * w.size())
		s2 += w, use += w.size();
	z = z_func(s2);
	for (long long i = 0; i < (long long)s2.size(); i++) {
		if (z[i] >= m)
			ans++;
	}
	cout << ans;
}