#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

void zfunc(string& s, vector<int>& z)
{
	int n = s.size();
	z.resize(n);

	int l = 0, r = 0;
	for (int i = 1; i < n; i++)
	{
		z[i] = max(0LL, min(z[i - l], r - i));
		while (s[z[i]] == s[i + z[i]])
			z[i]++;

		if (i + z[i] > r)
		{
			r = i + z[i];
			l = i;
		}
	}
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);


	int m, n;
	cin >> m >> n;

	string p;
	cin >> p;

	string t;
	for (int i = 0; i < n; i++)
	{
		int type;
		cin >> type;

		if (type == 1)
		{
			string w;
			cin >> w;
			t += w;
		}
		else
		{
			int pos, len;
			cin >> pos >> len;
			pos--;
			for (int j = pos; j < pos + len; j++)
			{
				t += t[j];
			}
		}
	}

	string comb = p + '#' + t;
	vector<int> z;
	zfunc(comb, z);

	int cnt = 0;
	for (int i = m + 1; i < comb.size(); i++)
	{
		if (z[i] == m)
			cnt++;
	}

	cout << cnt << endl;


	//system("pause");
	return 0;
}