#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct node {
    long long cl, cr;
    long long mn, mx;
    long long sm;
    node *left, *right;
    node(){}
    node(node* _left, node* _right){
        left = _left;
        right = _right;
        cl = left -> cl;
        cr = right -> cr;
        mn = left -> mn;
        mx = right -> mx;
        sm = left -> sm + right -> sm;
    }
    node(int _cl, int _cr, int x){
        cl = _cl;
        cr = _cr;
        mn = x;
        mx = x;
        sm = x;
    }
};

node *create(int nl, int nr, const vector <int> &a){
    if (nl + 1 == nr){
        return new node(nl, nr, a[nl]);
    }
    int mid = (nl + nr) / 2;
    return new node(create(nl, mid, a), create(mid, nr, a));
}

long long get_sum(node *root, long long L, long long R){
    if (L <= root -> mn && root -> mx <= R){
        return 0;
    }
    if (R <= root -> mn){
        return root -> sm - (root -> cr - root -> cl) * R;
    }
    if (L >= root -> mx){
        return (root -> cr - root -> cl) * L - root -> sm;
    }
    return get_sum(root -> left, L, R) + get_sum(root -> right, L, R);
}

bool cmp(const pair <int, int> &a, const pair <int, int> &b){
    return a.first < b.first || (a.first == b.first && a.second > b.second);
}

long long count(vector <int> &h, pair <int, int> &p){
    long long tr2 = 0;
    for (auto hn : h){
        if (p.first > hn || hn > p.second){
            tr2 += min(abs(hn - p.first), abs(hn - p.second));
        }
    }
    return tr2;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, k;
    cin >> m >> n >> k;
    vector <pair <int, int> > cp(k);
    for (int i = 0; i < k; i++){
        cin >> cp[i].first >> cp[i].second;
    }
    sort(cp.begin(), cp.end(), cmp);
    vector <pair <int, int> > p;
    for (int i = 0; i < k; i++){
        if (p.empty() || cp[i].second > p.back().second){
            p.push_back(cp[i]);
        }
    }
    k = p.size();
    vector <vector <int> > h(n);
    vector <node*> h2(n);
    for (int i = 0; i < m; i++){
        vector <int> tmp(n * 2);
        for (int j = 0; j < n * 2; j++){
            cin >> tmp[j];
        }
        sort(tmp.begin(), tmp.end());
        for (int j = 0; j < n * 2; j++){
            h[j / 2].push_back(tmp[j]);
        }
    }
    for (int i = 0; i < n; i++){
        h2[i] = create(0, m * 2, h[i]);
    }
    long long res = 0;
    int j = 0;
    for (int i = 0; i < n; i++){
        long long tr = get_sum(h2[i], p[0].first, p[0].second);
        for (int j = 1; j < k; j++){
            tr = min(tr, get_sum(h2[i], p[j].first, p[j].second));
        }
        res += tr;
    }
    cout << res;
    return 0;
}