#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 12e5 + 10, MOD = 998244353, INF = 2e9;

struct Treap {
	int x, y, c;
};

bool operator<(const Treap& a, const Treap& b) {
	return (a.x == b.x) ? a.y < b.y : a.x < b.x;
}

int64_t dp[6][MAX_N][2];
int treap[6][MAX_N];

map<pair<int, int>, int> treaps;

int n, m;

int64_t solveFor(int yStart, int yFinish) {
	//cout << "SOLVING FOR " << yStart << " " << yFinish << "\n";
	++yFinish;
	int mC = yFinish - yStart;
	int64_t ans = 0;
	for (int i = 0; i <= n; ++i)
		for (int j = 0; j <= mC; ++j)
			dp[i][j][0] = dp[i][j][1] = 0, treap[i][j] = (treaps.find({i, j + yStart}) != treaps.end()) ? treaps[{i, j + yStart}] : -INF;
	for (int i = n; i--; ) {
		for (int j = mC; j--; ) {
			if (treap[i][j] != -INF)
				dp[i][j][0] = dp[i][j][1] = treap[i][j];
			else
				dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]),
				dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
			ans += dp[i][j][0] % MOD;
		}
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int k, u, v;
	cin >> n >> m >> k;
	m = min(m, 95);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			treap[i][j] = -INF;
	set<int> xCoords;
	for (int i = 0; i < k; ++i) {
		int q, w, e;
		cin >> q >> w >> e;
		--q, --w;
		xCoords.insert(w);
		treaps[{q, w}] = e;
	}
	int64_t ans = 0;
	auto it = xCoords.begin();
	for (int i = 0; it != xCoords.end(); ++i) {
		auto itFinish = it, nextIt = itFinish;
		++nextIt;
		while (nextIt != xCoords.end() && *nextIt - *itFinish < 10)
			++itFinish, ++nextIt;
		ans += solveFor(max(*it - 9, 0), *itFinish);
		it = nextIt;
	}
	cout << (ans % MOD + MOD) % MOD << "\n";
	return 0;
}