#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

#define sz(x) ((int)(x).size())
#define pii pair<int, int>
#define l first
#define r second
#define MAXN 1005
#define MOD 998244353
#define LLINF 1000000000000000000LL

int n, m, k;
long long a[MAXN][MAXN];
long long dp[MAXN][MAXN];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> k;

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= m; ++j)
            dp[i][j] = LLINF;

    for(int i = 0; i < k; ++i) {
        int x, y, v;
        cin >> x >> y >> v;
        a[x][y] = v;
        dp[x][y] = v;
    }

    for(int i = n; i > 0; --i) {
        for(int j = m; j > 0; --j) {
            if(a[i][j])
                continue;
            if(a[i + 1][j])
                dp[i][j] = a[i + 1][j];
            else
                dp[i][j] = max(dp[i + 2][j], dp[i + 1][j + 1]);
            if(a[i][j + 1])
                dp[i][j] = min(dp[i][j], a[i][j + 1]);
            else
                dp[i][j] = min(dp[i][j], max(dp[i][j + 2], dp[i + 1][j + 1]));
        }
    }

    long long sum = 0;

    for(int i = 1; i <= n; ++i) 
        for(int j = 1; j <= m; ++j) {
            sum += dp[i][j];
            while(sum < 0)
                sum += MOD;
            while(sum >= MOD)
                sum -= MOD;
        }

    cout << sum << endl;

    return 0;
}