#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

const ll INF = 1e18;

int m, n, k;

std::vector<std::vector<int>> st;
std::vector<std::pair<int, int>> tb;

ll dif(int h, int i) {
    if (h >= tb[i].first && h <= tb[i].second) {
        return 0;
    }
    return std::min(std::abs(h - tb[i].first), std::abs(h - tb[i].second));
}

ll getDist(int iM, int iN, int iK) {
    ll s = 0;
    s += dif(st[iM][2 * iN], iK);
    s += dif(st[iM][2 * iN + 1], iK);
    return s;
}

void solveN1() {
    std::vector<ll> sum(k);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < m; ++j) {
            sum[i] += dif(st[j][0], i);
            sum[i] += dif(st[j][1], i);
        }
    }
    ll min = sum[0];
    for (int i = 1; i < k; ++i) {
        min = std::min(min, sum[i]);
    }
    std::cout << min;
    exit(0);
}

void solveM1() {
    std::vector<ll> mins(n, INF);
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < n; ++j) {
            ll curS = 0;
            curS += dif(st[0][2 * j], i);
            curS += dif(st[0][2 * j + 1], i);
            mins[j] = std::min(mins[j], curS);
        }
    }
    ll sum = 0;
    for (int i = 0; i < mins.size(); ++i) {
        sum += mins[i];
    }
    std::cout << sum;
    exit(0);
}

void solveK2() {
    std::vector<std::vector<ll>> add(m, std::vector<ll> (n));
    for (int i = 0; i < m; ++i) {
        ll sum1 = 0;
        for (int j = 0; j < n; ++j) {
            ll s0 = getDist(i, j, 0);
            ll s1 = getDist(i, j, 1);
            sum1 += s1;
            add[i][j] = s0 - s1;
        }
        std::sort(add[i].begin(), add[i].end());
        for (int j = 1; j < add[i].size(); ++j) {
            add[i][j] += add[i][j - 1];
        }
        for (int j = 0; j < add[i].size(); ++j) {
            add[i][j] += sum1;
        }
    }
    ll minS = INF;
    for (int i = 0; i < n; ++i) {
        ll curS = 0;
        for (int j = 0; j < m; ++j) {
           curS += add[j][i];
        }
        minS = std::min(minS, curS);
    }
    std::cout << minS;
    exit(0);
}

int main() {
//    freopen("input", "r", stdin);
    std::cin >> m >> n >> k;
    st.resize(m, std::vector<int> (2 * n));
    tb.resize(k);
    for (auto &i : tb) {
        std::cin >> i.first >> i.second;
    }
    for (auto &i : st) {
        for (auto &j : i) {
            std::cin >> j;
        }
    }
    for (int i = 0; i < m; ++i) {
        std::sort(st[i].begin(), st[i].end());
    }
    if (k == 2) {
        solveK2();
    }
    if (m == 1) {
        solveM1();
    }
    if (n == 1) {
        solveN1();
    }
    return 0;
}