#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

const int INF = 1e9 + 1;
const int MAXN = 1001;

const ll MOD = 998244353;

int fr[MAXN][MAXN];
int sc[MAXN][MAXN];

int main() {
//    freopen("input", "r", stdin);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int n, m, k;
    std::cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            fr[i][j] = sc[i][j] = INF;
        }
    }
    std::cin >> k;
    for (int p = 0; p < k; ++p) {
        int i,j,v;
        std::cin >> i >> j >> v;
        --i;
        --j;
        fr[i][j] = sc[i][j] = v;
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (fr[i][j] != INF) {
                continue;
            }
            fr[i][j] = std::min(sc[i + 1][j], sc[i][j + 1]);
            sc[i][j] = std::max(fr[i + 1][j], fr[i][j + 1]);
        }
    }
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            sum += fr[i][j];
            sum %= MOD;
        }
    }
    std::cout << (sum + MOD) % MOD;
    return 0;
}