#include <assert.h>
#include <algorithm>
#include <iostream>
#include <vector>

using ll = long long;

int m, n;
std::string s, t;

std::vector<int> pref(const std::string &s) {
    std::vector<int> p(s.size());
    p[0] = 0;
    for (int i = 1; i < s.size(); ++i) {
        int k = p[i - 1];
        while (k > 0 && s[k] != s[i]) {
            k = p[k - 1];
        }
        if (s[k] == s[i]) {
            ++k;
        }
        p[i] = k;
    }
    return p;
}

void solution() {
    for (int i = 0; i < n; ++i) {
        int tp;
        std::cin >> tp;
        if (tp == 1) {
            std::string s1;
            std::cin >> s1;
            t += s1;
        } else {
            int pos, len;
            std::cin >> pos >> len;
            --pos;
            for (int i = 0; i < len; ++i) {
                t.push_back(t[pos + i]);
            }
        }
    }
    t = s + '#' + t;
    auto p = pref(t);
    int k = 0;
    for (size_t i = s.size() + 1; i < t.size(); ++i) {
        if (p[i] == s.size()) {
            ++k;
        }
    }
    std::cout << k;
    exit(0);
}

void solution2() {
    ll tp, pos, len;
    std::string st;
    std::cin >> tp >> st;
    ll cnt = 1;
    for (int i = 1; i < n; ++i) {
        std::cin >> tp >> pos >> len;
        cnt += (len / st.size());
    }
    std::string t = s + '#' + st + st;
    auto p = pref(t);
    int sh = (int)s.size() + 1;
    ll k1 = 0, k2 = 0;
    for (int i = 0; i < st.size(); ++i) {
        if (p[i + sh] == s.size()) {
            ++k1;
        }
    }
    for (int i = (int)st.size(); i < st.size() + s.size() - 1; ++i) {
        if (p[i + sh] == s.size()) {
            ++k2;
        }
    }
    ll ans = k1 * cnt + k2 * (cnt - 1);
    std::cout << ans;
    exit(0);
}

void solution3() {
    ll tp, pos, len;
    std::string st;
    std::cin >> tp >> st;
    ll lst = 0;
    for (int i = 1; i < n; ++i) {
        std::cin >> tp >> pos >> len;
        assert(tp == 2);
        lst += len;
    }
    bool fl = true;
    char sym = st.back();
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] != sym) {
            fl = false;
            break;
        }
    }
    if (fl) {
        ll sum = 0;
        ll cnt = 0;
        for (int i = 0; i < st.size(); ++i) {
            if (st[i] == sym) {
                ++cnt;
            } else {
                if (cnt >= s.size()) {
                    sum += cnt - s.size() + 1;
                }
                cnt = 0;
            }
        }
        cnt += lst;
        if (cnt >= s.size()) {
            sum += cnt - s.size() + 1;
        }
        std::cout << sum;
        exit(0);
    }
    ll toadd = std::min((ll)s.size() + 3, lst);
    for (int i = 0; i < toadd; ++i) {
        st.push_back(sym);
    }
    t = s + '#' + st;
    auto p = pref(t);
    int k = 0;
    for (size_t i = s.size() + 1; i < t.size(); ++i) {
        if (p[i] == s.size()) {
            ++k;
        }
    }
    std::cout << k;
    exit(0);
}

int main() {
//    freopen("input", "r", stdin);
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> m >> n;
    std::cin >> s;
    if (n == 1) {
        solution();
    }
    solution3();
    return 0;
}