#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll INF_LL = 1e18;

int get(int l, int r, int a) {
	if (l <= a && a <= r)
		return 0;
	return min(abs(l - a), abs(r - a));
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	srand(time(NULL));
	
	int m, n, k;
	cin >> m >> n >> k;

	vector<int> l(k), r(k);
	for (int i = 0; i < k; i++)
		cin >> l[i] >> r[i];

	vector<vector<int>> v(m, vector<int>(2 * n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++)
			cin >> v[i][j];
		sort(v[i].begin(), v[i].end());
	}

	ll ans = 0;
	for (int i = 0; i < n; i++) {
		ll mi = INF_LL;
		for (int j = 0; j < k; j++) {
			ll cur = 0;
			for (int t = 0; t < m; t++) {
				int a = v[t][2 * i], b = v[t][2 * i + 1];
				cur += get(l[j], r[j], a) + get(l[j], r[j], b);
			}
			mi = min(mi, cur);
		}
		ans += mi;
	}

	cout << ans << endl;

	return 0;
}