#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <set>

//#define DEBUG

using namespace std;

typedef int64_t ll;

ll get_max(ll x, ll y, unordered_map <ll, unordered_map <ll, ll>> &g, unordered_map <ll, unordered_map <ll, ll>> &trap, set <ll> &useful, int n) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == n - 1 ? 0 : g[x + 1][y]);
	ll r = (!useful.count(-(y + 1)) ? 0 : g[x][y + 1]);
	return max(r, d);
}

ll get_min(ll x, ll y, unordered_map <ll, unordered_map <ll, ll>> &g, unordered_map <ll, unordered_map <ll, ll>> &trap, set <ll> &useful, int n) {
	if (trap[x][y]) return g[x][y];
	ll d = (x == n - 1 ? 0 : get_max(x + 1, y, g, trap, useful, n));
	ll r = (!useful.count(-(y + 1)) ? 0 : get_max(x, y + 1, g, trap, useful, n));
	return min(r, d);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m, k;
	cin >> n >> m >> k;
	unordered_map <ll, unordered_map <ll, ll>> trap;
	unordered_map <ll, unordered_map <ll, ll>> val;
	set<ll> useful;
	for (ll i = 0; i < k; i++) {
		ll x, y, v;
		cin >> x >> y >> v;
		x--, y--;
		trap[x][y] = 1;
		val[x][y] = v;
		for (ll j = max(0ll, (long long)(y - n - 1)); j <= y; j++) {
			useful.insert(-j);
		}
	}
	unordered_map <ll, unordered_map <ll, ll>> g = val;
	for (auto u : useful) {
		for (int i = n - 1; i > -1; i--) {
			g[i][-u] = get_min(i, -u, g, trap, useful, n);
		}
	}
#ifdef DEBUG
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (!g.count(i)) {
				cout << "i" << ' ';
				continue;
			}
			if (!g[i].count(j)) {
				cout << "i" << ' ';
				continue;
			}
			cout << g[i][j] << ' ';
		}
		cout << '\n';
	}
#endif // DEBUG
	long long sum = 0;
	const long long Q = 998244353;
	for (auto &u : g) {
		for (auto &w : u.second) {
			w.second %= Q;
			sum += Q + w.second;
			sum %= Q;
		}
	}
	cout << sum;
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}