#pragma GCC optimaze ("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4")

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

using namespace std;
typedef long long ll;

const ll INF = 1e18;
const ll mod = 998244353;

ll n, m, k;

bool comp56(pair<pair<ll, ll>, ll> a, pair<pair<ll, ll>, ll > b) {
	return a.first.second - a.first.first < b.first.second - b.first.first;
}

ll get_ans(vector<pair<pair<ll, ll>, ll> >& cd) {
	ll ans = 0;


	map<ll, ll> cp;

	sort(cd.begin(), cd.end(), comp56);

	ll di, dj;
	for (int i = 0; i < k; ++i) {
		ll xi = cd[i].first.first, yi = cd[i].first.second, xj, yj;
		di = yi - xi;
		cp[di] = max(cp[di], min(xi, yi) + ll(1));
		for (int j = i + 1; j < k; ++j) {
			xj = cd[j].first.first, yj = cd[j].first.second;
			dj = yj - xj;
			if (di + 4 < dj)
				break;
			if (di + 2 == dj && abs(xi - xj) == 1 && abs(yi - yj) == 1) {
				cp[di + 1] = max(cp[di + 1], min(xi - 1, yi) + ll(1));
			}
			if (di + 4 == dj) {
				cp[di + 2] = max(cp[di + 2], min(min(xi - 2, yi), min(xj, yj - 2)) + 1);
			}
			if (di + 3 == dj) {
				ll new_xi = cp[di] - 1;
				ll new_yi = new_xi + di;

				ll new_xj = cp[dj] - 1;
				ll new_yj = new_xj + dj;
				if (xi + yi < xj + yj) {
					cp[di + 1] = max(cp[di + 1], min(xi - 1, yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(xj, yj - 1) + ll(1));
				}
				if (new_xi + new_yi < xj + yj) {
					cp[di + 1] = max(cp[di + 1], min(new_xi - 1, new_yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(xj, yj - 1) + ll(1));
				}
				if (xi + yi < new_xj + new_yj) {
					cp[di + 1] = max(cp[di + 1], min(xi - 1, yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(new_xj, new_yj - 1) + ll(1));
				}
				if (new_xi + new_yi < new_xj + new_yj) {
					cp[di + 1] = max(cp[di + 1], min(new_xi - 1, new_yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(new_xj, new_yj - 1) + ll(1));
				}
			}

			dj = di + 3;
			ll new_xi = cp[di] - 1;
			ll new_yi = new_xi + di;
			ll new_xj = cp[dj] - 1;
			ll new_yj = new_xj + dj;
			if (new_xi >= 0 && new_yi < m) {
				if (xi + yi < new_xj + new_yj) {
					cp[di + 1] = max(cp[di + 1], min(xi - 1, yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(new_xj, new_yj - 1) + ll(1));
				}
				if (new_xi + new_yi < new_xj + new_yj) {
					cp[di + 1] = max(cp[di + 1], min(new_xi - 1, new_yi) + ll(1));
				}
				else {
					cp[dj - 1] = max(cp[dj - 1], min(new_xj, new_yj - 1) + ll(1));
				}
			}
		}
	}
	for (auto to : cp) {
		ans = (ans + to.second) % mod;
	}
	return ans;
}

ll get_stupid_ans(vector<pair<pair<ll, ll>, ll> >& cp) {
	ll ans = 0;
	vector<vector<ll> > dp1(n + 1, vector<ll>(m + 1)), dp2, cd(n + 1, vector<ll>(m + 1, -INF));
	dp2 = dp1;
	for (auto to : cp) {
		cd[to.first.first][to.first.second] = to.second;
	}
	for (int s = (n + m - 2); s >= 0; --s) {
		for (int i = 0; i < n; ++i) {
			int j = s - i;
			if (j >= m)
				continue;
			if (j < 0)
				break;
			if (cd[i][j] == -INF) {
				dp1[i][j] = min(dp2[i + 1][j], dp2[i][j + 1]);
				dp2[i][j] = max(dp1[i + 1][j], dp1[i][j + 1]);
			}
			else {
				dp1[i][j] = dp2[i][j] = cd[i][j];
			}
			ans = ((ans + dp1[i][j]) % mod + mod) % mod;
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false);

	cin >> n >> m >> k;
	vector<pair<pair<ll, ll>, ll> > cd(k);
	bool fl56 = true;
	for (int i = 0; i < k; ++i) {
		cin >> cd[i].first.first >> cd[i].first.second >> cd[i].second;
		--cd[i].first.first, --cd[i].first.second;
		fl56 &= cd[i].second == 1;
	}

	if (n * m <= 1000000) {
		cout << get_stupid_ans(cd);
		return 0;
	}
	if (fl56) {
		cout << get_ans(cd);
		return 0;
	}

	/*while (true) {
		n = rand() % 10 + 1, m = rand() % 10 + 1;
		k = rand() % min(n + m, ll(10)) + 1;
		vector<pair<pair<ll, ll>, ll> > cd(k);
		for (int i = 0; i < k; ++i) {
			bool fl = false;
			while (!fl) {
				fl = true;
				ll x = rand() % n, y = rand() % m;
				for (int j = 0; j < i; ++j)
					if (x == cd[j].first.first && y == cd[j].first.second) {
						fl = false;
						break;
					}
				if (fl) {
					cd[i].first.first = x, cd[i].first.second = y, cd[i].second = 1;
				}
			}
		}
		ll ans1 = get_ans(cd), ans2 = get_stupid_ans(cd);
		if (ans1 != ans2) {
			cout << "Error\n";
			return 0;
		}
	}
	*/
	return 0;
}


/*
3 3 3
2 3 -2
3 1 3
1 2 1

2 4 3
1 2 2
2 4 -3
2 1 1

8 8 9
6 1 1
4 1 1
6 7 1
5 7 1
3 6 1
4 8 1
2 6 1
2 8 1
1 8 1

7 7 7
7 1 1
6 1 1
3 1 1
2 1 1
4 3 1
5 6 1
4 7 1

*/