#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

int f(vpii a, int m){
    int ans = 1000000;
    for (int i = 0; i < a.size(); ++i){
        ans = min(ans, min(a[i].F, a[i].S));
    }
    return ans * (m + 1) + m;
}

const int inf = 2e9;

int getP(int r, vi &a){
    if (r < 0) return inf;
    return a[r];
}

int getS(int l, vi &a, int m){
    if (l >= m) return inf;
    return a[l];
}

int main() {
    init();
    int n;
    string str;
    cin >> n >> str;
    int m = 0;
    set<int> idx1;
    for (int i = 0; i < n; ++i){
        if (str[i] == '1'){
            m++;
            idx1.insert(i);
        }
    }
    vpii a;
    for (int i: idx1){
        a.pb({0, 0});
        int j1 = i, j2 = i;
        while (j1 > 0){
            j1--;
            if (str[j1] == '1') break;
        }
        if (str[j1] == '1') j1++;
        a.back().F = max(0, i - j1);
        while (j2 + 1 < n){
            j2++;
            if (str[j2] == '1') break;
        }
        if (str[j2] == '1') j2--;
        a.back().S = max(0, j2 - i);
    }
    int ans = f(a, m);
    int opt = 0;
    while (m > 1){
        vi pref(m), suf(m);
        int mn = 1000000;
        for (int i = 0; i < m; ++i){
            mn = min(mn, min(a[i].F, a[i].S));
            pref[i] = mn;
        }
        mn = 1000000;
        for (int i = m - 1; i >= 0; --i){
            mn = min(mn, min(a[i].F, a[i].S));
            suf[i] = mn;
        }
        int mx = -1;
        int id = -1;
        for (int i = 0; i < m; ++i){
            int a1 = inf, a2 = inf, c1 = inf, c2 = inf;
            int b1 = a[i].F, b2 = a[i].S;
            if (i > 0){
                a1 = a[i - 1].F, a2 = a[i - 1].S;
            }
            if (i + 1 < m){
                c1 = a[i + 1].F, c2 = a[i + 1].S;
            }
            a2 += b2, c1 += b1;
            int r = min(min(a1, a2), min(c1, c2));
            r = min(r, getP(i - 2, pref));
            r = min(r, getS(i + 2, suf, m));
            if (r > mx){
                mx = r;
                id = i;
            }
        }
        if (id > 0) a[id - 1].S += a[id].S;
        if (id + 1 < m) a[id + 1].F += a[id].F;
        vpii a3;
        for (int i = 0; i < m; ++i){
            if (i != id) a3.pb(a[i]);
        }
        a = a3;
        m--;
        int x = f(a, m);
        if (x > ans){
            ans = x;
            opt = inf;
            for (auto p: a) opt = min(opt, min(p.F, p.S));
        }
    }
    cout << ans << endl;
    string ANS = "";
    for (int i = 0; i < opt; ++i) ANS += "0";
    while(ANS.length() < ans){
        ANS += "1";
        for (int i = 0; i < opt; ++i) ANS += "0";
    }
    cout << ANS << endl;
    return 0;
}
