#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>
#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

int n, m, k;

vpll b;
const ll inf = 1024 * 1024 * 1023 * 2 - 1;
const ll INF = inf * inf;

int idxL(vll &a, ll x){
    if (a[0] > x)
        return -1;
    int l = 0, r = 2 * m - 1;
    while (l != r){
        int md = (l + r + 1) / 2;
        if (a[md] > x) r = md - 1; else l = md;
    }
    return l;
}

int idxR(vll &a, ll x){
    if (a.back() < x)
        return -1;
    int l = 0, r = 2 * m - 1;
    while (l != r){
        int md = (l + r) / 2;
        if (a[md] > x) r = md; else l = md + 1;
    }
    return l;
}

int main() {
    init();
    cin >> m >> n >> k;
    b.resize(k);
    for (int i = 0; i < k; ++i) cin >> b[i].F >> b[i].S;
    ll ans = 0;
    vvll a0(m, vll(2 * n));
    for (int i = 0; i < m; ++i){
        for (int j = 0; j < 2 * n; ++j) cin >> a0[i][j];
        sort(a0[i].begin(), a0[i].end());
    }
    vvll a1(n);
    for (int i = 0; i < m; ++i){
        for (int j = 0; j < 2 * n; ++j){
            a1[j / 2].pb(a0[i][j]);
        }
    }
    for (int i = 0; i < n; ++i){
        sort(a1[i].begin(), a1[i].end());
    }
    for (int i = 0; i < n; ++i){
        vll a = a1[i];
        vll pref(2 * m), suf(2 * m);
        ll sum = 0;
        for (int i0 = 0; i0 < 2 * m; ++i0){
            sum += a[i0];
            pref[i0] = sum;
        }
        sum = 0;
        for (int i0 = 2 * m - 1; i0 >= 0; --i0){
            sum += a[i0];
            suf[i0] = sum;
        }
        ll minimum = INF;
        for (int j = 0; j < k; ++j){
            ll l = b[j].F, r = b[j].S;
            int il = idxL(a, l), ir = idxR(a, r);
            ll add = 0;
            if (il != -1){
                add = (il + 1) * l - pref[il];
            }
            if (ir != -1){
                add += suf[ir] - (2 * m - ir) * r;
            }
            minimum = min(minimum, add);
        }
        ans += minimum;
    }
    cout << ans << endl;
    return 0;
}
