#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


const int INF = (int)2e9;
const int M = 998244353;


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


int n, m, k;
vector<vector<int>> trs, g;


int get_g(int x, int y) {
    if (g[x][y] != INF) {
        return g[x][y];
    }

    if (trs[x][y] != INF) {
        return g[x][y] = trs[x][y];
    }

    if (x >= n || y >= m) {
        return g[x][y] = 0;
    }

    int res = INF;

    if (trs[x + 1][y] != INF) {
        res = min(res, trs[x + 1][y]);
    } else {
        res = min(res, max(get_g(x + 2, y), get_g(x + 1, y + 1)));
    }

    if (trs[x][y + 1] != INF) {
        res = min(res, trs[x][y + 1]);
    } else {
        res = min(res, max(get_g(x, y + 2), get_g(x + 1, y + 1)));
    }

    return g[x][y] = res;
}


#define cerr if (false) cerr


signed main() {
    cin >> n >> m >> k;

    trs.resize(n + 2, vector<int>(m + 2, INF));

    int x, y, v;
    for (int i = 0; i < k; ++i) {
        cin >> x >> y >> v;

        --x;
        --y;

        trs[x][y] = v;
    }

    g.resize(n + 2, vector<int>(m + 2, INF));

    int answ = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            answ += get_g(i, j);
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cerr << get_g(i, j) << ' ';
        }

        cerr << '\n';
    }

    cout << mod(answ);

    return 0;
}


/*

3 3 3
2 3 -2
3 1 3
1 2 1

*/