#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


const int MAXN = (int)1e6 + 5;


const int M = 1791791791;
const int P = 57;

int PPOW[MAXN];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


class HS {
    vector<int> ph;

public:
    HS(string s) {
        int n = s.length();

        ph.resize(n + 1);
        for (int i = 0; i < n; ++i) {
            ph[i + 1] = mod(ph[i] * P + s[i]);
        }
    }

    int get(int i, int j) {
        return mod(ph[j] - ph[i] * PPOW[j - i]);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    PPOW[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        PPOW[i] = mod(PPOW[i - 1] * P);
    }

    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;

    int t, pos, len;
    string w;
    int exs = 1;

    cin >> t >> w;

    int wl = w.length();

    for (int i = 0; i < n - 1; ++i) {
        cin >> t >> pos >> len;

        exs += len / wl;
    }

    int dex = (m - 1) / wl + 1;

    if (exs < dex) {
        string s;
        for (int i = 0; i < exs; ++i) {
            s += w;
        }

        HS ph(p), sh(s);

        int tl = s.length();

        int answ = 0;
        for (int i = 0; i <= tl - m; ++i) {
            answ += (ph.get(0, m) == sh.get(i, i + m));
        }

        cout << answ;

        return 0;
    }

    string s;
    for (int i = 0; i < dex; ++i) {
        s += w;
    }

    HS ph(p), sh(s);

    int tl = s.length();

    int answ = 0;
    for (int i = 0; i <= tl - m; ++i) {
        answ += (ph.get(0, m) == sh.get(i, i + m));
    }

    int cans = 0;

    s += w;
    sh = HS(s);
    for (int i = tl - m + 1; i <= s.length() - m; ++i) {
        cans += (ph.get(0, m) == sh.get(i, i + m));
    }

    cout << (exs - dex) * cans + answ;

    return 0;
}


/*

7 4
ababaab
1 abaab
2 1 5
2 1 5
2 1 5

*/