#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

vector<int> zGroups;
int oneS = 0;
vector<int> prefS;


int getAns(int x) {
    if (x == 0) {
        return oneS;
    }
    int curS = 0;
    int ans = 0;
    int cnt = 0;
    int startFrom = 0;
    while (startFrom < (int) zGroups.size()) {
        int l = startFrom - 1;
        int r = (int) zGroups.size();
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (prefS[m + 1] - prefS[startFrom] >= x) {
                r = m;
            } else {
                l = m;
            }
        }
        if (r != zGroups.size()) {
            ans += x;
            ans++;
            cnt++;
        } else {
            break;
        }
        startFrom = r + 1;
    }
    ans--;
    if (cnt < 2) {
        return -1;
    }
    return ans;
}

string getAnsS(int x) {
    string ansS;
    if (x == 0) {
        for (int i = 0; i < oneS; ++i) {
            ansS += "1";
        }
        return ansS;
    }
    int curS = 0;
    int ans = 0;
    int cnt = 0;
    for (int i = 0; i < zGroups.size(); ++i) {
        curS += zGroups[i];
        if (curS >= x) {
            curS = 0;
            ans += x;
            for (int j = 0; j < x; ++j) {
                ansS += "0";
            }
            ansS += "1";
            cnt++;
        }
    }
    if (cnt < 2) {
        assert(false);
    }
    ansS = ansS.substr(0, ansS.length() - 1);
    return ansS;
}

int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;

    string s;
    cin >> s;
    int startPos = 0;
    for (int i = 0; i < s.size(); ++i) {
        if (s[i] == '1') {
            zGroups.push_back(i - startPos);
            startPos = i + 1;
            oneS++;
        }
    }
    int lst = s.size() - startPos;
    if (lst > 0) {
        zGroups.push_back(lst);
    }
    prefS.resize(zGroups.size() + 1);
    prefS[0] = 0;
    for (int i = 1; i <= zGroups.size(); ++i) {
        prefS[i] = zGroups[i - 1] + prefS[i - 1];
    }
    /*for (int x = 0; x < n; ++x) {
        cout << x << ' ' << getAns(x) << '\n';
    }*/
    int xMax = 0;
    for (int x = 0; x <= n; ++x) {
        if (getAns(x) > getAns(xMax)) {
            xMax = x;
        }
    }
    string ansS = getAnsS(xMax);
    cout << ansS.size() << '\n';
    cout << ansS;
    return 0;
}