#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include<bits/stdc++.h>
   
using namespace std;
#define int long long
  
struct Node{
    int x, y;
    int sum, sz;
    Node *l, *r;
    Node(int v){
        this->sum = v;
        this->sz = 1;
        this->x = v;
        this->y = rand() * rand() * rand();
        this->l = nullptr;
        this->r = nullptr;
    }
};
 
Node* pull(Node *t){
    if(!t) return t;
    t->sum = t->x;
    t->sz = 1;
    if(t->l){
        t->sum += t->l->sum;
        t->sz += t->l->sz;
    }
    if(t->r){
        t->sum += t->r->sum;
        t->sz += t->r->sz;
    }
    return t;
}
 
Node* merge(Node *l, Node *r){
    //cout << l << ' ' << r << 'a' << endl;
    if(!l) return pull(r);
    if(!r) return pull(l);
    if(l->y >= r->y){
        l->r = merge(l->r, r);
        return pull(l);
    }
    else{
        r->l = merge(l, r->l);
        return pull(r);
    }
}
 
pair<Node*, Node*> split(Node *t, int x){
    if(!t) return {t, t};
    if(t->x >= x){
        auto a = split(t->l, x);
        t->l = a.second;
        return {a.first, pull(t)};
    }
    else{
        auto a = split(t->r, x);
        t->r = a.first;
        return {pull(t), a.second};
    }
}
void print(Node *t){
    if(!t) return;
    print(t->l);
    cout << t->x << ' ';
    print(t->r);
}
 
 
Node* insert(Node *tree, int x){
    Node * ins = new Node(x);
    //cout << "kek " << x << endl;
    auto a = split(tree, x);
    tree = merge(a.first, merge(ins, a.second));
    return tree;
}
 
int getSz(Node *tree, int l, int r){
    auto a = split(tree, l);
    auto b = split(a.second, r - 1);
    int ans = 0;
    if(b.first){
        ans = b.first->sz;
    }
    a.second = merge(b.first, b.second);
    tree = merge(a.first, a.second);
    return ans;
}
 
int getSum(Node *tree, int l, int r){
    auto a = split(tree, l);
    auto b = split(a.second, r - 1);
    int ans = 0;
    if(b.first){
        ans = b.first->sum;
    }
    a.second = merge(b.first, b.second);
    tree = merge(a.first, a.second);
    return ans;
}
 
int calc(int l, int r, int c){
    if(c >= l && c <= r) return 0;
    return min(abs(l - c), abs(r - c));
}
 
int go(int l, int r, Node *tr){
    int ans = 0;
    //cout << "qr: " << l << ' ' << r << ' ' << tr->sz << '\n';
    //cout << getSz(tr, -1e+10, l + 1) << ' ' <<  getSum(tr, -1e+10, l + 1) << endl;
    //cout << getSum(tr, r, 1e+10) << ' ' << getSz(tr, r, 1e+10) << endl;
    ans += getSz(tr, -1e+10, l + 1) * l - getSum(tr, -1e+10, l + 1);
    ans += getSum(tr, r, 1e+10) - getSz(tr, r, 1e+10) * r;
    return ans;
}
 
int res = 1e+17;
vector<vector<int> > gs;
vector<pair<int, int> > sz;
vector<int> types;
int m, n, k;
void process(){
    int sum = 0;
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n; j++){
            sum += calc(sz[types[j]].first, sz[types[j]].second, gs[i][2 * j]);
            sum += calc(sz[types[j]].first, sz[types[j]].second, gs[i][2 * j + 1]);
        }
    }
    res = min(res, sum);
}
  
void gen(int p){
    if(p == n){
        process();
        return ;
    }
    for(int i = 0; i < k; i++){
        types.push_back(i);
        gen(p + 1);
        types.pop_back();
    }
}
 
int sti(string s){
    int ans = 0;
    for(char c: s) ans += c;
    return ans;
}
   
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    srand(sti("opukitpceno_hhr, kokosfggtuegyvbyegvsuhgvuevbsyhvsfvergergfghfhhfhfhfhfh"));
    cin >> m >> n >> k;
    sz.resize(k);
    gs.resize(m, vector<int> (2 * n));
    for(int i = 0; i < k; i++){
        cin >> sz[i].first >> sz[i].second;
    }
    Node* trs[200002];
    for(int i = 0; i < n; i++) trs[i] = nullptr;
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n * 2; j++){
            cin >> gs[i][j];
           // cout << gs[i][j] << ' ';
        }
        //cout << endl;
        sort(gs[i].begin(), gs[i].end());
        for(int j = 0; j < n * 2; j++){
            trs[j / 2] = insert(trs[j / 2], gs[i][j]);
        }
    }
    //for(int i = 0; i < n; i++){
   //   print(trs[i]);
   //   cout << endl;
    //}
    sort(sz.begin(), sz.end());
    //gen(0);
   // cout << res << endl;
    //return 0;
    int dp[200002];
    for(int i = 0; i <= n; i++) dp[i] = 1e+17;
    //vector<int> dp(n + 1, 1e+17);
    dp[0] = 0;
    for(int i = 0; i < n; i++){
        for(int j = 0; j < k; j++){
            dp[i + 1] = min(dp[i + 1], dp[i] + go(sz[j].first, sz[j].second, trs[i]));
        }
    }
    cout << dp[n] << endl;
}