#include <iostream>
#include <map>
#include <set>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <vector>

using namespace std;

typedef long long ll;

const int SZ = 1e5 + 100;
const ll INF = 1e17;
int n, m, k;

int l[SZ];
int r[SZ];
vector<int> v[SZ];

ll dist(int num, int pos)
{
    if (pos >= l[num] && pos <= r[num]) return 0;
    if (pos < l[num]) return (l[num] - pos);
    else return (pos - r[num]);
}

ll calc(int num, int tl, int tr)
{
    return dist(num, tl) + dist(num, tr);
}

int main()
{
    ios::sync_with_stdio(false);

    cin >> m >> n >> k;
    for (int i = 0; i < k; i++)
    {
        cin >> l[i] >> r[i];
    }
    for (int i = 0; i < m; i++)
    {
        v[i].resize(2 * n);
        for (int j = 0; j < (2 * n); j++)
        {
            cin >> v[i][j];
        }
        sort(v[i].begin(), v[i].end());
    }
    ll best = INF;
    ll ans, cur;
    if (n == 1)
    {

        for (int i = 0; i < k; i++)
        {
            ans = 0;
            for (int j = 0; j < m; j++)
            {
                ans += calc(i, v[j][0], v[j][1]);
            }
            best = min(best, ans);
        }
        cout << best << endl;
        return 0;
    }
    if (m == 1)
    {
        best = 0;
        for (int i = 0; i < n; i++)
        {
            ans = INF;
            for (int j = 0; j < k; j++)
            {
                cur = calc(j, v[0][2 * i], v[0][2 * i + 1]);
                ans = min(ans, cur);
            }
            best += ans;
        }
        cout << best << endl;
        return 0;
    }

    best = 0;
    for (int i = 0; i < n; i++)
    {
        ans = INF;
        for (int j = 0; j < k; j++)
        {
            cur = 0;
            for (int step = 0; step < m; step++)
            {
                cur += calc(j, v[step][2 * i], v[step][2 * i + 1]);
            }
            ans = min(ans, cur);
        }
        best += ans;
    }
    cout << best << endl;



    return 0;
}
