#include <iostream>
#include <map>
#include <set>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <vector>

using namespace std;

typedef long long ll;

const ll MOD = 998244353;

int n, m, k;

set< pair<int, int> > st;

bool can(int y, int x)
{
    return (st.find({y, x}) != st.end());
}

map<int, map<int, ll> > mp;

int main()
{
    ios::sync_with_stdio(false);

    cin >> n >> m >> k;
    int r, c;
    ll v;

    for (int i = 0; i < k; i++)
    {
        cin >> r >> c >> v;
        r--;
        c--;
        mp[r][c] = v;
        st.insert({r, c});
    }

    ll ans = 0;
    if (n <= 0)
    {

    }
    else
    {
        vector< vector<ll> > dp;
        dp.resize(n + 5);
        for (int i = 0; i < (n + 5); i++)
        {
            dp[i].resize(m + 5);
        }
        for (int i = 0; i < (n + 5); i++)
        {
            for (int j = 0; j < (m + 5); j++)
            {
                dp[i][j] = 0;
            }
        }
        ll fir, sec;
        for (int i = n - 1; i >= 0; i--)
        {
            for (int j = m - 1; j >= 0; j--)
            {
                if (can(i, j))
                {
                    dp[i][j] = mp[i][j];
                    continue;
                }
                bool fl1, fl2;
                fir = 0;
                sec = 0;
                fl1 = (can(i + 1, j));
                if (fl1) fir = mp[i + 1][j];
                fl2 = (can(i, j + 1));
                if (fl2) sec = mp[i][j + 1];

                if (fl1 && fl2)
                {
                    dp[i][j] = min(fir, sec);
                    continue;
                }
                if (fl1)
                {
                    dp[i][j] = min(fir, max(dp[i + 1][j + 1], dp[i][j + 2]));
                    continue;
                }
                if (fl2)
                {
                    dp[i][j] = min(sec, max(dp[i + 1][j + 1], dp[i + 2][j]));
                    continue;
                }
                dp[i][j] = min(max(dp[i + 1][j + 1], dp[i][j + 2]),
                               max(dp[i + 1][j + 1], dp[i + 2][j]));
            }
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                ans = (ans + (ll)(dp[i][j])) % MOD;
                while (ans < 0) ans += MOD;
            }
        }
    }
    if (ans < 0) ans /= 0;
    cout << ans << endl;

    return 0;
}

