#include <iostream>
#include <algorithm>
using namespace std;
const int inf = 1e9;

int check(string s, int f)
{
    int j = 0, ans = 0, t = 0;
    for (int i = 0; i < s.length(); ++i)
    {
        if (s[i] == '0')
            j++;
        else if (j >= f)
            j = 0, ans += f + 1, t++;
    }
    if (j >= f)
        ans += f;
    else
        ans--, t--;
    return t ? ans : -1;
}

void add(string& s, int f)
{
    for (int i = 0; i < f; ++i)
        s += '0';
    s += '1';
}

string get(string s, int f)
{
    string ans;
    int j = 0, n = s.length();
    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '0')
            j++;
        else if (j >= f)
            j = 0, add(ans, f);
    }
    if (j >= f)
        add(ans, f);
    ans.pop_back();
    return ans;
}

string solve1(string s, int k)
{
    int best = -1, r = 0, n = s.length();
    for (int i = 0; i < k; ++i)
    {
        int u = check(s, i);
        if (u > best)
            best = u, r = i;
    }
    for (int i = 0; i < k; ++i)
    {
        int j = n - i;
        if (j % (i + 1))
            continue;
        j /= i + 1;
        int u = check(s, j);
        if (u > best)
            best = u, r = j;
    }
    return get(s, r);
}

string get2(string s, int f)
{
    string ans;
    int j = 0, n = s.length();
    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '0')
            j++;
        else if (j >= f)
            j = 0, add(ans, f);
    }
    if (j && j >= f)
        add(ans, f);
    return ans;
}

string solve2(string s)
{
    int n = (s += '1').length();
    int best = -1, r = 0, k = count(s.begin(), s.end(), '1');
    int dp[k+1][k+1]; // i units passed, chosen j, value is max number of zeros in block
    fill(dp[0], dp[0] + k + 1, -inf), dp[0][0] = inf;
    dp[1][1] = s.find_first_of('1');
    for (int i = 2; i <= k; ++i)
        dp[1][i] = -inf;
    int pos[k] = {0}, p[n+1] = {0};
    for (int i = 0, j = 1; i < n; ++i)
        if (s[i] == '1')
            pos[j++] = i;
    for (int i = 0; i < n; ++i)
        p[i+1] = p[i] + (s[i] == '0');
    /*cout << "pos: ";
    for (int i = 0; i <= k; ++i)
        cout << pos[i] << ' ';
    cout << "\np: ";
    for (int i = 0; i <= n; ++i)
        cout << p[i] << ' ';
    cout << "\ndp:\n";*/
    for (int i = 2; i <= k; ++i)
    {
        for (int j = 1; j <= k; ++j)
        {
            dp[i][j] = dp[i-1][j];
            for (int l = 0; l < i; ++l)
            {
                int z = p[pos[i]] - p[pos[l]];
                dp[i][j] = max(dp[i][j], min(z, dp[l][j-1]));
            }
        }
    }
    /*for (int i = 1; i <= k; ++i)
    {
        cout << '\t';
        for (int j = 1; j <= k; ++j)
            cout << dp[i][j] << '\t';
        cout << '\n';
    }*/
    int y = -1, m = 0;
    for (int i = 2; i <= k; ++i)
    {
        int z = dp[k][i] * i + i;
        if (z > y)
            y = z, m = dp[k][i];
    }
    string g = get2(s, m);
    g.pop_back();
    return g;
}

string stress(int n)
{
    while (true)
    {
        string s;
        for (int i = 0; i < n; ++i)
            s += '0' + rand() % 2;
        if (solve1(s, s.length()).length() != solve2(s).length())
            return s;
    }
}

int main()
{
    //5
    //11010
    //8
    //11011011
    int n;
    cin >> n;
    string s, u;
    cin >> s;
    int on = count(s.begin(), s.end(), '1');
    if (on <= 1200)
        u = solve2(s);
    else
        u = solve1(s, 1000);
    cout << u.length() << '\n' << u;
    return 0;
}
