#include <iostream>
#include <set>
#include <vector>
#include <assert.h>
using namespace std;
#define int long long
const int maxn = static_cast<const int>(2e5 + 5);
const int inf = 1e18;

multiset<int> a[maxn];

struct elem {
    int l, r;
};

elem b[maxn];

int parse(int p, int h) {
    if (b[p].l <= h && h <= b[p].r) return 0;
    return min(abs(b[p].l - h), abs(b[p].r - h));
}
//return id, res
pair<int, int> best_in_group(int p, int group) {
    auto iter = a[group].lower_bound(b[p].l);
    int r1 = inf;
    int i1 = 0;
    if (iter != a[group].end()) {
        i1 = *iter;
        r1 = parse(p, *iter);
    }
    int r2 = inf;
    int i2 = 0;
    if (iter != a[group].begin()) {
        iter--;
        i2 = *iter;
        r2 =  parse(p, *iter);
    }
    if (r1 < r2) return {i1, r1};
    return {i2, r2};
}

pair<pair<int, int>, pair<int, int>> bests_in_group(int p, int group) {
    auto i1 = best_in_group(p, group);
    a[group].erase(a[group].find(i1.first));
    auto i2 = best_in_group(p, group);
    a[group].insert(i1.first);
    return {i1, i2};
}

signed main() {
    ios_base::sync_with_stdio(false);
    int n, m, k;
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].r;
    }
    n *= 2;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            int x;
            cin >> x;
            a[i].insert(x);
        }
    }

    int res = 0;
    for (int it = 0; it < n / 2; it++) {
        int best = inf;
        int bestid = 0;
        for (int p = 0; p < k; p++) {
            int cur = 0;
            for (int i = 0; i < m; i++) {
                auto f = bests_in_group(p, i);
                cur += f.first.second + f.second.second;
            }
            if (cur < best) {
                best = cur;
                bestid = p;
            }
        }
        res += best;
        for (int i = 0; i < m; i++) {
            auto f = bests_in_group(bestid, i);
            a[i].erase(a[i].find(f.first.first));
            a[i].erase(a[i].find(f.second.first));
        }
    }
    assert(res < inf);
    cout << res;
    return 0;
}