#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include "set"
using namespace std;
#define int long long
struct elem {
    int l, r;
};
const int maxn = 2e5 + 5;
const int inf = 1e18;
vector<int> a[maxn];
vector<pair<int, int>> groups[maxn]; // n re groups

elem b[maxn];

int parse(int p, int h) {
    if (b[p].l <= h && h <= b[p].r) return 0;
    return min(abs(b[p].l - h), abs(b[p].r - h));
}

set<int> lls;
set<int> rrs;

map<int, int> pref;
map<int, int> suff;

struct event {
    int x;
    int type; // 0 -- add, 1 -- parse
};


bool comp (const event& e1, const event& e2) {
    return e1.x < e2.x || (e1.x == e2.x && e1.type < e2.type);
}
vector<event> events;

signed main() {
    int m, n, k;
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++) {
        cin >> b[i].l >> b[i].r;
        lls.insert({b[i].l});
        rrs.insert({b[i].r});
    }
    for (int i = 0; i < m; i++) {
        a[i].resize(2 * n);
        for (int j = 0; j < 2 * n; j++) {
            cin >> a[i][j];
        }
        sort(a[i].begin(), a[i].end());
        for (int j = 0; j < n; j++) {
            groups[j].emplace_back(a[i][2 * j], a[i][2 * j + 1]);
        }
    }
    int res = 0;
    for (int it = 0; it < n; it++) {
        events.clear();
        for (auto& x: lls) {
            events.push_back({x, 0});
        }
        for (auto& x: rrs) {
            events.push_back({x, 0});
        }
        for (int i = 0; i < m; i++) {
            events.push_back({groups[it][i].first, 1});
            events.push_back({groups[it][i].second, 1});
//            cur += parse(p, ) + parse(p, groups[it][i].second);
        }
        sort(events.begin(), events.end(), comp);
        int curcnt = 0;
        int curx = 0;
        int curpref = 0;

        for (int i = 0; i < events.size(); i++) {
            curpref += (events[i].x - curx) * curcnt;
            curx = events[i].x;
            if (events[i].type == 1) {
                curcnt++;
            } else {
                pref[events[i].x] = curpref;
            }
        }
        curcnt = 0;
        curx = 0;
        int cursuff = 0;
        for (int i = events.size() - 1; i >= 0; i--) {
            cursuff += (curx - events[i].x) * curcnt;
            curx = events[i].x;
            if (events[i].type == 1) {
                curcnt++;
            } else {
                suff[events[i].x] = cursuff;
            }
        }
        int best = inf;
        for (int p = 0; p < k; p++) {
            best = min(best, pref[b[p].l] + suff[b[p].r]);
        }
        res += best;
        /*for (int p = 0; p < k; p++) {
            int cur = 0;
            for (int i = 0; i < m; i++) {
                cur += parse(p, groups[it][i].first) + parse(p, groups[it][i].second);
                if (cur > best) break;
            }
            if (cur < best) {
                best = cur;
            }
        }*/
        /*int sum = 0;
        for (int i = 0; i < m; i++) {
            sum += groups[it][i].first + groups[it][i].second;
        }
        int best = inf;
        int bestid = 0;
        for (int p = 0; p < k; p++) {
            if (abs(sum - b[p].l * 2 * m) < best) {
                best = abs(sum - b[p].l * 2 * m);
                bestid = p;
            }
        }
        int cur = 0;
        for (int i = 0; i < m; i++) {
            cur += parse(bestid, groups[it][i].first) + parse(bestid, groups[it][i].second);
            if (cur > best) break;
        }*/
        //res += cur;
    }
    cout << res;
    return 0;
}