#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <set>
using namespace std;
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,abm,mmx,popcnt,tune=native")
typedef long long ll;
typedef long double ld;
#define fs first
#define sc second
mt19937 rng(time(NULL));
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
const int inf = 2e9 + 100;

struct segtree {
	struct node {
		int v, pos;
	} t[maxn * 4];

	node min(node a, node b) {
		if (a.v <= b.v) return a;
		else return b;
	}

	void build(int v, int tl, int tr, vector<int> &a) {
		if (tl == tr) {
			if (tl >= a.size()) t[v] = { inf, 0 };
			else t[v] = { a[tl] , tl};
		}
		else {
			int tm = (tl + tr)/2;
			build(v * 2, tl, tm, a);
			build(v * 2 + 1, tm + 1, tr, a);
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	void build(vector<int> &a) {
		build(1, 0, maxn - 1, a);
	}

	void upd(int v, int tl, int tr, int pos, int nv) {
		if (tl == tr) t[v] = { nv , pos};
		else {
			int tm = (tl + tr) / 2;
			if (pos <= tm) upd(v * 2, tl, tm, pos, nv);
			else upd(v * 2 + 1, tm + 1, tr, pos, nv);
			t[v] = min(t[v * 2], t[v * 2 + 1]);
		}
	}

	void upd(int pos, int nv) {
		upd(1, 0, maxn - 1, pos, nv);
	}

	node mn(int v, int tl, int tr, int l, int r) {
		if (l > r) return { inf, 0 };
		if (tl == l && tr == r) return t[v];
		int tm = (tl + tr) / 2;
		return min(mn(v * 2, tl, tm, l, std::min(r, tm)), mn(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
	}

	node mn(int l, int r) {
		return mn(1, 0, maxn - 1, l, r);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m,n,k;
	cin >> m>>n>>k;
	vector<pair<int, int> > p(k);
	vector<vector<int> > s(m, vector<int>(2 * n));
	for (int i = 0; i < k; ++i) cin >> p[i].fs >> p[i].sc;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) cin >> s[i][j];
		sort(s[i].begin(), s[i].end());
	}
	ll ans = 0;
	auto dist = [&](int i, int j, int h) {
		ll u;
		if (s[h][i] < p[j].fs) u = p[j].fs - s[h][i];
		else if (s[h][i] < p[j].sc) u = 0;
		else u = s[h][i] - p[j].sc;
		return u;
	};
	for (int i = 0; i < n; ++i) {
		ll best = 1e18;
		for (int j = 0; j < k; ++j) {
			ll cur = 0;
			for (int h = 0; h < m; ++h) 
				cur += dist(i*2, j, h) + dist(i*2+1,j,h);
			best = min(best, cur);
		}
		ans += best;
	}
	cout << ans;
	return 0;
}