#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <random>
#include <ctime>
#include <map>
#include <set>
#include <ext/rope>
using namespace std;
using namespace __gnu_cxx;
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,abm,mmx,popcnt,tune=native")
typedef long long ll;
typedef long double ld;
#define fs first
#define sc second
#define at mutable_reference_at
mt19937 rng(time(NULL));
const int maxn = 2e6 + 100;
const int mod = 1e9 + 7;
const int inf = 2e9 + 100;

int p1 = 239, p2 = 443;
int mod1 = 1e9 + 33, mod2 = 1e9 + 229;

ll pw1[maxn], pw2[maxn];
ll h1[maxn], h2[maxn];

struct hws {

    int n;

    void build(string &s, string &r) {
        n = s.size();
        s += r;
        pw1[0] = pw2[0] = 1;
        h1[0] = h2[0] = s[0] - 'a' + 1;
        for (int i = 1;i<s.size();++i) {
            pw1[i] = 1ll * pw1[i-1] * p1 % mod1;
            pw2[i] = 1ll * pw2[i-1] * p2 % mod2;
            h1[i] = (h1[i-1] + 1ll * pw1[i] * (s[i] - 'a' + 1)) % mod1;
            h2[i] = (h2[i-1] + 1ll * pw2[i] * (s[i] - 'a' + 1)) % mod2;
        }
    }

    bool eq(int a, int b, int sz) {
        int ha1 = h1[a + sz - 1];
        int ha2 = h2[a + sz - 1];
        if (a) {
            ha1 = (ha1 - h1[a-1] + mod1)%mod1;
            ha2 = (ha2 - h2[a-1] + mod2)%mod2;
        }
        int hb1 = h1[b + sz - 1];
        int hb2 = h2[b + sz - 1];
        if (b) {
            hb1 = (hb1 - h1[b-1] + mod1)%mod1;
            hb2 = (hb2 - h2[b-1] + mod2)%mod2;
        }
        if (a < b) return 1ll*pw1[b-a]*ha1%mod1 == hb1 && 1ll*pw2[b-a]*ha2%mod2 == hb2;
        else if (a > b) return ha1 == 1ll*pw1[a-b]*hb1%mod1 && ha2 == 1ll*pw2[a-b]*hb2%mod2;
        else return ha1 == hb1 && ha2 == hb2;
    }

    int count(string r) {
        int ans = 0;
        for (int i = 0;i<n-r.size()+1;++i) {
            if (eq(i,n, r.size())) ans++;
        }
        return ans;
    }

};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

    int m,n;
    cin>>m>>n;
    hws f;
    string s, r;
    cin>>r;
    for (int i = 0;i<n;++i) {
        int t;
        cin>>t;
        if (t == 1) {
            string w;
            cin>>w;
             s += w;
        }
        else {
            int p, l;
            cin>>p>>l;
            p--;
            while (l--) s += s[p++];
        }
    }
    if (s.size() < r.size()) return cout<<0,0;
    f.build(s, r);
    cout<<f.count(r);

	return 0;
}
