#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>
#include <climits>
#include <cstdio>
#include <string>
std::string solve(std::string str)
{
	int n = str.size();
	std::string ostr = str;
	while(str[0] == '1') str = str.substr(1), n--;
	while(str.back() == '1') str = str.substr(0, str.size() - 1), n--;
	str += '1';
	n++;
	int k = 0; for(int i = 0; i < n; i++) k += str[i] - '0';
	std::vector<int> lc(k), rc(k), pos(k);
	int curLc = 0, ck = 0;
	for(int i = 0; i < n; i++)
	{
		if(str[i] == '0') curLc++;
		else lc[ck] = curLc, pos[ck] = i, ck++;
	}
	int curRc = 0; ck--;
	for(int i = n - 1; i >= 0; i--)
	{
		if(str[i] == '0') curRc++;
		else rc[ck] = curRc, ck--;
	}
	//when meeting a one, get len iff including it as first
	//do that in o(nk)
	int mints = INT_MAX, mintsi = -1;
	for(int i = 0; i < k - 1; i++)
	{
		int l = lc[i];
		int totalSkips = pos[i] - lc[i]; //skipped some ones already
		//printf(" i=%d (p=%d), ts=%d\n", i, pos[i], totalSkips);
		int zl = 0; //counter
		int oc = 0;
		for(int j = pos[i]; j < n; j++)
		{
			//printf("  looking at j=%d. ts=%d, zl=%d\n", j, totalSkips, zl);
			if(str[j] == '0' && zl > 0) zl--;
			else if(str[j] == '0') totalSkips++;
			else if(str[j] == '1' && zl > 0) totalSkips++;
			else if(str[j] == '1') zl = lc[i], oc++;
		}
		int len = oc * (lc[i] + 1);
		totalSkips = str.size() - len;
		//printf(" i=%d (p=%d), ts=%d\n", i, pos[i], totalSkips);
		if(totalSkips < mints) mintsi = i, mints = totalSkips;
	}
	std::string ans; for(int i = 0; i < lc[mintsi]; i++) ans += "0";
	int zl = 0;
	for(int i = pos[mintsi]; i < n; i++)
	{
		if(str[i] == '0' && zl > 0) zl--, ans += str[i];
		if(str[i] == '1' && zl == 0) zl = lc[mintsi], ans += str[i];
	}
	ans = ans.substr(0, ans.size() - 1);
	bool any = false;
	for(int i = 0; i < ans.size(); i++) if(ans[i] != '0') any = true;
	std::string ans2;
	for(int i = 0; i < int(ostr.size()); i++)
		if(ostr[i] == '1') ans2 += "1";
	if(!any)
		return ans2;
	else
	{
		if(ans.size() > ans2.size()) return ans;
		else return ans2;
	}
}
bool valid(std::string s)
{
	std::string str = s + "1";
	int rl = -1, lo = -1;
	int n = str.size();
	for(int i = 0; i < n; i++)
	{
		if(str[i] == '0') continue;
		if(rl == -1) rl = i;
		else if(i - lo - 1 != rl) return false;
		lo = i;
	}
	return rl != -1;
}
std::string supersolve(std::string s)
{
	std::string bsol = "";
	for(int i = 0; i < s.size(); i++)
	{
		std::string tos = s.substr(i);
		std::string sol = solve(tos);
		if(!valid(sol)) continue;
		if(sol.size() > bsol.size()) bsol = sol;
	}
	return bsol;
}
std::string reallySolve(std::string s)
{
	std::string bsol = supersolve(s);
	std::reverse(s.begin(), s.end());
	std::string sol = supersolve(s);
	if(sol.size() > bsol.size()) bsol = sol;
	return bsol;
}
int main()
{
	int n; std::cin >> n;
	std::string str; std::cin >> str;
	std::string sol = reallySolve(str);
	std::cout << sol.size() << "\n" << sol;
}
