#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cmath>
#include <climits>
#include <cstdio>
#include <string>
#include <random>
int W, H, tn;
int64_t MOD = 998244353;
std::vector<std::vector<std::vector<int>>> kres;
int gResult(int x, int y, bool max)
{
	if(x >= W || y >= H) return 0;
	if(kres[y][x][max] != -1) return kres[y][x][max];
	//bool max = (x + y) % 2; //x == 0, y == 0 -> minimising
	int r1 = gResult(x+1, y, !max);
	int r2 = gResult(x, y+1, !max);
	if(max)
		return kres[y][x][max] = std::max(r1, r2);
	else
		return kres[y][x][max] = std::min(r1, r2);
}
int main()
{
	std::cin >> H >> W >> tn;
	kres.resize(H, std::vector<std::vector<int>>(W, std::vector<int>(2, -1)));
	for(int i = 0; i < tn; i++)
	{
		int y, x; std::cin >> y >> x; y--; x--;
		int cost; std::cin >> cost;
		kres[y][x][0] = cost;
		kres[y][x][1] = cost;
	}
	int64_t sum = 0;
	for(int x = 0; x < W; x++)
	{
		for(int y = 0; y < H; y++)
		{
			//printf(" y=%d, x=%d. res=%d\n", y, x, gResult(x,y,false));
			sum += gResult(x, y,false);
			sum += MOD; sum += MOD;
			while(sum > MOD) sum -= MOD;
		}
	}
	std::cout << sum;
	return 0;
}
