#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll MOD = 998244353;
const int mx1 = 1e6 + 228;
const int mx2 = 6;
const int NEUTRAL = 2e9;

struct trap {
	int x, y, cost;
};

int n, m, k, X;
int a[mx1][mx2][2];
vector<int> good_x;
vector<trap> v;

int main() {
	fast_io();
	cin >> n >> m >> k;
	swap(n, m);
	for (int i = 0; i < k; ++i) {
		int x, y, cost;
		cin >> x >> y >> cost;
		swap(x, y);
		x--;
		y--;
		for (int j = max(0, x - 6); j <= x; ++j) {
			good_x.push_back(j);
		}
		v.push_back({x, y, cost});
	}
	sort(all(good_x));
	good_x.erase(unique(all(good_x)), good_x.end());
	X = good_x.size();
	for (int i = 0; i < X; ++i) {
		for (int j = 0; j < m; ++j) {
			a[i][j][0] = NEUTRAL;
			a[i][j][1] = NEUTRAL;
		}
	}
	for (auto tr : v) {
		int x1 = lower_bound(all(good_x), tr.x) - good_x.begin();
		a[x1][tr.y][0] = tr.cost;
		a[x1][tr.y][1] = tr.cost;
	}
	for (int i = X - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j][0] != NEUTRAL) {
				continue;
			}
			a[i][j][0] = a[i][j + 1][1];
			a[i][j][1] = a[i][j + 1][0];
			int zero = (i == X - 1 || good_x[i + 1] != good_x[i] + 1);
			chkmin(a[i][j][0], zero ? 0 : a[i + 1][j][1]);
			chkmax(a[i][j][1], zero ? 0 : a[i + 1][j][0]);
		}
	}
	ll sum = 0;
	for (int i = 0; i < X; ++i) {
		for (int j = 0; j < m; ++j) {
			sum += a[i][j][0];
		}
	}
	sum = (sum % MOD + MOD) % MOD;
	cout << sum << endl;
}
