#include <bits/stdc++.h>
//#define int long long

using namespace std;

int inf = 1e9;

struct even{
    int l, r;
};

bool cmp(even a, even b) {
    if (a.l != b.l)
        return a.l < b.l;
    return a.r > b.r;
}

bool cmp2(even a, even b) {
    if (a.r != b.r)
        return a.r < b.r;
    return a.l < b.r;
}

vector<even> L, R;
vector<int> q;

void relax(int x1, int x2, int l, int r, int& val) {
    int val2 = ((x1 >= l && x1 <= r) ? 0 : min(abs(x1 - l), abs(x1 - r))) + ((x2 >= l && x2 <= r) ? 0 : min(abs(x2 - l), abs(x2 - r)));
    val = min(val, val2);
}

long long solve2() {
    sort(q.begin(), q.end());

    long long sum = 0;

    for (int i = 0; i < q.size(); i += 2) {
        int ans = inf;
        even a, b;
        a.l = q[i], b.r = q[i + 1];

        auto A = lower_bound(L.begin(), L.end(), a, cmp);

        if (A != L.begin()) {
            a = *(A - 1);
            relax(q[i], q[i + 1], a.l, a.r, ans);
        }

        auto B = lower_bound(R.begin(), R.end(), b, cmp2);

        if (B != R.end()) {
            b = *B;
            relax(q[i], q[i + 1], b.l, b.r, ans);
        }

        while (A != L.end() && (*A).l <= q[i + 1]) {
            a = *A;
            relax(q[i], q[i + 1], a.l, a.r, ans);
            ++A;
        }

        sum += ans;
    }

    return sum;
}

long long solve() {
    long long sum = 0;
    //sort(q.begin(), q.end());

    for (int i = 0; i < q.size(); i += 2) {
        int ans = inf;
        for (even e : L)
            relax(q[i], q[i + 1], e.l, e.r, ans);
        sum += ans;
    }

    return sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    vector<even> in(k);

    for (int i = 0; i < k; ++i) {
        cin >> in[i].l >> in[i].r;
    }

    L = in, R = in;

    sort(L.begin(), L.end(), cmp);
    sort(R.begin(), R.end(), cmp2);

    /*{
        vector<even> nl, nr;

        nl.push_back(L[0]);
        for (int i = 1; i < k; ++i) {
            if (L[i].l == L[i - 1].l || L[i].r <= nl.back().r)
                continue;
            nl.push_back(L[i]);
        }

        nr.push_back(R[0]);
        for (int i = 1; i < k; ++i) {
            if (R[i].r == R[i - 1].r)
                continue;
            while (nr.size() && nr.back().l >= R[i].l)
                nr.pop_back();
            nr.push_back(R[i]);
        }

        L.swap(nl);
        R.swap(nr);
    }*/

    q.resize(2 * n);

    long long ans = 0;

    while (m--) {
        for (int i = 0; i < 2 * n; ++i)
            cin >> q[i];
        long long s1 = solve();
        while (next_permutation(q.begin(), q.end()))
            s1 = min(s1, solve());
        ans += s1;
    }
    cout << ans;
}