#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <string>
using namespace std;
#define int long long

const int mod = 998244353;

vector <int> get_pi(string& s) {
	int n = s.size();
	vector <int> pi(n, 0);
	for (int i = 1; i < n; ++i) {
		int j = pi[i - 1];
		while (j > 0 && s[j] != s[i]) j = pi[j - 1];
		pi[i] = j + (s[i] == s[j]);
	}
	return pi;
}

int kmp(string& s, string t) {
	string st = s + '#' + t;
	auto pi = get_pi(st);
	int res = 0;
	for (auto& i : pi) {
		if (i == s.size()) ++res;
	}
	return res;
}

void solve() {
	int m, n;
	cin >> m >> n;
	string s, t = "";
	cin >> s;
	int cnt = 1;
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			string toadd;
			cin >> toadd;
			t += toadd;
		}
		else {
			int pos, len;
			cin >> pos >> len;
			--pos;
			cnt += len / t.size();
		}
	}
	cout << (kmp(s, t + t) - kmp(s, t)) * (cnt - 1) + kmp(s, t);
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
#ifdef  _DEBUG
	cout << "Exec. time: " << (clock() + 0.0) / 1000 << "\n";
#endif
	return 0;
}