#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>

#define int long long

using namespace std;

long long lf(vector<int>& a, vector<long long>& pr, pair<int, int> b) {
	int left = -1;
	int right = a.size();
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (a[mid] >= b.first) {
			right = mid;
		}
		else {
			left = mid;
		}
	}
	return (long long)right * b.first - pr[right];
}

long long rf(vector<int>& a, vector<long long>& pr, pair<int, int> b) {
	int left = -1;
	int right = a.size();
	while (right - left > 1) {
		int mid = (left + right) / 2;
		if (a[mid] <= b.second) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return pr.back() - pr[right] - (long long)(a.size() - right) * b.second;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int>> b(k);
	for (int i = 0; i < k; ++i) {
		cin >> b[i].first >> b[i].second;
	}
	vector<vector<int>> a(n);
	for (int i = 0; i < m; ++i) {
		vector<int> c(2 * n);
		for (int j = 0; j < 2 * n; ++j) {
			cin >> c[j];
		}
		sort(c.begin(), c.end());
		for (int j = 0; j < 2 * n; j += 2) {
			a[j / 2].emplace_back(c[j]);
			a[j / 2].emplace_back(c[j + 1]);
		}
	}
	sort(b.begin(), b.end(), [](pair<int, int> a, pair<int, int> b) {return make_pair(a.first, -a.second) < make_pair(b.first, -b.second); });
	int ptr = 0;
	for (int i = 1; i < b.size(); ++i) {
		if (b[ptr].first <= b[i].first && b[ptr].second >= b[i].second) {
			continue;
		}
		++ptr;
		b[ptr] = b[i];
	}
	b.resize(ptr + 1);
	long long result = 0;
	for (int i = 0; i < n; ++i) {
		sort(a[i].begin(), a[i].end());
		int left = 0;
		int right = b.size() - 1;
		vector<long long> pr(a[i].size() + 1);
		for (int j = 1; j <= a[i].size(); ++j) {
			pr[j] = a[i][j - 1] + pr[j - 1];
		}
		while (right - left > 1000) {
			int mid = (right + left) / 2;
			if (lf(a[i], pr, b[mid]) < rf(a[i], pr, b[mid])) {
				left = mid;
			}
			else {
				right = mid;
			}
		}
		int mn = 1e17;
		for (int j = left; j <= right; ++j) {
			mn = min(mn, lf(a[i], pr, b[j]) + rf(a[i], pr, b[j]));
		}
		result += mn;
	}
	cout << result << endl;
	system("pause");
	return 0;
}
