#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;
const long long MOD = 998144352;

int n, m, k;
vector<vector<int>> a;

inline int get(int x, int y) {
	if (x >= n || y >= m) {
		return 0;
	}
	return a[x][y];
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	cin >> n >> m >> k;
	a.resize(n + 5, vector<int>(m + 5));
	vector<vector<int>> used(n, vector<int>(m));
	for (int i = 0; i < k; ++i) {
		int x, y, z;
		cin >> x >> y >> z;
		a[x - 1][y - 1] = z;
		used[x - 1][y - 1] = 1;
	}
	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			if (used[i][j]) {
				continue;
			}
			a[i][j] = max(min(a[i + 2][j], a[i + 1][j + 1]), min(a[i][j + 2], a[i + 1][j + 1]));
		}
	}
	long long result = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			result += a[i][j];
		}
	}
	cout << (result % MOD + MOD * MOD) % MOD << endl;
	return 0;
}
