#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>

using namespace std;

vector<int> z_function(string s) {
	int n = s.length();
	vector<int> z(n);
	int left = 0;
	int right = 0;
	for (int i = 1; i < n; ++i) {
		if (right > i) {
			z[i] = min(right - i, z[i - left]);
		}
		while (z[i] + i < n && s[i + z[i]] == s[z[i]]) {
			++z[i];
		}
		if (i + z[i] > right) {
			right = i + z[i];
			left = i;
		}
	}
	return z;
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	int n, m;
	cin >> m >> n;
	string s, p;
	cin >> p;
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			string ss;
			cin >> ss;
			s += ss;
		}
		if (type == 2) {
			int pos, len;
			cin >> pos >> len;
			--pos;
			while (len--) {
				s += s[pos];
				++pos;
			}
		}
	}
	s = p + "#" + s;
	vector<int> z = z_function(s);
	int result = 0;
	for (int i : z) {
		if (i == p.size()) {
			++result;
		}
	}
	cout << result << endl;
	//system("pause");
	return 0;
}